define(["exports","../../../lit-element/lit-element.js","../../../@polymer/iron-icons/iron-icons.js"],function(_exports,_litElement,_ironIcons){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.A11yTab=void 0;function _templateObject2_2b0bf7305fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          height: var(--a11y-tabs-tab-height, --a11y-tabs-height);\n          overflow: var(--a11y-tabs-tab-overflow, --a11y-tabs-overflow);\n        }\n        /*:host([disabled]) {\n          display:none;\n        }*/\n        :host([hidden]) {\n          display: none;\n        }\n        .sr-only {\n          position: absolute;\n          left: -99999px;\n          height: 0;\n          overflow: hidden;\n        }\n      "]);_templateObject2_2b0bf7305fe711ea9416fd1a737b18eb=function _templateObject2_2b0bf7305fe711ea9416fd1a737b18eb(){return data};return data}function _templateObject_2b0bf7305fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n      <span class=\"sr-only\">Tab ","</span>\n      <slot></slot>\n      <span class=\"sr-only\">\n        End of tab ",". Back to <a href=\"#","\">tabs</a>.\n      </span>\n    "]);_templateObject_2b0bf7305fe711ea9416fd1a737b18eb=function _templateObject_2b0bf7305fe711ea9416fd1a737b18eb(){return data};return data}/**
 * `a11y-tab`
 * a single tab within `a11y-tabs`
 * 
### Styling

`<a11y-tab>` provides the following custom properties
for styling:

Custom property | Description | Default
----------------|-------------|----------
`--a11y-tabs-tab-height` | tab height | `--a11y-tabs-height`
`--a11y-tabs-tab-overflow` | tab overflow | `--a11y-tabs-overflow`
 *
 * @customElement a11y-tab
 * @demo ./demo/index.html
 * @see ../a11y-tabs.js
 */var A11yTab=/*#__PURE__*/function(_LitElement){babelHelpers.inherits(A11yTab,_LitElement);babelHelpers.createClass(A11yTab,[{key:"render",value:function render(){return(0,_litElement.html)(_templateObject_2b0bf7305fe711ea9416fd1a737b18eb(),this.xOfY,this.xOfY,this.id)}// properties available to the custom element for data binding
}],[{key:"styles",get:function get(){return[(0,_litElement.css)(_templateObject2_2b0bf7305fe711ea9416fd1a737b18eb())]}},{key:"properties",get:function get(){return{/**
       * optional flag the tab, eg. `new`, `alert`, or `error`
       */flag:{type:String,reflect:!0},/**
       * optional flag icon the tab, eg. `av:fiber-new`, `icons:warning`, or `icons:error`
       */flagIcon:{type:String,attribute:"flag-icon"},/**
       * whether the tabbed interface is disabled
       */disabled:{type:Boolean,reflect:!0,attribute:"disabled"},/**
       * whether the tab is hidden
       */hidden:{type:Boolean,reflect:!0},/**
       * icon for this tab, eg. `maps:local-airport`, `maps:local-bar`, or `notification:wifi`
       */icon:{type:String},/**
       * the unique identifier and anchor for the tab
       */id:{type:String},/**
       * label for the tab
       */label:{type:String},/**
       * order of the tab
       */order:{type:Number},/**
       * total number of tabs
       */total:{type:Number}}}}]);function A11yTab(){var _this;babelHelpers.classCallCheck(this,A11yTab);_this=babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(A11yTab).call(this));_this.flag=null;_this.flagIcon=null;_this.hidden=!1;_this.icon=null;_this.id=null;_this.label=null;_this.order=1;_this.total=1;_this.addEventListener("a11y-tab-flag",function(e){return _this.handleFlag(e)});return _this}babelHelpers.createClass(A11yTab,[{key:"disconnectedCallback",value:function disconnectedCallback(){var _this2=this;this.removeEventListener("a11y-tab-flag",function(e){return _this2.handleFlag(e)});babelHelpers.get(babelHelpers.getPrototypeOf(A11yTab.prototype),"disconnectedCallback",this).call(this)}/**
   * @fires a11y-tab-changed
   */},{key:"updated",value:function updated(changedProperties){var _this3=this;changedProperties.forEach(function(oldValue,propName){if(["id","order"].includes(propName)&&!_this3.id)_this3.id="tab-".concat(_this3.order);if(["label","order"].includes(propName)&&!_this3.label)_this3.label="Tab ".concat(_this3.order);if("flag"===propName)_this3._tabChanged();if("flagIcon"===propName)_this3._tabChanged();if("icon"===propName)_this3._tabChanged();if("id"===propName)_this3._tabChanged();if("label"===propName)_this3._tabChanged()})}/**
   * Store the tag name to make it easier to obtain directly.
   */},{key:"_handleFlag",/**
   * handles any change in flag
   * @param {event} e the tab change event
   */value:function _handleFlag(e){this.flag=e.detail.flag;this.flagIcon=e.detail.flagIcon}/**
   * handles any change in the tab attributes
   */},{key:"_tabChanged",value:function _tabChanged(){/**
     * handles any change in the tab attributes
     *
     * @event a11y-tab-changed
     */this.dispatchEvent(new CustomEvent("a11y-tab-changed",{bubbles:!0,cancelable:!0,composed:!1,detail:this}))}},{key:"xOfY",get:function get(){return"".concat(this.order," of ").concat(this.total)}}],[{key:"tag",get:function get(){return"a11y-tab"}}]);return A11yTab}(_litElement.LitElement);_exports.A11yTab=A11yTab;window.customElements.define(A11yTab.tag,A11yTab)});