define(["exports"],function(_exports){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.DragNDrop=void 0;function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable});keys.push.apply(keys,symbols)}return keys}function _objectSpread(target){for(var i=1,source;i<arguments.length;i++){source=null!=arguments[i]?arguments[i]:{};if(i%2){ownKeys(Object(source),!0).forEach(function(key){babelHelpers.defineProperty(target,key,source[key])})}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source))}else{ownKeys(Object(source)).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))})}}return target}/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 *
 * Inspiration from: https://codepen.io/bradtraversy/pen/odmVgN
 */ /**
 * `drag-n-drop`
 * @customElement drag-n-drop
 * `drag and drop elements and manager`
 *
 * @microcopy - language worth noting:
 *  -
 *

 * @demo demo/index.html
 */var DragNDrop=/*#__PURE__*/function(_HTMLElement){babelHelpers.inherits(DragNDrop,_HTMLElement);babelHelpers.createClass(DragNDrop,[{key:"html",// render function
get:function get(){return"\n<style>\n:host {\n  display: block;\n}\n\n:host([hidden]) {\n  display: none;\n}\n\n:host([editing]) .items ::slotted(.hold) {\n  border: solid 5px #ccc;\n}\n\n:host([editing]) .items ::slotted([data-droppable]) {\n  margin: 10px;\n  border: solid 3px salmon;\n  background: white;\n}\n\n:host([editing]) .items ::slotted(.hovered) {\n  background: #f4f4f4;\n  border-style: dashed;\n}\n        </style>\n<div class=\"items\">\n  <slot></slot>\n</div>"}// properties available to the custom element for data binding
}],[{key:"properties",get:function get(){return _objectSpread({},babelHelpers.get(babelHelpers.getPrototypeOf(DragNDrop),"properties",this),{editing:{name:"editing",type:Boolean}})}/**
   * Store the tag name to make it easier to obtain directly.
   * @notice function name must be here for tooling to operate correctly
   */},{key:"tag",get:function get(){return"drag-n-drop"}/**
   * life cycle
   */}]);function DragNDrop(){var _this,delayRender=0<arguments.length&&arguments[0]!==void 0?arguments[0]:!1;babelHelpers.classCallCheck(this,DragNDrop);_this=babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(DragNDrop).call(this));// dragging tracker
_this.__dragging={};// set tag for later use
_this.tag=DragNDrop.tag;// map our imported properties json to real props on the element
// @notice static getter of properties is built via tooling
// to edit modify src/DragNDrop-properties.json
var obj=DragNDrop.properties;for(var p in obj){if(obj.hasOwnProperty(p)){if(_this.hasAttribute(p)){_this[p]=_this.getAttribute(p)}else{_this.setAttribute(p,obj[p].value);_this[p]=obj[p].value}}}_this.template=document.createElement("template");_this.attachShadow({mode:"open"});if(!delayRender){_this.render()}return _this}/**
   * life cycle, element is afixed to the DOM
   */babelHelpers.createClass(DragNDrop,[{key:"connectedCallback",value:function connectedCallback(){if(window.ShadyCSS){window.ShadyCSS.styleElement(this)}}},{key:"_copyAttribute",value:function _copyAttribute(name,to){var recipients=this.shadowRoot.querySelectorAll(to),value=this.getAttribute(name),fname=null==value?"removeAttribute":"setAttribute",_iteratorNormalCompletion=!0,_didIteratorError=!1,_iteratorError=void 0;try{for(var _iterator=recipients[Symbol.iterator](),_step,node;!(_iteratorNormalCompletion=(_step=_iterator.next()).done);_iteratorNormalCompletion=!0){node=_step.value;node[fname](name,value)}}catch(err){_didIteratorError=!0;_iteratorError=err}finally{try{if(!_iteratorNormalCompletion&&null!=_iterator.return){_iterator.return()}}finally{if(_didIteratorError){throw _iteratorError}}}}},{key:"_setProperty",value:function _setProperty(_ref){var name=_ref.name,value=_ref.value;this[name]=value}},{key:"render",value:function render(){this.shadowRoot.innerHTML=null;this.template.innerHTML=this.html;if(window.ShadyCSS){window.ShadyCSS.prepareTemplate(this.template,this.tag)}this.shadowRoot.appendChild(this.template.content.cloneNode(!0))}},{key:"attributeChangedCallback",// disconnectedCallback() {}
value:function attributeChangedCallback(attr,oldValue,newValue){if("editing"===attr){var draggable=this.querySelectorAll("[data-draggable]"),droppable=this.querySelectorAll("[data-droppable]");if(newValue){// Loop through empty boxes and add listeners
var _iteratorNormalCompletion2=!0,_didIteratorError2=!1,_iteratorError2=void 0;try{for(var _iterator2=droppable[Symbol.iterator](),_step2,dropArea;!(_iteratorNormalCompletion2=(_step2=_iterator2.next()).done);_iteratorNormalCompletion2=!0){dropArea=_step2.value;dropArea.setAttribute("droppable","true");dropArea.addEventListener("dragover",this.dragOver.bind(this));dropArea.addEventListener("dragenter",this.dragEnter.bind(this));dropArea.addEventListener("dragleave",this.dragLeave.bind(this));dropArea.addEventListener("drop",this.dragDrop.bind(this))}// Loop through fills and add listeners
}catch(err){_didIteratorError2=!0;_iteratorError2=err}finally{try{if(!_iteratorNormalCompletion2&&null!=_iterator2.return){_iterator2.return()}}finally{if(_didIteratorError2){throw _iteratorError2}}}var _iteratorNormalCompletion3=!0,_didIteratorError3=!1,_iteratorError3=void 0;try{for(var _iterator3=draggable[Symbol.iterator](),_step3,dragItem;!(_iteratorNormalCompletion3=(_step3=_iterator3.next()).done);_iteratorNormalCompletion3=!0){dragItem=_step3.value;dragItem.setAttribute("draggable","true");dragItem.addEventListener("dragstart",this.dragStart.bind(this));dragItem.addEventListener("dragend",this.dragEnd.bind(this))}}catch(err){_didIteratorError3=!0;_iteratorError3=err}finally{try{if(!_iteratorNormalCompletion3&&null!=_iterator3.return){_iterator3.return()}}finally{if(_didIteratorError3){throw _iteratorError3}}}}else{// Loop through empty boxes and add listeners
var _iteratorNormalCompletion4=!0,_didIteratorError4=!1,_iteratorError4=void 0;try{for(var _iterator4=droppable[Symbol.iterator](),_step4,_dropArea;!(_iteratorNormalCompletion4=(_step4=_iterator4.next()).done);_iteratorNormalCompletion4=!0){_dropArea=_step4.value;_dropArea.removeAttribute("droppable");_dropArea.removeEventListener("dragover",this.dragOver.bind(this));_dropArea.removeEventListener("dragenter",this.dragEnter.bind(this));_dropArea.removeEventListener("dragleave",this.dragLeave.bind(this));_dropArea.removeEventListener("drop",this.dragDrop.bind(this))}// Loop through fills and add listeners
}catch(err){_didIteratorError4=!0;_iteratorError4=err}finally{try{if(!_iteratorNormalCompletion4&&null!=_iterator4.return){_iterator4.return()}}finally{if(_didIteratorError4){throw _iteratorError4}}}var _iteratorNormalCompletion5=!0,_didIteratorError5=!1,_iteratorError5=void 0;try{for(var _iterator5=draggable[Symbol.iterator](),_step5,_dragItem;!(_iteratorNormalCompletion5=(_step5=_iterator5.next()).done);_iteratorNormalCompletion5=!0){_dragItem=_step5.value;_dragItem.removeAttribute("draggable");_dragItem.removeEventListener("dragstart",this.dragStart.bind(this));_dragItem.removeEventListener("dragend",this.dragEnd.bind(this))}}catch(err){_didIteratorError5=!0;_iteratorError5=err}finally{try{if(!_iteratorNormalCompletion5&&null!=_iterator5.return){_iterator5.return()}}finally{if(_didIteratorError5){throw _iteratorError5}}}}}}// Drag Functions
},{key:"dragStart",value:function dragStart(e){var _this2=this;this.__dragging=e.target;this.__dragging.className+=" hold";setTimeout(function(){return _this2.__dragging.className="invisible"},0);e.stopPropagation();e.stopImmediatePropagation()}},{key:"dragEnd",value:function dragEnd(e){this.__dragging.className="fill"}},{key:"dragOver",value:function dragOver(e){e.preventDefault()}},{key:"dragEnter",value:function dragEnter(e){e.preventDefault();e.target.className+=" hovered"}},{key:"dragLeave",value:function dragLeave(e){e.target.className="empty"}},{key:"dragDrop",value:function dragDrop(e){e.target.className="empty";e.target.appendChild(this.__dragging)}},{key:"editing",get:function get(){this.getAttribute("editing")},set:function set(val){if(!val){this.removeAttribute("editing")}else{this.setAttribute("editing",val)}}}],[{key:"observedAttributes",get:function get(){return["editing"]}}]);return DragNDrop}(babelHelpers.wrapNativeSuper(HTMLElement));_exports.DragNDrop=DragNDrop;window.customElements.define(DragNDrop.tag,DragNDrop)});