define(["exports","meta","../../lit-element/lit-element.js","../es-global-bridge/es-global-bridge.js","./lib/md5.min.js"],function(_exports,meta,_litElement,_esGlobalBridge,md5){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.PaperAvatar=void 0;meta=babelHelpers.interopRequireWildcard(meta);md5=babelHelpers.interopRequireWildcard(md5);function _templateObject3_25c5b7205fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n        :host {\n          --paper-avatar-width: 40px;\n          display: inline-block;\n          box-sizing: border-box;\n          position: relative;\n          width: var(--paper-avatar-width);\n          height: var(--paper-avatar-width);\n          border-radius: 50%;\n          cursor: default;\n          background-color: var(\n            --paper-avatar-color,\n            var(--paper-avatar-bgcolor)\n          );\n          -webkit-user-select: none;\n          -moz-user-select: none;\n          -ms-user-select: none;\n          user-select: none;\n        }\n\n        :host > * {\n          pointer-events: none;\n        }\n        img {\n          width: var(--paper-avatar-width);\n          height: var(--paper-avatar-width);\n        }\n        #label,\n        #img,\n        #jdenticon {\n          position: absolute;\n          top: 0;\n          left: 0;\n          right: 0;\n          bottom: 0;\n          width: 100%;\n          height: 100%;\n          border-radius: 50%;\n        }\n        #label {\n          overflow: hidden;\n          display: -ms-flexbox;\n          display: -webkit-flex;\n          display: flex;\n          -webkit-flex-direction: row;\n          -ms-flex-direction: row;\n          flex-direction: row;\n          -webkit-align-items: center;\n          -ms-flex-align: center;\n          align-items: center;\n        }\n        #label span {\n          display: block;\n          width: 100%;\n          font-weight: 400;\n          color: var(--paper-avatar-text-color, rgba(255, 255, 255, 0.8));\n          text-transform: capitalize;\n          font-family: \"Roboto\", \"Noto\", sans-serif;\n          -webkit-font-smoothing: antialiased;\n          text-align: center;\n          font-size: calc(var(--paper-avatar-width) / 1.65);\n        }\n        #jdenticon {\n          width: var(--paper-avatar-width);\n          height: var(--paper-avatar-width);\n        }\n        #jdenticon * {\n          fill: var(\n            --paper-avatar-text-color,\n            rgba(255, 255, 255, 0.8)\n          ) !important;\n        }\n      "]);_templateObject3_25c5b7205fe711ea9416fd1a737b18eb=function _templateObject3_25c5b7205fe711ea9416fd1a737b18eb(){return data};return data}function _templateObject2_25c5b7205fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n            <img\n              id=\"img\"\n              loading=\"lazy\"\n              src=\"","\"\n              title=\"","\"\n              @load=\"","\"\n              @error=\"","\"\n              alt=\"\"\n            />\n          "]);_templateObject2_25c5b7205fe711ea9416fd1a737b18eb=function _templateObject2_25c5b7205fe711ea9416fd1a737b18eb(){return data};return data}function _templateObject_25c5b7205fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n      <div id=\"label\" title=\"","\">\n        <span>","</span>\n      </div>\n      <svg id=\"jdenticon\" width=\"40\" height=\"40\"><slot></slot></svg>\n      ","\n    "]);_templateObject_25c5b7205fe711ea9416fd1a737b18eb=function _templateObject_25c5b7205fe711ea9416fd1a737b18eb(){return data};return data}/**
`paper-avatar`
User avatar in material style

### Styling

To change the background color:

    paper-avatar {
      --paper-avatar-color: red;
    }
	
To change the size of the avatar:

    paper-avatar {
      --paper-avatar-width: 60px;
    }

Custom property | Description | Default
----------------|-------------|----------
`--paper-avatar-width` | Size (width and height) of the avatar image | `40px`
`--paper-avatar-color` | Background color of the avatar image | 


* @demo demo/index.html 
*/var PaperAvatar=/*#__PURE__*/function(_LitElement){babelHelpers.inherits(PaperAvatar,_LitElement);babelHelpers.createClass(PaperAvatar,[{key:"render",/**
   * LitElement render method
   */value:function render(){return(0,_litElement.html)(_templateObject_25c5b7205fe711ea9416fd1a737b18eb(),this.label,this._label(this.label),this.src?(0,_litElement.html)(_templateObject2_25c5b7205fe711ea9416fd1a737b18eb(),this.src,this.label,this._onImgLoad,this._onImgError):"")}/**
   * HTMLElement specification
   */}],[{key:"styles",/**
   * LitElement style method
   */get:function get(){return[(0,_litElement.css)(_templateObject3_25c5b7205fe711ea9416fd1a737b18eb())]}/**
   * A convention our team uses
   */},{key:"tag",get:function get(){return"paper-avatar"}}]);function PaperAvatar(){var _this;babelHelpers.classCallCheck(this,PaperAvatar);_this=babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(PaperAvatar).call(this));_this.label=null;_this.src=null;_this.jdenticonExists=!1;_this.twoChars=!1;_this.jdenticon=!1;return _this}/**
   * LitElement specific property update life cycle
   */babelHelpers.createClass(PaperAvatar,[{key:"updated",value:function updated(changedProperties){var _this2=this;changedProperties.forEach(function(oldValue,propName){if("label"==propName){_this2._observerLabel(_this2[propName])}})}/**
   * LitElement / popular library convention
   */},{key:"_observerLabel",/**
   * Generate the correct label from change with optional jdenticon md5 hash
   */value:function _observerLabel(label){if(label){if(this.jdenticonExists&&this.jdenticon){this.shadowRoot.querySelector("#label").hidden=!0;window.jdenticon.config={lightness:{color:[1,1],grayscale:[1,1]},saturation:1};window.jdenticon.update(this.shadowRoot.querySelector("#jdenticon"),window.md5(label))}this.style.backgroundColor=this._parseColor(label)}}// simple path from a url modifier
},{key:"pathFromUrl",value:function pathFromUrl(url){return url.substring(0,url.lastIndexOf("/")+1)}/**
   * LitElement life cycle - shadowDom / properties mapped
   */},{key:"firstUpdated",value:function firstUpdated(changedProperties){var basePath=this.pathFromUrl(decodeURIComponent(meta.url)),location="".concat(basePath,"lib/jdenticon-1.4.0.min.js");window.addEventListener("es-bridge-jdenticon-loaded",this._jdenticonLoaded.bind(this));window.ESGlobalBridge.requestAvailability();window.ESGlobalBridge.instance.load("jdenticon",location)}/**
   * HTMLElement life cycle
   */},{key:"disconnectedCallback",value:function disconnectedCallback(){window.removeEventListener("es-bridge-jdenticon-loaded",this._jdenticonLoaded.bind(this));babelHelpers.get(babelHelpers.getPrototypeOf(PaperAvatar.prototype),"disconnectedCallback",this).call(this)}/**
   * Callback once we know that the jdenticon library is globally loaded.
   */},{key:"_jdenticonLoaded",value:function _jdenticonLoaded(e){this.jdenticonExists=!0;this._observerLabel(this.label)}/**
   * convert label in context
   */},{key:"_label",value:function _label(label){if(!label)return"";if(this.twoChars){if(-1<this.label.indexOf(" ")){var matches=this.label.match(/\b(\w)/g);return matches[0]+matches[1]}else{return label.substring(0,2)}}return label.charAt(0)}},{key:"_onImgLoad",value:function _onImgLoad(e){e.currentTarget.hidden=!1}},{key:"_onImgError",value:function _onImgError(e){e.currentTarget.hidden=!0}},{key:"_parseColor",value:function _parseColor(label){for(var colors=this.colors?this.colors:["#F44336","#E91E63","#9C27B0","#673AB7","#3F51B5","#2196F3","#03A9F4","#00BCD4","#795548","#009688","#4CAF50","#8BC34A","#CDDC39","#FFEB3B","#FFC107","#FF9800","#FF5722","#9E9E9E","#607D8B"],hash=0,a=0;a<label.length;a++){hash+=label.charCodeAt(a)<<5}if(hash>=colors.length)return colors[hash%colors.length];return colors[hash]}}],[{key:"properties",get:function get(){return{/**
       * Image address or base64
       */src:{type:String},/**
       *	Label with username
       */label:{type:String},/**
       * Ensure we can support jdenticon before invoking it
       */jdenticonExists:{type:Boolean},/**
       * Show two chars in avatar
       */twoChars:{type:Boolean,attribute:"two-chars"},/**
       * Array of colors for avatar background
       */colors:{type:Array},/**
       * Set true if you want use a jdenticon avatar
       */jdenticon:{type:Boolean}}}}]);return PaperAvatar}(_litElement.LitElement);_exports.PaperAvatar=PaperAvatar;window.customElements.define(PaperAvatar.tag,PaperAvatar)});