define(["exports","../../../../@polymer/polymer/polymer-element.js","./rich-text-editor-button.js","../../../simple-picker/simple-picker.js","../../../es-global-bridge/es-global-bridge.js"],function(_exports,_polymerElement,_richTextEditorButton,_simplePicker,_esGlobalBridge){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.RichTextEditorPicker=void 0;function _templateObject_33798ef05fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n      <style include=\"rich-text-editor-button-styles\">\n        :host {\n          margin: 0 var(--rich-text-editor-button-margin);\n        }\n        :host simple-picker {\n          --simple-picker-border-radius: 0px;\n          --simple-picker-color: var(--rich-text-editor-button-color);\n          --simple-picker-color-active: var(\n            --rich-text-editor-button-hover-color\n          );\n          --simple-picker-color-disabled: var(--rich-text-editor-border-color);\n          --simple-picker-background-color: var(--rich-text-editor-bg);\n          --simple-picker-background-color-disabled: var(\n            --rich-text-editor-border-color\n          );\n          --simple-picker-border-width: 0px;\n          --simple-picker-option-size: 18px;\n          --simple-picker-options-border-width: 1px;\n        }\n      </style>\n      <simple-picker\n        id=\"button\"\n        allow-null$=\"[[allowNull]]\"\n        class=\"rtebutton\"\n        disabled$=\"[[super.disabled]]\"\n        controls$=\"[[super.controls]]\"\n        on-change=\"_pickerChange\"\n        tabindex=\"0\"\n        title-as-html$=\"[[titleAsHtml]]\"\n        options=\"[[options]]\"\n        value=\"{{value}}\"\n      >\n        <span id=\"label\" class$=\"[[super.labelStyle]]\">[[__label]]</span>\n      </simple-picker>\n      <simple-tooltip id=\"tooltip\" for=\"button\">[[__label]]</simple-tooltip>\n    "]);_templateObject_33798ef05fe711ea9416fd1a737b18eb=function _templateObject_33798ef05fe711ea9416fd1a737b18eb(){return data};return data}/**
 * `rich-text-editor-picker`
 * `a picker for rich text editor (custom buttons can extend this)`
 *
 * @microcopy - language worth noting:
 *  -
 *

 * @polymer
 */var RichTextEditorPicker=/*#__PURE__*/function(_RichTextEditorButton){babelHelpers.inherits(RichTextEditorPicker,_RichTextEditorButton);function RichTextEditorPicker(){var _this;babelHelpers.classCallCheck(this,RichTextEditorPicker);_this=babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(RichTextEditorPicker).call(this));_this.label="Insert link";return _this}// render function
babelHelpers.createClass(RichTextEditorPicker,[{key:"_isToggled",/**
   * determines the value of the picker based on the selected range
   *
   * @param {object} the text selected range
   * @returns {boolean} whether the button is toggled
   *
   */value:function _isToggled(range){var _ref,selectors=this.options?(_ref=[]).concat.apply(_ref,babelHelpers.toConsumableArray(this.options))//flatten th eoptions array
.map(function(option){return option.value})//get all the values
.filter(//remove the empty values
function(option){return null!==option&&""!==option}//stringify the list
).join(","):null,//get the selected range parent
parent=null!==range&&range.commonAncestorContainer?range.commonAncestorContainer.parentNode:null;this.shadowRoot.querySelector("#button").value="formatBlock"===this.command&&selectors&&parent&&null!==parent.closest(selectors)?parent.closest(selectors).tagName.toLowerCase():null;return!1}/**
   * Handles default options loaded from an external js file
   */},{key:"_setOptions",value:function _setOptions(){this.set("options",this._getPickerOptions(data,this.allowNull,this.icon))}/**
   * Picker change
   */},{key:"_pickerChange",value:function _pickerChange(e){var val=this.shadowRoot.querySelector("#button").value;console.log("_pickerChange",this.shadowRoot.querySelector("#button").value);e.preventDefault();if(null!==val&&this.range!==void 0&&null!==this.range){this.commandVal=this.shadowRoot.querySelector("#button").value;console.log("commandVal",this.commandVal);this.doTextOperation();if(!0!==this.block){this.shadowRoot.querySelector("#button").value=null;this.dispatchEvent(new CustomEvent("deselect",{detail:this}))}}}/**
   * Converts option data to picker option data;
   * can be overridden in extended elements
   *
   * @param {object} data about the option
   * @returns {object} picker dato for the option
   */},{key:"_getOptionData",value:function _getOptionData(option){return{alt:option.alt,icon:option.icon,style:option.style,value:option.value}}/**
   * gets a list of icons and load them in a format
   * that the simple-picker can take;
   * if no icons are provided, loads a list from iron-meta
   *
   * @param {array} a list of custom icons for the picker
   * @param {array} default list of icons for the picker
   * @param {boolean} allow a null value for the picker
   */},{key:"_getPickerOptions",value:function _getPickerOptions(){for(var options=0<arguments.length&&arguments[0]!==void 0?arguments[0]:[],allowNull=1<arguments.length&&arguments[1]!==void 0?arguments[1]:!1,icon=2<arguments.length&&arguments[2]!==void 0?arguments[2]:null,items=[],cols=11>Math.sqrt(options.length)?Math.ceil(Math.sqrt(options.length)):10,i=0;i<options.length;i++){var row=Math.floor(i/cols),col=i-row*cols,_data=this._getOptionData(options[i]);if(items[row]===void 0||null===items[row])items[row]=[];items[row][col]=_data}return items}}],[{key:"template",get:function get(){return(0,_polymerElement.html)(_templateObject_33798ef05fe711ea9416fd1a737b18eb())}// properties available to the custom element for data binding
},{key:"properties",get:function get(){return{/**
       * Allow a null option to be selected?
       */allowNull:{name:"allowNull",type:Boolean,value:!1},/**
       * The command used for document.execCommand.
       */command:{name:"command",type:String,value:"insertHTML"},/**
       * Optional icon for null value
       */icon:{name:"icon",type:String,value:null},/**
       * The command used for document.execCommand.
       */options:{name:"options",type:Array,value:[],notify:!0},/**
       * Renders html as title. (Good for titles with HTML in them.)
       */titleAsHtml:{name:"titleAsHtml",type:Boolean,value:!1},/**
       * The value
       */value:{name:"value",type:Object,value:null}}}/**
   * Store the tag name to make it easier to obtain directly.
   */},{key:"tag",get:function get(){return"rich-text-editor-picker"}}]);return RichTextEditorPicker}(_richTextEditorButton.RichTextEditorButton);_exports.RichTextEditorPicker=RichTextEditorPicker;window.customElements.define(RichTextEditorPicker.tag,RichTextEditorPicker)});