define(["exports","../../lit-element/lit-element.js","./lib/date.format.js"],function(_exports,_litElement,_dateFormat){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.SimpleDatetime=void 0;function _templateObject2_2964afd05fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          font-size: 14px;\n          color: #b3b3b1;\n          line-height: 30px;\n        }\n      "]);_templateObject2_2964afd05fe711ea9416fd1a737b18eb=function _templateObject2_2964afd05fe711ea9416fd1a737b18eb(){return data};return data}function _templateObject_2964afd05fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n      <time datetime=\"","\">","</time>\n    "]);_templateObject_2964afd05fe711ea9416fd1a737b18eb=function _templateObject_2964afd05fe711ea9416fd1a737b18eb(){return data};return data}/**
 * `simple-datetime`
 * @customElement simple-datetime
 * A simple datetime element that takes in unix timestamp and outputs a date.
 * @demo demo/index.html
 * @microcopy - the mental model for this element
 * - passing in a timestamp from unix and having it be php based date formatting to render is super helpful
 */var SimpleDatetime=/*#__PURE__*/function(_LitElement){babelHelpers.inherits(SimpleDatetime,_LitElement);/**
   * HTMLElement life cycle
   */function SimpleDatetime(){var _this;babelHelpers.classCallCheck(this,SimpleDatetime);_this=babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(SimpleDatetime).call(this));_this.format="M jS, Y";_this.unix=!1;return _this}/**
   * LitElement constructable styles enhancement
   */babelHelpers.createClass(SimpleDatetime,[{key:"render",/**
   * LitElement life cycle - render callback
   */value:function render(){return(0,_litElement.html)(_templateObject_2964afd05fe711ea9416fd1a737b18eb(),this.date,this.date)}},{key:"updated",/**
   * LitElement life cycle - property changed callback
   */value:function updated(changedProperties){var _this2=this;changedProperties.forEach(function(oldValue,propName){if(["timestamp","format","unix"].includes(propName)){_this2.date=_this2.formatDate(_this2.timestamp,_this2.format,_this2.unix)}})}/**
   * Figure out the date
   */},{key:"formatDate",value:function formatDate(timestamp,format,unix){// unix timestamp is seconds, JS is milliseconds
if(unix){timestamp=1e3*timestamp}return new Date(timestamp).format(format)}}],[{key:"styles",get:function get(){return[(0,_litElement.css)(_templateObject2_2964afd05fe711ea9416fd1a737b18eb())]}},{key:"tag",get:function get(){return"simple-datetime"}/**
   * LitElement life cycle -  properties definitions
   */},{key:"properties",get:function get(){return{/**
       * Javascript timestamp
       */timestamp:{type:Number},/**
       * Format to output, see https://github.com/jacwright/date.format#supported-identifiers
       */format:{type:String},/**
       * Date, generated from timestamp + format
       */date:{type:String},/**
       * Support for UNIX timestamp conversion on the fly
       */unix:{type:Boolean}}}}]);return SimpleDatetime}(_litElement.LitElement);_exports.SimpleDatetime=SimpleDatetime;window.customElements.define(SimpleDatetime.tag,SimpleDatetime)});