define(["exports","../../../lit-element/lit-element.js","../../../@polymer/paper-icon-button/paper-icon-button.js","../../../@polymer/paper-button/paper-button.js","../../../@polymer/iron-icons/iron-icons.js","../../simple-tooltip/simple-tooltip.js"],function(_exports,_litElement,_paperIconButton,_paperButton,_ironIcons,_simpleTooltip){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.SimpleFieldsArrayItem=void 0;function _templateObject2_320bce205fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          transition: all 0.5s;\n          border-radius: 3px;\n        }\n        :host([disabled]) {\n          opacity: 0.5;\n        }\n        :host([aria-expanded=\"true\"]) {\n          border: 1px solid #ddd;\n        }\n        :host(:focus-within) {\n          border: 1px solid #444;\n          z-index: 2;\n        }\n        *[aria-controls=\"content\"][disabled] {\n          cursor: not-allowed;\n        }\n        #drag-handle,\n        ::slotted([slot=\"sort\"]),\n        ::slotted([slot=\"preview\"]) {\n          flex: 0 1 auto;\n          margin: 0 15px;\n        }\n        ::slotted([slot=\"preview\"]) {\n          flex: 1 0 auto;\n        }\n        #heading,\n        .heading-inner {\n          display: flex;\n          justify-content: space-between;\n          align-items: center;\n        }\n        #content {\n          max-height: 0;\n          overflow: hidden;\n          transition: all 0.5s ease-in-out;\n        }\n        :host #content-inner {\n          overflow: hidden;\n          display: flex;\n          align-items: flex-end;\n          justify-content: space-between;\n        }\n        :host(:focus-within) #content,\n        :host([aria-expanded=\"true\"]) #content {\n          max-height: unset;\n          overflow: hidden;\n        }\n        :host(:focus-within) #content-inner,\n        :host([aria-expanded=\"true\"]) #content-inner {\n          overflow: unset;\n          margin: 0 15px;\n        }\n        #content-inner > * {\n          flex: 1 1 auto;\n        }\n        #remove {\n          flex: 0 0 auto;\n          color: #cc0000;\n          margin-right: -15px;\n        }\n      "]);_templateObject2_320bce205fe711ea9416fd1a737b18eb=function _templateObject2_320bce205fe711ea9416fd1a737b18eb(){return data};return data}function _templateObject_320bce205fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n      <div id=\"heading\">\n        <slot name=\"sort\"></slot>\n        <slot name=\"preview\"></slot>\n      </div>\n      <div id=\"content\">\n        <div id=\"content-inner\">\n          <div><slot></slot></div>\n          <paper-icon-button\n            id=\"remove\"\n            controls=\"","\"\n            icon=\"delete\"\n            label=\"Remove this item\"\n            ?disabled=\"","\"\n            @click=\"","\"\n          >\n          </paper-icon-button>\n          <simple-tooltip for=\"remove\">Remove this item</simple-tooltip>\n        </div>\n      </div>\n    "]);_templateObject_320bce205fe711ea9416fd1a737b18eb=function _templateObject_320bce205fe711ea9416fd1a737b18eb(){return data};return data}/**
 * `simple-fields-array-item`
 * an accessible expand collapse
 * 
### Styling

`<simple-fields-array-item>` provides the following custom properties
for styling:

Custom property | Description | Default
----------------|-------------|----------
`--simple-fields-array-item-margin` | margin around simple-fields-array-item | 15px 0
`--simple-fields-array-item-border` | border around simple-fields-array-item | 1px solid
`--simple-fields-array-item-horizontal-padding` | horizontal padding inside simple-fields-array-item | 16px
`--simple-fields-array-item-horizontal-padding-left` | left padding inside simple-fields-array-item | `--simple-fields-array-item-horizontal-padding`
`--simple-fields-array-item-horizontal-padding-right` | right padding inside simple-fields-array-item | `--simple-fields-array-item-horizontal-padding`
`--simple-fields-array-item-vertical-padding` | vertical padding inside simple-fields-array-item | 16px
`--simple-fields-array-item-horizontal-padding-top` | top padding inside simple-fields-array-item | `--simple-fields-array-item-vertical-padding`
`--simple-fields-array-item-horizontal-padding-bottom` | bottom padding inside simple-fields-array-item | --simple-fields-array-item-vertical-padding
`--simple-fields-array-item-border-between` | border between simple-fields-array-item heading and content | --simple-fields-array-item-border
`--simple-fields-array-item-heading-font-weight` | font-weight for simple-fields-array-item heading | bold
`--simple-fields-array-item-heading-color` | text color for simple-fields-array-item heading | unset
`--simple-fields-array-item-heading-background-color` | background-color for simple-fields-array-item heading | unset
 *
 * @customElement simple-fields-array-item
 * @demo ./demo/index.html demo
 * @demo ./demo/group.html collapse groups
 */var SimpleFieldsArrayItem=/*#__PURE__*/function(_LitElement){babelHelpers.inherits(SimpleFieldsArrayItem,_LitElement);babelHelpers.createClass(SimpleFieldsArrayItem,[{key:"render",value:function render(){var _this2=this;return(0,_litElement.html)(_templateObject_320bce205fe711ea9416fd1a737b18eb(),this.id,this.disabled,function(e){return _this2._handleRemove()})}}],[{key:"styles",get:function get(){return[(0,_litElement.css)(_templateObject2_320bce205fe711ea9416fd1a737b18eb())]}},{key:"tag",get:function get(){return"simple-fields-array-item"}},{key:"properties",get:function get(){return{/**
       * is disabled?
       */disabled:{type:Boolean,reflect:!0}}}}]);function SimpleFieldsArrayItem(){var _this;babelHelpers.classCallCheck(this,SimpleFieldsArrayItem);_this=babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(SimpleFieldsArrayItem).call(this));_this.disabled=!1;return _this}babelHelpers.createClass(SimpleFieldsArrayItem,[{key:"connectedCallback",value:function connectedCallback(){var _this3=this;babelHelpers.get(babelHelpers.getPrototypeOf(SimpleFieldsArrayItem.prototype),"connectedCallback",this).call(this);setTimeout(function(){/**
       * Fires when constructed, so that parent radio group can listen for it.
       *
       * @event add-item
       */_this3.dispatchEvent(new CustomEvent("added",{bubbles:!0,cancelable:!0,composed:!0,detail:_this3}))},0)}/**
   * Fires add event
   * @event add
   */},{key:"_handleRemove",value:function _handleRemove(){this.dispatchEvent(new CustomEvent("remove",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}/**
   * Let the group know that this is gone.
   */},{key:"disconnectedCallback",value:function disconnectedCallback(){/**
     * Fires when detatched, so that parent radio group will no longer listen for it.
     *
     * @event remoive-item
     */this.dispatchEvent(new CustomEvent("removed",{bubbles:!0,cancelable:!0,composed:!0,detail:this}));babelHelpers.get(babelHelpers.getPrototypeOf(SimpleFieldsArrayItem.prototype),"disconnectedCallback",this).call(this)}}]);return SimpleFieldsArrayItem}(_litElement.LitElement);_exports.SimpleFieldsArrayItem=SimpleFieldsArrayItem;window.customElements.define(SimpleFieldsArrayItem.tag,SimpleFieldsArrayItem)});