define(["exports","../../lit-element/lit-element.js","../../@polymer/iron-icons/iron-icons.js","../../@polymer/paper-input/paper-input.js","../simple-tooltip/simple-tooltip.js","./lib/simple-search-content.js","./lib/simple-search-match.js"],function(_exports,_litElement,_ironIcons,_paperInput,_simpleTooltip,_simpleSearchContent,_simpleSearchMatch){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.SimpleSearch=void 0;function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable});keys.push.apply(keys,symbols)}return keys}function _objectSpread(target){for(var i=1,source;i<arguments.length;i++){source=null!=arguments[i]?arguments[i]:{};if(i%2){ownKeys(Object(source),!0).forEach(function(key){babelHelpers.defineProperty(target,key,source[key])})}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source))}else{ownKeys(Object(source)).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))})}}return target}function _templateObject2_29e68a005fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: flex;\n          align-items: flex-end;\n          justify-content: space-between;\n          width: 100%;\n        }\n        #input {\n          flex-grow: 2;\n          margin-right: 4px;\n          padding: var(--simple-search-padding, unset);\n          margin: var(--simple-search-margin, unset);\n          --paper-input-container-input-color: var(\n            --simple-search-input-text-color,\n            #000\n          );\n          --paper-input-container-shared-input-style_-_color: var(\n            --simple-search-input-text-color,\n            #000\n          );\n          --paper-input-container-focus-color: var(\n            --simple-search-input-line-color,\n            #000\n          );\n          --paper-input-container-color: var(\n            --simple-search-input-placeholder-color,\n            #222\n          );\n          color: var(--simple-search-input-placeholder-color, #222);\n        }\n        #xofy {\n          margin: 8px;\n        }\n        button {\n          margin: 8px 0 8px;\n          color: var(--simple-search-button-color, #111);\n          background-color: var(--simple-search-button-bg-color, #eee);\n          border-color: var(--simple-search-button-border-color, #ccc);\n        }\n        button:not([disabled]):focus,\n        button:not([disabled]):hover {\n          cursor: pointer;\n          color: var(--simple-search-button-hover-color, #000);\n          background-color: var(--simple-search-button-hover-bg-color, #fff);\n          border-color: var(--simple-search-button-hover-border-color, #ddd);\n        }\n        button[disabled] {\n          cursor: not-allowed;\n          color: var(--simple-search-button-disabled-color, #999);\n          background-color: var(--simple-search-button-disabled-bg-color, #eee);\n          border-color: var(--simple-search-button-disabled-border-color, #ccc);\n        }\n        button:not([controls]) {\n          display: none;\n        }\n        *[shrink-hide] {\n          display: none;\n        }\n      "]);_templateObject2_29e68a005fe711ea9416fd1a737b18eb=function _templateObject2_29e68a005fe711ea9416fd1a737b18eb(){return data};return data}function _templateObject_29e68a005fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n      <paper-input\n        id=\"input\"\n        label=\"","\"\n        ?always-float-label=\"","\"\n        ?no-label-float=\"","\"\n        @change=\"","\"\n      >\n        <iron-icon icon=\"","\" slot=\"prefix\"></iron-icon>\n      </paper-input>\n      <div id=\"xofy\" ?shrink-hide=\"","\">\n        ","\n      </div>\n      <div ?shrink-hide=\"","\">\n        <button\n          id=\"prev\"\n          aria-label=\"","\"\n          aria-role=\"button\"\n          controls=\"","\"\n          tabindex=\"0\"\n          ?disabled=\"","\"\n          @click=\"","\"\n        >\n          <iron-icon icon=\"","\"></iron-icon>\n        </button>\n        <simple-tooltip for=\"prev\">","</simple-tooltip>\n        <button\n          id=\"next\"\n          aria-label=\"","\"\n          aria-role=\"button\"\n          controls=\"","\"\n          tabindex=\"0\"\n          ?disabled=\"","\"\n          @click=\"","\"\n        >\n          <iron-icon icon=\"","\"></iron-icon>\n        </button>\n        <simple-tooltip for=\"next\">","</simple-tooltip>\n      </div>\n    "]);_templateObject_29e68a005fe711ea9416fd1a737b18eb=function _templateObject_29e68a005fe711ea9416fd1a737b18eb(){return data};return data}/**
 * `simple-search`
 * @customElement simple-search
 * a button used in simple-search
 * 
### Styling

`<simple-search>` provides the following custom properties
for styling:

Custom property | Description | Default
----------------|-------------|----------
`--simple-search-button-color` | text color for button | #111
`--simple-search-button-bg-color` | background-color for button | #eee
`--simple-search-button-border-color` | border-color for button | #ccc
`--simple-search-button-disabled-color` | background-color for disabled seach button | #999
`--simple-search-button-disabled-bg-color` | text color for disabled seach button | #eee
`--simple-search-button-disabled-border-color` | border-color for disabled seach button | #ccc
`--simple-search-button-hover-color` | text color for button when hovered or focused | #000
`--simple-search-button-hover-bg-color` | background-color for button when hovered or focused | #fff
`--simple-search-button-hover-border-color` | border-color for button when hovered or focused | #ddd
`--simple-search-input-placeholder-color` | text-color for search input's placeholder | #222
`--simple-search-container-padding` | search input's padding | unset
`--simple-search-margin` | search input's margin | unset
 *

 * @demo ./demo/index.html
 * @demo ./demo/selector.html Searching by CSS selectors
 *
 */var SimpleSearch=/*#__PURE__*/function(_LitElement){babelHelpers.inherits(SimpleSearch,_LitElement);babelHelpers.createClass(SimpleSearch,[{key:"render",// render function
value:function render(){return(0,_litElement.html)(_templateObject_29e68a005fe711ea9416fd1a737b18eb(),this.searchInputLabel,this.alwaysFloatLabel,this.noLabelFloat,this._handleChange,this.searchInputIcon,this._hasNoSearch(this.searchTerms),this._getResultsSpan(this.resultPointer,this.resultCount),this._hasNoSearch(this.searchTerms),this.prevButtonLabel,this.controls,this.__hidePrev,this._navigateResults,this.prevButtonIcon,this.prevButtonLabel,this.nextButtonLabel,this.controls,this.__hideNext,this._navigateResults,this.nextButtonIcon,this.nextButtonLabel)}// properties available to the custom element for data binding
}],[{key:"styles",//styles function
get:function get(){return[(0,_litElement.css)(_templateObject2_29e68a005fe711ea9416fd1a737b18eb())]}},{key:"properties",get:function get(){return _objectSpread({},babelHelpers.get(babelHelpers.getPrototypeOf(SimpleSearch),"properties",this),{/**
       * always float the label
       */alwaysFloatLabel:{attribute:"always-float-label",type:Boolean},/**
       * Is the search case-sensitive
       */caseSensitive:{attribute:"case-sensitive",type:Boolean},/**
       * The id of the container element that the navigation buttons control
       */controls:{attribute:"controls",type:String},/**
       * label for next result icon
       */nextButtonIcon:{attribute:"next-button-icon",type:String},/**
       * label for next result button
       */nextButtonLabel:{attribute:"next-button-label",type:String},/**
       * never float the label
       */noLabelFloat:{attribute:"no-label-float",type:Boolean},/**
       * label for previous result icon
       */prevButtonIcon:{attribute:"prev-button-icon",type:String},/**
       * label for previous result button
       */prevButtonLabel:{attribute:"prev-button-label",type:String},/**
       * Number of results.
       */resultCount:{attribute:"result-count",type:Number},/**
       * Which result are we currently on?
       */resultPointer:{attribute:"result-pointer",type:Number},/**
       * limits search to within target's elements that match a selectgor
       */selector:{attribute:"selector",type:String},/**
       * label for search icon
       */searchInputIcon:{attribute:"search-input-icon",type:String},/**
       * label for search input
       */searchInputLabel:{attribute:"search-input-label",type:String},/**
       * an array of search terms
       */searchTerms:{attribute:"search-terms",type:Array},/**
       * If set, search will be automated and restricted to this object.
       */target:{type:Object},/**
       * Hide next button
       */__hideNext:{type:Boolean},/**
       * Hide prev button
       */__hidePrev:{type:Boolean}})}},{key:"tag",get:function get(){return"simple-search"}}]);function SimpleSearch(){var _this;babelHelpers.classCallCheck(this,SimpleSearch);_this=babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(SimpleSearch).call(this));_this.alwaysFloatLabel=!1;_this.caseSensitive=null;_this.controls=null;_this.nextButtonIcon="arrow-forward";_this.nextButtonLabel="next result";_this.noLabelFloat=!1;_this.prevButtonIcon="arrow-back";_this.prevButtonLabel="previous result";_this.resultCount=0;_this.resultPointer=0;_this.searchInputIcon="search";_this.searchInputLabel="search";_this.searchTerms=[];_this.target=null;_this.selector=null;_this.__hideNext=!0;_this.__hidePrev=!0;return _this}babelHelpers.createClass(SimpleSearch,[{key:"updated",value:function updated(changedProperties){var _this2=this;changedProperties.forEach(function(oldValue,propName){if("resultPointer"===propName||"resultCount"===propName)_this2._getNavDisabled(_this2.resultPointer,_this2.resultCount)})}/**
   * are there any results to navigate?
   */},{key:"_handleChange",value:function _handleChange(e){var _this3=this,selector=this.selector?" ".concat(this.selector):"",selections=this.controls?this.getRootNode().querySelectorAll("#".concat(this.controls).concat(selector)):null;console.log(this.controls,selections,this.getRootNode());this._getSearchText();this.resultCount=0;this.resultPointer=0;selections.forEach(function(selection){_this3._searchSelection(selection)});/**
     * Fires when search changes (detail = { search: this, content: event })
     *
     * @event simple-search
     */this.dispatchEvent(new CustomEvent("simple-search",{detail:{search:this,content:e}}))}},{key:"_searchSelection",value:function _searchSelection(selection){if(selection&&selection.innerHTML)selection.innerHTML=this.findMatches(selection.innerHTML)}/**
   * are there any results to navigate?
   *
   * @param {array} array of search terms
   * @returns {boolean} whether or not there are search terms
   */},{key:"_hasNoSearch",value:function _hasNoSearch(terms){return 1>terms.length}/**
   * get results span text
   *
   * @param {boolean} whether or not there are search terms
   * @param {number} the current search result's position
   * @param {number} the total number of search results
   * @returns {string} "y results" or "x/y" text
   */},{key:"_getResultsSpan",value:function _getResultsSpan(pointer,count){return 0<count&&0<pointer?pointer+"/"+count:0<count?count:"0"}/**
   * navigate results
   */},{key:"_navigateResults",value:function _navigateResults(e){var increment="next"===e.currentTarget.id?1:-1;if(0<this.resultPointer+increment&&this.resultPointer+increment<=this.resultCount){this.resultPointer+=increment;this.dispatchEvent(new CustomEvent("goto-result",{detail:this.resultPointer}))}}},{key:"_getNavDisabled",value:function _getNavDisabled(pointer,count){this.__hidePrev=this._isNavButtonDisabled(pointer,count,-1);this.__hideNext=this._isNavButtonDisabled(pointer,count)}/**
   * navigate results
   */},{key:"_isNavButtonDisabled",value:function _isNavButtonDisabled(pointer,count){var inc=2<arguments.length&&arguments[2]!==void 0?arguments[2]:1;return!count||0===count||0>=pointer+inc||pointer+inc>count}/**
   * gets the tab-index of cues based on whether or not interactive cues are disabled
   *
   * @param {string} a string of search text
   */},{key:"_getSearchText",value:function _getSearchText(){var find=this.shadowRoot.querySelector("#input").value,temp=[];if(find!==void 0&&null!==find){temp=find.split(/[\"\']/gm);for(var i=0;i<temp.length;i++){temp[i]=temp[i].trim();if(""===temp[i])temp.splice(i,1)}}//this.searchTerms = [];
this.searchTerms=temp.slice(0)}/**
   * search a string of content for any terms and return an array of results.
   * For example if I searched for the with
   * `findMatches("The quick brown fox jumps over the lazy dog.")`,
   * the array would be:
   * ```[
   *   {
   *     "matched": true,
   *     "matchNumber": 1,
   *     "text": "The",
   *     "searchObject": root
   *   },{
   *     "matched": false,
   *     "text": " quick brown fox jumps over ",
   *     "searchObject": root
   *   },{
   *     "matched": true,
   *     "matchNumber": 2,
   *     "text": "the",
   *     "searchObject": root
   *   },{
   *     "matched": false,
   *     "text": " lazy dog.",
   *     "searchObject": root
   *   }
   * ]```
   *
   * or `findMatches("The quick brown fox jumps over the lazy dog.",true)`,
   * the array would be:
   * ```[
   *   {
   *     "matched": false,
   *     "text": "The quick brown fox jumps over ",
   *     "searchObject": root
   *   },{
   *     "matched": true,
   *     "matchNumber": 1,
   *     "text": "the",
   *     "searchObject": root
   *   },{
   *     "matched": false,
   *     "text": " lazy dog.",
   *     "searchObject": root
   *   }
   * ]```
   *
   * @param {array} an array of search terms
   * @returns {array} an array of search results
   */},{key:"findMatches",value:function findMatches(results){var _this4=this;this.resultPointer=0;results=results.replace(/<\/?simple-search-match[^>]*>/g,"");this.searchTerms.forEach(function(term){var modifier=_this4.caseSensitive?"gm":"gim",regex=new RegExp("\\b("+term+")\\b",modifier),replacer=function replacer(match){_this4.resultCount++;return"<simple-search-match tabindex=\"0\" match-number=\"".concat(_this4.resultCount,"\">").concat(match,"</simple-search-match>")};results=results.replace(regex,replacer)});return results}}]);return SimpleSearch}(_litElement.LitElement);_exports.SimpleSearch=SimpleSearch;customElements.define(SimpleSearch.tag,SimpleSearch)});