define(["exports","../../../@polymer/polymer/polymer-legacy.js","./vaadin-grid-column.js","../../vaadin-checkbox/src/vaadin-checkbox.js","../../../@polymer/polymer/lib/utils/html-tag.js"],function(_exports,_polymerLegacy,_vaadinGridColumn,_vaadinCheckbox,_htmlTag){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.GridSelectionColumnElement=void 0;function _templateObject_42277e305fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n    <template class=\"header\" id=\"defaultHeaderTemplate\">\n      <vaadin-checkbox class=\"vaadin-grid-select-all-checkbox\" aria-label=\"Select All\" hidden$=\"[[_selectAllHidden]]\" on-checked-changed=\"_onSelectAllCheckedChanged\" checked=\"[[_isChecked(selectAll, _indeterminate)]]\" indeterminate=\"[[_indeterminate]]\"></vaadin-checkbox>\n    </template>\n    <template id=\"defaultBodyTemplate\">\n      <vaadin-checkbox aria-label=\"Select Row\" checked=\"{{selected}}\"></vaadin-checkbox>\n    </template>\n"],["\n    <template class=\"header\" id=\"defaultHeaderTemplate\">\n      <vaadin-checkbox class=\"vaadin-grid-select-all-checkbox\" aria-label=\"Select All\" hidden\\$=\"[[_selectAllHidden]]\" on-checked-changed=\"_onSelectAllCheckedChanged\" checked=\"[[_isChecked(selectAll, _indeterminate)]]\" indeterminate=\"[[_indeterminate]]\"></vaadin-checkbox>\n    </template>\n    <template id=\"defaultBodyTemplate\">\n      <vaadin-checkbox aria-label=\"Select Row\" checked=\"{{selected}}\"></vaadin-checkbox>\n    </template>\n"]);_templateObject_42277e305fe711ea9416fd1a737b18eb=function _templateObject_42277e305fe711ea9416fd1a737b18eb(){return data};return data}/**
 * `<vaadin-grid-selection-column>` is a helper element for the `<vaadin-grid>`
 * that provides default templates and functionality for item selection.
 *
 * #### Example:
 * ```html
 * <vaadin-grid items="[[items]]">
 *  <vaadin-grid-selection-column frozen auto-select></vaadin-grid-selection-column>
 *
 *  <vaadin-grid-column>
 *    ...
 * ```
 *
 * By default the selection column displays `<vaadin-checkbox>` elements in the
 * column cells. The checkboxes in the body rows toggle selection of the corresponding row items.
 *
 * When the grid data is provided as an array of [`items`](#/elements/vaadin-grid#property-items),
 * the column header gets an additional checkbox that can be used for toggling
 * selection for all the items at once.
 *
 * __The default content can also be overridden__
 *
 * @memberof Vaadin
 */var GridSelectionColumnElement=/*#__PURE__*/function(_GridColumnElement){babelHelpers.inherits(GridSelectionColumnElement,_GridColumnElement);babelHelpers.createClass(GridSelectionColumnElement,[{key:"_pathOrHeaderChanged",value:function _pathOrHeaderChanged(path,header,headerCell,footerCell,cells,renderer,headerRenderer,bodyTemplate,headerTemplate){// As a special case, allow overriding the default header / body templates
if(cells.value&&(path!==void 0||renderer!==void 0)){this._bodyTemplate=bodyTemplate=void 0;this.__cleanCellsOfTemplateProperties(cells.value)}if(headerCell&&(header!==void 0||headerRenderer!==void 0)){this._headerTemplate=headerTemplate=void 0;this.__cleanCellsOfTemplateProperties([headerCell])}babelHelpers.get(babelHelpers.getPrototypeOf(GridSelectionColumnElement.prototype),"_pathOrHeaderChanged",this).call(this,path,header,headerCell,footerCell,cells,renderer,headerRenderer,bodyTemplate,headerTemplate)}},{key:"__cleanCellsOfTemplateProperties",value:function __cleanCellsOfTemplateProperties(cells){cells.forEach(function(cell){cell._content.innerHTML="";delete cell._instance;delete cell._template})}},{key:"_prepareHeaderTemplate",value:function _prepareHeaderTemplate(){var headerTemplate=this._prepareTemplatizer(this._findTemplate(!0)||this.$.defaultHeaderTemplate);// needed to override the dataHost correctly in case internal template is used.
headerTemplate.templatizer.dataHost=headerTemplate===this.$.defaultHeaderTemplate?this:this.dataHost;return headerTemplate}},{key:"_prepareBodyTemplate",value:function _prepareBodyTemplate(){var template=this._prepareTemplatizer(this._findTemplate()||this.$.defaultBodyTemplate);// needed to override the dataHost correctly in case internal template is used.
template.templatizer.dataHost=template===this.$.defaultBodyTemplate?this:this.dataHost;return template}}],[{key:"template",get:function get(){return(0,_htmlTag.html)(_templateObject_42277e305fe711ea9416fd1a737b18eb())}},{key:"is",get:function get(){return"vaadin-grid-selection-column"}},{key:"properties",get:function get(){return{/**
       * Width of the cells for this column.
       */width:{type:String,value:"58px"},/**
       * Flex grow ratio for the cell widths. When set to 0, cell width is fixed.
       */flexGrow:{type:Number,value:0},/**
       * When true, all the items are selected.
       */selectAll:{type:Boolean,value:!1,notify:!0},/**
       * When true, the active gets automatically selected.
       */autoSelect:{type:Boolean,value:!1},_indeterminate:Boolean,/**
       * The previous state of activeItem. When activeItem turns to `null`,
       * previousActiveItem will have an Object with just unselected activeItem
       */_previousActiveItem:Object,_selectAllHidden:Boolean}}},{key:"observers",get:function get(){return["_onSelectAllChanged(selectAll)"]}}]);function GridSelectionColumnElement(){var _this;babelHelpers.classCallCheck(this,GridSelectionColumnElement);_this=babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(GridSelectionColumnElement).call(this));_this._boundOnActiveItemChanged=_this._onActiveItemChanged.bind(babelHelpers.assertThisInitialized(_this));_this._boundOnDataProviderChanged=_this._onDataProviderChanged.bind(babelHelpers.assertThisInitialized(_this));_this._boundOnSelectedItemsChanged=_this._onSelectedItemsChanged.bind(babelHelpers.assertThisInitialized(_this));return _this}/** @protected */babelHelpers.createClass(GridSelectionColumnElement,[{key:"disconnectedCallback",value:function disconnectedCallback(){this._grid.removeEventListener("active-item-changed",this._boundOnActiveItemChanged);this._grid.removeEventListener("data-provider-changed",this._boundOnDataProviderChanged);this._grid.removeEventListener("filter-changed",this._boundOnSelectedItemsChanged);this._grid.removeEventListener("selected-items-changed",this._boundOnSelectedItemsChanged);var isSafari=/^((?!chrome|android).)*safari/i.test(navigator.userAgent);if(isSafari&&window.ShadyDOM&&this.parentElement){// Detach might have beem caused by order change.
// Shady on safari doesn't restore isAttached so we'll need to do it manually.
var parent=this.parentElement,nextSibling=this.nextElementSibling;parent.removeChild(this);if(nextSibling){parent.insertBefore(this,nextSibling)}else{parent.appendChild(this)}}babelHelpers.get(babelHelpers.getPrototypeOf(GridSelectionColumnElement.prototype),"disconnectedCallback",this).call(this)}/** @protected */},{key:"connectedCallback",value:function connectedCallback(){babelHelpers.get(babelHelpers.getPrototypeOf(GridSelectionColumnElement.prototype),"connectedCallback",this).call(this);if(this._grid){this._grid.addEventListener("active-item-changed",this._boundOnActiveItemChanged);this._grid.addEventListener("data-provider-changed",this._boundOnDataProviderChanged);this._grid.addEventListener("filter-changed",this._boundOnSelectedItemsChanged);this._grid.addEventListener("selected-items-changed",this._boundOnSelectedItemsChanged)}}},{key:"_onSelectAllChanged",value:function _onSelectAllChanged(selectAll){if(selectAll===void 0||!this._grid){return}if(this._selectAllChangeLock){return}this._grid.selectedItems=selectAll&&Array.isArray(this._grid.items)?this._grid._filter(this._grid.items):[]}// Return true if array `a` contains all the items in `b`
// We need this when sorting or to preserve selection after filtering.
},{key:"_arrayContains",value:function _arrayContains(a,b){for(var i=0;a&&b&&b[i]&&0<=a.indexOf(b[i]);i++){;}// eslint-disable-line
return i==b.length}},{key:"_onSelectAllCheckedChanged",value:function _onSelectAllCheckedChanged(e){this.selectAll=this._indeterminate||e.target.checked}// iOS needs indeterminated + checked at the same time
},{key:"_isChecked",value:function _isChecked(selectAll,indeterminate){return indeterminate||selectAll}},{key:"_onActiveItemChanged",value:function _onActiveItemChanged(e){var activeItem=e.detail.value;if(this.autoSelect){var item=activeItem||this._previousActiveItem;if(item){this._grid._toggleItem(item)}}this._previousActiveItem=activeItem}},{key:"_onSelectedItemsChanged",value:function _onSelectedItemsChanged(e){this._selectAllChangeLock=!0;if(Array.isArray(this._grid.items)){if(!this._grid.selectedItems.length){this.selectAll=!1;this._indeterminate=!1}else if(this._arrayContains(this._grid.selectedItems,this._grid._filter(this._grid.items))){this.selectAll=!0;this._indeterminate=!1}else{this.selectAll=!1;this._indeterminate=!0}}this._selectAllChangeLock=!1}},{key:"_onDataProviderChanged",value:function _onDataProviderChanged(e){this._selectAllHidden=!Array.isArray(this._grid.items)}}]);return GridSelectionColumnElement}(_vaadinGridColumn.GridColumnElement);_exports.GridSelectionColumnElement=GridSelectionColumnElement;customElements.define(GridSelectionColumnElement.is,GridSelectionColumnElement)});