define(["exports","../../../@polymer/polymer/polymer-element.js","../../../@polymer/polymer/lib/elements/custom-style.js","./vaadin-text-field.js","../../../@polymer/polymer/lib/elements/dom-module.js"],function(_exports,_polymerElement,_customStyle,_vaadinTextField,_domModule){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.NumberFieldElement=void 0;/**
@license
Copyright (c) 2017 Vaadin Ltd.
This program is available under Apache License Version 2.0, available at https://vaadin.com/license/
*/var $_documentContainer=document.createElement("template");$_documentContainer.innerHTML="<dom-module id=\"vaadin-number-field-template\">\n  <template>\n    <style>\n      :host([readonly]) [part$=\"button\"] {\n        pointer-events: none;\n      }\n\n      [part=\"decrease-button\"]::before {\n        content: \"\u2212\";\n      }\n\n      [part=\"increase-button\"]::before {\n        content: \"+\";\n      }\n\n      [part=\"decrease-button\"],\n      [part=\"increase-button\"] {\n        -webkit-user-select: none;\n        -moz-user-select: none;\n        -ms-user-select: none;\n        user-select: none;\n      }\n\n      /* Hide the native arrow icons */\n      [part=\"value\"]::-webkit-outer-spin-button,\n      [part=\"value\"]::-webkit-inner-spin-button {\n        -webkit-appearance: none;\n        margin: 0;\n      }\n\n      [part=\"value\"] {\n        /* Older Firefox versions (v47.0) requires !important */\n        -moz-appearance: textfield !important;\n      }\n    </style>\n\n    <div disabled$=\"[[!_allowed(-1, value, min, max, step)]]\" part=\"decrease-button\" on-click=\"_decreaseValue\" on-touchend=\"_decreaseButtonTouchend\" hidden$=\"[[!hasControls]]\">\n    </div>\n\n    <div disabled$=\"[[!_allowed(1, value, min, max, step)]]\" part=\"increase-button\" on-click=\"_increaseValue\" on-touchend=\"_increaseButtonTouchend\" hidden$=\"[[!hasControls]]\">\n    </div>\n  </template>\n\n  \n</dom-module>";document.head.appendChild($_documentContainer.content);var memoizedTemplate,NumberFieldElement=/*#__PURE__*/function(_TextFieldElement){babelHelpers.inherits(NumberFieldElement,_TextFieldElement);function NumberFieldElement(){babelHelpers.classCallCheck(this,NumberFieldElement);return babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(NumberFieldElement).apply(this,arguments))}babelHelpers.createClass(NumberFieldElement,[{key:"ready",value:function ready(){babelHelpers.get(babelHelpers.getPrototypeOf(NumberFieldElement.prototype),"ready",this).call(this);this.__previousValidInput=this.value||"";this.inputElement.type="number";this.inputElement.addEventListener("change",this.__onInputChange.bind(this))}},{key:"_decreaseButtonTouchend",value:function _decreaseButtonTouchend(e){// Cancel the following click and focus events
e.preventDefault();this._decreaseValue()}},{key:"_increaseButtonTouchend",value:function _increaseButtonTouchend(e){// Cancel the following click and focus events
e.preventDefault();this._increaseValue()}},{key:"_createConstraintsObserver",value:function _createConstraintsObserver(){// NOTE: do not call "super" but instead override the method to add extra arguments
this._createMethodObserver("_constraintsChanged(required, minlength, maxlength, pattern, min, max, step)")}},{key:"_constraintsChanged",value:function _constraintsChanged(required,minlength,maxlength,pattern,min,max,step){if(!this.invalid){return}var isNumUnset=function isNumUnset(n){return!n&&0!==n};if(!isNumUnset(min)||!isNumUnset(max)){this.validate()}else{babelHelpers.get(babelHelpers.getPrototypeOf(NumberFieldElement.prototype),"_constraintsChanged",this).call(this,required,minlength,maxlength,pattern)}}},{key:"_decreaseValue",value:function _decreaseValue(){this._incrementValue(-1)}},{key:"_increaseValue",value:function _increaseValue(){this._incrementValue(1)}},{key:"_incrementValue",value:function _incrementValue(incr){if(this.disabled||this.readonly){return}var value=parseFloat(this.value);if(!this.value){if(0==this.min&&0>incr||0==this.max&&0<incr||0==this.max&&0==this.min){incr=0;value=0}else if((null==this.max||0<=this.max)&&(null==this.min||0>=this.min)){value=0}else if(0<this.min){value=this.min;if(0>this.max&&0>incr){value=this.max}incr=0}else if(0>this.max){value=this.max;if(0>incr){incr=0}else{// FIXME(yuriy): find a proper solution to make correct step back
if(this._getIncrement(1,value-this.step)>this.max){value-=2*this.step}else{value-=this.step}}}}else if(value<this.min){incr=0;value=this.min}else if(value>this.max){incr=0;value=this.max}var newValue=this._getIncrement(incr,value);if(!this.value||0==incr||this._incrementIsInsideTheLimits(incr,value)){this._setValue(newValue)}}},{key:"_setValue",value:function _setValue(value){this.value=this.inputElement.value=parseFloat(value)+"";this.dispatchEvent(new CustomEvent("change",{bubbles:!0}))}},{key:"_getIncrement",value:function _getIncrement(incr,currentValue){var step=this.step||1,min=this.min||0,multiplier=Math.max(this._getMultiplier(currentValue),this._getMultiplier(step),this._getMultiplier(min));// To avoid problems with decimal math, multiplying to operate with integers.
step*=multiplier;currentValue=Math.round(currentValue*multiplier);min*=multiplier;var margin=(currentValue-min)%step;if(0<incr){return(currentValue-margin+step)/multiplier}else if(0>incr){return(currentValue-(margin||step))/multiplier}else{return currentValue/multiplier}}},{key:"_getDecimalCount",value:function _getDecimalCount(number){var s=number+"",i=s.indexOf(".");return-1===i?1:s.length-i-1}},{key:"_getMultiplier",value:function _getMultiplier(number){if(!isNaN(number)){return Math.pow(10,this._getDecimalCount(number))}}},{key:"_incrementIsInsideTheLimits",value:function _incrementIsInsideTheLimits(incr,value){if(0>incr){return null==this.min||this._getIncrement(incr,value)>=this.min}else if(0<incr){return null==this.max||this._getIncrement(incr,value)<=this.max}else{return this._getIncrement(incr,value)<=this.max&&this._getIncrement(incr,value)>=this.min}}},{key:"_allowed",value:function _allowed(sign){var incr=sign*(this.step||1),value=parseFloat(this.value);return!this.value||!this.disabled&&this._incrementIsInsideTheLimits(incr,value)}},{key:"_stepChanged",value:function _stepChanged(step){// Avoid using initial value in validation
this.__validateByStep=this.__stepChangedCalled||null!==this.getAttribute("step");this.inputElement.step=this.__validateByStep?step:"any";this.__stepChangedCalled=!0;this.setAttribute("step",step)}},{key:"_minChanged",value:function _minChanged(min){this.inputElement.min=min}},{key:"_maxChanged",value:function _maxChanged(max){this.inputElement.max=max}},{key:"_valueChanged",value:function _valueChanged(newVal,oldVal){// Validate value to be numeric
if(newVal&&isNaN(parseFloat(newVal))){this.value=""}else if("string"!==typeof this.value){this.value=this.value+""}babelHelpers.get(babelHelpers.getPrototypeOf(NumberFieldElement.prototype),"_valueChanged",this).call(this,this.value,oldVal)}},{key:"_onKeyDown",value:function _onKeyDown(e){if(38==e.keyCode){e.preventDefault();this._increaseValue()}else if(40==e.keyCode){e.preventDefault();this._decreaseValue()}babelHelpers.get(babelHelpers.getPrototypeOf(NumberFieldElement.prototype),"_onKeyDown",this).call(this,e)}},{key:"__onInputChange",value:function __onInputChange(){this.validate()}},{key:"checkValidity",value:function checkValidity(){// text-field mixin does not check against `min`, `max` and `step`
if(this.min!==void 0||this.max!==void 0||this.__validateByStep){return this.inputElement.checkValidity()}return babelHelpers.get(babelHelpers.getPrototypeOf(NumberFieldElement.prototype),"checkValidity",this).call(this)}}],[{key:"is",get:function get(){return"vaadin-number-field"}},{key:"version",get:function get(){return"2.5.4"}},{key:"properties",get:function get(){return{/**
      * Set to true to display value increase/decrease controls.
      */hasControls:{type:Boolean,value:!1,reflectToAttribute:!0},/**
      * The minimum value of the field.
      */min:{type:Number,reflectToAttribute:!0,observer:"_minChanged"},/**
       * The maximum value of the field.
       */max:{type:Number,reflectToAttribute:!0,observer:"_maxChanged"},/**
       * Specifies the allowed number intervals of the field.
       */step:{type:Number,value:1,observer:"_stepChanged"}}}},{key:"template",get:function get(){if(!memoizedTemplate){// Clone the superclass template
memoizedTemplate=babelHelpers.get(babelHelpers.getPrototypeOf(NumberFieldElement),"template",this).cloneNode(!0);// Retrieve this element's dom-module template
var thisTemplate=_domModule.DomModule.import(this.is+"-template","template"),decreaseButton=thisTemplate.content.querySelector("[part=\"decrease-button\"]"),increaseButton=thisTemplate.content.querySelector("[part=\"increase-button\"]"),styles=thisTemplate.content.querySelector("style"),inputField=memoizedTemplate.content.querySelector("[part=\"input-field\"]"),prefixSlot=memoizedTemplate.content.querySelector("[name=\"prefix\"]");inputField.insertBefore(decreaseButton,prefixSlot);inputField.appendChild(increaseButton);memoizedTemplate.content.appendChild(styles)}return memoizedTemplate}}]);return NumberFieldElement}(_vaadinTextField.TextFieldElement);/**
* `<vaadin-number-field>` is a Web Component for number field control in forms.
*
* ```html
* <vaadin-number-field label="Number">
* </vaadin-number-field>
* ```
*
* @memberof Vaadin
* @demo demo/index.html
*/_exports.NumberFieldElement=NumberFieldElement;window.customElements.define(NumberFieldElement.is,NumberFieldElement)});