define(["exports","../../lit-element/lit-element.js","../responsive-utility/responsive-utility.js","../../@polymer/paper-button/paper-button.js","../../@polymer/iron-icons/iron-icons.js","../simple-tooltip/simple-tooltip.js","./lib/a11y-tab.js"],(function(t,a,e,s,i,o,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.A11yTabs=void 0;
/**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class A11yTabs extends a.LitElement{static get styles(){return[a.css`
        :host {
          display: block;
          --a11y-tabs-border-radius: 2px;
          --a11y-tabs-justify-tabs: flex-start;
          --ally-tabs-wrap: unset;
          --a11y-tabs-background: white;
          --a11y-tabs-border-color: #ddd;
          --a11y-tabs-color: #222;
          --a11y-tabs-focus-color: #000;
          --a11y-tabs-faded-background: #eee;
          --a11y-tabs-content-padding: 16px;
          --a11y-tabs-button-padding: 0.7em 0.57em;
          --a11y-tabs-vertical-button-padding: unset;
          --a11y-tabs-horizontal-border-radius: unset;
          --a11y-tabs-vertical-border-radius: unset;
          --a11y-tabs-horizontal-button-padding: 2px 5px;
          --a11y-tabs-width: auto;
          height: var(--a11y-tabs-height);
          overflow: var(--a11y-tabs-overflow);
          font-size: var(--a11y-tabs-font-size, 12px);
        }

        :host([vertical]) {
          border: 1px solid var(--a11y-tabs-border-color);
          border-radius: var(
            --a11y-tabs-vertical-border-radius,
            var(--a11y-tabs-border-radius)
          );
          display: flex;
          justify-content: space-between;
          align-items: stretch;
        }

        :host([hidden]) {
          display: none;
        }

        :host #tabs {
          align-items: stretch;
          flex-wrap: var(--ally-tabs-wrap, unset);
          margin: 0;
          display: flex;
          list-style: none;
          padding: 0;
        }

        :host([vertical]) #tabs {
          background-color: var(--a11y-tabs-border-color);
          justify-content: var(
            --a11y-tabs-vertical-justify-tabs,
            var(--a11y-tabs-justify-tabs, flex-start)
          );
          flex-wrap: var(
            --ally-tabs-vertical-wrap,
            var(--ally-tabs-wrap, unset)
          );
          border-left: none;
          flex: 0 1 auto;
          flex-direction: column;
        }

        :host(:not([vertical])) #tabs {
          scroll-margin-top: 16px;
          z-index: 1;
          width: var(--a11y-tabs-width);
          background-color: var(--a11y-tabs-background);
          justify-content: var(
            --a11y-tabs-horizontal-justify-tabs,
            var(--a11y-tabs-justify-tabs, flex-start)
          );
        }

        :host #tabs .flag-type {
          position: absolute;
          left: -99999px;
          height: 0;
          overflow: hidden;
        }

        :host #content {
          padding: var(--a11y-tabs-content-padding);
          background-color: var(--a11y-tabs-background);
          border: 1px solid var(--a11y-tabs-border-color);
        }

        :host([vertical]) #content {
          flex: 1 0 auto;
          border: none;
        }

        :host(:not([vertical])) #content {
          border-radius: var(
            --a11y-tabs-horizontal-border-radius,
            var(--a11y-tabs-border-radius)
          );
          margin-top: -1px;
        }

        :host #tabs paper-button {
          margin: 0;
          text-transform: unset;
          color: var(--a11y-tabs-color);
          background-color: var(--a11y-tabs-faded-background);
          border: 1px solid var(--a11y-tabs-border-color);
          padding: var(--a11y-tabs-button-padding, 0.7em 0.57em);
        }

        :host([vertical]) #tabs paper-button {
          border-top: none;
          border-left: none;
          border-radius: 0;
          display: flex;
          justify-content: space-between;
          align-items: center;
          padding: var(
            --a11y-tabs-vertical-button-padding,
            var(--a11y-tabs-button-padding)
          );
        }

        :host(:not([vertical])) #tabs paper-button {
          width: 100%;
          border-bottom: none;
          border-radius: var(
              --a11y-tabs-horizontal-border-radius,
              var(--a11y-tabs-border-radius)
            )
            var(
              --a11y-tabs-horizontal-border-radius,
              var(--a11y-tabs-border-radius)
            )
            0 0;
          padding: var(
            --a11y-tabs-horizontal-button-padding,
            var(--a11y-tabs-button-padding)
          );
        }

        :host(:not([vertical])) #tabs li:not(:first-of-type) paper-button {
          border-left: none;
        }

        :host #tabs paper-button:active,
        :host #tabs paper-button:focus,
        :host #tabs paper-button:hover {
          color: var(--a11y-tabs-focus-color);
          background-color: var(--a11y-tabs-faded-background);
        }

        :host #tabs paper-button.active[disabled] {
          color: var(--a11y-tabs-focus-color);
          background-color: var(--a11y-tabs-background);
          opacity: 1;
        }

        :host #tabs paper-button:not(.active)[disabled] {
          opacity: 0.5;
          cursor: not-allowed;
        }

        :host([vertical]) #tabs paper-button[disabled] {
          border-right-color: var(--a11y-tabs-background);
        }

        :host(:not([vertical])) #tabs paper-button[disabled] {
          border-bottom: 1px solid var(--a11y-tabs-background);
        }

        :host #tabs span.label,
        :host #tabs .flag-icon {
          margin-right: 8px;
        }

        :host #tabs.icons-only paper-button {
          justify-content: center;
        }

        :host #tabs.icons-only span.label {
          display: none;
        }

        :host #tabs:not(.icons-only) simple-tooltip {
          display: none;
        }
      `]}render(){return a.html`
      <ul
        id="tabs"
        .class="${this._showIcons(this.__hasIcons,this.iconBreakpoint,this.layoutBreakpoint,this.responsiveSize)}"
      >
        ${this.tabs.map((t,e)=>a.html`
            <li>
              <paper-button
                id="${t.id}-button"
                controls="${t.id}"
                class="${t.id===this.activeTab?"active":""}"
                @click="${a=>this._handleTab(t)}"
                ?disabled="${t.id===this.activeTab||t.disabled}"
                .flag="${t.flag}"
              >
                <iron-icon
                  class="flag-icon"
                  ?hidden="${!t.flagIcon}"
                  .icon="${t.flagIcon}"
                >
                </iron-icon>
                <span class="label">${t.label}</span>
                <span class="flag-type" ?hidden="${!t.flag}">
                  ${t.flag}
                </span>
                <iron-icon
                  class="icon"
                  ?hidden="${!t.icon}"
                  .icon="${t.icon}"
                >
                </iron-icon>
              </paper-button>
              <simple-tooltip for="${t.id}-button"
                >${t.label}</simple-tooltip
              >
            </li>
          `)}
      </ul>
      <div id="content">
        <slot></slot>
      </div>
    `}static get haxProperties(){return{}}static get properties(){return{...super.properties,activeTab:{type:String,attribute:"active-tab"},disabled:{type:Boolean,reflect:!0},hidden:{type:Boolean,reflect:!0},iconBreakpoint:{type:Number,attribute:"icon-breakpoint"},id:{type:String,reflect:!0},layoutBreakpoint:{type:Number,attribute:"layout-breakpoint"},responsiveSize:{type:String,reflect:!0,attribute:"responsive-size"},vertical:{type:Boolean,reflect:!0},__hasIcons:{type:Boolean},__items:{type:Array},__observer:{type:Object},forceHorizontal:{type:Boolean,attribute:"force-horizontal"}}}static get tag(){return"a11y-tabs"}constructor(){super();this.activeTab=null,this.disabled=!1,this.hidden=!1,this.iconBreakpoint=400,this.id=null,this.layoutBreakpoint=600,this.forceHorizontal=!1,this.responsiveSize="xs",this.vertical=!1,this.__hasIcons=!1,this.__tabs=[],this.updateItems(),this.__observer=new MutationObserver((t,a)=>this.updateItems()),this._breakpointChanged(),window.ResponsiveUtility.requestAvailability(),this.__observer.observe(this,{attributes:!1,childList:!0,subtree:!1}),this.addEventListener("a11y-tab-changed",t=>this.updateItems())}get tabs(){return this.__tabs?Object.keys(this.__tabs).map(t=>this.__tabs[t]):[]}connectedCallback(){super.connectedCallback()}disconnectedCallback(){this.__observer&&this.__observer.disconnect&&this.__observer.disconnect(),this.removeEventListener("a11y-tab-changed",t=>this.updateItems()),this._unsetBreakpoints(),super.disconnectedCallback()}updated(t){t.forEach((t,a)=>{"id"===a&&this._idChanged(this.id,t),"activeTab"===a&&this.selectTab(this.activeTab),"iconBreakpoint"===a&&this._breakpointChanged(),"layoutBreakpoint"===a&&this._breakpointChanged(),"responsiveSize"===a&&this._setVertical()})}selectTab(t){let a=this.querySelectorAll("a11y-tab"),e=t&&this.querySelector(`a11y-tab#${t}`)?this.querySelector(`a11y-tab#${t}`):this.querySelector("a11y-tab");e&&e.id!==t?this.activeTab=e.id:a&&a.length>0&&a.forEach(a=>{a.hidden=a.id!==t})}updateItems(t){this.__tabs=this.querySelectorAll("a11y-tab"),this.__hasIcons=!0,this.id||(this.id=this._generateUUID()),this.__tabs&&this.__tabs.length>0&&this.__tabs.forEach((t,a)=>{t.icon||(this.__hasIcons=!1),t.order=a+1,t.total=this.__tabs.length}),this.selectTab(this.activeTab)}_activeTabChanged(t){this.selectTab(t)}_breakpointChanged(){this._unsetBreakpoints(),this._setBreakpoints(),this._setVertical()}_generateUUID(){return"ss-s-s-s-sss".replace(/s/g,Math.floor(65536*(1+Math.random())).toString(16).substring(1))}_handleTab(t){t.disabled||(this.activeTab=t.id)}_idChanged(t,a){t||(this.id="a11y-tabs"+this._generateUUID())}_setBreakpoints(){let t=this.layoutBreakpoint>-1?this.layoutBreakpoint:0,a=this.iconBreakpoint>-1?this.iconBreakpoint:0,e=a>t?t:a,s=a>t?a:t,i=Math.max(a,t)+1,o=Math.max(a,t)+2;window.dispatchEvent(new CustomEvent("responsive-element",{detail:{element:this,attribute:"responsive-size",relativeToParent:!0,sm:e,md:s,lg:i,xl:o}}))}_setVertical(){this.forceHorizontal?this.vertical=!1:this.vertical=-1===this.layoutBreakpoint||this.iconBreakpoint>this.layoutBreakpoint?"xs"===this.responsiveSize:this.responsiveSize.indexOf("s")>-1}_showIcons(t,a,e,s){return t&&-1!==a&&("xs"===s||a>e&&"sm"===s)?"icons-only":""}_unsetBreakpoints(){window.dispatchEvent(new CustomEvent("responsive-element-deleted",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}}t.A11yTabs=A11yTabs,window.customElements.define(A11yTabs.tag,A11yTabs)}));