define(["exports","meta","require","../../lit-element/lit-element.js","../schema-behaviors/schema-behaviors.js"],(function(e,t,o,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeEditor=void 0,t=babelHelpers.interopRequireWildcard(t),o=babelHelpers.interopRequireWildcard(o);
/**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class CodeEditor extends((0,d.SchemaBehaviors)(i.LitElement)){static get styles(){return[i.css`
        :host {
          display: block;
          font-family: unset;
        }
        :host([hidden]) {
          display: none !important;
        }
        .code-pen-container:not([hidden]) {
          width: 100%;
          display: flex;
          background-color: var(--code-pen-button-color, #222222);
          color: white;
          height: 40px;
          justify-content: flex-end;
          align-items: center;
        }
        .code-pen-container span {
          display: inline-flex;
          line-height: 16px;
          font-size: 16px;
          padding: 12px;
        }
        code-pen-button {
          float: right;
          height: 40px;
        }
        label {
          color: var(--code-editor-label-color, #888);
          transition: all 0.5s;
        }

        :host([focused]) label {
          color: var(
            --code-editor-float-label-active-color,
            var(--code-editor-label-color, #000)
          );
        }

        #codeeditor {
          height: 100%;
          display: flex;
          border: var(--code-editor-code-border);
          border-radius: var(--code-editor-code-border-radius);
        }

        :host([focused]) #codeeditor {
          border: var(--code-editor-focus-code-border);
        }
      `]}constructor(){super(),this.showCodePen=!1,this.readOnly=!1,this.theme="vs-dark",this.language="javascript",this.fontSize=16,this.autofocus=!1,this.hideLineNumbers=!1,this.focused=!1,this.__libPath=decodeURIComponent(t.url)+"/../../../monaco-editor/min/vs",new Promise((e,t)=>o.default(["./lib/monaco-element/monaco-element.js"],e,t)),new Promise((e,t)=>o.default(["./lib/code-pen-button.js"],e,t)),setTimeout(()=>{this.addEventListener("monaco-element-ready",this.editorReady.bind(this))},0)}render(){return i.html`
      <label for="codeeditor" ?hidden="${!this.title}">${this.title}</label>
      <monaco-element
        id="codeeditor"
        ?autofocus="${this.autofocus}"
        ?hide-line-numbers="${this.hideLineNumbers}"
        lib-path="${this.__libPath}"
        language="${this.language}"
        theme="${this.theme}"
        @value-changed="${this._editorDataChanged}"
        font-size="${this.fontSize}"
        ?read-only="${this.readOnly}"
        @code-editor-focus="${this._handleFocus}"
        @code-editor-blur="${this._handleBlur}"
      >
      </monaco-element>
      <div class="code-pen-container" ?hidden="${!this.showCodePen}">
        <span>Check it out on code pen: </span
        ><code-pen-button .data="${this.codePenData}"></code-pen-button>
      </div>
    `}static get tag(){return"code-editor"}static get properties(){return{...super.properties,title:{type:String},showCodePen:{type:Boolean,reflect:!0,attribute:"show-code-pen"},readOnly:{type:Boolean,reflect:!0,attribute:"read-only"},codePenData:{type:Object},editorValue:{type:String},value:{type:String},theme:{type:String},mode:{type:String},language:{type:String},fontSize:{type:Number,attribute:"font-size"},autofocus:{type:Boolean,reflect:!0},hideLineNumbers:{type:Boolean,attribute:"hide-line-numbers"},focused:{type:Boolean,reflect:!0}}}updated(e){e.forEach((e,t)=>{"editorValue"==t&&this._editorValueChanged(this[t],e),"mode"==t&&this._modeChanged(this[t],e),"showCodePen"===t&&this.dispatchEvent(new CustomEvent("show-code-pen-changed",{detail:{value:this[t]}})),"value"===t&&this.dispatchEvent(new CustomEvent("value-changed",{detail:{value:this[t]}})),["title","value"].includes(t)&&(this.codePenData=this._computeCodePenData(this.title,this.value))})}_computeCodePenData(e,t){return{title:e,html:t}}_handleFocus(e){this.focused=!0}_handleBlur(e){this.focused=!1}_modeChanged(e){this.language=this.mode}_editorDataChanged(e){this.value=e.detail}updateEditorValue(e){if(e){var t="",o=e;if("TEMPLATE"!==e.tagName){if(console.warn("code-editor works best with a template tag provided in light dom"),(o=this.childNodes).length>0)for(var i=0,d=o.length;i<d;i++)void 0!==o[i].tagName?t+=o[i].outerHTML:t+=o[i].textContent}else t=o.innerHTML;t&&(this.shadowRoot.querySelector("#codeeditor").value=t.trim())}}_editorValueChanged(e){e&&(this.shadowRoot.querySelector("#codeeditor").value=e)}preProcessHaxNodeToContent(e){return e.editorValue=null,e.codePenData=null,e.value=null,e.removeAttribute("value"),e.removeAttribute("code-pen-data"),e}connectedCallback(){super.connectedCallback(),this._observer=new MutationObserver(e=>{e.forEach(e=>{e.addedNodes.length>0&&e.addedNodes.forEach(e=>{e.tagName&&this.updateEditorValue(e)}),e.removedNodes.length>0&&e.removedNodes.forEach(e=>{e.tagName&&this.updateEditorValue(e)})})}),this._observer.observe(this,{childList:!0})}disconnectedCallback(){this._observer&&(this._observer.disconnect(),this._observer=null),super.disconnectedCallback()}editorReady(e){this.editorValue&&(this.shadowRoot.querySelector("#codeeditor").value=this.editorValue)}}e.CodeEditor=CodeEditor,window.customElements.define(CodeEditor.tag,CodeEditor)}));