define(["exports","../../../@polymer/polymer/polymer-element.js","../../../@polymer/polymer/lib/elements/dom-if.js","../../../@polymer/app-localize-behavior/app-localize-behavior.js","../../../@polymer/polymer/lib/legacy/class.js","../../../@polymer/iron-flex-layout/iron-flex-layout-classes.js","./eco-json-schema-array.js","./eco-json-schema-fieldset.js","./eco-json-schema-markup.js","./eco-json-schema-tabs.js","./eco-json-schema-boolean.js","./eco-json-schema-enum.js","./eco-json-schema-file.js","./eco-json-schema-input.js"],(function(e,o,t,r,a,s,i,n,c,l,p,m,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EcoJsonSchemaObject=void 0;class EcoJsonSchemaObject extends((0,a.mixinBehaviors)([r.AppLocalizeBehavior],o.PolymerElement)){static get tag(){return"eco-json-schema-object"}static get template(){return o.html`
      <custom-style>
        <style is="custom-style" include="iron-flex iron-flex-alignment">
          :host {
            --eco-json-field-margin: 0 0 15px;
            --eco-json-form-border-radius: 2px;
            --eco-json-form-font-family: var(
              --paper-font-caption_-_font-family,
              unset
            );
            --eco-json-form-bg: var(--primary-background-color, #fff);
            --eco-json-form-color: var(--primary-text-color, #222);
            --eco-json-form-faded-color: #888;
            --eco-json-form-active-color: var(--primary-color, #000);
            --eco-json-form-faded-bg: #f0f0f0;
            --eco-json-form-add-color: #008811;
            --eco-json-form-add-focus: #007700;
            --eco-json-form-remove-focus: #cc0000;
            --eco-json-form-remove-color: #dd0000;
            --simple-picker-float-label-color: var(--eco-json-form-faded-color);
            --simple-picker-float-label-active-color: var(
              --eco-json-form-active-color
            );
            --simple-picker-background-color: var(--eco-json-form-bg);
            --simple-picker-border-color: var(--eco-json-form-faded-color);
            --simple-picker-focus-border-color: var(
              --eco-json-form-active-color
            );
            --simple-picker-focus-border-width: 2px;
            --paper-input-container: {
              padding-top: 0;
            }
          }
          div.layout {
            height: auto;
          }
          #form {
            display: block;
            font-family: var(--eco-json-form-font-family);
            background-color: var(--eco-json-form-bg);
            color: var(--eco-json-form-color);
            --simple-tooltip-background: var(--eco-json-form-active-color);
            --simple-tooltip-text-color: var(--eco-json-form-bg);
            @apply --eco-json-schema-object-form;
            @apply --layout-vertical;
            @apply --layout-wrap;
          }
          #form ::slotted(paper-input) {
            margin-bottom: 15px;
          }
          #form ::slotted(*.has-tooltip-desc) {
            margin-bottom: 0;
            padding-bottom: 0;
            --paper-input-container: {
              margin-bottom: 0;
              padding-bottom: 0;
            }
          }
          #form ::slotted(div.tooltip-desc) {
            font-size: 12px;
            margin: var(--eco-json-field-margin);
            color: var(--eco-json-form-faded-color);
          }
          #form ::slotted(paper-input),
          #form ::slotted(div.tooltip-desc) {
            font-family: var(--eco-json-form-font-family);
          }
          #form ::slotted(div.desc-for-paper-textarea) {
            margin-top: -18px;
            margin-right: 35px;
          }
          #form ::slotted(code-editor) {
            margin: 8px 0;
            padding: 0;
            --code-editor-float-label-color: var(--eco-json-form-faded-color);
            --code-editor-float-label-active-color: var(
              --eco-json-form-active-color
            );
            --code-pen-button-color: var(--eco-json-form-faded-color);
            --code-editor-code-border: 1px solid
              var(--eco-json-form-faded-color);
            --code-editor-code-border-radius: 2px;
            --code-editor-focus-code-border: 2px solid
              var(--eco-json-form-active-color);
          }
        </style>
      </custom-style>

      <template is="dom-if" if="{{!wizard}}">
        <div class="header" hidden\$="[[!label]]">[[label]]</div>
      </template>
      <div class="layout vertical flex start-justified">
        <div
          id="form"
          class="layout horizontal flex start-justified"
          aria-live="polite"
        >
          <slot></slot>
        </div>
      </div>
    `}static get properties(){return{language:{value:"en"},resources:{value:()=>({})},schema:{type:Object,notify:!0,observer:"_schemaChanged"},label:{type:String},value:{type:Object,notify:!0,value:()=>({})},error:{type:Object,observer:"_errorChanged"},wizard:{type:Boolean,notify:!0},codeTheme:{type:String,value:"vs-light-2"},autofocus:{type:Boolean,value:!1}}}disconnectedCallback(){this._clearForm(),super.disconnectedCallback()}_buildSchemaProperties(e=this.schema){var o=this;return Object.keys(e.properties||[]).map(t=>{var r=e.properties[t],a={name:t,schema:r,label:r.title||t,description:r.description,component:r.component||{}};if(a.component.valueProperty||(a.component.valueProperty="value"),a.component.slot||(a.component.slot=""),o._isSchemaEnum(r))a.component.name=a.component.name||"eco-json-schema-enum",void 0===r.value&&(r.value=""),a.value=r.value;else if(o._isSchemaBoolean(r.type))a.component.name=a.component.name||"eco-json-schema-boolean",void 0===r.value&&(r.value=!1),a.value=r.value;else if(o._isSchemaFile(r.type))a.component.name=a.component.name||"eco-json-schema-file",void 0===r.value&&(r.value={}),a.value=r.value;else if(o._isSchemaValue(r.type))a.component.name=a.component.name||"eco-json-schema-input",void 0===r.value&&(r.value=""),a.value=r.value;else if(o._isSchemaObject(r.type))a.component.name=a.component.name||"eco-json-schema-object",void 0===r.value&&(r.value={}),a.value=r.value;else if(o._isSchemaArray(r.type))a.component.name=a.component.name||"eco-json-schema-array",this._buildNestedSchemaProperties(a,r);else if(o._isSchemaFieldset(r.type))a.component.name=a.component.name||"eco-json-schema-fieldset",this._buildNestedSchemaProperties(a,r);else if(o._isSchemaTabs(r.type))a.component.name=a.component.name||"eco-json-schema-tabs",this._buildNestedSchemaProperties(a,r);else{if(!o._isSchemaMarkup(r.type))return console.error("Unknown property type %s",r.type);a.component.name=a.component.name||"eco-json-schema-markup",void 0===r.value&&(r.value=""),a.value=r.value}return a})}_buildNestedSchemaProperties(e,o){void 0===o.value&&(o.value="array"!==o.type?{}:[]),e.value=o.value;for(let t in o.items.properties)o.items.properties[t].value=o.value[t];e.schema.properties=this._buildSchemaProperties(o.items,e.property+".")}_schemaPropertyChanged(e,o){if(o){if(o.path&&/\.length$/.test(o.path))return;var t=this,r=e.target.schemaProperty,a=["value"].concat(`${e.target.propertyPrefix}${e.target.propertyName}`.split("."));r.property||e.target.propertyName,o&&o.value&&this._deepClone(o.value);if(o.path&&/\.splices$/.test(o.path)){for(var s=o.path.split(".").slice(1,-1);s.length;)a.push(s.shift()),r.keyMap&&r.keyMap[a.join(".")]&&(a=r.keyMap[a.join(".")].split("."));o.value.keySplices&&r.keyMap&&o.value.keySplices.forEach(e=>{e.removed.forEach(e=>{delete r.keyMap[a.concat([e]).join(".")]})}),o.value&&o.value.indexSplices.forEach(e=>{var o=[a.join("."),e.index,e.removed.length];if(e.addedCount)for(var s=0,i=e.addedCount;s<i;s++)e.addedKeys&&e.addedKeys[s]&&(r.keyMap=r.keyMap||{},r.keyMap[a.concat([e.addedKeys[s]]).join(".")]=a.concat([s+e.index]).join(".")),o.push(t._deepClone(e.object[s+e.index]));t.splice.apply(t,o)})}else if(o.path){s=o.path.split(".").slice(1);for(this.value.hasOwnProperty(r.property)||(this.set("value."+r.property,{}),this.notifyPath("value."+r.property));s.length;){var i=s.shift();a.push(i),r.keyMap&&r.keyMap[a.join(".")]&&(a=r.keyMap[a.join(".")].split("."))}this.set(a.join("."),this._deepClone(o.value)),this.notifyPath(a.join("."))}else this.set(a.join("."),this._deepClone(o.value)),this.notifyPath("value");e.target.dispatchEvent(new CustomEvent("form-field-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:e.target})),this.dispatchEvent(new CustomEvent("value-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}}_setValue(e=this._schemaProperties,o=""){let t=o.replace(/\[(\d+)\]/g,".$1");""!=t&&(t=`.${t}`),e.length>0&&(e.forEach(e=>{void 0!==e.value&&this.set(`value${t}.${e.property}`,this._deepClone(e.value),JSON.stringify(e.value))}),this.notifyPath("value.*"))}_buildForm(e=this._schemaProperties,o=this,t=""){let r=this.autofocus;e.forEach(e=>{"code-editor"===e.component.name&&(e.schema.component.properties.editorValue=e.schema.value,e.schema.component.properties.theme=this.codeTheme);let a=""!==t?`${t}.`:"",s=e.property||e.name;var i=this.create(e.component.name,{label:e.label,schema:e.schema,schemaProperty:e,propertyPrefix:a,propertyName:s,language:this.language,resources:this.resources});for(var n in"paper-input"===e.component.name&&(i.style["background-color"]="transparent",i.style.width="100%"),i.setAttribute("name",`${a}${s}`),e.schema.hidden&&void 0!==e.schema.hidden&&i.setAttribute("hidden",e.schema.hidden),r&&i.setAttribute("autofocus",r),r=!1,i.className="flex start-justified",i[e.component.valueProperty]=e.value,e.component.attributes)i.setAttribute(n,e.component.attributes[n]);for(var c in e.component.properties)i[c]=e.component.properties[c];if(this.listen(i,e.component.valueProperty.replace(/([A-Z])/g,"-$1").toLowerCase()+"-changed","_schemaPropertyChanged"),this.listen(i,"build-fieldset","_onBuildFieldset"),void 0!==this.$&&(o.appendChild(i),e.description)){var l="tip-"+e.property,p=document.createElement("div");i.setAttribute("aria-describedby",l),i.setAttribute("class","has-tooltip-desc"),p.setAttribute("id",l),p.setAttribute("class","tooltip-desc desc-for-"+e.component.name),!0===e.schema.hidden&&p.setAttribute("hidden","hidden"),p.setAttribute("role","tooltip"),p.innerHTML=e.description,o.appendChild(p)}if(""!=e.component.slot){let o=document.createElement("div");o.innerHTML=e.component.slot;let t=o.cloneNode(!0);for(;null!==t.firstChild;)i.appendChild(t.firstChild)}this.dispatchEvent(new CustomEvent("form-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))})}_onBuildFieldset(e,o){void 0===this.get(`value.${o.prefix}`)&&this.set(`value.${o.path}`,this._deepClone(o.value)),this._clearForm(o.container),this._buildForm(o.properties,o.container,o.prefix)}_removePropertyEl(e,o=this){void 0!==e.schemaProperty&&this.unlisten(e,e.schemaProperty.component.valueProperty.replace(/([A-Z])/g,"-$1").toLowerCase()+"-changed","_schemaPropertyChanged"),e.schemaProperty=null,o.removeChild(e)}_clearForm(e=this){if(void 0!==this.$)for(var o=e;o.firstChild;)this._removePropertyEl(o.firstChild,e)}_schemaChanged(e,o){e&&e!==o&&(this._clearForm(),this._schemaProperties=this._buildSchemaProperties(),this._buildForm(),this._setValue())}_errorChanged(){this.childNodes.forEach(e=>{var o=e.getAttribute("name");this.error&&this.error[o]?e.error=this.error[o]:e.error=null})}_deepClone(e){return JSON.parse(JSON.stringify(e))}_isSchemaValue(e){return this._isSchemaBoolean(e)||this._isSchemaNumber(e)||this._isSchemaString(e)||this._isSchemaFile(e)}_isSchemaFile(e){return Array.isArray(e)?-1!==e.indexOf("file"):"file"===e}_isSchemaBoolean(e){return Array.isArray(e)?-1!==e.indexOf("boolean"):"boolean"===e}_isSchemaEnum(e){return!!e.enum}_isSchemaNumber(e){return Array.isArray(e)?-1!==e.indexOf("number")||-1!==e.indexOf("integer"):"number"===e||"integer"===e}_isSchemaString(e){return Array.isArray(e)?-1!==e.indexOf("string"):"string"===e}_isSchemaObject(e){return"object"===e}_isSchemaArray(e){return"array"===e}_isSchemaFieldset(e){return"fieldset"===e}_isSchemaTabs(e){return"tabs"===e}_isSchemaMarkup(e){return"markup"===e}focus(){}}e.EcoJsonSchemaObject=EcoJsonSchemaObject,window.customElements.define(EcoJsonSchemaObject.tag,EcoJsonSchemaObject)}));