define(["exports","require","../../lit-element/lit-element.js","../simple-modal/simple-modal.js"],(function(e,t,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditableList=void 0,t=babelHelpers.interopRequireWildcard(t);
/**
   * Copyright 2018 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class EditableList extends i.LitElement{static get styles(){return[i.css`
        :host {
          display: block;
        }

        :host([hidden]) {
          display: none;
        }

        #list {
          height: 100%;
        }
      `]}render(){return i.html`
      <div id="list">
        ${this.items.map(e=>i.html`
            <editable-list-item
              ?edit-mode="${e.metadata.canEdit}"
              ?can-edit="${e.metadata.canEdit}"
              ?can-delete="${e.metadata.canDelete}"
              value="${e.title}"
            ></editable-list-item>
          `)}
      </div>
    `}static get properties(){return{...super.properties,editMode:{type:Boolean,reflect:!0,attribute:"edit-mode"},items:{type:Array,reflect:!1},activeElement:{type:Object}}}static get tag(){return"editable-list"}constructor(){super(),this.editMode=!1,this.items=[],window.SimpleModal.requestAvailability(),new Promise((e,i)=>t.default(["./lib/editable-list-item.js"],e,i)),setTimeout(()=>{this.shadowRoot.querySelector("#list").addEventListener("editable-list-item-delete",this.triggerDeleteModal.bind(this))},0)}updated(e){e.forEach((e,t)=>{"items"==t&&this._itemsChanged(this[t],e),"editMode"==t&&(this._editModeChanged(this[t],e),this.dispatchEvent(new CustomEvent("edit-mode-changed",{detail:{value:this[t]}})))})}triggerDeleteModal(e){this.activeElement=e.detail.element;let t=document.createElement("div");t.innerHTML=`<div>Are you sure you want to delete <strong>${e.detail.element.value}</strong>?</div>`;let i=document.createElement("paper-button");i.raised=!0,i.addEventListener("click",this._deleteItemConfirm.bind(this)),i.appendChild(document.createTextNode("Delete"));let d=document.createElement("paper-button");d.raised=!0,d.setAttribute("dialog-dismiss","dialog-dismiss"),d.appendChild(document.createTextNode("cancel"));let s=document.createElement("div");s.appendChild(i),s.appendChild(d);const l=new CustomEvent("simple-modal-show",{bubbles:!0,cancelable:!0,composed:!0,detail:{title:`Delete ${e.detail.element.value}`,elements:{content:t,buttons:s},invokedBy:e.detail.element.shadowRoot.querySelector("#delete"),clone:!1}});this.dispatchEvent(l)}_deleteItemConfirm(e){const t=new CustomEvent("simple-modal-hide",{bubbles:!0,cancelable:!0,composed:!0,detail:{}});this.dispatchEvent(t)}_editModeChanged(e,t){if(void 0!==e)for(var i in this._itemsChanged(this.items),this.items)if(this.items[i].metadata){let t=this.items[i].metadata;t.canEdit=e,this.items[i].metadata={...t}}}_itemsChanged(e,t){void 0!==e&&"string"==typeof e&&(this.items=[...JSON.parse(e)])}}e.EditableList=EditableList,window.customElements.define(EditableList.tag,EditableList)}));