define(["exports","../../../../@polymer/polymer/polymer-element.js","../../../../@polymer/polymer/lib/utils/render-status.js","../../../../@polymer/polymer/lib/utils/async.js","../../../../@polymer/app-route/app-route.js","../../../../@polymer/iron-ajax/iron-ajax.js","../../../../@polymer/app-layout/app-toolbar/app-toolbar.js","../../../../@polymer/marked-element/marked-element.js","../../../../@polymer/iron-icon/iron-icon.js","../../../../@polymer/paper-dialog/paper-dialog.js","../../../../@polymer/polymer/lib/elements/dom-if.js","../../../../@polymer/paper-button/paper-button.js","../../../../@polymer/paper-badge/paper-badge.js","../../../../@polymer/paper-toast/paper-toast.js","../../../../@vaadin/vaadin-split-layout/vaadin-split-layout.js","../../../lrnsys-layout/lib/lrnsys-dialog.js","../../../lrnsys-button/lrnsys-button.js","../../../lrnsys-comment/lib/lrnsys-comment-list.js","../../../elmsln-loading/elmsln-loading.js","./lrnapp-studio-submission-object.js","./lrnapp-studio-submission-comments.js","./lrnapp-studio-submission-comment.js"],(function(e,t,s,i,n,o,a,r,l,m,d,p,u,c,b,h,g,y,v,f,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LrnappStudioSubmissionPage=void 0;class LrnappStudioSubmissionPage extends t.PolymerElement{static get template(){return t.html`
      <style>
        :host {
          display: block;
          position: relative;
        }

        p {
          font-size: 14px;
          line-height: 18px;
        }

        h1 {
          margin: 0;
          text-align: left;
        }

        iron-selector {
          line-height: 1em;
        }

        iron-selector lrnsys-button {
          display: inline-flex;
        }

        iron-image {
          margin: 0 0.5em;
        }

        lrnsys-dialog {
          display: inline;
        }

        .contain {
          width: 10em;
          height: 10em;
          background: #ddd;
        }

        .center {
          margin: auto;
          width: 100%;
        }

        .title {
          color: #222;
          font-size: 2rem;
          font-weight: 600;
          line-height: 2.5rem;
          padding: 0.25rem 0;
          white-space: nowrap;
          overflow-x: hidden;
          text-overflow: ellipsis;
          margin-top: 1rem;
          text-transform: uppercase;
          text-align: left;
        }

        .author {
          color: #555;
          font-size: 1rem;
          font-weight: 500;
          font-style: normal;
          line-height: 1rem;
          padding: 0.25rem 0 0.5rem 0;
          margin: 0;
          text-transform: capitalize;
        }

        .comments {
          text-align: right;
          margin: 0;
          font-size: 1.5em;
        }

        .submission-page-wrapper {
          padding: 0;
          --vaadin-split-layout-splitter: {
            min-width: 0.4em;
            background: var(--paper-amber-200);
          }
        }

        .submission-page {
          width: 70vw;
        }

        .submission-page-card {
          width: 100%;
          margin: 0;
          padding: 0 0 2em 1em;
        }

        .submission-comments {
          overflow-y: hidden;
          padding: 0;
          margin: 0;
        }

        elmsln-loading {
          position: absolute;
          display: none;
          top: 0;
          left: 0;
          width: 100%;
          height: 100%;
          background: rgba(255, 255, 255, 0.8);
          z-index: 10;
          align-items: flex-end;
          justify-content: center;
        }

        :host([saving]) elmsln-loading {
          display: block;
        }

        elmsln-loading {
          top: calc(50% - 5vmax);
          left: calc(50% - 5vmax);
          position: fixed;
          transform-origin: center center;
          width: 10vmax !important;
          height: 10vmax !important;
        }

        iron-pages {
          width: 100%;
        }

        paper-dialog {
          width: 50%;
          width: 50vmax;
          padding: 1em;
          z-index: 99999;
        }

        lrnapp-studio-submission-object {
          width: 100%;
        }

        .assignment-body {
          padding: 2em;
        }

        iron-icon {
          margin: 0.2em;
        }
      </style>

      <app-route
        route="{{route}}"
        pattern="/edit"
        tail="{{tail}}"
        active="{{editPage}}"
      >
      </app-route>

      <iron-ajax
        id="ajaxRequest"
        auto=""
        url="[[reqUrl]]"
        method="GET"
        params="[[reqParams]]"
        content-type="application/json"
        handle-as="json"
        on-response="_handleResponse"
      ></iron-ajax>
      <!-- Update Submission Node -->
      <iron-ajax
        id="ajaxUpdateRequest"
        url="[[reqUrl]]"
        method="PUT"
        body="[[submission]]"
        params="[[reqParams]]"
        content-type="application/json"
        handle-as="json"
        on-response="_handleUpdateResponse"
      ></iron-ajax>
      <!-- Delete Submission Node -->
      <iron-ajax
        id="ajaxDeleteRequest"
        url="[[reqUrl]]"
        method="DELETE"
        params="[[reqParams]]"
        content-type="application/json"
        handle-as="json"
        on-response="_handleDeleteResponse"
      ></iron-ajax>

      <app-toolbar class="amber lighten-3" hidden\$="[[hideMenuBar]]">
        <template is="dom-if" if="[[showComments]]">
          <lrnsys-button
            on-click="_backToStudio"
            icon="arrow-back"
            label="See in studio"
            hover-class="amber darken-4 white-text"
          ></lrnsys-button>
        </template>
        <template is="dom-if" if="[[!showComments]]">
          <lrnsys-button
            on-click="_backToKanban"
            icon="arrow-back"
            label="Back to project management"
            hover-class="amber darken-4 white-text"
          ></lrnsys-button>
        </template>
        <div spacer="" main-title="">[[submission.attributes.title]]</div>
        <div spacer="">
          <lrnsys-dialog
            raised
            header="[[submission.relationships.assignment.attributes.title]]"
          >
            <span slot="button"
              ><iron-icon icon="icons:assignment"></iron-icon>Assignment
              Details</span
            >
            <div class="assignment-body">
              <marked-element
                id="assignment-body"
                markdown="[[submission.relationships.assignment.attributes.body]]"
              ></marked-element>
            </div>
          </lrnsys-dialog>
        </div>
        <div>
          <paper-button
            id="comment-count"
            style="margin:0;padding:.25em;text-transform:none;"
          >
            <iron-icon icon="communication:forum"></iron-icon>
            [[submission.meta.comment_count]] Comments
          </paper-button>
          <paper-badge
            hidden\$="[[displayNewBadge(submission.meta.comment_new)]]"
            for="comment-count"
            label\$="[[submission.meta.comment_new]]"
          ></paper-badge>
        </div>
        <div hidden\$="[[editPage]]">
          <lrnsys-button
            on-click="_setEditRoute"
            icon="create"
            label="Edit"
            hover-class="amber darken-4 white-text"
            hidden\$="[[!submission.meta.canUpdate]]"
          ></lrnsys-button>
        </div>
        <div hidden\$="[[!editPage]]">
          <lrnsys-button
            on-click="_resetRoute"
            icon="cancel"
            label="Cancel"
            hover-class="amber darken-4 white-text"
            hidden\$="[[!submission.meta.canUpdate]]"
          ></lrnsys-button>
        </div>
      </app-toolbar>

      <vaadin-split-layout class="submission-page-wrapper">
        <div
          id="commentcolumn"
          class="submission-comments"
          style="min-width: 25%; max-width: 40%; width:30%;"
        >
          <template is="dom-if" if="[[showComments]]">
            <lrnsys-comment-list
              comment-ops-base="{{commentOpsBase}}"
              csrf-token="[[csrfToken]]"
              source-path="{{commentsUrl}}"
              create-stub-url="{{createStubUrl}}"
            ></lrnsys-comment-list>
          </template>
        </div>
        <div id="submissioncolumn" style="width:70%;">
          <lrnapp-studio-submission-object
            submission="{{submission}}"
            edit="[[editPage]]"
          ></lrnapp-studio-submission-object>
        </div>
        <iron-icon class="splitter-handle" icon="more-vert"></iron-icon>
      </vaadin-split-layout>

      <elmsln-loading></elmsln-loading>

      <paper-dialog id="deletedialog">
        <h2>Delete submission?</h2>
        <p>Are you sure you want to delete this submission?</p>
        <div class="buttons">
          <paper-button dialog-dismiss="">Cancel</paper-button>
          <paper-button dialog-confirm="" on-click="_submissionDeleteConfirmed"
            >Delete</paper-button
          >
        </div>
      </paper-dialog>
      <paper-dialog id="publishdialog">
        <h2>Ready to publish?</h2>
        <p>
          By publishing, the author of this submission will be able to view your
          feedback. Are you ready to publish?
        </p>
        <div class="buttons">
          <paper-button dialog-dismiss="">Cancel</paper-button>
          <paper-button dialog-confirm="" on-click="_submissionPublishConfirmed"
            >Yes Publish</paper-button
          >
        </div>
      </paper-dialog>

      <paper-toast id="toast"></paper-toast>
    `}static get tag(){return"lrnapp-studio-submission-page"}static get properties(){return{id:{type:String},hideMenuBar:{type:Boolean,value:!1},elmslnCourse:{type:String},elmslnSection:{type:String},basePath:{type:String},csrfToken:{type:String},endPoint:{type:String},endPoint:{type:String},basePath:{type:String},csrfToken:{type:String},reqUrl:{type:String},reqParams:{type:Object},submission:{type:Object},commentsUrl:{type:String,computed:"_computeCommentsUrl(id, endPoint, csrfToken)"},createStubUrl:{type:String,computed:"_computeCommentsStubUrl(id, endPoint, csrfToken)"},commentOpsBase:{type:String,computed:"_computeCommentsOpsUrl(id, endPoint, csrfToken)"},editPage:{type:Boolean,reflectToAttribute:!0},saving:{type:Boolean,value:!1,notify:!0,reflectToAttribute:!0},showComments:{type:Boolean,computed:"_computeShowComments(submission)"}}}connectedCallback(){super.connectedCallback(),(0,s.afterNextRender)(this,(function(){this.addEventListener("submissionDeleteClicked",this._submissionDeleteClicked.bind(this)),this.addEventListener("submissionPublishClicked",this._submissionPublishClicked.bind(this)),this.addEventListener("submissionSaveDraftClicked",this._submissionSaveDraftClicked.bind(this))}))}disconnectedCallback(){this.removeEventListener("submissionDeleteClicked",this._submissionDeleteClicked.bind(this)),this.removeEventListener("submissionPublishClicked",this._submissionPublishClicked.bind(this)),this.removeEventListener("submissionSaveDraftClicked",this._submissionSaveDraftClicked.bind(this)),super.disconnectedCallback()}static get observers(){return["_urlVarsChanged(id, endPoint)","_paramsChanged(csrfToken)","_bodyChanged(title)"]}_backToStudio(e){window.location.href=this.basePath+"lrnapp-open-studio"}_backToKanban(e){window.location.href=this.basePath+"lrnapp-studio-kanban"}_setEditRoute(e){this.set("route.path","edit"),this.notifyPath("route.path")}_resetRoute(e){this.set("route.path",""),this.notifyPath("route.path")}displayNewBadge(e){return 0==e}_computeCommentsUrl(e,t,s){return t+"/api/submissions/"+e+"/comments?token="+s}_computeCommentsOpsUrl(e,t,s){return t+"/api/submissions/"+e+"/comments"}_computeCommentsStubUrl(e,t,s){return t+"/api/submissions/"+e+"/comments/create-stub?token="+s}_urlVarsChanged(e,t){this.reqUrl=t+"/api/submissions/"+e}_paramsChanged(e){var t=this.reqParams||{};t.token=e,this.reqParams=t}_handleResponse(e){e.detail.response.data&&(this.set("submission",[]),this.set("submission",e.detail.response.data),i.microTask.run(()=>{window.dispatchEvent(new Event("resize"))}))}_isReply(e){this.thread=submission.relationships.comments.data.attributes.thread}_submissionSaveDraftClicked(e){this.saving=!0,this.shadowRoot.querySelector("#ajaxUpdateRequest").generateRequest()}_submissionPublishClicked(e){this.shadowRoot.querySelector("#publishdialog").open()}_submissionPublishConfirmed(e){this.saving=!0,this.shadowRoot.querySelector("#ajaxUpdateRequest").generateRequest()}_submissionDeleteClicked(e){this.shadowRoot.querySelector("#deletedialog").open()}_submissionDeleteConfirmed(e){this.saving=!0,this.$.ajaxDeleteRequest.generateRequest()}_handleUpdateResponse(e){var t=e.detail.response.status,s=e.detail.response.data;this.saving=!1,200===t&&(this.set("submission",{}),this.set("submission",s),this.set("route.path",""),"submission_ready"===s.attributes.state&&this.$.toast.show("Published!"),window.location.href=this.endPoint+"/submissions/"+s.id)}_handleDeleteResponse(e){var t=e.detail.response.status;this.saving=!1,200===t&&(window.location.href=this.basePath+"lrnapp-studio-kanban?deletetoast")}_computeShowComments(e){try{if("critique"!==e.meta.submissionType&&"submission_ready"==e.attributes.state)return!0}catch(t){}return!1}_toArray(e){return"object"==typeof e&&null!==e?Object.keys(e).map((function(t){return e[t]})):[]}}e.LrnappStudioSubmissionPage=LrnappStudioSubmissionPage,window.customElements.define(LrnappStudioSubmissionPage.tag,LrnappStudioSubmissionPage)}));