define(["exports","meta","require","../../../../lit-element/lit-element.js","../../../../@polymer/polymer/lib/utils/settings.js","../../../json-outline-schema/json-outline-schema.js","../../../utils/utils.js","../../../../mobx/lib/mobx.module.js","./haxcms-site-store.js","../../../../@polymer/iron-ajax/iron-ajax.js"],(function(e,t,a,i,s,o,d,n,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HAXCMSSiteBuilder=void 0,t=babelHelpers.interopRequireWildcard(t),a=babelHelpers.interopRequireWildcard(a);class HAXCMSSiteBuilder extends i.LitElement{static get styles(){return[i.css`
        :host {
          display: block;
        }
        :host #slot {
          background-color: var(--haxcms-color, white);
          opacity: 0.2;
          visibility: hidden;
        }
        :host([dashboard-opened]) {
          display: inline-block !important;
          margin-left: 50vw;
          height: 100vh;
          pointer-events: none;
          opacity: 0.5;
          width: 100vw;
        }
        :host([theme-loaded]) #slot {
          opacity: 1;
          visibility: visible;
        }
        paper-progress {
          display: block;
          width: 100%;
          position: fixed;
          top: 0;
          left: 0;
          right: 0;
          background-color: transparent;
          z-index: 1000;
          --paper-progress-active-color: var(
            --haxcms-color,
            rgba(255, 255, 255, 0.5)
          );
          --paper-progress-container-color: transparent;
        }
      `]}static get tag(){return"haxcms-site-builder"}render(){return i.html`
      <haxcms-site-router base-uri="${this.baseURI}"></haxcms-site-router>
      <paper-progress .hidden="${!this.loading}" indeterminate></paper-progress>
      <iron-ajax
        id="manifest"
        .url="${this.outlineLocation}${this.file}${this._timeStamp}"
        handle-as="json"
        @last-response-changed="${this._updateManifest}"
        @last-error-changed="${this.lastErrorChanged}"
      ></iron-ajax>
      <iron-ajax
        id="activecontent"
        .url="${this.outlineLocation}${this.activeItemLocation}${this._timeStamp}"
        handle-as="text"
        @loading-changed="${this._updateLoading}"
        @last-response-changed="${this._updateActiveItemContent}"
        @last-error-changed="${this.lastErrorChanged}"
      ></iron-ajax>
      <div id="slot"><slot></slot></div>
      <simple-colors-polymer></simple-colors-polymer>
    `}_updateManifest(e){this.manifest={...e.detail.value}}_updateLoading(e){this.loading=e.detail.value}_updateActiveItemContent(e){this.activeItemContent=e.detail.value}firstUpdated(){this.shadowRoot.querySelector("#manifest").generateRequest()}updated(e){e.forEach((e,t)=>{"dashboardOpened"==t?this._dashboardOpenedChanged(this[t],e):"themeData"==t?this._themeChanged(this[t],e):"themeName"==t?this._themeNameChanged(this[t],e):"file"==t?this._fileChanged(this[t],e):"outlineLocation"==t?this.dispatchEvent(new CustomEvent("outline-location-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this[t]})):"manifest"==t?(this.dispatchEvent(new CustomEvent("manifest-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this[t]})),this._manifestChanged(this[t],e)):"activeItem"==t?(this.dispatchEvent(new CustomEvent("active-item-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this[t]})),this._activeItemChanged(this[t],e)):"activeItemContent"==t&&(this.dispatchEvent(new CustomEvent("active-item-content-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this[t]})),this._activeItemContentChanged(this[t],e))})}static get properties(){return{activeItemLocation:{type:String,attribute:"active-item-location"},_timeStamp:{type:String},dashboardOpened:{type:Boolean,reflect:!0,attribute:"dashboard-opened"},queryParams:{type:Object},loading:{type:Boolean,reflect:!0},outlineLocation:{type:String,attribute:"outline-location"},manifest:{type:Object},themeData:{type:Object},themeName:{type:String},__imported:{type:Object},themeLoaded:{type:Boolean,reflect:!0,attribute:"theme-loaded"},activeItem:{type:Object},activeItemContent:{type:String},file:{type:String},baseURI:{type:String}}}_themeNameChanged(e){e?(r.store.themeElement=document.createElement(e),(0,d.wipeSlot)(this,"*"),this.appendChild(r.store.themeElement)):e&&oldValue&&(r.store.themeElement.remove(),(0,d.wipeSlot)(this,"*"),r.store.themeElement=document.createElement(e),this.appendChild(r.store.themeElement))}lastErrorChanged(e){if(e.detail.value){console.error(e);const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!1,detail:{text:e.detail.value.status+" "+e.detail.value.statusText}});window.dispatchEvent(t)}}constructor(){super(),(0,s.setPassiveTouchGestures)(!0),this.__disposer=[],this.queryParams={},this.loading=!1,this.__imported={},this.themeLoaded=!1,this._timeStamp="",this.outlineLocation="",this.activeItemLocation="",new Promise((e,t)=>a.default(["./haxcms-site-router.js"],e,t)),new Promise((e,t)=>a.default(["../../../../@polymer/paper-progress/paper-progress.js"],e,t)),new Promise((e,t)=>a.default(["../../../simple-toast/simple-toast.js"],e,t)),new Promise((e,t)=>a.default(["../../../simple-colors/lib/simple-colors-polymer.js"],e,t)),setTimeout(()=>{window.addEventListener("hax-store-ready",this.storeReady.bind(this)),window.addEventListener("haxcms-trigger-update",this._triggerUpdatedData.bind(this)),window.addEventListener("haxcms-trigger-update-node",this._triggerUpdatedNode.bind(this)),(0,n.autorun)(e=>{this.dashboardOpened=(0,n.toJS)(r.store.dashboardOpened),this.__disposer.push(e)}),(0,n.autorun)(e=>{this.themeData=(0,n.toJS)(r.store.themeData),this.themeData&&this.themeData.element!==this.themeName&&(this.themeName=this.themeData.element),this.__disposer.push(e)}),(0,n.autorun)(e=>{this.activeItem=(0,n.toJS)(r.store.activeItem),this.activeItem&&this.activeItem.location&&(this.activeItemLocation=this.activeItem.location),this.__disposer.push(e)})},0)}_dashboardOpenedChanged(e,t){e?(this.setAttribute("aria-hidden","aria-hidden"),this.setAttribute("tabindex","-1")):!e&&t&&(this.removeAttribute("aria-hidden"),this.removeAttribute("tabindex"))}connectedCallback(){super.connectedCallback(),this.dispatchEvent(new CustomEvent("haxcms-ready",{bubbles:!0,composed:!0,cancelable:!1,detail:this})),new Promise((e,t)=>a.default(["./haxcms-editor-builder.js"],e,t)).then(e=>{this.editorBuilder=document.createElement("haxcms-editor-builder"),document.body.appendChild(this.editorBuilder),"published"!==this.editorBuilder.getContext()&&"demo"!==this.editorBuilder.getContext()&&(this._timeStamp="?"+Math.floor(Date.now()/1e3))}).catch(e=>{console.log(e)});var e=document.createEvent("UIEvents");e.initUIEvent("resize",!0,!1,window,0),window.dispatchEvent(e)}disconnectedCallback(){for(var e in this.__disposer)this.__disposer[e].dispose();super.disconnectedCallback()}storeReady(e){r.store.cmsSiteEditor&&r.store.cmsSiteEditor.instance&&window.HaxStore.instance.activeHaxBody&&r.store.activeItemContent&&window.HaxStore.instance.activeHaxBody.importContent(r.store.activeItemContent)}_activeItemContentChanged(e,i){if(e){var s=e;if(null!==s&&((0,d.wipeSlot)(r.store.themeElement,"*"),s=(0,d.encapScript)(e),r.store.activeItemContent=s,setTimeout(()=>{if(0===r.store.themeElement.childNodes.length){let e=document.createRange().createContextualFragment(s);r.store.themeElement.appendChild(e),this.dispatchEvent(new CustomEvent("json-outline-schema-active-body-changed",{bubbles:!0,composed:!0,cancelable:!1,detail:s}))}},5),(0,d.varExists)(this.manifest,"metadata.node.dynamicElementLoader"))){let e=(0,d.findTagsInHTML)(s);const i=this.pathFromUrl(decodeURIComponent(t.url));for(var o in e){const t=e[o];this.manifest.metadata.node.dynamicElementLoader[t]&&!window.customElements.get(t)&&new Promise((e,s)=>a.default([`${i}../../../../${this.manifest.metadata.node.dynamicElementLoader[t]}`],e,s)).then(e=>{}).catch(e=>{console.log(e),console.log(t)})}}}}_activeItemChanged(e,t){this.shadowRoot&&e&&void 0!==e.id?(this.queryParams.nodeId=e.id,this.editorBuilder&&"published"===this.editorBuilder.getContext()?this._timeStamp="":this._timeStamp="?"+Math.floor(Date.now()/1e3),this.shadowRoot.querySelector("#activecontent").generateRequest()):t&&!e&&this.dispatchEvent(new CustomEvent("json-outline-schema-active-body-changed",{bubbles:!0,composed:!0,cancelable:!1,detail:null}))}_triggerUpdatedData(e){this.editorBuilder&&"published"!==this.editorBuilder.getContext()&&(this._timeStamp="?"+Math.floor(Date.now()/1e3)),this.shadowRoot.querySelector("#manifest").generateRequest()}_triggerUpdatedNode(e){this.editorBuilder&&"published"!==this.editorBuilder.getContext()&&"demo"!==this.editorBuilder.getContext()&&(this._timeStamp="?"+Math.floor(Date.now()/1e3)),this.activeItem.location&&this.shadowRoot.querySelector("#activecontent").generateRequest()}_fileChanged(e,t){this.shadowRoot.querySelector("#manifest").generateRequest&&void 0!==e&&this.shadowRoot.querySelector("#manifest").generateRequest()}_manifestChanged(e,t){if(e&&e.metadata&&e.items){if((0,d.varExists)(e,"metadata.siteName")){let t=(0,d.varGet)(e,"publishing.git",{});e.metadata.site={name:e.metadata.siteName,git:t,created:e.metadata.created,updated:e.metadata.updated},e.metadata.theme.variables={image:e.metadata.image,icon:e.metadata.icon,hexCode:e.metadata.hexCode,cssVariable:e.metadata.cssVariable},e.metadata.node={dynamicElementLoader:e.metadata.dynamicElementLoader,fields:e.metadata.fields},delete e.metadata.publishing,delete e.metadata.created,delete e.metadata.updated,delete e.metadata.siteName,delete e.metadata.image,delete e.metadata.icon,delete e.metadata.hexCode,delete e.metadata.cssVariable,delete e.metadata.dynamicElementLoader,delete e.metadata.fields}var a=new o.JsonOutlineSchema,i=a.itemsToNodes(e.items),s=a.nodesToItems(i),n=[];for(var l in s)n.push(e.items.find(e=>e.id===s[l].id));e.items=n,r.store.manifest=e,this.dispatchEvent(new CustomEvent("json-outline-schema-changed",{bubbles:!0,composed:!0,cancelable:!1,detail:e}))}}pathFromUrl(e){return e.substring(0,e.lastIndexOf("/")+1)}_themeChanged(e,i){if(e){this.themeLoaded=!1;let i=e;if(void 0!==this.__imported[i.element])this.themeLoaded=!0;else try{new Promise((i,s)=>a.default([this.pathFromUrl(decodeURIComponent(t.url))+"../../../../"+e.path],i,s)).then(e=>{this.__imported[i.element]=i.element,this.themeLoaded=!0})}catch(s){this.themeLoaded=!0}}}}e.HAXCMSSiteBuilder=HAXCMSSiteBuilder,window.customElements.define(HAXCMSSiteBuilder.tag,HAXCMSSiteBuilder),window.HAXme=function(e=null){null==e&&(e="demo",window.appSettings={login:"dist/dev/login.json",logout:"dist/dev/logout.json",saveNodePath:"dist/dev/saveNode.json",saveManifestPath:"dist/dev/saveManifestPath.json",createNodePath:"dist/dev/saveNode.json",deleteNodePath:"dist/dev/saveNode.json",saveOutlinePath:"dist/dev/saveNode.json",publishSitePath:"dist/dev/saveNode.json",syncSitePath:"dist/dev/saveNode.json",getNodeFieldsPath:"dist/dev/getNodeFieldsPath.json",getSiteFieldsPath:"dist/dev/getSiteFieldsPath.json",revertSitePath:"dist/dev/saveNode.json",getFormToken:"adskjadshjudfu823u823u8fu8fij",appStore:{url:"dist/dev/appstore.json"},themes:{"haxcms-dev-theme":{element:"haxcms-dev-theme",path:"@lrnwebcomponents/haxcms-elements/lib/haxcms-dev-theme.js",name:"Developer theme"}}}),"demo"==e&&(window.__haxCMSContextDemo=!0),document.body.querySelector("haxcms-editor-builder").__appliedContext=!1,document.body.querySelector("haxcms-editor-builder").applyContext(e)}}));