define(["exports","../../../../lit-element/lit-element.js","./haxcms-site-store.js","../../../../mobx/lib/mobx.module.js","../../../hax-body-behaviors/lib/HAXWiring.js","../../../simple-colors/lib/simple-colors-polymer.js","../../../../@polymer/iron-ajax/iron-ajax.js","../../../jwt-login/jwt-login.js","../../../h-a-x/h-a-x.js","../../../simple-toast/simple-toast.js","../../../simple-modal/simple-modal.js","../../../../@polymer/paper-button/paper-button.js","../../../hax-body/lib/hax-schema-form.js","./haxcms-site-dashboard.js"],(function(e,t,s,a,i,n,o,d,h,r,l,c,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HAXCMSSiteEditor=void 0;
/**
   * Copyright 2018 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class HAXCMSSiteEditor extends t.LitElement{static get tag(){return"haxcms-site-editor"}constructor(){super(),this.__disposer=[],this.method="POST",this.editMode=!1}render(){return t.html`
      <style>
        :host {
          display: block;
        }
        #editbutton {
          position: fixed;
          bottom: 0;
          right: 0;
          margin: 16px;
          padding: 2px;
          width: 40px;
          height: 40px;
          visibility: visible;
          opacity: 1;
          transition: all 0.4s ease;
          z-index: 1000;
        }
        #outlinebutton {
          position: fixed;
          bottom: 0;
          right: 46px;
          margin: 16px;
          padding: 2px;
          width: 40px;
          height: 40px;
          visibility: visible;
          opacity: 1;
          transition: all 0.4s ease;
          z-index: 1000;
        }
        :host([edit-mode]) #editbutton {
          width: 100%;
          z-index: 100;
          right: 0;
          bottom: 0;
          border-radius: 0;
          height: 80px;
          margin: 0;
          padding: 8px;
          background-color: var(--paper-blue-500) !important;
        }
        h-a-x {
          margin: auto;
          display: none;
        }
        :host([edit-mode]) h-a-x {
          display: block;
        }
      </style>
      <iron-ajax
        reject-with-request
        .headers='{"Authorization": "Bearer ${this.jwt}"}'
        id="nodeupdateajax"
        .url="${this.saveNodePath}"
        .method="${this.method}"
        content-type="application/json"
        handle-as="json"
        @response="${this._handleNodeResponse}"
        @last-error-changed="${this.lastErrorChanged}"
      ></iron-ajax>
      <iron-ajax
        reject-with-request
        .headers='{"Authorization": "Bearer ${this.jwt}"}'
        id="outlineupdateajax"
        .url="${this.saveOutlinePath}"
        .method="${this.method}"
        content-type="application/json"
        handle-as="json"
        @response="${this._handleOutlineResponse}"
        @last-error-changed="${this.lastErrorChanged}"
      ></iron-ajax>
      <iron-ajax
        reject-with-request
        .headers='{"Authorization": "Bearer ${this.jwt}"}'
        id="manifestupdateajax"
        .url="${this.saveManifestPath}"
        .method="${this.method}"
        content-type="application/json"
        handle-as="json"
        @response="${this._handleManifestResponse}"
        @last-error-changed="${this.lastErrorChanged}"
      ></iron-ajax>
      <iron-ajax
        reject-with-request
        .headers='{"Authorization": "Bearer ${this.jwt}"}'
        id="publishajax"
        .loading="${this.publishing}"
        @loading-changed="${this.loadingChanged}"
        .url="${this.publishSitePath}"
        .method="${this.method}"
        content-type="application/json"
        handle-as="json"
        @response="${this._handlePublishResponse}"
        @last-error-changed="${this.lastErrorChanged}"
      ></iron-ajax>
      <iron-ajax
        reject-with-request
        .headers='{"Authorization": "Bearer ${this.jwt}"}'
        id="revertajax"
        .url="${this.revertSitePath}"
        .method="${this.method}"
        content-type="application/json"
        handle-as="json"
        @response="${this._handleRevertResponse}"
        @last-error-changed="${this.lastErrorChanged}"
      ></iron-ajax>
      <iron-ajax
        reject-with-request
        .headers='{"Authorization": "Bearer ${this.jwt}"}'
        id="syncajax"
        .url="${this.syncSitePath}"
        .method="${this.method}"
        content-type="application/json"
        handle-as="json"
        @response="${this._handleSyncResponse}"
        @last-error-changed="${this.lastErrorChanged}"
      ></iron-ajax>
      <iron-ajax
        reject-with-request
        .headers='{"Authorization": "Bearer ${this.jwt}"}'
        id="createajax"
        .url="${this.createNodePath}"
        .method="${this.method}"
        content-type="application/json"
        handle-as="json"
        @response="${this._handleCreateResponse}"
        @last-error-changed="${this.lastErrorChanged}"
        @last-response-changed="${this.__createNodeResponseChanged}"
      ></iron-ajax>
      <iron-ajax
        reject-with-request
        .headers='{"Authorization": "Bearer ${this.jwt}"}'
        id="deleteajax"
        .url="${this.deleteNodePath}"
        .method="${this.method}"
        content-type="application/json"
        handle-as="json"
        @response="${this._handleDeleteResponse}"
        @last-error-changed="${this.lastErrorChanged}"
        @last-response-changed="${this.__deleteNodeResponseChanged}"
      ></iron-ajax>
      <iron-ajax
        reject-with-request
        .headers='{"Authorization": "Bearer ${this.jwt}"}'
        id="getnodefieldsajax"
        .url="${this.getNodeFieldsPath}"
        .method="${this.method}"
        content-type="application/json"
        handle-as="json"
        @response="${this._handleGetNodeFieldsResponse}"
        @last-error-changed="${this.lastErrorChanged}"
      ></iron-ajax>
      <iron-ajax
        reject-with-request
        headers='{"Authorization": "Bearer ${this.jwt}"}'
        id="getuserdata"
        url="${this.getUserDataPath}"
        method="${this.method}"
        content-type="application/json"
        handle-as="json"
        @response="${this._handleUserDataResponse}"
        @last-error-changed="${this.lastErrorChanged}"
      ></iron-ajax>
      <h-a-x
        id="hax"
        element-align="left"
        offset-margin="0 0 0 48px"
        hide-panel-ops="hide-panel-ops"
      ></h-a-x>
    `}static get properties(){return{getUserDataPath:{type:String,attribute:"get-user-data-path"},method:{type:String},jwt:{type:String},saveNodePath:{type:String,attribute:"save-node-path"},createNodePath:{type:String,attribute:"create-node-path"},deleteNodePath:{type:String,attribute:"delete-node-path"},saveManifestPath:{type:String,attribute:"save-manifest-path"},publishSitePath:{type:String,attribute:"publish-site-path"},revertSitePath:{type:String,attribute:"revert-site-path"},appendTarget:{type:Object},appElement:{type:Object},syncSitePath:{type:String,attribute:"sync-site-path"},publishing:{type:Boolean},saveOutlinePath:{type:String,attribute:"save-outline-path"},appStore:{type:Object},editMode:{type:Boolean,reflect:!0,attribute:"edit-mode"},activeItem:{type:Object},manifest:{type:Object},getNodeFieldsPath:{type:String,attribute:"get-node-fields-path"},getSiteFieldsPath:{type:String,attribute:"save-site-fields-path"},getFormToken:{type:String,attribute:"get-form-token"},siteDashboard:{type:Object}}}__deleteNodeResponseChanged(e){this.__deleteNodeResponse=e.detail.value}__createNodeResponseChanged(e){this.__createNodeResponse=e.detail.value}_handleUserDataResponse(e){e.detail.response&&e.detail.response.data&&(s.store.userData=e.detail.response.data)}lastErrorChanged(e){if(e.detail.value)switch(console.error(e),parseInt(e.detail.value.status)){case 401:this.dispatchEvent(new CustomEvent("jwt-login-logout",{composed:!0,bubbles:!0,cancelable:!1,detail:{redirect:!0}}));break;case 403:this.dispatchEvent(new CustomEvent("jwt-login-refresh-token",{composed:!0,bubbles:!0,cancelable:!1,detail:{element:{obj:this,callback:"refreshRequest",params:[e.path[0]]}}}));break;default:const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:e.detail.value.status+" "+e.detail.value.statusText}});window.dispatchEvent(t)}}refreshRequest(e,t){this.jwt=e,t.body.jwt=e,t.headers={Authorization:`Bearer ${this.jwt}`},setTimeout(()=>{t.generateRequest()},0)}loadingChanged(e){this.loading=e.detail.value}createRenderRoot(){return this}firstUpdated(e){if((0,a.autorun)(e=>{this.editMode=(0,a.toJS)(s.store.editMode),this.__disposer.push(e)}),(0,a.autorun)(e=>{this.manifest=(0,a.toJS)(s.store.manifest),this.__disposer.push(e)}),(0,a.autorun)(e=>{this.activeItem=(0,a.toJS)(s.store.activeItem),this.__disposer.push(e)}),window.SimpleToast.requestAvailability(),window.SimpleModal.requestAvailability(),window.addEventListener("jwt-login-refresh-error",this._tokenRefreshFailed.bind(this)),window.addEventListener("hax-store-ready",this._storeReadyToGo.bind(this)),window.addEventListener("json-outline-schema-active-item-changed",this._newActiveItem.bind(this)),window.addEventListener("json-outline-schema-active-body-changed",this._bodyChanged.bind(this)),window.addEventListener("haxcms-save-outline",this.saveOutline.bind(this)),window.addEventListener("haxcms-save-node",this.saveNode.bind(this)),window.addEventListener("haxcms-save-node-details",this.saveNodeDetails.bind(this)),window.addEventListener("haxcms-save-site-data",this.saveManifest.bind(this)),window.addEventListener("haxcms-load-node-fields",this.loadNodeFields.bind(this)),window.addEventListener("haxcms-load-site-dashboard",this.loadSiteDashboard.bind(this)),window.addEventListener("haxcms-load-user-data",this.loadUserData.bind(this)),window.addEventListener("haxcms-publish-site",this.publishSite.bind(this)),window.addEventListener("haxcms-sync-site",this.syncSite.bind(this)),window.addEventListener("haxcms-git-revert-last-commit",this.revertCommit.bind(this)),window.addEventListener("haxcms-create-node",this.createNode.bind(this)),window.addEventListener("haxcms-delete-node",this.deleteNode.bind(this)),window.HaxStore.ready){let e={detail:!0};this._storeReadyToGo(e)}const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:"You are logged in, edit tools shown."}});window.dispatchEvent(t),window.dispatchEvent(new CustomEvent("haxcms-site-editor-loaded",{bubbles:!0,composed:!0,cancelable:!1,detail:!0})),this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0}))}updated(e){e.forEach((e,t)=>{"appStore"==t&&this.querySelector("#hax").setAttribute("app-store",JSON.stringify(this[t])),"publishing"==t?this._publishingChanged(this[t],e):"activeItem"==t?(this.dispatchEvent(new CustomEvent("manifest-changed",{detail:this[t]})),this._activeItemChanged(this[t],e)):"manifest"==t&&(this.dispatchEvent(new CustomEvent("manifest-changed",{detail:this[t]})),this._manifestChanged(this[t],e))})}_tokenRefreshFailed(e){401==e.detail.value.status&&this.dispatchEvent(new CustomEvent("jwt-login-logout",{composed:!0,bubbles:!0,cancelable:!1,detail:{redirect:!0}}))}disconnectedCallback(){for(var e in this.siteDashboard&&(this.siteDashboard.remove(),delete this.siteDashboard),this.__disposer)this.__disposer[e].dispose();window.removeEventListener("jwt-login-refresh-error",this._tokenRefreshFailed.bind(this)),window.removeEventListener("hax-store-ready",this._storeReadyToGo.bind(this)),window.removeEventListener("haxcms-save-outline",this.saveOutline.bind(this)),window.removeEventListener("haxcms-save-node",this.saveNode.bind(this)),window.removeEventListener("haxcms-save-node-details",this.saveNodeDetails.bind(this)),window.removeEventListener("haxcms-save-site-data",this.saveManifest.bind(this)),window.removeEventListener("haxcms-publish-site",this.publishSite.bind(this)),window.removeEventListener("haxcms-sync-site",this.syncSite.bind(this)),window.removeEventListener("haxcms-git-revert-last-commit",this.revertCommit.bind(this)),window.removeEventListener("json-outline-schema-active-item-changed",this._newActiveItem.bind(this)),window.removeEventListener("json-outline-schema-active-body-changed",this._bodyChanged.bind(this)),window.removeEventListener("haxcms-load-node-fields",this.loadNodeFields.bind(this)),window.removeEventListener("haxcms-load-site-dashboard",this.loadSiteDashboard.bind(this)),window.removeEventListener("haxcms-load-user-data",this.loadUserData.bind(this)),window.removeEventListener("haxcms-create-node",this.createNode.bind(this)),window.removeEventListener("haxcms-delete-node",this.deleteNode.bind(this)),super.disconnectedCallback()}loadUserData(e){this.querySelector("#getuserdata").body={jwt:this.jwt},this.querySelector("#getuserdata").generateRequest()}loadNodeFields(e){this.__nodeFieldsInvoked=e.detail,this.querySelector("#getnodefieldsajax").body={jwt:this.jwt,token:this.getFormToken,site:{name:this.manifest.metadata.site.name},node:{id:this.activeItem.id}},this.querySelector("#getnodefieldsajax").generateRequest()}loadSiteDashboard(e){if(this.__siteFieldsInvoked=e.detail,!this.siteDashboard){let e=document.getElementsByTagName("haxcms-site-builder")[0];this.siteDashboard=document.createElement("haxcms-site-dashboard"),this.siteDashboard.headers={Authorization:`Bearer ${this.jwt}`},this.siteDashboard.loadEndpoint=this.getSiteFieldsPath,this.siteDashboard.method=this.method,e.parentNode.insertBefore(this.siteDashboard,e)}this.siteDashboard.body={jwt:this.jwt,token:this.getFormToken,site:{name:this.manifest.metadata.site.name}},this.siteDashboard.headers={Authorization:`Bearer ${this.jwt}`},setTimeout(()=>{s.store.dashboardOpened=!s.store.dashboardOpened},300)}_handleGetNodeFieldsResponse(e){let t=new i.HAXWiring;this._haxSchema=t.prototypeHaxProperties(),this._haxSchema.settings=e.detail.response.haxSchema;let a=e.detail.response.values,n=document.createElement("hax-schema-form");for(var o in n.style.minWidth="50vw",this._haxSchema.settings){let e=t.getHaxJSONSchema(o,this._haxSchema);for(var d in e.properties)a[d]&&(e.properties[d].value=a[d]);n.set(o+"Schema",e)}this.__fieldsForm=n;let h=document.createElement("paper-button"),r=document.createElement("iron-icon");r.icon="icons:save",h.appendChild(r),h.appendChild(document.createTextNode("Save fields")),h.style.color="white",h.style.backgroundColor="#2196f3",h.setAttribute("dialog-confirm","dialog-confirm"),h.addEventListener("click",this._saveNodeFieldsTap.bind(this));let l=document.createElement("paper-button");l.appendChild(document.createTextNode("cancel")),l.setAttribute("dialog-dismiss","dialog-dismiss");let c=document.createElement("div");c.style.position="absolute",c.style.bottom=0,c.style.left=0,c.style.right=0,c.style.zIndex=1e6,c.appendChild(h),c.appendChild(l);const m=new CustomEvent("simple-modal-show",{bubbles:!0,composed:!0,cancelable:!1,detail:{title:"Edit "+s.store.activeTitle+" fields",styles:{"--simple-modal-width":"75vw","--simple-modal-max-width":"75vw"},elements:{content:n,buttons:c},invokedBy:this.__nodeFieldsInvoked,clone:!1,modal:!0}});window.dispatchEvent(m)}_schemaFormValueChanged(e){}_saveNodeFieldsTap(e){let t=this.__fieldsForm.value;t.id=this.activeItem.id,window.dispatchEvent(new CustomEvent("haxcms-save-node-details",{bubbles:!0,composed:!0,cancelable:!0,detail:t})),window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,composed:!0,cancelable:!0,detail:{}}))}_saveSiteFieldsTap(e){window.dispatchEvent(new CustomEvent("haxcms-save-site-data",{bubbles:!0,composed:!0,cancelable:!0,detail:this.querySelector("#siteform").submit()})),window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,composed:!0,cancelable:!0,detail:{}}))}createNode(e){if(e.detail.values){this.querySelector("#createajax").body={jwt:this.jwt,site:{name:this.manifest.metadata.site.name},node:e.detail.values},this.querySelector("#createajax").generateRequest();const t=new CustomEvent("simple-modal-hide",{bubbles:!0,composed:!0,cancelable:!0,detail:{}});window.dispatchEvent(t)}}_handleCreateResponse(e){const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:`Created ${this.__createNodeResponse.title}!`,duration:3e3}});window.dispatchEvent(t),this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0}))}deleteNode(e){this.querySelector("#deleteajax").body={jwt:this.jwt,site:{name:this.manifest.metadata.site.name},node:{id:e.detail.item.id}},this.querySelector("#deleteajax").generateRequest();const t=new CustomEvent("simple-modal-hide",{bubbles:!0,composed:!0,cancelable:!0,detail:{}});window.dispatchEvent(t)}_handleDeleteResponse(e){const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:`Deleted ${this.__deleteNodeResponse.title}`,duration:3e3}});this.dispatchEvent(t),this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0}))}_storeReadyToGo(e){e.detail&&(window.HaxStore.instance.connectionRewrites.appendJwt="jwt")}_publishingChanged(e,t){if(e){const e=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:"Publishing...",duration:0}});window.dispatchEvent(e)}else if(!e&&t){const e=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:"Publishing...",duration:3e3}});window.dispatchEvent(e)}}_manifestChanged(e){this.activeItem&&e.metadata&&(window.HaxStore.instance.connectionRewrites.appendUploadEndPoint="siteName="+e.metadata.site.name+"&nodeId="+this.activeItem.id)}_newActiveItem(e){this.activeItem=e.detail}_activeItemChanged(e,t){e&&this.manifest&&(window.HaxStore.instance.connectionRewrites.appendUploadEndPoint="siteName="+this.manifest.metadata.site.name+"&nodeId="+e.id)}_handleNodeResponse(e){if(void 0!==e.detail.location&&this.activeItem.location!==e.detail.location){window.location(e.detail.location),window.history.pushState({},null,e.detail.location),window.dispatchEvent(new PopStateEvent("popstate"));const t=this.manifest.items.find(t=>t.id===e.detail.id);this.activeItem=t,this.dispatchEvent(new CustomEvent("json-outline-schema-active-item-changed",{bubbles:!0,composed:!0,cancelable:!0,detail:t}))}const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:"Page saved!",duration:4e3}});window.dispatchEvent(t),this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0})),this.dispatchEvent(new CustomEvent("haxcms-trigger-update-node",{bubbles:!0,composed:!0,cancelable:!1,detail:!0}))}_handleOutlineResponse(e){const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:"Outline saved!",duration:3e3}});window.dispatchEvent(t),this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0})),setTimeout(()=>{window.dispatchEvent(t),this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0}))},100)}_handleManifestResponse(e){const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:"Site details saved!",duration:3e3}});s.store.dashboardOpened=!1,this.dispatchEvent(t),this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0}))}_handleRevertResponse(e){const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:"Last save undone",duration:3e3}});this.dispatchEvent(t),this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0}))}_handleSyncResponse(e){const t=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:"Site synced",duration:3e3}});this.dispatchEvent(t),this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0})),s.store.dashboardOpened=!1}_handlePublishResponse(e){let t=e.detail.response,a=document.createElement("span");a.innerHTML=`\n    <a href="${t.url}" target="_blank">\n      <paper-button raised style="color:yellow;text-transform: none;font-weight: bold;">\n      ${t.label}\n      </paper-button>\n    </a>`;const i=new CustomEvent("simple-toast-show",{bubbles:!0,composed:!0,cancelable:!0,detail:{text:t.response,duration:1e4,slot:a.cloneNode(!0)}});window.dispatchEvent(i),s.store.dashboardOpened=!1}saveNode(e){if(this.saveNodePath){let e=window.HaxStore.instance.activeHaxBody.haxToContent();this.querySelector("#nodeupdateajax").body={jwt:this.jwt,site:{name:this.manifest.metadata.site.name},node:{id:this.activeItem.id,body:e,schema:window.HaxStore.htmlToHaxElements(e)}},this.querySelector("#nodeupdateajax").generateRequest()}}saveNodeDetails(e){this.saveNodePath&&(this.querySelector("#nodeupdateajax").body={jwt:this.jwt,site:{name:this.manifest.metadata.site.name},node:{id:e.detail.id,details:e.detail}},this.querySelector("#nodeupdateajax").generateRequest())}saveOutline(e){this.saveOutlinePath&&(this.querySelector("#outlineupdateajax").body={jwt:this.jwt,site:{name:this.manifest.metadata.site.name},items:e.detail},this.querySelector("#outlineupdateajax").generateRequest())}saveManifest(e){let t=e.detail;t.cssVariable&&(t.hexCode=window.SimpleColorsStyles.colors[t.cssVariable.replace("--simple-colors-default-theme-","").replace("-7","")][6]),t.jwt=this.jwt,t.site?t.site.name=this.manifest.metadata.site.name:t.site={name:this.manifest.metadata.site.name},this.saveManifestPath&&(this.querySelector("#manifestupdateajax").body=t,this.querySelector("#manifestupdateajax").generateRequest())}_bodyChanged(e){window.HaxStore.instance.activeHaxBody&&window.HaxStore.instance.activeHaxBody.importContent(e.detail)}publishSite(e){this.publishSitePath&&(this.querySelector("#publishajax").body={jwt:this.jwt,site:{name:this.manifest.metadata.site.name}},this.querySelector("#publishajax").generateRequest())}syncSite(e){this.syncSitePath&&(this.querySelector("#syncajax").body={jwt:this.jwt,site:{name:s.store.manifest.metadata.site.name}},this.querySelector("#syncajax").generateRequest())}revertCommit(e){this.revertSitePath&&(this.querySelector("#revertajax").body={jwt:this.jwt,site:{name:s.store.manifest.metadata.site.name}},this.querySelector("#revertajax").generateRequest())}}e.HAXCMSSiteEditor=HAXCMSSiteEditor,window.customElements.define(HAXCMSSiteEditor.tag,HAXCMSSiteEditor)}));