define(["exports","require","../../../../../lit-element/lit-element.js","../../core/haxcms-site-store.js","../../../../../mobx/lib/mobx.module.js","../../../../../@polymer/polymer/lib/elements/custom-style.js"],(function(t,e,i,o,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SiteMenuButton=void 0,e=babelHelpers.interopRequireWildcard(e);
/**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class SiteMenuButton extends i.LitElement{static get styles(){return[i.css`
        :host {
          display: block;
          font-size: 16px;
          transition: 0.3s all ease-in-out;
        }
        :host([disabled]) {
          pointer-events: none;
          opacity: 0.3;
        }
        a {
          color: var(--site-menu-button-link-color, black);
          text-decoration: underline;
        }
        paper-button {
          transition: 0.3s all ease-in-out;
          min-width: unset;
        }
        iron-icon {
          display: block;
          font-size: 16px;
          --iron-icon-width: var(--site-menu-button-icon-width, 32px);
          --iron-icon-height: var(--site-menu-button-icon-height, 32px);
          --iron-icon-fill-color: var(
            --site-menu-button-icon-fill-color,
            black
          );
        }
        simple-tooltip {
          --simple-tooltip-background: var(
            --site-menu-button-tooltip-bg,
            #000000
          );
          --simple-tooltip-opacity: 1;
          --simple-tooltip-text-color: var(
            --site-menu-button-tooltip-text,
            #ffffff
          );
          --simple-tooltip-delay-in: 0;
          --simple-tooltip-border-radius: 0;
        }
      `]}static get tag(){return"site-menu-button"}constructor(){super(),this.__disposer=[],(0,n.autorun)(t=>{this.activeRouterManifestIndex=(0,n.toJS)(o.store.activeRouterManifestIndex),this.__disposer.push(t)}),(0,n.autorun)(t=>{this.routerManifest=(0,n.toJS)(o.store.routerManifest),this.__disposer.push(t)}),(0,n.autorun)(t=>{this.editMode=(0,n.toJS)(o.store.editMode),this.__disposer.push(t)}),new Promise((t,i)=>e.default(["../../../../../@polymer/iron-icon/iron-icon.js"],t,i)),new Promise((t,i)=>e.default(["../../../../../@polymer/iron-icons/iron-icons.js"],t,i)),new Promise((t,i)=>e.default(["../../../../simple-tooltip/simple-tooltip.js"],t,i)),new Promise((t,i)=>e.default(["../../../../../@polymer/paper-button/paper-button.js"],t,i))}render(){return i.html`
      <custom-style>
        <style>
          paper-button {
            @apply --site-menu-button-button;
          }
          paper-button:hover,
          paper-button:focus,
          paper-button:active {
            @apply --site-menu-button-button-hover;
          }
        </style>
      </custom-style>
      <a tabindex="-1" ?disabled="${this.disabled}" .title="${this.label}">
        <paper-button
          id="menulink"
          noink
          ?disabled="${this.disabled}"
          ?raised="${this.raised}"
          title="${this.label}"
        >
          <slot name="prefix"></slot>
          <iron-icon icon="${this.icon}"></iron-icon>
          <slot name="suffix"></slot>
        </paper-button>
      </a>
      <simple-tooltip for="menulink" offset="8" .position="${this.position}">
        ${this.label}
      </simple-tooltip>
    `}static get properties(){return{type:{type:String,reflect:!0},activeRouterManifestIndex:{type:String},routerManifest:{type:Object},link:{type:String},editMode:{type:Boolean,reflect:!0,attribute:"edit-mode"},disabled:{type:Boolean,reflect:!0,attribute:"disabled"},label:{type:String},icon:{type:String},position:{type:String},raised:{type:Boolean}}}updated(t){t.forEach((t,e)=>{"type"==e&&this._typeChanged(this[e],t),"link"==e&&this._linkChanged(this[e]),["type","activeRouterManifestIndex","routerManifest"].includes(e)&&(this.link=this.pageLink(this.type,this.activeRouterManifestIndex,this.routerManifest.items),this.label=this.pageLinkLabel(this.type,this.activeRouterManifestIndex,this.routerManifest.items)),["type","activeRouterManifestIndex","routerManifest","editMode","link"].includes(e)&&(this.disabled=this.pageLinkStatus(this.type,this.activeRouterManifestIndex,this.routerManifest.items,this.editMode,this.link))})}_linkChanged(t){null==t?this.shadowRoot.querySelector("a").removeAttribute("href"):this.shadowRoot.querySelector("a").setAttribute("href",t)}_typeChanged(t){"prev"===t?(this.icon||(this.icon="icons:chevron-left"),this.position||(this.position="right")):"next"===t?(this.icon||(this.icon="icons:chevron-right"),this.position||(this.position="left")):(this.icon="",this.direction="")}pageLink(t,e,i){return"prev"===t&&i?e>0&&i[e-1]?i[e-1].location:null:"next"===t&&i&&e<i.length-1&&i[e+1]?i[e+1].location:null}pageLinkStatus(t,e,i,o,n){if(o||null==n)return!0;if("prev"===t){if(0===e||-1===e)return!0}else if("next"===t&&i&&e>=i.length-1)return!0;return!1}pageLinkLabel(t,e,i){return"prev"===t&&i?0!==e&&-1!==e&&i[e-1]?i[e-1].title:"":"next"===t&&i?e>=i.length-1||!i[e+1]?"":i[e+1].title:void 0}disconnectedCallback(){for(var t in this.__disposer)this.__disposer[t].dispose();super.disconnectedCallback()}}t.SiteMenuButton=SiteMenuButton,window.customElements.define(SiteMenuButton.tag,SiteMenuButton)}));