define(["exports","../../../@polymer/polymer/polymer-element.js","../../../@polymer/polymer/lib/utils/render-status.js","./lrndesign-gallery-behaviors.js","./lrndesign-gallery-zoom.js","./lrndesign-gallery-details.js"],(function(e,t,i,l,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LrndesignGalleryGrid=void 0;
/**
   * Copyright 2018 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class LrndesignGalleryGrid extends l.LrndesignGalleryBehaviors{static get tag(){return"lrndesign-gallery-grid"}static get behaviors(){return[l.LrndesignGalleryBehaviors]}static get template(){return t.html`
      <style is="custom-style" include="lrndesign-gallery-shared-styles">
        :host {
          margin: 15px 0 0;
          padding: 0;
          max-width: 100%;
          display: block;
        }
        :host .gallerythumb div {
          position: relative;
          display: flex;
          align-items: stretch;
        }
        :host .gallerythumb div,
        :host .gallerythumb iron-image {
          width: 100%;
        }
        :host .gallerythumb {
          width: var(--lrndesign-gallery-grid-thumbnail-xs, 100px);
        }
        :host([responsive-size="sm"]) .gallerythumb {
          width: var(--lrndesign-gallery-grid-thumbnail-sm, 150px);
        }
        :host([responsive-size="md"]) .gallerythumb {
          width: var(--lrndesign-gallery-grid-thumbnail-md, 200px);
        }
        :host([responsive-size="lg"]) .gallerythumb {
          width: var(--lrndesign-gallery-grid-thumbnail-lg, 250px);
        }
        :host([responsive-size="xl"]) .gallerythumb {
          width: var(--lrndesign-gallery-grid-thumbnail-lg, 300px);
        }
        :host .gallerythumb iron-icon {
          position: absolute;
          bottom: 7px;
          left: 7px;
        }
      </style>
      <article id="grid">
        <template is="dom-if" if="[[_isAttrSet(title)]]">
          <h1 id="gallery-title">[[title]]</h1>
        </template>
        <div id="gallery-description"><slot></slot></div>
        <p class="sr-only">A list of thumbnail buttons items:</p>
        <div id="galleryscreen">
          <template id="screenlist" is="dom-repeat" items="[[items]]" as="item">
            <lrndesign-gallery-zoom
              anchored-item="[[__anchoredItem]]"
              class="gallerythumb"
              details$="[[item.details]]"
              heading$="[[item.heading]]"
              item-id="[[item.id]]"
              on-gallery-scroll="_handleScroll"
              scrolled$="[[item.scroll]]"
              src$="[[item.large]]"
              tooltip$="[[item.tooltip]]"
              zoom-alt$="[[item.zoomAlt]]"
              zoomed$="[[item.zoom]]"
            >
              <div>
                <iron-image
                  alt$="[[item.zoomAlt]]"
                  fade
                  sizing="cover"
                  src$="[[item.thumbnail]]"
                  style$="[[_getImageStyle(items)]]"
                >
                </iron-image>
              </div>
              <iron-icon icon="zoom-in"></iron-icon>
            </lrndesign-gallery-zoom>
          </template>
        </div>
        <div id="galleryprint">
          <template id="printlist" is="dom-repeat" items="[[items]]" as="item">
            <section>
              <template is="dom-if" if="[[_isAttrSet(item.title)]]">
                <h2>[[item.title]]</h2>
              </template>
              <lrndesign-gallery-details
                details$="[[item.details]]"
              ></lrndesign-gallery-details>
              <img
                class="print-image"
                alt$="[[item.alt]]"
                src$="[[item.src]]"
              />
            </section>
          </template>
        </div>
      </article>
    `}static get properties(){return{imageStyle:{type:String,computed:"_getImageStyle(items)",reflectToAttribute:!0}}}_handleScroll(e){this._scrollIntoView([this._getParentOffset(this),e.path[0].offsetTop])}_getImageStyle(e=[]){let t=new Image,i=75;return void 0!==e&&e.length>0&&(t.src=e[0].src,t.naturalWidth>0&&t.naturalHeight>0&&(i=100*t.naturalHeight/t.naturalWidth)),"padding-bottom: "+i+"%;"}}e.LrndesignGalleryGrid=LrndesignGalleryGrid,window.customElements.define(LrndesignGalleryGrid.tag,LrndesignGalleryGrid)}));