define(["exports","../../@polymer/polymer/polymer-element.js","./lib/lrndesign-gallery-behaviors.js","../simple-colors/lib/simple-colors-polymer.js","./lib/lrndesign-gallery-carousel.js","./lib/lrndesign-gallery-grid.js"],(function(e,t,i,r,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LrndesignGallery=void 0;
/**
   * Copyright 2018 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class LrndesignGallery extends i.LrndesignGalleryBehaviors{static get tag(){return"lrndesign-gallery"}static get behaviors(){return[i.LrndesignGalleryBehaviors]}static get template(){return t.html`
      <style include="simple-colors-shared-styles-polymer">
        :host {
          display: block;
        }
        :host([hidden]) {
          display: none;
        }
      </style>
      <div id="gallery">
        <template is="dom-if" if="[[!grid]]" restamp>
          <lrndesign-gallery-carousel
            accent-color$="[[accentColor]]"
            aspect-ratio$="[[aspectRatio]]"
            title$="[[title]]"
            dark$="[[dark]]"
            gallery-id$="[[id]]"
            responsive-size$="[[responsiveSize]]"
            sizing$="[[sizing]]"
            sources="[[sources]]"
            title$="[[title]]"
          >
            <slot></slot>
          </lrndesign-gallery-carousel>
        </template>
        <template is="dom-if" if="[[grid]]">
          <lrndesign-gallery-grid
            accent-color$="[[accentColor]]"
            aspect-ratio$="[[aspectRatio]]"
            dark$="[[dark]]"
            gallery-id$="[[id]]"
            responsive-size$="[[responsiveSize]]"
            sizing$="[[sizing]]"
            sources="[[sources]]"
            title$="[[title]]"
          >
            <slot></slot>
          </lrndesign-gallery-grid>
        </template>
      </div>
    `}static get haxProperties(){return{canScale:!1,canPosition:!1,canEditSource:!0,gizmo:{title:"Image Gallery",description:"An image gallery displayed as a carousel or a grid",icon:"image:collections",color:"cyan",groups:["Content","Instructional","Media","Image"],handles:[{type:"image",source:"image"}],meta:{author:"ELMS:LN"}},settings:{quick:[],configure:[{property:"title",title:"Gallery Title",description:"A title for the gallery.",inputMethod:"textfield",icon:"editor:title"},{property:"accentColor",title:"Accent Color",description:"An optional accent color.",inputMethod:"colorpicker",icon:"editor:format-color-fill"},{property:"dark",title:"Dark Theme",description:"Enable Dark Theme",inputMethod:"boolean",icon:"icons:invert-colors"},{property:"grid",title:"Grid View",description:"Display as grid?",inputMethod:"boolean",icon:"icons:view-module"},{slot:"description",title:"Gallery Description",description:"An optional description for the gallery.",inputMethod:"textfield"},{property:"sources",title:"Gallery Images",description:"The images for the gallery.",inputMethod:"array",itemLabel:"title",properties:[{property:"title",title:"Image Title",description:"The heading for the image.",inputMethod:"textfield"},{property:"details",title:"Image Details",description:"The body text with details for the image.",inputMethod:"textfield"},{property:"src",title:"Image Source",description:"The path of the image.",inputMethod:"haxupload"},{property:"thumbnail",title:"Image Thumbnail Source",description:"The path of an optional thumbnail version of the image.",inputMethod:"haxupload"},{property:"large",title:"Image Full Size Source",description:"The path of an optional large version of the image for zooming.",inputMethod:"haxupload"}]}],advanced:[{property:"aspectRatio",title:"Aspect Ratio",description:"Custom aspect ratio, default is calculated based on the first image's aspect ratio",inputMethod:"textfield"},{property:"sizing",title:"Fit to Aspect Ratio",description:"Fit images to aspect ratio",inputMethod:"select",options:{cover:"crop",contain:"letterbox"}}]}}}static get properties(){return{}}connectedCallback(){super.connectedCallback();this.__gallery=this.shadowRoot.querySelector("#gallery"),this.anchorData=this._getAnchorData(),window.ResponsiveUtility.requestAvailability(),window.dispatchEvent(new CustomEvent("responsive-element",{detail:{element:this,attribute:"responsive-size",relativeToParent:!0}}))}ready(){super.ready()}}e.LrndesignGallery=LrndesignGallery,window.customElements.define(LrndesignGallery.tag,LrndesignGallery)}));