define(["exports","../../../../@polymer/polymer/polymer-element.js","../../../../@polymer/iron-a11y-keys/iron-a11y-keys.js","../../../simple-popover/simple-popover.js","../../../simple-fields/simple-fields.js","../buttons/rich-text-editor-button-styles.js"],(function(t,e,o,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RichTextEditorPrompt=void 0;
/**
   * Copyright 2018 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class RichTextEditorPrompt extends e.PolymerElement{static get template(){return e.html`
      <style include="rich-text-editor-styles rich-text-editor-button-styles">
        :host {
          --paper-input-container-focus-color: var(
            --rich-text-editor-focus-color,
            #000
          );
          --paper-input-container-invalid-color: var(
            --rich-text-editor-error-color,
            #800
          );
        }
        :host #prompt {
          display: none;
          width: 300px;
          max-width: 300px;
          --simple-popover-padding: 0px;
        }
        :host #prompt[for]{
          display: block;
          z-index: 2;
        }
        :host #prompt[for] #form {
          display: flex;
          flex-direction: column;
          align-items: center;
          justify-content: space-between;
          z-index: 2;
        }
        :host #formfields {
          width: calc(100% - 20px);
          padding: 10px 10px 0;
        }
        :host #prompt paper-input {
          padding: 0;
        }
        :host #confirm, 
        :host #cancel {
          min-width: unset;
        }
        :host #formfields {
          overflow: visible;
        }
        :host #cancel {
          color: var(--rich-text-editor-button-color);
          background-color: var(--rich-text-editor-button-bg);

        }
        :host #cancel:focus,
        :host #cancel:hover {
          color: var(--rich-text-editor-button-hover-color);
          background-color: var(--rich-text-editor-button-hover-bg);
        }
        :host #confirm {
          color: var(--rich-text-editor-button-color);
          background-color: var(--rich-text-editor-button-bg);

        }
        :host #confirm:focus,
        :host #confirm:hover {
          color: var(--rich-text-editor-button-hover-color);
          background-color: var(--rich-text-editor-button-hover-bg);
        }
        :host .actions {
          width: 100%;
          padding-bottom: 3px;
          display: flex;
          align-items: center;
          justify-content: flex-end;
        }
        :host .confirm-or-cancel {
          min-width: 40px;
        }
      </style>
      <simple-popover
        id="prompt"
        auto
        for$="[[for]]"
      >
        <form id="form">
          <simple-fields
            id="formfields"
            autofocus
            hide-line-numbers
            fields="[[fields]]"
            value="{{value}}"
          ></simple-fields>
          <div class="actions">
            </iron-a11y-keys>
            <paper-button
              id="cancel"
              class="rtebutton"
              controls$="[[for]]"
              on-click="_cancel"
              tabindex="0"
            >
              <iron-icon id="icon" aria-hidden icon="clear"> </iron-icon>
              <span id="label" class="offscreen">Cancel</span>
            </paper-button>
            <simple-tooltip id="tooltip" for="cancel">Cancel</simple-tooltip>
            <paper-button
              id="confirm"
              class="rtebutton"
              controls$="[[for]]"
              on-click="_confirm"
              tabindex="0"
            >
              <iron-icon id="icon" aria-hidden icon="check"> </iron-icon>
              <span id="label" class="offscreen">OK</span>
            </paper-button>
            <simple-tooltip id="tooltip" for="confirm">OK</simple-tooltip>
          </div>
          <iron-a11y-keys
            id="a11ycancel"
            target="[[__a11ycancel]]"
            keys="enter space"
            on-keys-pressed="_cancel"
          >
          <iron-a11y-keys
            id="a11yconfirm"
            target="[[__a11yconfirm]]"
            keys="enter space"
            on-keys-pressed="_confirm"
          >
          </iron-a11y-keys>
        </form>
      </simple-popover>
    `}static get tag(){return"rich-text-editor-prompt"}static get properties(){return{for:{type:String},range:{type:Object,value:null},fields:{type:Array,value:null},value:{type:Object,value:null},__button:{type:Object,value:null}}}constructor(){super();if(!window.RichTextEditorPrompt.instance)return window.RichTextEditorPrompt.instance=this,this}connectedCallback(){super.connectedCallback(),this.__a11yconfirm=this.shadowRoot.querySelector("#confirm"),this.__a11ycancel=this.shadowRoot.querySelector("#cancel")}setTarget(t){this.clearTarget(),this.set("fields",t.__fields),this.set("value",t.value),this.__button=t,t.__selection&&(this.for=t.__selection.getAttribute("id"))}clearTarget(){this.__button&&(this.for=null,this.set("fields",null),this.set("value",null),this.__button=null)}_cancel(t){t.preventDefault(),this.__button&&(this.__button.cancel(),this.clearTarget())}_confirm(t){t.preventDefault(),this.__button.value=this.value,this.__button.confirm(),this.clearTarget()}}t.RichTextEditorPrompt=RichTextEditorPrompt,window.customElements.define(RichTextEditorPrompt.tag,RichTextEditorPrompt),window.RichTextEditorPrompt=window.RichTextEditorPrompt||{},window.RichTextEditorPrompt.requestAvailability=()=>(window.RichTextEditorPrompt.instance||(window.RichTextEditorPrompt.instance=document.createElement("rich-text-editor-prompt"),document.body.appendChild(window.RichTextEditorPrompt.instance)),window.RichTextEditorPrompt.instance)}));