define(["exports","../../@polymer/polymer/polymer-element.js","../../@polymer/iron-a11y-keys/iron-a11y-keys.js","./lib/rich-text-editor-styles.js","./lib/toolbars/rich-text-editor-toolbar.js","./lib/toolbars/rich-text-editor-toolbar-mini.js","./lib/toolbars/rich-text-editor-toolbar-full.js"],(function(t,e,r,o,i,l,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RichTextEditor=void 0;
/**
   * Copyright 2018 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class RichTextEditor extends e.PolymerElement{static get template(){return e.html`
      <style>
        :host([hidden]) {
          display: none;
        }
        :host {
          display: block;
          min-height: 20px;
          cursor: pointer;
          @apply --rich-text-editor-content;
        }
        :host([contenteditable="true"]) {
          border: var(--rich-text-editor-border);
          overflow: auto;
          @apply --rich-text-editor-content-edit;
        }
        :host(.heightmax[contenteditable="true"]) {
          max-height: calc(100vh - 200px);
          overflow-y: scroll;
          @apply --rich-text-editor-heightmax;
        }
        :host(:empty) {
          border: 1px dashed var(--rich-text-editor-border-color);
          @apply --rich-text-editor-empty;
        }
        :host(:not([contenteditable="true"]):empty):before {
          content: attr(placeholder);
          padding: 0 5px;
          display: block;
          color: var(--rich-text-editor-button-disabled-color);
          @apply --rich-text-editor-empty-placeholder;
        }
        :host([contenteditable="true"]:empty):before {
          @apply --rich-text-editor-empty-editable;
        }
      </style>
      <style include="rich-text-editor-styles"></style>
      <slot></slot>
    `}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Rich text-editor",description:"a standalone rich text editor",icon:"icons:android",color:"green",groups:["Text"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"nikkimk",owner:"Penn State University"}},settings:{quick:[],configure:[{property:"title",description:"",inputMethod:"textfield",required:!1,icon:"icons:android"}],advanced:[]}}}static get properties(){return{...super.properties,id:{name:"id",type:String,value:""},placeholder:{name:"placeholder",type:String,reflectToAttribute:!0,value:"Click to edit"},toolbar:{name:"toolbar",type:String,value:""},type:{name:"type",type:String,value:"rich-text-editor-toolbar"}}}static get tag(){return"rich-text-editor"}connectedCallback(){super.connectedCallback(),this.id||(this.id=this._generateUUID()),window.RichTextEditorStyleManager.requestAvailability()}ready(){super.ready(),this.getEditor()}getEditor(){let t=this,e=this.toolbar?"#"+this.toolbar:"",r=document.querySelector(this.type+e),o=e?document.querySelector(e):null,i=document.querySelector(this.type),l=r||o||i;this.toolbar||(this.toolbar=this._generateUUID()),l&&l.addEditableRegion||(l=document.createElement(this.type),l.id=this.toolbar,t.parentNode.appendChild(l)),l.addEditableRegion(t)}_getRange(){let t=window.getSelection();return t.getRangeAt&&t.rangeCount?t.getRangeAt(0):t||void 0}_generateUUID(){let t=Math.floor(65536*(1+Math.random())).toString(16).substring(1);return"rte-"+"ss-s-s-s-sss".replace(/s/g,t)}}t.RichTextEditor=RichTextEditor,window.customElements.define(RichTextEditor.tag,RichTextEditor)}));