define(["exports","require","../../lit-element/lit-element.js","../../@polymer/polymer/lib/elements/custom-style.js"],(function(t,o,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollButton=void 0,o=babelHelpers.interopRequireWildcard(o);
/**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class ScrollButton extends e.LitElement{static get styles(){return[e.css`
        :host {
          display: block;
          --scroll-button-z-index: 99;
          z-index: var(--scroll-button-z-index);
        }

        :host([hidden]) {
          display: none;
        }
        paper-icon-button {
          background-color: rgba(0, 0, 0, 0.6);
          color: white;
        }
        paper-icon-button:hover,
        paper-icon-button:active,
        paper-icon-button:focus {
          background-color: rgba(0, 0, 0, 1);
        }
        simple-tooltip {
          --simple-tooltip-background: #000000;
          --simple-tooltip-opacity: 1;
          --simple-tooltip-text-color: #ffffff;
          --simple-tooltip-delay-in: 0;
          --simple-tooltip-border-radius: 0;
        }
      `]}render(){return e.html`
      <custom-style>
        <style>
          paper-icon-button {
            @apply --scroll-button-button;
          }
          paper-icon-button:hover,
          paper-icon-button:active,
          paper-icon-button:focus {
            @apply --scroll-button-button-active;
          }
          simple-tooltip {
            @apply --scroll-button-tooltip;
          }
        </style>
      </custom-style>
      <paper-icon-button
        @click="${this.scrollEvent}"
        id="btn"
        icon="${this.icon}"
        title="${this.label}"
      ></paper-icon-button>
      <simple-tooltip for="btn" position="${this.position}" offset="14">
        ${this.label}
      </simple-tooltip>
    `}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Scroll button",description:"button to scroll to an area or back to top",icon:"icons:android",color:"green",groups:["Button"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"btopro",owner:"The Pennsylvania State University"}},settings:{quick:[],configure:[{property:"target",description:"",inputMethod:"array",required:!1,icon:"icons:android"},{property:"icon",description:"",inputMethod:"textfield",required:!1,icon:"icons:android"},{property:"label",description:"",inputMethod:"textfield",required:!1,icon:"icons:android"}],advanced:[]}}}static get properties(){return{...super.properties,target:{type:Object},icon:{type:String},label:{type:String},position:{type:String}}}constructor(){super(),this.icon="icons:expand-less",this.label="Scroll to top",this.position="top",new Promise((t,e)=>o.default(["../../@polymer/paper-icon-button/paper-icon-button.js"],t,e)),new Promise((t,e)=>o.default(["../simple-tooltip/simple-tooltip.js"],t,e)),new Promise((t,e)=>o.default(["../../@polymer/iron-icons/iron-icons.js"],t,e))}static get tag(){return"scroll-button"}scrollEvent(t){this.target?this.target.scrollIntoView({behavior:"smooth",block:"end",inline:"nearest"}):window.scrollTo({top:0,left:0,behavior:"smooth"})}}t.ScrollButton=ScrollButton,window.customElements.define(ScrollButton.tag,ScrollButton)}));