define(["exports","../../../lit-element/lit-element.js","../simple-modal.js"],(function(e,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SimpleModalTemplate=void 0;
/**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class SimpleModalTemplate extends t.LitElement{static get styles(){return[t.css`
        :host {
          display: none;
          --simple-modal-width: auto;
          --simple-modal-height: auto;
          --simple-modal-min-width: unset;
          --simple-modal-min-height: unset;
          --simple-modal-max-width: unset;
          --simple-modal-max-height: unset;
          --simple-modal-titlebar-color: #444;
          --simple-modal-titlebar-background: #ddd;
          --simple-modal-header-color: #222;
          --simple-modal-header-background: #ccc;
          --simple-modal-content-container-color: #222;
          --simple-modal-content-container-background: #fff;
          --simple-modal-buttons-color: blue;
          --simple-modal-buttons-background: #fff;
          --simple-modal-button-color: var(--simple-modal-buttons-color);
          --simple-modal-button-background: var(
            --simple-modal-buttons-background-color
          );
        }
      `]}static get tag(){return"simple-modal-template"}constructor(){super(),this.modalId=null,this.title="",this.modal=window.SimpleModal.requestAvailability()}static get properties(){return{modalId:{type:Object,attribute:"modal-id"},modal:{type:Object},title:{type:String}}}render(){return t.html`
      <slot name="header"></slot> <slot name="content"></slot>
      <slot name="buttons"></slot>
    `}associateEvents(e,t="click",l=!0,o=!0){return e.addEventListener(t,t=>{this.openModal(e,l,o)}),this.modal}openModal(e,t=!0,l=!0){let o=getComputedStyle(this),i={};["--simple-modal-width","--simple-modal-height","--simple-modal-min-width","--simple-modal-min-height","--simple-modal-max-width","--simple-modal-max-height","--simple-modal-titlebar-color","--simple-modal-titlebar-background","--simple-modal-header-color","--simple-modal-header-background","--simple-modal-content-container-color","--simple-modal-content-container-background","--simple-modal-buttons-color","--simple-modal-buttons-background","--simple-modal-button-color","--simple-modal-button-background","--simple-modal-titlebar-button-border","--simple-modal-titlebar-button-padding","--simple-modal-titlebar-button-outline","--simple-modal-titlebar-button-outline-offset","--simple-modal-titlebar-icon-width","--simple-modal-titlebar-icon-height"].forEach(e=>{i[e]=o.getPropertyValue(e)});const a=new CustomEvent("simple-modal-show",{bubbles:t,cancelable:l,composed:!0,detail:{id:this.getAttribute("modal-id"),elements:{header:this._getSlot("header"),content:this._getSlot("content"),buttons:this._getSlot("buttons")},invokedBy:e,modalClass:this.getAttribute("class"),styles:i,clone:!1,title:null!==this.title&&this.title}});window.dispatchEvent(a)}_getSlot(e){let t=this.querySelectorAll('[slot="'+e+'"]');t&&t[0]&&"SLOT"==t[0].tagName&&(t=t[0].assignedNodes({flatten:!0}));let l=document.createElement("div");return t.forEach(e=>{l.appendChild(e.cloneNode(!0))}),null!==t&&l.cloneNode(!0)}}e.SimpleModalTemplate=SimpleModalTemplate,window.customElements.define(SimpleModalTemplate.tag,SimpleModalTemplate)}));