define(["exports","../../@polymer/polymer/polymer-element.js","../../@polymer/iron-icons/iron-icons.js","../social-media-icons/social-media-icons.js"],(function(e,t,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocialShareLink=void 0;
/**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */
class SocialShareLink extends t.PolymerElement{static get template(){return t.html`
      <style>
        :host {
          display: inline;
        }
        :host([hidden]) {
          display: none;
        }
        :host a {
          display: inline-flex;
          align-items: center;
          color: var(--social-share-link-color, inherit);
          transition: all 0.5s;
          margin: 5px;
          padding: var(--social-share-button-padding, 0px);
          border-radius: var(--social-share-button-border-radius, 0px);
          @apply --social-share-link;
        }
        :host a:visited {
          color: var(--social-share-visited-link-color, inherit);
          @apply --social-share-visited-link;
        }
        :host a:focus,
        :host a:hover {
          color: var(--social-share-link-hover-color, inherit);
          @apply --social-share-link-hover;
        }
        :host([disabled]) a,
        :host([disabled]) a:focus,
        :host([disabled]) a:hover,
        :host([disabled]) a:visited {
          color: var(--social-share-disabled-link-color, #ddd);
          @apply --social-share-disabled-link;
        }
        :host([button-style]) a {
          padding: var(--social-share-button-padding, 5px 10px);
          border-radius: var(--social-share-button-border-radius, 3px);
          color: var(--social-share-button-color, white);
          background-color: var(--social-share-button-bg, #0066ff);
          text-decoration: none;
          transition: all 0.5s;
          @apply --social-share-button;
        }
        :host([button-style]) a:visited {
          color: var(--social-share-visited-button-color, white);
          @apply --social-share-visited-button;
        }
        :host([button-style]) a:focus,
        :host([button-style]) a:hover {
          color: var(--social-share-button-hover-color, white);
          background-color: var(--social-share-button-hover-bg, #0044ee);
          @apply --social-share-button-hover;
        }
        :host([button-style][disabled]) a,
        :host([button-style][disabled]) a:focus,
        :host([button-style][disabled]) a:hover,
        :host([button-style][disabled]) a:visited {
          color: var(--social-share-disabled-button-color, #ddd);
          background-color: var(--social-share-disabled-button-bg, #666);
          @apply --social-share-disabled-button;
        }
        :host iron-icon {
          margin-right: 5px;
        }
        :host a.text-only iron-icon {
          display: none;
        }
        :host a.icon-only .linktext {
          position: absolute;
          left: -999999px;
          top: 0;
          height: 0;
          width: 0;
          overflow: hidden;
        }
        :host a.icon-only iron-icon {
          margin-right: 0;
        }
      </style>
      <a
        href$="[[__href]]"
        disabled$="[[!__href]]"
        class$="[[mode]]"
        rel="noopener noreferrer"
        target="_blank"
      >
        <iron-icon
          aria-hidden="true"
          icon$="[[__icon]]"
          hidden$="[[!__showIcon]]"
        ></iron-icon>
        <span class="linktext">[[__linkText]]</span>
      </a>
    `}static get properties(){return{...super.properties,buttonStyle:{name:"buttonStyle",type:Boolean,value:!1,reflectToAttribute:!0},image:{name:"image",type:String,value:""},message:{name:"message",type:String,value:""},mode:{name:"mode",type:String,value:null},text:{name:"text",type:String,value:null},type:{name:"type",type:String,value:"Twitter"},url:{name:"url",type:String,value:null},__href:{name:"__href",type:String,computed:"_getHref(image,message,type,url)"},__icon:{name:"icon",type:String,computed:"_getIcon(type)"},__linkText:{name:"__linkText",type:String,computed:"_getLinkText(text,type)"}}}static get tag(){return"social-share-link"}connectedCallback(){super.connectedCallback()}_getHref(e,t,o,a){let i;switch(o){case"Facebook":i=null!==a&&"https://www.facebook.com/sharer/sharer.php?u="+a;break;case"LinkedIn":i=(null!==a?"&url="+a:"")+(null!==t?"&summary="+t:""),i=null!==i&&"https://www.linkedin.com/shareArticle?mini=true"+i;break;case"Pinterest":i=(null!==a?"&url="+a:"")+(null!==t?"&description="+t:"")+(null!==e?"&media="+e:""),i=null!==i&&"http://pinterest.com/pin/create/button/?"+i.substring(1);break;case"Twitter":i=null!==t?"status="+t+" "+a:a,i=null!==i&&"https://twitter.com/home?"+i}return encodeURI(i)}_getLinkText(e,t){return null!==e?e:"Share via "+t}_getIcon(e){return"social-media:"+e.toLowerCase()}}e.SocialShareLink=SocialShareLink,window.customElements.define(SocialShareLink.tag,SocialShareLink)}));