/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as a}from"../../../lit-element/lit-element.js";import"../../../@polymer/iron-icons/iron-icons.js";class A11yTab extends t{static get styles(){return[a`
        :host {
          display: block;
          height: var(--a11y-tabs-tab-height, --a11y-tabs-height);
          overflow: var(--a11y-tabs-tab-overflow, --a11y-tabs-overflow);
        }
        /*:host([disabled]) {
          display:none;
        }*/
        :host([hidden]) {
          display: none;
        }
        .sr-only {
          position: absolute;
          left: -99999px;
          height: 0;
          overflow: hidden;
        }
      `]}render(){return e`
      <span class="sr-only">Tab ${this.xOfY}</span>
      <slot></slot>
      <span class="sr-only">
        End of tab ${this.xOfY}. Back to <a href="#${this.id}">tabs</a>.
      </span>
    `}static get properties(){return{flag:{type:String,reflect:!0},flagIcon:{type:String,attribute:"flag-icon"},disabled:{type:Boolean,reflect:!0,attribute:"disabled"},hidden:{type:Boolean,reflect:!0},icon:{type:String},id:{type:String},label:{type:String},order:{type:Number},total:{type:Number}}}constructor(){super(),this.flag=null,this.flagIcon=null,this.hidden=!1,this.icon=null,this.id=null,this.label=null,this.order=1,this.total=1,this.addEventListener("a11y-tab-flag",t=>this.handleFlag(t))}get xOfY(){return`${this.order} of ${this.total}`}disconnectedCallback(){this.removeEventListener("a11y-tab-flag",t=>this.handleFlag(t)),super.disconnectedCallback()}updated(t){t.forEach((t,e)=>{["id","order"].includes(e)&&!this.id&&(this.id=`tab-${this.order}`),["label","order"].includes(e)&&!this.label&&(this.label=`Tab ${this.order}`),"flag"===e&&this._tabChanged(),"flagIcon"===e&&this._tabChanged(),"icon"===e&&this._tabChanged(),"id"===e&&this._tabChanged(),"label"===e&&this._tabChanged()})}static get tag(){return"a11y-tab"}_handleFlag(t){this.flag=t.detail.flag,this.flagIcon=t.detail.flagIcon}_tabChanged(){this.dispatchEvent(new CustomEvent("a11y-tab-changed",{bubbles:!0,cancelable:!0,composed:!1,detail:this}))}}window.customElements.define(A11yTab.tag,A11yTab);export{A11yTab};