import{LitElement as e,html as t,css as i}from"../../../../lit-element/lit-element.js";import{store as o}from"./haxcms-site-store.js";import{autorun as a,toJS as s}from"../../../../mobx/lib/mobx.module.js";class HAXCMSSiteEditorUI extends e{static get styles(){return[i`
        :host *:not(:defined) {
          display: none;
        }
        :host {
          display: block;
          position: fixed;
          left: 0;
          top: 0;
          bottom: 0;
          background-color: var(--haxcms-system-bg, #37474f);
          z-index: 10000;
          border-right: 2px solid black;
          visibility: visible;
        }
        :host([edit-mode]) {
          z-index: 9999;
        }
        :host([dashboard-opened]) {
          left: 50vw;
        }
        @media screen and (max-width: 800px) {
          :host([dashboard-opened]) {
            left: 90vw;
          }
          :host([edit-mode]) {
            bottom: unset;
          }
          :host([edit-mode]) paper-fab,
          :host([edit-mode]) paper-icon-button,
          :host([edit-mode]) paper-avatar {
            width: 24px;
            height: 24px;
            padding: 1px;
            margin: 0;
            --iron-icon-width: 20px;
            --iron-icon-height: 20px;
          }
        }
        /**
         * Dashboard open trumps all contextual settings
         */
        :host([dashboard-opened]) #editbutton,
        :host([dashboard-opened]) #editdetails,
        :host([dashboard-opened]) #deletebutton,
        :host([dashboard-opened]) #addbutton,
        :host([dashboard-opened]) #outlinebutton {
          display: none !important;
        }
        :host *[hidden] {
          display: none;
        }
        paper-fab:not(:defined),
        simple-tooltip:not(:defined),
        paper-icon-button:not(:defined) {
          display: none !important;
        }
        paper-avatar {
          width: 48px;
          height: 48px;
          line-height: 20px;
          padding: 12px;
        }
        paper-fab {
          display: block;
          width: 48px;
          height: 48px;
          line-height: 20px;
          background-color: black;
          color: #ffffff;
          transition: 0.3s all ease-in-out;
          padding: 12px;
          margin: 0;
          position: relative;
          box-shadow: 0 8px 10px 1px rgba(0, 0, 0, 0.14),
            0 3px 14px 2px rgba(0, 0, 0, 0.12),
            0 5px 5px -3px rgba(0, 0, 0, 0.4);
        }
        :host([painting]) {
          opacity: 0;
          visibility: hidden;
        }
        paper-icon-button {
          display: block;
          padding: 8px;
          width: 48px;
          min-width: 48px;
          height: 48px;
          border-radius: 50%;
          margin: 0px;
          background-color: black;
          color: #ffffff;
          transition: 0.3s all ease-in-out;
          box-shadow: 0 8px 10px 1px rgba(0, 0, 0, 0.14),
            0 3px 14px 2px rgba(0, 0, 0, 0.12),
            0 5px 5px -3px rgba(0, 0, 0, 0.4);
        }
        paper-fab:hover,
        paper-fab:focus,
        paper-fab:active,
        paper-icon-button:hover,
        paper-icon-button:focus,
        paper-icon-button:active {
          background-color: var(--haxcms-color, blue);
          color: #ffffff;
        }
        #cancelbutton {
          background-color: var(--haxcms-system-danger-color);
        }
        #editbutton,
        #editdetails,
        #deletebutton {
          visibility: hidden;
          opacity: 0;
        }
        :host([page-allowed]) #editbutton,
        :host([page-allowed]) #editdetails,
        :host([page-allowed]) #deletebutton {
          visibility: visible;
          opacity: 1;
        }
        :host([edit-mode]) #editbutton {
          color: white;
          background-color: var(--haxcms-system-action-color, blue) !important;
        }
        :host([edit-mode]) #manifestbutton,
        :host([edit-mode]) #editdetails,
        :host([edit-mode]) #deletebutton,
        :host([edit-mode]) #addbutton,
        :host([edit-mode]) #outlinebutton {
          display: none !important;
        }

        :host(:hover),
        :host(:active),
        :host(:focus) {
          opacity: 1;
        }
        simple-tooltip {
          --simple-tooltip-background: #000000;
          --simple-tooltip-opacity: 1;
          --simple-tooltip-text-color: #ffffff;
          --simple-tooltip-delay-in: 0;
          --simple-tooltip-duration-in: 200ms;
          --simple-tooltip-duration-out: 0;
          --simple-tooltip-border-radius: 0;
          --simple-tooltip-font-size: 14px;
          --simple-tooltip-width: 145px;
        }
      `]}static get tag(){return"haxcms-site-editor-ui"}constructor(){super(),this.__disposer=[],this.painting=!0,this.pageAllowed=!1,this.editMode=!1,this.manifestEditMode=!1,this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0})),setTimeout(()=>{import("./haxcms-outline-editor-dialog.js"),import("./haxcms-site-dashboard.js"),import("../../../hax-iconset/hax-iconset.js"),import("../../../simple-tooltip/simple-tooltip.js"),import("../../../../@polymer/paper-icon-button/paper-icon-button.js"),import("../../../simple-modal/simple-modal.js"),import("../../../../@polymer/iron-icons/editor-icons.js"),import("../../../../@polymer/paper-fab/paper-fab.js"),import("../../../paper-avatar/paper-avatar.js")},0)}render(){return t`
      <paper-avatar
        id="username"
        label="${this.userName}"
        two-chars
        src="${this.userPicture}"
      ></paper-avatar>
      <paper-fab
        id="editbutton"
        icon="${this.__editIcon}"
        @click="${this._editButtonTap}"
        title="${this.__editText}"
        voice-command="edit (this) page"
      ></paper-fab>
      <paper-fab
        id="cancelbutton"
        icon="icons:cancel"
        @click="${this._cancelButtonTap}"
        .hidden="${!this.editMode}"
        title="Cancel editing"
        voice-command="cancel (editing)"
      ></paper-fab>
      <paper-fab
        id="editdetails"
        icon="hax:page-details"
        @click="${this._editDetailsButtonTap}"
        title="Edit page details"
        voice-command="edit (page) details"
      ></paper-fab>
      <paper-icon-button
        id="addbutton"
        icon="hax:add-page"
        @click="${this._addButtonTap}"
        title="Add new page"
        voice-command="add page"
      ></paper-icon-button>
      <paper-fab
        id="deletebutton"
        icon="icons:delete"
        @click="${this._deleteButtonTap}"
        title="Delete this page"
        voice-command="delete page"
      ></paper-fab>
      <paper-icon-button
        id="outlinebutton"
        icon="hax:site-map"
        @click="${this._outlineButtonTap}"
        title="Edit site outline"
        voice-command="edit site outline"
      ></paper-icon-button>
      <paper-icon-button
        id="manifestbutton"
        icon="${this.icon}"
        @click="${this._manifestButtonTap}"
        title="${this.__settingsText}"
        voice-command="edit site settings"
      ></paper-icon-button>
      <simple-tooltip for="username" position="right" offset="14"
        >${this.userName}</simple-tooltip
      >
      <simple-tooltip for="cancelbutton" position="right" offset="14"
        >Cancel editing</simple-tooltip
      >
      <simple-tooltip for="editbutton" position="right" offset="14"
        >${this.__editText}</simple-tooltip
      >
      <simple-tooltip for="editdetails" position="right" offset="14"
        >Edit page details</simple-tooltip
      >
      <simple-tooltip for="deletebutton" position="right" offset="14"
        >Delete this page</simple-tooltip
      >
      <simple-tooltip for="addbutton" position="right" offset="14"
        >Add new page</simple-tooltip
      >
      <simple-tooltip for="outlinebutton" position="right" offset="14"
        >Organize site content</simple-tooltip
      >
      <simple-tooltip for="manifestbutton" position="right" offset="14"
        >${this.__settingsText}</simple-tooltip
      >
    `}firstUpdated(e){this.dispatchEvent(new CustomEvent("haxcms-load-user-data",{bubbles:!0,composed:!0,cancelable:!1,detail:!0})),this.shadowRoot.querySelectorAll("[voice-command]").forEach(e=>{"editbutton"==e.getAttribute("id")?this.dispatchEvent(new CustomEvent("hax-add-voice-command",{bubbles:!0,composed:!0,cancelable:!1,detail:{command:":name: save (this) page",context:e,callback:"click"}})):"manifestbutton"==e.getAttribute("id")&&this.dispatchEvent(new CustomEvent("hax-add-voice-command",{bubbles:!0,composed:!0,cancelable:!1,detail:{command:":name: cancel site settings",context:e,callback:"click"}})),this.dispatchEvent(new CustomEvent("hax-add-voice-command",{bubbles:!0,composed:!0,cancelable:!1,detail:{command:":name: "+e.getAttribute("voice-command"),context:e,callback:"click"}}))}),this.dispatchEvent(new CustomEvent("haxcms-trigger-update",{bubbles:!0,composed:!0,cancelable:!1,detail:!0}))}updated(e){e.forEach((e,t)=>{"editMode"==t&&(this._editModeChanged(this[t],e),this.dispatchEvent(new CustomEvent("edit-mode-changed",{detail:this[t]}))),"manifestEditMode"==t&&(this._manifestEditModeChanged(this[t],e),this.dispatchEvent(new CustomEvent("manifest-edit-mode-changed",{detail:this[t]}))),"dashboardOpened"==t&&this._dashboardOpenedChanged(this[t],e)})}static get properties(){return{userName:{type:String,attribute:"user-name"},userPicture:{type:String,attribute:"user-picture"},__editIcon:{type:String},__editText:{type:String},__settingsText:{type:String},painting:{type:Boolean,reflect:!0},pageAllowed:{type:Boolean,attribute:"page-allowed",reflect:!0},editMode:{type:Boolean,reflect:!0,attribute:"edit-mode"},manifestEditMode:{type:Boolean,attribute:"manifest-edit-mode",reflect:!0},activeTitle:{type:String,attribute:"active-title"},manifest:{type:Object},icon:{type:String},dashboardOpened:{type:Boolean,reflect:!0,attribute:"dashboard-opened"}}}connectedCallback(){super.connectedCallback(),a(e=>{this.userName=s(o.userData.userName),this.userPicture=s(o.userData.userPicture),this.__disposer.push(e)}),a(e=>{this.editMode=s(o.editMode),this.__disposer.push(e)}),a(e=>{this.manifest=s(o.manifest),this.icon="hax:site-settings",this.__disposer.push(e)}),a(e=>{this.dashboardOpened=s(o.dashboardOpened),this.__disposer.push(e)}),a(e=>{const t=s(o.activeItem);t&&t.id?(this.activeTitle=t.title,this.pageAllowed=!0):this.pageAllowed=!1,this.__disposer.push(e)})}disconnectedCallback(){for(var e in this.__disposer)this.__disposer[e].dispose();super.disconnectedCallback()}_dashboardOpenedChanged(e,t){e?(this.__settingsText="Close site settings",this.icon="icons:cancel"):e||(this.__settingsText="Edit site settings",this.icon="hax:site-settings")}_editButtonTap(e){this.editMode=!this.editMode,this.editMode||this.dispatchEvent(new CustomEvent("haxcms-save-node",{bubbles:!0,composed:!0,cancelable:!1,detail:o.activeItem})),window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,cancelable:!0,detail:{}}))}_editDetailsButtonTap(e){const t=new CustomEvent("haxcms-load-node-fields",{bubbles:!0,composed:!0,cancelable:!1,detail:e.target});window.dispatchEvent(t)}_cancelButtonTap(e){this.editMode=!1,this.dispatchEvent(new CustomEvent("hax-cancel",{bubbles:!0,composed:!0,cancelable:!1,detail:e.detail})),window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,cancelable:!0,detail:{}}))}_addButtonTap(e){this.__newForm=document.createElement("eco-json-schema-object");let t=window.JSONOutlineSchema.requestAvailability();this.__newForm.schema=t.getItemSchema("item"),delete this.__newForm.schema.properties.id,delete this.__newForm.schema.properties.description,delete this.__newForm.schema.properties.order,delete this.__newForm.schema.properties.parent,delete this.__newForm.schema.properties.metadata,delete this.__newForm.schema.properties.indent,this.__newForm.schema.properties.title.value="";let i=document.createElement("paper-button"),o=document.createElement("iron-icon");o.icon="icons:add",i.appendChild(o),i.appendChild(document.createTextNode("Create page")),i.style.color="white",i.style.backgroundColor="#2196f3",i.addEventListener("click",this._createNewItem.bind(this));let a=document.createElement("paper-button");a.appendChild(document.createTextNode("cancel")),a.setAttribute("dialog-dismiss","dialog-dismiss");let s=document.createElement("span");s.appendChild(i),s.appendChild(a);const d=new CustomEvent("simple-modal-show",{bubbles:!0,composed:!0,cancelable:!1,detail:{title:"Add a new page",styles:{"--simple-modal-width":"75vw","--simple-modal-max-width":"75vw"},elements:{content:this.__newForm,buttons:s},invokedBy:this.shadowRoot.querySelector("#addbutton"),clone:!1,modal:!0}});window.dispatchEvent(d)}_createNewItem(e){const t=new CustomEvent("haxcms-create-node",{bubbles:!0,composed:!0,cancelable:!1,detail:{values:this.__newForm.value}});this.dispatchEvent(t)}_updateItem(e){var t,i=e.target;t=i.__form?i.__form.value:i.parentNode.__form.value,window.dispatchEvent(new CustomEvent("haxcms-save-node-details",{bubbles:!0,composed:!0,cancelable:!0,detail:t})),window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,composed:!0,cancelable:!0,detail:{}}))}_deleteButtonTap(e){let t=document.createElement("span");t.innerHTML=`"${o.activeItem.title}" will be removed from the outline but its content stays on the file system.`;let i=document.createElement("paper-button"),a=document.createElement("iron-icon");a.icon="icons:delete",i.appendChild(a),i.appendChild(document.createTextNode("Confirm")),i.style.color="white",i.style.backgroundColor="#ee0000",i.addEventListener("click",this._deleteActive.bind(this));let s=document.createElement("paper-button");s.appendChild(document.createTextNode("cancel")),s.setAttribute("dialog-dismiss","dialog-dismiss");let d=document.createElement("span");d.appendChild(i),d.appendChild(s);const n=new CustomEvent("simple-modal-show",{bubbles:!0,composed:!0,cancelable:!1,detail:{title:"Are you sure you want to delete this page?",styles:{"--simple-modal-width":"75vw","--simple-modal-max-width":"75vw"},elements:{content:t,buttons:d},invokedBy:this.shadowRoot.querySelector("#deletebutton"),clone:!1,modal:!0}});window.dispatchEvent(n)}_deleteActive(e){const t=new CustomEvent("haxcms-delete-node",{bubbles:!0,composed:!0,cancelable:!1,detail:{item:o.activeItem}});this.dispatchEvent(t)}_outlineButtonTap(e){const t=new CustomEvent("simple-modal-show",{bubbles:!0,composed:!0,cancelable:!1,detail:{title:"Edit site outline",styles:{"--simple-modal-width":"75vw","--simple-modal-height":"75vh","--simple-modal-max-width":"75vw","--simple-modal-max-height":"75vh"},elements:{content:document.createElement("haxcms-outline-editor-dialog")},invokedBy:this.shadowRoot.querySelector("#outlinebutton"),clone:!1,modal:!0}});window.dispatchEvent(t)}_manifestButtonTap(e){window.dispatchEvent(new CustomEvent("simple-modal-hide",{bubbles:!0,cancelable:!0,detail:{}})),window.dispatchEvent(new CustomEvent("haxcms-load-site-dashboard",{bubbles:!0,composed:!0,cancelable:!1,detail:e.target}))}_editModeChanged(e,t){e?(this.__editIcon="icons:save",this.__editText="Save page content"):(this.__editIcon="hax:page-edit",this.__editText="Edit page content"),void 0!==t&&(o.editMode=e)}_outlineEditModeChanged(e,t){this.dispatchEvent(new CustomEvent("haxcms-outline-edit-mode-changed",{bubbles:!0,composed:!0,cancelable:!1,detail:e}))}_manifestEditModeChanged(e,t){this.dispatchEvent(new CustomEvent("haxcms-manifest-edit-mode-changed",{bubbles:!0,composed:!0,cancelable:!1,detail:e}))}}window.customElements.define(HAXCMSSiteEditorUI.tag,HAXCMSSiteEditorUI);export{HAXCMSSiteEditorUI};