/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../../../../lit-element/lit-element.js";import"../../../../simple-modal/lib/simple-modal-template.js";import"../../../../../@polymer/paper-icon-button/paper-icon-button.js";import"../../../../../@polymer/polymer/lib/elements/custom-style.js";class SiteModal extends t{static get styles(){return[i`
        :host {
          display: block;
        }
        paper-icon-button {
          color: var(--site-modal-icon-color);
        }
      `]}static get tag(){return"site-modal"}constructor(){super(),this.title="Dialog",this.icon="icons:menu",this.buttonLabel="Open dialog",this.position="bottom",import("../../../../simple-tooltip/simple-tooltip.js")}render(){return e`
      <custom-style>
        <style>
          simple-modal-template {
            @apply --site-modal-modal;
          }
        </style>
      </custom-style>
      <paper-icon-button
        ?disabled="${this.editMode}"
        id="btn"
        @click="${this.fireEvent}"
        .icon="${this.icon}"
        .title="${this.buttonLabel}"
      ></paper-icon-button>
      <simple-tooltip for="btn" .position="${this.position}" offset="14">
        ${this.buttonLabel}
      </simple-tooltip>
      <simple-modal-template id="smt" .title="${this.title}">
        <div id="content" slot="content"></div>
      </simple-modal-template>
    `}fireEvent(t){this.dispatchEvent(new CustomEvent("site-modal-click",{detail:{value:!0}}))}static get properties(){return{disabled:{type:Boolean,reflect:!0},title:{type:String},icon:{type:String},buttonLabel:{type:String,attribute:"button-label"},position:{type:String}}}firstUpdated(t){this.shadowRoot.querySelector("#smt").associateEvents(this.shadowRoot.querySelector("#btn")),setTimeout(()=>{if(this.children&&this.shadowRoot.querySelector("#content"))for(var t in this.children)"object"==typeof this.children[t]&&this.shadowRoot.querySelector("#content").appendChild(this.children[t])},0)}}window.customElements.define(SiteModal.tag,SiteModal);export{SiteModal};