/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as n}from"../../../../../lit-element/lit-element.js";import{store as i}from"../../core/haxcms-site-store.js";import"../../../../../@polymer/polymer/lib/elements/custom-style.js";class SitePrintButton extends t{static get styles(){return[n`
        :host {
          display: block;
          text-rendering: optimizelegibility;
          position: relative;
        }
      `]}static get tag(){return"site-print-button"}constructor(){super(),this.icon="icons:print",this.position="bottom",this.type="page",import("../../../../simple-tooltip/simple-tooltip.js"),import("../../../../../@polymer/paper-icon-button/paper-icon-button.js")}render(){return e`
      <custom-style>
        <style>
          paper-icon-button {
            @apply --site-print-button-button;
          }
          paper-icon-button:hover,
          paper-icon-button:focus,
          paper-icon-button:active {
            @apply --site-print-button-button-hover;
          }
          simple-tooltip {
            @apply --site-print-button-tooltip;
          }
        </style>
      </custom-style>
      <paper-icon-button
        id="btn"
        icon="${this.icon}"
        @click="${this.print}"
        .title="${this.label}"
        ?disabled="${this.disabled}"
      ></paper-icon-button>
      <simple-tooltip for="btn" position="${this.position}" offset="14">
        ${this.label}
      </simple-tooltip>
    `}updated(t){t.forEach((t,e)=>{"type"==e&&this._typeChanged(this[e],t)})}static get properties(){return{icon:{type:String},disabled:{type:Boolean,reflect:!0},label:{type:String},position:{type:String},type:{type:String}}}_typeChanged(t){void 0===this.label&&(this.label="page"===t||"site"===t?`Print ${t}`:"Print outline")}async print(t){import("../layout/site-footer.js");const e=this.type;let n="";if("page"===e)n=`\n      <h1>${i.activeItem.title}</h1>\n      <div>${i.activeItemContent}</div>`;else if("parent"===e){const t=i.computeItems(1,100,i.activeId,"parent",i.routerManifest,!0);for(var o in t)n+=await fetch("pages/"+t[o].location+"/index.html").then((function(t){return t.text()})).then((function(e){let n=t[o].indent+1;return n>6&&(n=6),`<h${n}>${t[o].title}</h${n}>\n              ${e}`}))}else if("ancestor"===e){const t=i.computeItems(1,100,i.activeId,"ancestor",i.routerManifest,!0);for(var o in t)n+=await fetch("pages/"+t[o].location+"/index.html").then((function(t){return t.text()})).then((function(e){let n=t[o].indent+1;return n>6&&(n=6),`<h${n}>${t[o].title}</h${n}>\n              ${e}`}))}else if("site"===e){const t=i.routerManifest.items;for(var o in t)n+=await fetch("pages/"+t[o].location+"/index.html").then((function(t){return t.text()})).then((function(e){let n=t[o].indent+1;return n>6&&(n=6),`<h${n}>${t[o].title}</h${n}>\n              ${e}`}))}var r=new Date,s="Printed on: "+r.getDate()+"/"+(r.getMonth()+1)+"/"+r.getFullYear()+" at "+r.getHours()+":"+r.getMinutes()+":"+r.getSeconds();let p=document.createElement("div");p.innerHTML=`\n<style>\n  @media print {\n    body {\n      padding: 0 15px 5px;\n      color: #000;\n      background-color: #ffffff;\n      border-top: 1px solid #aaa;\n    }\n  }\n</style>\n<h1>${i.siteTitle}</h1>\n<site-footer></site-footer>\n<p>${s}</p>\n${n}`;let l=window.open("","","left=0,top=0,width=800,height=800,toolbar=0,scrollbars=0,status =0");if(document.head.getElementsByTagName("base")){let t=document.createElement("base");t.href=document.head.getElementsByTagName("base")[0].getAttribute("href"),l.document.head.appendChild(t)}l.document.body.appendChild(p),l.document.close(),l.focus(),l.print(),l.close()}}window.customElements.define(SitePrintButton.tag,SitePrintButton);export{SitePrintButton};