/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as r}from"../../../../../lit-element/lit-element.js";import"../../../../../@polymer/polymer/lib/elements/custom-style.js";class SiteRSSButton extends t{static get styles(){return[r`
        :host {
          display: block;
          font-size: 16px;
          color: var(--site-rss-color, #383f45);
        }
        a {
          text-decoration: var(--site-rss-text-decoration, none);
        }
        paper-button {
          text-transform: unset;
          color: white;
          background-color: var(--site-rss-bg-color, #383f45);
          font-size: var(--site-rss-font-size, 13px);
          margin: var(--site-rss-paper-button-margin, 0);
          border-radius: var(--site-rss-border-radius, 3px);
          padding: var(--site-rss-paper-button-padding, 0);
        }
        paper-button:hover,
        paper-button:focus,
        paper-button:active {
          background-color: var(--site-rss-bg-active, #2d3237);
        }
      `]}static get tag(){return"site-rss-button"}constructor(){super(),this.type="rss",this.raised=!1,import("../../../../../@polymer/paper-button/paper-button.js"),import("../../../../../@polymer/iron-icon/iron-icon.js"),import("../../../../../@polymer/iron-icons/communication-icons.js")}render(){return e`
      <custom-style>
        <style>
          paper-button {
            @apply --site-rss-paper-button;
          }
        </style>
      </custom-style>
      <a
        ?disabled="${this.disabled}"
        tabindex="-1"
        href="${this.href}"
        target="_blank"
        rel="noopener noreferrer"
      >
        <paper-button ?raised="${this.raised}">
          <iron-icon icon="${this.icon}"></iron-icon> ${this.label}
        </paper-button>
      </a>
    `}static get properties(){return{disabled:{type:Boolean,reflect:!0},label:{type:String},href:{type:String},icon:{type:String},type:{type:String},raised:{type:Boolean,reflect:!0}}}updated(t){t.forEach((t,e)=>{"type"==e&&this._generateLink(this[e],t)})}_generateLink(t,e){if(this._link&&document.head.removeChild(this._link),t){let e=document.createElement("link");e.rel="alternate","rss"===t?(e.href="rss.xml",e.title="RSS feed",e.type="application/rss+xml",this.icon="communication:rss-feed"):"atom"===t&&(e.href="atom.xml",e.title="Atom feed",e.type="application/atom+xml",this.icon="communication:rss-feed"),this.label=e.title,this.href=e.href,document.head.appendChild(e),this._link=e}}}window.customElements.define(SiteRSSButton.tag,SiteRSSButton);export{SiteRSSButton};