/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{html as t,PolymerElement as e}from"../../../@polymer/polymer/polymer-element.js";import{GestureEventListeners as s}from"../../../@polymer/polymer/lib/mixins/gesture-event-listeners.js";import*as i from"../../../@polymer/polymer/lib/utils/async.js";import*as r from"../../../@polymer/polymer/lib/utils/gestures.js";class SortableList extends(s(e)){static get template(){return t`
      <style>
        :host {
          display: flex;
        }
        #items ::slotted(*) {
          user-drag: none;
          user-select: none;
          -moz-user-select: none;
          -ms-user-select: none;
          -webkit-user-drag: none;
          -webkit-user-select: none;
          -webkit-tap-highlight-color: rgba(255, 255, 255, 0);
        }
        #items ::slotted(.item--transform) {
          left: 0;
          margin: 0 !important;
          position: fixed !important;
          top: 0;
          transition: transform 0.2s cubic-bezier(0.333, 0, 0, 1);
          will-change: transform;
          z-index: 1;
        }
        #items ::slotted(.item--pressed) {
          transition: none !important;
        }
        #items ::slotted(.item--dragged) {
          -webkit-box-shadow: 0 2px 10px rgba(0, 0, 0, 0.2);
          box-shadow: 0 2px 10px rgba(0, 0, 0, 0.2);
          filter: brightness(1.1);
          z-index: 2;
        }
      </style>
      <div id="items"><slot id="slot"></slot></div>
    `}static get is(){return"sortable-list"}static get properties(){return{sortable:String,items:{type:Array,notify:!0,readOnly:!0},dragging:{type:Boolean,notify:!0,readOnly:!0,reflectToAttribute:!0,value:!1},disabled:{type:Boolean,reflectToAttribute:!0,value:!1}}}constructor(){super(),this._observer=null,this._target=null,this._targetRect=null,this._rects=null,this._onTrack=this._onTrack.bind(this),this._onDragStart=this._onDragStart.bind(this),this._onTransitionEnd=this._onTransitionEnd.bind(this),this._onContextMenu=this._onContextMenu.bind(this),this._onTouchMove=this._onTouchMove.bind(this)}connectedCallback(){super.connectedCallback(),i.microTask.run(()=>{this._observeItems(),this._updateItems(),this._toggleListeners({enable:!0})})}disconnectedCallback(){super.disconnectedCallback(),this._unobserveItems(),this._toggleListeners({enable:!1})}_toggleListeners({enable:t}){const e=t?"addEventListener":"removeEventListener";this.shadowRoot.querySelector("#items")[e]("dragstart",this._onDragStart),this.shadowRoot.querySelector("#items")[e]("transitionend",this._onTransitionEnd),this.shadowRoot.querySelector("#items")[e]("contextmenu",this._onContextMenu),this.shadowRoot.querySelector("#items")[e]("touchmove",this._onTouchMove),t?r.addListener(this,"track",this._onTrack):r.removeListener(this,"track",this._onTrack)}_onTrack(t){switch(t.detail.state){case"start":this._trackStart(t);break;case"track":this._track(t);break;case"end":this._trackEnd(t)}}_trackStart(t){if(this.disabled)return;if(this._target=this._itemFromEvent(t),!this._target)return;t.stopPropagation(),this._rects=this._getItemsRects(),this._targetRect=this._rects[this.items.indexOf(this._target)],this._target.classList.add("item--dragged","item--pressed"),"vibrate"in navigator&&navigator.vibrate(30);const e=this.getBoundingClientRect();this.style.height=e.height+"px",this.style.width=e.width+"px",this.items.forEach((t,e)=>{const s=this._rects[e];t.classList.add("item--transform"),t.style.transition="none",t.__originalWidth=t.style.width,t.__originalHeight=t.style.height,t.style.width=s.width+"px",t.style.height=s.height+"px",this._translate3d(s.left,s.top,1,t),setTimeout(e=>{t.style.transition=null},20)}),this._setDragging(!0)}_track(t){if(!this.dragging)return;const e=this._targetRect.left+t.detail.dx,s=this._targetRect.top+t.detail.dy;this._translate3d(e,s,1,this._target);const i=this._itemFromCoords(t.detail);if(i&&i!==this._target){const t=this.items.indexOf(i),e=this.items.indexOf(this._target);this._moveItemArray(this.items,e,t);for(let t=0;t<this.items.length;t++)if(this.items[t]!==this._target){const e=this._rects[t];requestAnimationFrame(s=>{this._translate3d(e.left,e.top,1,this.items[t])})}}}_trackEnd(t){if(!this.dragging)return;const e=this._rects[this.items.indexOf(this._target)];this._target.classList.remove("item--pressed"),this._setDragging(!1),this._translate3d(e.left,e.top,1,this._target)}_onTransitionEnd(){if(this.dragging||!this._target)return;const t=document.createDocumentFragment();this.items.forEach(e=>{e.style.transform="",e.style.width=e.__originalWidth,e.style.height=e.__originalHeight,e.classList.remove("item--transform"),t.appendChild(e)}),this.children[0]?this.insertBefore(t,this.children[0]):this.appendChild(t),this.style.height="",this._target.classList.remove("item--dragged"),this._rects=null,this._targetRect=null,this._updateItems(),this.dispatchEvent(new CustomEvent("sort-finish",{composed:!0,detail:{target:this._target}})),this._target=null}_onDragStart(t){t.preventDefault()}_onContextMenu(t){this.dragging&&(t.preventDefault(),this._trackEnd())}_onTouchMove(t){t.preventDefault()}_updateItems(){if(this.dragging)return;const t=this.shadowRoot.querySelector("#slot").assignedNodes().filter(t=>{if(t.nodeType===Node.ELEMENT_NODE&&(!this.sortable||t.matches(this.sortable)))return!0});this._setItems(t)}_itemFromCoords({x:t,y:e}){if(!this._rects)return;let s=null;return this._rects.forEach((i,r)=>{t>=i.left&&t<=i.left+i.width&&e>=i.top&&e<=i.top+i.height&&(s=this.items[r])}),s}_itemFromEvent(t){const e=t.composedPath();for(var s=0;s<e.length;s++)if(this.items.indexOf(e[s])>-1)return e[s]}_getItemsRects(){return this.items.map(t=>t.getBoundingClientRect())}_observeItems(){this._observer||(this._observer=new MutationObserver(t=>{this._updateItems()}),this._observer.observe(this,{childList:!0}))}_unobserveItems(){this._observer&&(this._observer.disconnect(),this._observer=null)}_moveItemArray(t,e,s){if(s>=t.length)for(var i=s-t.length;1+i--;)t.push(void 0);return t.splice(s,0,t.splice(e,1)[0]),t}_translate3d(t,e,s,i){i.style.transform=`translate3d(${t}px, ${e}px, ${s}px)`}}window.customElements.define("sortable-list",SortableList);export{SortableList};