/**
 * Copyright 2020 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../lit-element/lit-element.js";import{IntersectionObserverMixin as r}from"../intersection-element/lib/IntersectionObserverMixin.js";class TypeWriter extends(r(t)){static get styles(){return[i`
        :host {
          display: inline-block;
          margin: 0px 0.1em;
        }

        @keyframes flickerAnimation {
          0% {
            opacity: 1;
          }

          50% {
            opacity: 0;
          }

          100% {
            opacity: 1;
          }
        }
        @-o-keyframes flickerAnimation {
          0% {
            opacity: 1;
          }

          50% {
            opacity: 0;
          }

          100% {
            opacity: 1;
          }
        }
        @-moz-keyframes flickerAnimation {
          0% {
            opacity: 1;
          }

          50% {
            opacity: 0;
          }

          100% {
            opacity: 1;
          }
        }
        @-webkit-keyframes flickerAnimation {
          0% {
            opacity: 1;
          }

          50% {
            opacity: 0;
          }

          100% {
            opacity: 1;
          }
        }

        #cursor {
          display: none;
          opacity: 0;
        }

        :host([typing]) #cursor {
          display: inline;
          -webkit-animation: flickerAnimation 1s infinite;
          -moz-animation: flickerAnimation 1s infinite;
          -o-animation: flickerAnimation 1s infinite;
          animation: flickerAnimation 1s infinite;
        }
      `]}render(){return e`
      <span id="text"></span><span id="cursor">|</span>
    `}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Type writer",description:"typewritter effect",icon:"icons:android",color:"green",groups:["Writer"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"btopro",owner:"The Pennsylvania State University"}},settings:{quick:[],configure:[{property:"delay",description:"",inputMethod:"textfield",required:!1,icon:"icons:android"},{property:"cursorDuration",description:"",inputMethod:"textfield",required:!1,icon:"icons:android"},{property:"text",description:"",inputMethod:"textfield",required:!1,icon:"icons:android"},{property:"speed",description:"",inputMethod:"textfield",required:!1,icon:"icons:android"},{property:"typing",description:"",inputMethod:"boolean",required:!1,icon:"icons:android"}],advanced:[]}}}static get properties(){return{...super.properties,delay:{type:Number},cursorDuration:{type:Number,attribute:"cursor-duration"},text:{type:String},speed:{type:Number},elementVisible:{type:Boolean},eraseSpeed:{type:Number,attribute:"erase-speed"},typing:{type:Boolean,reflect:!0},_length:{type:Number},_oldText:{type:String}}}static get tag(){return"type-writer"}constructor(){super(),this.delay=100,this.cursorDuration=0,this.speed=150,this.eraseSpeed=80,this.typing=!1}_observeText(t,e,i){if(t&&void 0!==e&&i){if(this.shadowRoot.querySelector("#text").textContent)return this._oldText=this.shadowRoot.querySelector("#text").textContent,this.typing&&this._cancel&&(clearTimeout(this._cancel),this._cancel=null),this.erase();this._length=0,setTimeout(()=>{this.type()},this.delay)}}type(){this.typing=!0,this.shadowRoot.querySelector("#text").textContent=this.text.substr(0,this._length++),this._length<this.text.length+1?this._cancel=setTimeout(()=>{this.type()},this.speed+(Math.random()-.5)*this.speed/2):setTimeout(()=>{this.typing=!1,this.dispatchEvent(new CustomEvent("type-writer-end",{detail:this.text,bubbles:!0,composed:!0}))},this.cursorDuration)}erase(){this.typing=!0,this.shadowRoot.querySelector("#text").textContent=this._oldText.substr(0,this._length--),this._length>=0?this._cancel=setTimeout(()=>{this.erase()},this.eraseSpeed||this.speed):this.type()}updated(t){t.forEach((t,e)=>{["text","delay","elementVisible"].includes(e)&&this._observeText(this.text,this.delay,this.elementVisible)})}}customElements.define(TypeWriter.tag,TypeWriter);export{TypeWriter};