define(["exports","require","../../lit-element/lit-element.js","../schema-behaviors/schema-behaviors.js"],function(_exports,_require,_litElement,_schemaBehaviors){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.ImageCompareSlider=void 0;_require=babelHelpers.interopRequireWildcard(_require);function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly)symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable});keys.push.apply(keys,symbols)}return keys}function _objectSpread(target){for(var i=1,source;i<arguments.length;i++){source=null!=arguments[i]?arguments[i]:{};if(i%2){ownKeys(Object(source),!0).forEach(function(key){babelHelpers.defineProperty(target,key,source[key])})}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source))}else{ownKeys(Object(source)).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))})}}return target}function _templateObject2_18325fa05fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n      <div>\n        <h2>","</h2>\n        <div id=\"container\" style=\"background-image: url(",");\">\n          <div id=\"top\" style=\"background-image: url(",");\"></div>\n        </div>\n        <user-action track=\"click\">\n          <paper-slider id=\"slider\" value=\"50\"></paper-slider>\n        </user-action>\n        <div></div>\n      </div>\n    "]);_templateObject2_18325fa05fe711ea9416fd1a737b18eb=function _templateObject2_18325fa05fe711ea9416fd1a737b18eb(){return data};return data}function _templateObject_18325fa05fe711ea9416fd1a737b18eb(){var data=babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: inline-flex;\n          width: 100%;\n        }\n        :host > div,\n        :host #container,\n        :host #top {\n          width: 100%;\n        }\n        :host #container {\n          background-size: cover;\n          overflow: visible;\n        }\n        :host #top {\n          background-size: auto 100%;\n          overflow: hidden;\n        }\n        :host #slider {\n          width: calc(100% + 30px);\n          margin-left: -15px;\n        }\n      "]);_templateObject_18325fa05fe711ea9416fd1a737b18eb=function _templateObject_18325fa05fe711ea9416fd1a737b18eb(){return data};return data}/**
 * `image-compare-slider`
 * Layers images over each other with a slider interface to compare them
 * @demo demo/index.html
 * @customElement image-compare-slider
 */var ImageCompareSlider=/*#__PURE__*/function(_SchemaBehaviors){babelHelpers.inherits(ImageCompareSlider,_SchemaBehaviors);babelHelpers.createClass(ImageCompareSlider,null,[{key:"styles",/**
   * LitElement constructable styles enhancement
   */get:function get(){return[(0,_litElement.css)(_templateObject_18325fa05fe711ea9416fd1a737b18eb())]}}]);function ImageCompareSlider(){var _this;babelHelpers.classCallCheck(this,ImageCompareSlider);_this=babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(ImageCompareSlider).call(this));_this.opacity=!1;new Promise(function(res,rej){return _require.default(["../user-action/user-action.js"],res,rej)});new Promise(function(res,rej){return _require.default(["../../@polymer/iron-image/iron-image.js"],res,rej)});new Promise(function(res,rej){return _require.default(["../../@polymer/paper-slider/paper-slider.js"],res,rej)});return _this}babelHelpers.createClass(ImageCompareSlider,[{key:"render",value:function render(){return(0,_litElement.html)(_templateObject2_18325fa05fe711ea9416fd1a737b18eb(),this.title,this.bottomSrc,this.topSrc)}},{key:"updated",value:function updated(changedProperties){var _this2=this;changedProperties.forEach(function(oldValue,propName){if(["topSrc"].includes(propName)){_this2._updateAspect();_this2._slide()}})}},{key:"firstUpdated",value:function firstUpdated(){var _this3=this;this.shadowRoot.querySelector("#slider").addEventListener("immediate-value-changed",function(e){_this3._slide()})}/**
   * updates the slider
   */},{key:"_slide",value:function _slide(){if(!1===this.opacity){this.shadowRoot.querySelector("#top").style.width=this.shadowRoot.querySelector("#slider").immediateValue+"%"}else{this.shadowRoot.querySelector("#top").style.opacity=this.shadowRoot.querySelector("#slider").immediateValue/100}}/**
   * updates the aspect ratio
   */},{key:"_updateAspect",value:function _updateAspect(){var img=document.createElement("img"),el=this.shadowRoot.querySelector("#top"),getAspect=function getAspect(img){el.style.paddingTop=100*img.height/img.width+"%"};this.__aspect="75";img.setAttribute("src",this.topSrc);if(img.height!==void 0&&0<img.height){getAspect(img)}else{img.addEventListener("load",function(){getAspect(img)})}}}],[{key:"tag",get:function get(){return"image-compare-slider"}},{key:"properties",get:function get(){return _objectSpread({},babelHelpers.get(babelHelpers.getPrototypeOf(ImageCompareSlider),"properties",this),{/**
       * Title
       */title:{type:String},/**
       * src for top image
       */topSrc:{type:String,attribute:"top-src"},/**
       * mode for the slider: wipe
       */opacity:{type:Boolean},/**
       * src for top image
       */bottomSrc:{type:String,attribute:"bottom-src"}})}},{key:"haxProperties",get:function get(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Image comparison",description:"Simple element to allow one image to swipe over top of the other.",icon:"image:compare",color:"orange",groups:["Image","Media"],handles:[{type:"image",source:"bottomSrc",source2:"topSrc",title:"title"}],meta:{author:"ELMS:LN"}},settings:{quick:[{property:"title",title:"Title",description:"The title of the element",inputMethod:"textfield",icon:"editor:title"},{property:"opacity",title:"Slider Behavior",description:"Do you want the slider to wipe the top image across the bottom one (default), or to adjust the opacity of the top image?",inputMethod:"select",options:{false:"wipe across",true:"adjust opacity"},icon:"image:compare"}],configure:[{property:"title",title:"Title",description:"The title of the element",inputMethod:"textfield"},{property:"bottomSrc",title:"Bottom image",description:"The base image to swipe over",inputMethod:"haxupload",validationType:"url"},{property:"topSrc",title:"Top image",description:"The top image that swipes over",inputMethod:"haxupload",validationType:"url"}],advanced:[]}}}}]);return ImageCompareSlider}((0,_schemaBehaviors.SchemaBehaviors)(_litElement.LitElement));_exports.ImageCompareSlider=ImageCompareSlider;window.customElements.define(ImageCompareSlider.tag,ImageCompareSlider)});