define(["exports"],function(_exports){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.LrnMath=_exports.LrnMathController=void 0;// forked from https://github.com/janmarthedal/math-tex
var document=window.document,states={start:1,loading:2,ready:3,typesetting:4,error:5},mathjaxHub,typesets=[],state=states.start,styleNode,src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.2/MathJax.js";function getStyleNode(){var styleNodes=document.querySelectorAll("style"),sn=Array.prototype.filter.call(styleNodes,function(n){return n.sheet&&100<n.sheet.cssRules.length&&".mjx-chtml"===n.sheet.cssRules[0].selectorText});styleNode=sn[0]}// precondition: state === states.ready
function flush_typesets(){if(!typesets.length)return;var jaxs=[],items=[];typesets.forEach(function(item){var script=document.createElement("script"),div=document.createElement("div");script.type=item[1]?"math/tex; mode=display":"math/tex";script.text=item[0];div.style.position="fixed";div.style.top=0;div.style.left="99999px";div.appendChild(script);document.body.appendChild(div);jaxs.push(script);items.push([div,item[2]])});typesets=[];state=states.typesetting;mathjaxHub.Queue(["Typeset",mathjaxHub,jaxs]);mathjaxHub.Queue(function(){if(!styleNode)getStyleNode();items.forEach(function(item){var div=item[0],result="SPAN"===div.firstElementChild.tagName?div.firstElementChild:null;item[1](result,styleNode);document.body.removeChild(div)});state=states.ready;flush_typesets()})}function load_library(){state=states.loading;window.MathJax={skipStartupTypeset:!0,showMathMenu:!1,jax:["input/TeX","output/CommonHTML"],TeX:{extensions:["AMSmath.js","AMSsymbols.js","noErrors.js","noUndefined.js"]},AuthorInit:function AuthorInit(){mathjaxHub=window.MathJax.Hub;mathjaxHub.Register.StartupHook("End",function(){state=states.ready;flush_typesets()})}};var script=document.createElement("script");script.type="text/javascript";script.src=src;script.async=!0;script.onerror=function(){console.warn("Error loading MathJax library "+src);state=states.error;typesets=[]};document.head.appendChild(script)}var LrnMathController=/*#__PURE__*/function(_HTMLElement){babelHelpers.inherits(LrnMathController,_HTMLElement);function LrnMathController(){babelHelpers.classCallCheck(this,LrnMathController);return babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(LrnMathController).apply(this,arguments))}babelHelpers.createClass(LrnMathController,[{key:"connectedCallback",value:function connectedCallback(){if(this.hasAttribute("src"))src=this.getAttribute("src");if(!this.hasAttribute("lazy"))load_library()}},{key:"typeset",value:function typeset(math,displayMode,cb){if(state===states.error)return;typesets.push([math,displayMode,cb]);if(state===states.start)load_library();else if(state===states.ready)flush_typesets()}}]);return LrnMathController}(babelHelpers.wrapNativeSuper(HTMLElement));_exports.LrnMathController=LrnMathController;window.customElements.define("lrn-math-controller",LrnMathController);/*
Typesets math written in (La)TeX, using [MathJax](http://mathjax.org).
##### Example
    <math-tex>c = \sqrt{a^2 + b^2}</math-tex>
##### Example
    <math-tex mode="display">\sum_{k=1}^n k = \frac{n (n + 1)}{2}</math-tex>
@element math-tex
@version 0.3.2
@homepage http://github.com/janmarthedal/math-tex/
*/var TAG_NAME="lrn-math",CONTROLLER_TAG_NAME="lrn-math-controller",mutation_config={childList:!0,characterData:!0,attributes:!0,subtree:!0},handler;function check_handler(){if(handler)return;handler=document.querySelector(CONTROLLER_TAG_NAME)||document.createElement(CONTROLLER_TAG_NAME);handler.setAttribute("lazy","lazy");if(!handler||"function"!==typeof handler.typeset){console.warn("no %s element defined; %s element will not work",CONTROLLER_TAG_NAME,TAG_NAME);handler=void 0}else if(!document.contains(handler))document.head.appendChild(handler)}function update(elem){var sdom=elem.shadowRoot,math=elem.textContent.trim(),isBlock="display"===elem.getAttribute("mode"),check=(isBlock?"D":"I")+math;if(check!==elem._private.check){while(sdom.firstChild){sdom.removeChild(sdom.firstChild)}elem._private.check=check;if(math.length){handler.typeset(math,isBlock,function(melem,styleNode){sdom.appendChild(styleNode.cloneNode(!0));sdom.appendChild(melem)})}}}/**
 * lrn-math
 * A mathjax wrapper tag in vanillaJS
 *
 * @demo demo/index.html
 */var LrnMath=/*#__PURE__*/function(_HTMLElement2){babelHelpers.inherits(LrnMath,_HTMLElement2);function LrnMath(){var _this;babelHelpers.classCallCheck(this,LrnMath);_this=babelHelpers.possibleConstructorReturn(this,babelHelpers.getPrototypeOf(LrnMath).call(this));_this.attachShadow({mode:"open"});return _this}babelHelpers.createClass(LrnMath,[{key:"connectedCallback",value:function connectedCallback(){var elem=this;check_handler();window.requestAnimationFrame(function(){elem._private={check:"",observer:new MutationObserver(function(){update(elem)})};update(elem);elem._private.observer.observe(elem,mutation_config)})}},{key:"refresh",/**
   * forces a refresh to prevent dom reattachment issue
   */value:function refresh(){var root=this,clone=document.createElement("lrn-math");root.parentNode.insertBefore(clone,root);clone.innerHTML=this.innerHTML;this.remove()}},{key:"disconnectedCallback",value:function disconnectedCallback(){if(this._private){this._private.observer.disconnect();delete this._private}}}],[{key:"tag",get:function get(){return"lrn-math"}},{key:"haxProperties",get:function get(){return{canScale:!0,canPosition:!0,canEditSource:!0,gizmo:{title:"Math",description:"Present math in a nice looking way.",icon:"hax:pi",iconLib:"@lrnwebcomponents/hax-iconset/hax-iconset.js",color:"grey",groups:["Content"],handles:[{type:"math",math:"mathText"},{type:"inline",text:"mathText"}],meta:{author:"ELMS:LN",inlineOnly:!0}},settings:{quick:[],configure:[{slot:"",title:"Math",description:"Enter equation as MathML",inputMethod:"code-editor",icon:"editor:format-quote"}],advanced:[]}}}}]);return LrnMath}(babelHelpers.wrapNativeSuper(HTMLElement));_exports.LrnMath=LrnMath;window.customElements.define(LrnMath.tag,LrnMath)});