define(["exports"],function(_exports){"use strict";Object.defineProperty(_exports,"__esModule",{value:!0});_exports.scopeCss=void 0;/**
 * @license
 * Copyright Google Inc. All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 *
 * This file is a port of shadowCSS from webcomponents.js to TypeScript.
 * https://github.com/webcomponents/webcomponentsjs/blob/4efecd7e0e/src/ShadowCSS/ShadowCSS.js
 * https://github.com/angular/angular/blob/master/packages/compiler/src/shadow_css.ts
 */var safeSelector=function safeSelector(selector){var placeholders=[],index=0,content;// Replaces attribute selectors with placeholders.
// The WS in [attr="va lue"] would otherwise be interpreted as a selector separator.
selector=selector.replace(/(\[[^\]]*\])/g,function(_,keep){var replaceBy="__ph-".concat(index,"__");placeholders.push(keep);index++;return replaceBy});// Replaces the expression in `:nth-child(2n + 1)` with a placeholder.
// WS and "+" would otherwise be interpreted as selector separators.
content=selector.replace(/(:nth-[-\w]+)(\([^)]+\))/g,function(_,pseudo,exp){var replaceBy="__ph-".concat(index,"__");placeholders.push(exp);index++;return pseudo+replaceBy});var ss={content:content,placeholders:placeholders};return ss},restoreSafeSelector=function restoreSafeSelector(placeholders,content){return content.replace(/__ph-(\d+)__/g,function(_,index){return placeholders[+index]})},_polyfillHost="-shadowcsshost",_polyfillSlotted="-shadowcssslotted",_polyfillHostContext="-shadowcsscontext",_parenSuffix=")(?:\\(("+"(?:\\([^)(]*\\)|[^)(]*)+?"+")\\))?([^,{]*)",_cssColonHostRe=new RegExp("("+_polyfillHost+_parenSuffix,"gim"),_cssColonHostContextRe=new RegExp("("+_polyfillHostContext+_parenSuffix,"gim"),_cssColonSlottedRe=new RegExp("("+_polyfillSlotted+_parenSuffix,"gim"),_polyfillHostNoCombinator=_polyfillHost+"-no-combinator",_polyfillHostNoCombinatorRe=/-shadowcsshost-no-combinator([^\s]*)/,_shadowDOMSelectorsRe=[/::shadow/g,/::content/g],_selectorReSuffix="([>\\s~+[.,{:][\\s\\S]*)?$",_polyfillHostRe=/-shadowcsshost/gim,_colonHostRe=/:host/gim,_colonSlottedRe=/::slotted/gim,_colonHostContextRe=/:host-context/gim,_commentRe=/\/\*\s*[\s\S]*?\*\//g,stripComments=function stripComments(input){return input.replace(_commentRe,"")},_commentWithHashRe=/\/\*\s*#\s*source(Mapping)?URL=[\s\S]+?\*\//g,extractCommentsWithHash=function extractCommentsWithHash(input){return input.match(_commentWithHashRe)||[]},_ruleRe=/(\s*)([^;\{\}]+?)(\s*)((?:{%BLOCK%}?\s*;?)|(?:\s*;))/g,_curlyRe=/([{}])/g,OPEN_CURLY="{",CLOSE_CURLY="}",BLOCK_PLACEHOLDER="%BLOCK%",processRules=function processRules(input,ruleCallback){var inputWithEscapedBlocks=escapeBlocks(input),nextBlockIndex=0;return inputWithEscapedBlocks.escapedString.replace(_ruleRe,function(){var selector=2>=arguments.length?void 0:arguments[2],content="",suffix=4>=arguments.length?void 0:arguments[4],contentPrefix="";if(suffix&&suffix.startsWith("{"+BLOCK_PLACEHOLDER)){content=inputWithEscapedBlocks.blocks[nextBlockIndex++];suffix=suffix.substring(BLOCK_PLACEHOLDER.length+1);contentPrefix="{"}var cssRule={selector:selector,content:content},rule=ruleCallback(cssRule);return"".concat(1>=arguments.length?void 0:arguments[1]).concat(rule.selector).concat(3>=arguments.length?void 0:arguments[3]).concat(contentPrefix).concat(rule.content).concat(suffix)})},escapeBlocks=function escapeBlocks(input){for(var inputParts=input.split(_curlyRe),resultParts=[],escapedBlocks=[],bracketCount=0,currentBlockParts=[],partIndex=0,part;partIndex<inputParts.length;partIndex++){part=inputParts[partIndex];if(part===CLOSE_CURLY){bracketCount--}if(0<bracketCount){currentBlockParts.push(part)}else{if(0<currentBlockParts.length){escapedBlocks.push(currentBlockParts.join(""));resultParts.push(BLOCK_PLACEHOLDER);currentBlockParts=[]}resultParts.push(part)}if(part===OPEN_CURLY){bracketCount++}}if(0<currentBlockParts.length){escapedBlocks.push(currentBlockParts.join(""));resultParts.push(BLOCK_PLACEHOLDER)}var strEscapedBlocks={escapedString:resultParts.join(""),blocks:escapedBlocks};return strEscapedBlocks},insertPolyfillHostInCssText=function insertPolyfillHostInCssText(selector){selector=selector.replace(_colonHostContextRe,_polyfillHostContext).replace(_colonHostRe,_polyfillHost).replace(_colonSlottedRe,_polyfillSlotted);return selector},convertColonRule=function convertColonRule(cssText,regExp,partReplacer){// m[1] = :host(-context), m[2] = contents of (), m[3] rest of rule
return cssText.replace(regExp,function(){for(var _len=arguments.length,m=Array(_len),_key=0;_key<_len;_key++){m[_key]=arguments[_key]}if(m[2]){for(var parts=m[2].split(","),r=[],i=0,p;i<parts.length;i++){p=parts[i].trim();if(!p)break;r.push(partReplacer(_polyfillHostNoCombinator,p,m[3]))}return r.join(",")}else{return _polyfillHostNoCombinator+m[3]}})},colonHostPartReplacer=function colonHostPartReplacer(host,part,suffix){return host+part.replace(_polyfillHost,"")+suffix},convertColonHost=function convertColonHost(cssText){return convertColonRule(cssText,_cssColonHostRe,colonHostPartReplacer)},colonHostContextPartReplacer=function colonHostContextPartReplacer(host,part,suffix){if(-1<part.indexOf(_polyfillHost)){return colonHostPartReplacer(host,part,suffix)}else{return host+part+suffix+", "+part+" "+host+suffix}},convertColonSlotted=function convertColonSlotted(cssText,slotAttr){var regExp=_cssColonSlottedRe;return cssText.replace(regExp,function(){for(var _len2=arguments.length,m=Array(_len2),_key2=0;_key2<_len2;_key2++){m[_key2]=arguments[_key2]}if(m[2]){var compound=m[2].trim(),suffix=m[3],sel="."+slotAttr+" > "+compound+suffix;return sel}else{return _polyfillHostNoCombinator+m[3]}})},convertColonHostContext=function convertColonHostContext(cssText){return convertColonRule(cssText,_cssColonHostContextRe,colonHostContextPartReplacer)},convertShadowDOMSelectors=function convertShadowDOMSelectors(cssText){return _shadowDOMSelectorsRe.reduce(function(result,pattern){return result.replace(pattern," ")},cssText)},makeScopeMatcher=function makeScopeMatcher(scopeSelector){var lre=/\[/g,rre=/\]/g;scopeSelector=scopeSelector.replace(lre,"\\[").replace(rre,"\\]");return new RegExp("^("+scopeSelector+")"+_selectorReSuffix,"m")},selectorNeedsScoping=function selectorNeedsScoping(selector,scopeSelector){var re=makeScopeMatcher(scopeSelector);return!re.test(selector)},applySimpleSelectorScope=function applySimpleSelectorScope(selector,scopeSelector,hostSelector){// In Android browser, the lastIndex is not reset when the regex is used in String.replace()
_polyfillHostRe.lastIndex=0;if(_polyfillHostRe.test(selector)){var replaceBy=".".concat(hostSelector);return selector.replace(_polyfillHostNoCombinatorRe,function(_,selector){return selector.replace(/([^:]*)(:*)(.*)/,function(_,before,colon,after){return before+replaceBy+colon+after})}).replace(_polyfillHostRe,replaceBy+" ")}return scopeSelector+" "+selector},applyStrictSelectorScope=function applyStrictSelectorScope(selector,scopeSelector,hostSelector){var isRe=/\[is=([^\]]*)\]/g;scopeSelector=scopeSelector.replace(isRe,function(_){return 1>=arguments.length?void 0:arguments[1]});var className="."+scopeSelector,_scopeSelectorPart=function _scopeSelectorPart(p){var scopedP=p.trim();if(!scopedP){return""}if(-1<p.indexOf(_polyfillHostNoCombinator)){scopedP=applySimpleSelectorScope(p,scopeSelector,hostSelector)}else{// remove :host since it should be unnecessary
var t=p.replace(_polyfillHostRe,"");if(0<t.length){var matches=t.match(/([^:]*)(:*)(.*)/);if(matches){scopedP=matches[1]+className+matches[2]+matches[3]}}}return scopedP},safeContent=safeSelector(selector);selector=safeContent.content;var scopedSelector="",startIndex=0,res,sep=/( |>|\+|~(?!=))\s*/g,hasHost=-1<selector.indexOf(_polyfillHostNoCombinator),shouldScope=!hasHost;while(null!==(res=sep.exec(selector))){var separator=res[1],_part=selector.slice(startIndex,res.index).trim();shouldScope=shouldScope||-1<_part.indexOf(_polyfillHostNoCombinator);var scopedPart=shouldScope?_scopeSelectorPart(_part):_part;scopedSelector+="".concat(scopedPart," ").concat(separator," ");startIndex=sep.lastIndex}var part=selector.substring(startIndex);shouldScope=shouldScope||-1<part.indexOf(_polyfillHostNoCombinator);scopedSelector+=shouldScope?_scopeSelectorPart(part):part;// replace the placeholders with their original values
return restoreSafeSelector(safeContent.placeholders,scopedSelector)},scopeSelector=function scopeSelector(selector,scopeSelectorText,hostSelector,slotSelector){return selector.split(",").map(function(shallowPart){if(slotSelector&&-1<shallowPart.indexOf("."+slotSelector)){return shallowPart.trim()}if(selectorNeedsScoping(shallowPart,scopeSelectorText)){return applyStrictSelectorScope(shallowPart,scopeSelectorText,hostSelector).trim()}else{return shallowPart.trim()}}).join(", ")},scopeSelectors=function scopeSelectors(cssText,scopeSelectorText,hostSelector,slotSelector,commentOriginalSelector){return processRules(cssText,function(rule){var selector=rule.selector,content=rule.content;if("@"!==rule.selector[0]){selector=scopeSelector(rule.selector,scopeSelectorText,hostSelector,slotSelector)}else if(rule.selector.startsWith("@media")||rule.selector.startsWith("@supports")||rule.selector.startsWith("@page")||rule.selector.startsWith("@document")){content=scopeSelectors(rule.content,scopeSelectorText,hostSelector,slotSelector)}var cssRule={selector:selector.replace(/\s{2,}/g," ").trim(),content:content};return cssRule})},scopeCssText=function scopeCssText(cssText,scopeId,hostScopeId,slotScopeId,commentOriginalSelector){cssText=insertPolyfillHostInCssText(cssText);cssText=convertColonHost(cssText);cssText=convertColonHostContext(cssText);cssText=convertColonSlotted(cssText,slotScopeId);cssText=convertShadowDOMSelectors(cssText);if(scopeId){cssText=scopeSelectors(cssText,scopeId,hostScopeId,slotScopeId)}cssText=cssText.replace(/-shadowcsshost-no-combinator/g,".".concat(hostScopeId));cssText=cssText.replace(/>\s*\*\s+([^{, ]+)/gm," $1 ");return cssText.trim()},scopeCss=function scopeCss(cssText,scopeId,commentOriginalSelector){var hostScopeId=scopeId+"-h",slotScopeId=scopeId+"-s",commentsWithHash=extractCommentsWithHash(cssText);cssText=stripComments(cssText);var orgSelectors=[];if(commentOriginalSelector){var processCommentedSelector=function processCommentedSelector(rule){var placeholder="/*!@___".concat(orgSelectors.length,"___*/"),comment="/*!@".concat(rule.selector,"*/");orgSelectors.push({placeholder:placeholder,comment:comment});rule.selector=placeholder+rule.selector;return rule};cssText=processRules(cssText,function(rule){if("@"!==rule.selector[0]){return processCommentedSelector(rule)}else if(rule.selector.startsWith("@media")||rule.selector.startsWith("@supports")||rule.selector.startsWith("@page")||rule.selector.startsWith("@document")){rule.content=processRules(rule.content,processCommentedSelector);return rule}return rule})}var scopedCssText=scopeCssText(cssText,scopeId,hostScopeId,slotScopeId);cssText=[scopedCssText].concat(babelHelpers.toConsumableArray(commentsWithHash)).join("\n");if(commentOriginalSelector){orgSelectors.forEach(function(_ref){var placeholder=_ref.placeholder,comment=_ref.comment;cssText=cssText.replace(placeholder,comment)})}return cssText};_exports.scopeCss=scopeCss});