define(["exports","../utils/boot.js","../utils/wrap.js","../utils/mixin.js","../utils/path.js","../utils/case-map.js","./property-accessors.js","./template-stamp.js","../utils/settings.js"],(function(t,e,a,i,r,s,n,o,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PropertyEffects=void 0;
/**
   * @fileoverview
   * @suppress {checkPrototypalTypes}
   * @license Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
   * This code may only be used under the BSD style license found at
   * http://polymer.github.io/LICENSE.txt The complete set of authors may be found
   * at http://polymer.github.io/AUTHORS.txt The complete set of contributors may
   * be found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by
   * Google as part of the polymer project is also subject to an additional IP
   * rights grant found at http://polymer.github.io/PATENTS.txt
   */
let d=0;const h={COMPUTE:"__computeEffects",REFLECT:"__reflectEffects",NOTIFY:"__notifyEffects",PROPAGATE:"__propagateEffects",OBSERVE:"__observeEffects",READ_ONLY:"__readOnly"},_=/[A-Z]/;function ensureOwnEffectMap(t,e){let a=t[e];if(a){if(!t.hasOwnProperty(e)){a=t[e]=Object.create(t[e]);for(let t in a){let e=a[t],i=a[t]=Array(e.length);for(let t=0;t<e.length;t++)i[t]=e[t]}}}else a=t[e]={};return a}function runEffects(t,e,a,i,r,s){if(e){let n=!1,o=d++;for(let l in a)runEffectsForProperty(t,e,o,l,a,i,r,s)&&(n=!0);return n}return!1}function runEffectsForProperty(t,e,a,i,s,n,o,l){let d=!1,h=e[o?(0,r.root)(i):i];if(h)for(let r,_=0,f=h.length;_<f&&(r=h[_]);_++)r.info&&r.info.lastRun===a||o&&!pathMatchesTrigger(i,r.trigger)||(r.info&&(r.info.lastRun=a),r.fn(t,i,s,n,r.info,o,l),d=!0);return d}function pathMatchesTrigger(t,e){if(e){let a=e.name;return a==t||!(!e.structured||!(0,r.isAncestor)(a,t))||!(!e.wildcard||!(0,r.isDescendant)(a,t))}return!0}function runObserverEffect(t,e,a,i,r){let s="string"==typeof r.method?t[r.method]:r.method,n=r.property;s?s.call(t,t.__data[n],i[n]):r.dynamicFn||console.warn("observer method `"+r.method+"` not defined")}function notifyPath(t,e,a){let i=(0,r.root)(e);if(i!==e){return dispatchNotifyEvent(t,(0,s.camelToDashCase)(i)+"-changed",a[e],e),!0}return!1}function dispatchNotifyEvent(t,e,i,r){let s={value:i,queueProperty:!0};r&&(s.path=r),(0,a.wrap)(t).dispatchEvent(new CustomEvent(e,{detail:s}))}function runNotifyEffect(t,e,a,i,s,n){let o=(n?(0,r.root)(e):e)!=e?e:null,l=o?(0,r.get)(t,o):t.__data[e];o&&void 0===l&&(l=a[e]),dispatchNotifyEvent(t,s.eventName,l,o)}function runReflectEffect(t,e,a,i,r){let s=t.__data[e];l.sanitizeDOMValue&&(s=(0,l.sanitizeDOMValue)(s,r.attrName,"attribute",t)),t._propertyToAttribute(e,r.attrName,s)}function runComputedEffect(t,e,a,i,r){let s=runMethodEffect(t,e,a,i,r),n=r.methodInfo;t.__dataHasAccessor&&t.__dataHasAccessor[n]?t._setPendingProperty(n,s,!0):t[n]=s}function addBinding(t,e,a,i,r,n,o){a.bindings=a.bindings||[];let l={kind:i,target:r,parts:n,literal:o,isCompound:1!==n.length};if(a.bindings.push(l),function shouldAddListener(t){return Boolean(t.target)&&"attribute"!=t.kind&&"text"!=t.kind&&!t.isCompound&&"{"===t.parts[0].mode}(l)){let{event:t,negate:e}=l.parts[0];l.listenerEvent=t||(0,s.camelToDashCase)(r)+"-changed",l.listenerNegate=e}let d=e.nodeInfoList.length;for(let s=0;s<l.parts.length;s++){let a=l.parts[s];a.compoundIndex=s,addEffectForBindingPart(t,e,l,a,d)}}function addEffectForBindingPart(t,e,a,i,r){if(!i.literal)if("attribute"===a.kind&&"-"===a.target[0])console.warn("Cannot set attribute "+a.target+' because "-" is not a valid attribute starting character');else{let s=i.dependencies,n={index:r,binding:a,part:i,evaluator:t};for(let a=0;a<s.length;a++){let i=s[a];"string"==typeof i&&(i=parseArg(i),i.wildcard=!0),t._addTemplatePropertyEffect(e,i.rootProperty,{fn:runBindingEffect,info:n,trigger:i})}}}function runBindingEffect(t,e,a,i,s,n,o){let d=o[s.index],_=s.binding,f=s.part;if(n&&f.source&&e.length>f.source.length&&"property"==_.kind&&!_.isCompound&&d.__isPropertyEffectsClient&&d.__dataHasAccessor&&d.__dataHasAccessor[_.target]){let i=a[e];e=(0,r.translate)(f.source,_.target,e),d._setPendingPropertyOrPath(e,i,!1,!0)&&t._enqueueClient(d)}else{!function applyBindingValue(t,e,a,i,r){r=function computeBindingValue(t,e,a,i){if(a.isCompound){let r=t.__dataCompoundStorage[a.target];r[i.compoundIndex]=e,e=r.join("")}"attribute"!==a.kind&&("textContent"!==a.target&&("value"!==a.target||"input"!==t.localName&&"textarea"!==t.localName)||(e=null==e?"":e));return e}(e,r,a,i),l.sanitizeDOMValue&&(r=(0,l.sanitizeDOMValue)(r,a.target,a.kind,e));if("attribute"==a.kind)t._valueToNodeAttribute(e,r,a.target);else{let i=a.target;e.__isPropertyEffectsClient&&e.__dataHasAccessor&&e.__dataHasAccessor[i]?e[h.READ_ONLY]&&e[h.READ_ONLY][i]||e._setPendingProperty(i,r)&&t._enqueueClient(e):t._setUnmanagedPropertyToNode(e,i,r)}}(t,d,_,f,s.evaluator._evaluateBinding(t,f,e,a,i,n))}}function setupCompoundStorage(t,e){if(e.isCompound){let i=t.__dataCompoundStorage||(t.__dataCompoundStorage={}),r=e.parts,s=new Array(r.length);for(let t=0;t<r.length;t++)s[t]=r[t].literal;let n=e.target;i[n]=s,e.literal&&"property"==e.kind&&("className"===n&&(t=(0,a.wrap)(t)),t[n]=e.literal)}}function addNotifyListener(t,e,a){if(a.listenerEvent){let i=a.parts[0];t.addEventListener(a.listenerEvent,(function(t){!function handleNotification(t,e,a,i,s){let n,o=t.detail,l=o&&o.path;l?(i=(0,r.translate)(a,i,l),n=o&&o.value):n=t.currentTarget[a],n=s?!n:n,e[h.READ_ONLY]&&e[h.READ_ONLY][i]||!e._setPendingPropertyOrPath(i,n,!0,Boolean(l))||o&&o.queueProperty||e._invalidateProperties()}(t,e,a.target,i.source,i.negate)}))}}function createMethodEffect(t,e,a,i,r,s){s=e.static||s&&("object"!=typeof s||s[e.methodName]);let n={methodName:e.methodName,args:e.args,methodInfo:r,dynamicFn:s};for(let o,l=0;l<e.args.length&&(o=e.args[l]);l++)o.literal||t._addPropertyEffect(o.rootProperty,a,{fn:i,info:n,trigger:o});s&&t._addPropertyEffect(e.methodName,a,{fn:i,info:n})}function runMethodEffect(t,e,a,i,r){let s=t._methodHost||t,n=s[r.methodName];if(n){let i=t._marshalArgs(r.args,e,a);return n.apply(s,i)}r.dynamicFn||console.warn("method `"+r.methodName+"` not defined")}const f=[],p=new RegExp("(\\[\\[|{{)\\s*(?:(!)\\s*)?((?:[a-zA-Z_$][\\w.:$\\-*]*)\\s*(?:\\(\\s*(?:(?:(?:((?:[a-zA-Z_$][\\w.:$\\-*]*)|(?:[-+]?[0-9]*\\.?[0-9]+(?:[eE][-+]?[0-9]+)?)|(?:(?:'(?:[^'\\\\]|\\\\.)*')|(?:\"(?:[^\"\\\\]|\\\\.)*\")))\\s*)(?:,\\s*(?:((?:[a-zA-Z_$][\\w.:$\\-*]*)|(?:[-+]?[0-9]*\\.?[0-9]+(?:[eE][-+]?[0-9]+)?)|(?:(?:'(?:[^'\\\\]|\\\\.)*')|(?:\"(?:[^\"\\\\]|\\\\.)*\")))\\s*))*)?)\\)\\s*)?)(?:]]|}})","g");function literalFromParts(t){let e="";for(let a=0;a<t.length;a++){e+=t[a].literal||""}return e}function parseMethod(t){let e=t.match(/([^\s]+?)\(([\s\S]*)\)/);if(e){let t={methodName:e[1],static:!0,args:f};if(e[2].trim()){return function parseArgs(t,e){return e.args=t.map((function(t){let a=parseArg(t);return a.literal||(e.static=!1),a}),this),e}(e[2].replace(/\\,/g,"&comma;").split(","),t)}return t}return null}function parseArg(t){let e=t.trim().replace(/&comma;/g,",").replace(/\\(.)/g,"$1"),a={name:e,value:"",literal:!1},i=e[0];switch("-"===i&&(i=e[1]),i>="0"&&i<="9"&&(i="#"),i){case"'":case'"':a.value=e.slice(1,-1),a.literal=!0;break;case"#":a.value=Number(e),a.literal=!0}return a.literal||(a.rootProperty=(0,r.root)(e),a.structured=(0,r.isPath)(e),a.structured&&(a.wildcard=".*"==e.slice(-2),a.wildcard&&(a.name=e.slice(0,-2)))),a}function getArgValue(t,e,a){let i=(0,r.get)(t,a);return void 0===i&&(i=e[a]),i}function notifySplices(t,e,a,i){t.notifyPath(a+".splices",{indexSplices:i}),t.notifyPath(a+".length",e.length)}function notifySplice(t,e,a,i,r,s){notifySplices(t,e,a,[{index:i,addedCount:r,removed:s,object:e,type:"splice"}])}const c=(0,i.dedupingMixin)(t=>{const e=(0,o.TemplateStamp)((0,n.PropertyAccessors)(t));return class PropertyEffects extends e{constructor(){super(),this.__isPropertyEffectsClient=!0,this.__dataCounter=0,this.__dataClientsReady,this.__dataPendingClients,this.__dataToNotify,this.__dataLinkedPaths,this.__dataHasPaths,this.__dataCompoundStorage,this.__dataHost,this.__dataTemp,this.__dataClientsInitialized,this.__data,this.__dataPending,this.__dataOld,this.__computeEffects,this.__reflectEffects,this.__notifyEffects,this.__propagateEffects,this.__observeEffects,this.__readOnly,this.__templateInfo}get PROPERTY_EFFECT_TYPES(){return h}_initializeProperties(){super._initializeProperties(),u.registerHost(this),this.__dataClientsReady=!1,this.__dataPendingClients=null,this.__dataToNotify=null,this.__dataLinkedPaths=null,this.__dataHasPaths=!1,this.__dataCompoundStorage=this.__dataCompoundStorage||null,this.__dataHost=this.__dataHost||null,this.__dataTemp={},this.__dataClientsInitialized=!1}_initializeProtoProperties(t){this.__data=Object.create(t),this.__dataPending=Object.create(t),this.__dataOld={}}_initializeInstanceProperties(t){let e=this[h.READ_ONLY];for(let a in t)e&&e[a]||(this.__dataPending=this.__dataPending||{},this.__dataOld=this.__dataOld||{},this.__data[a]=this.__dataPending[a]=t[a])}_addPropertyEffect(t,e,a){this._createPropertyAccessor(t,e==h.READ_ONLY);let i=ensureOwnEffectMap(this,e)[t];i||(i=this[e][t]=[]),i.push(a)}_removePropertyEffect(t,e,a){let i=ensureOwnEffectMap(this,e)[t],r=i.indexOf(a);r>=0&&i.splice(r,1)}_hasPropertyEffect(t,e){let a=this[e];return Boolean(a&&a[t])}_hasReadOnlyEffect(t){return this._hasPropertyEffect(t,h.READ_ONLY)}_hasNotifyEffect(t){return this._hasPropertyEffect(t,h.NOTIFY)}_hasReflectEffect(t){return this._hasPropertyEffect(t,h.REFLECT)}_hasComputedEffect(t){return this._hasPropertyEffect(t,h.COMPUTE)}_setPendingPropertyOrPath(t,e,a,i){if(i||(0,r.root)(Array.isArray(t)?t[0]:t)!==t){if(!i){let a=(0,r.get)(this,t);if(!(t=(0,r.set)(this,t,e))||!super._shouldPropertyChange(t,e,a))return!1}if(this.__dataHasPaths=!0,this._setPendingProperty(t,e,a))return function computeLinkedPaths(t,e,a){let i=t.__dataLinkedPaths;if(i){let s;for(let n in i){let o=i[n];(0,r.isDescendant)(n,e)?(s=(0,r.translate)(n,o,e),t._setPendingPropertyOrPath(s,a,!0,!0)):(0,r.isDescendant)(o,e)&&(s=(0,r.translate)(o,n,e),t._setPendingPropertyOrPath(s,a,!0,!0))}}}(this,t,e),!0}else{if(this.__dataHasAccessor&&this.__dataHasAccessor[t])return this._setPendingProperty(t,e,a);this[t]=e}return!1}_setUnmanagedPropertyToNode(t,e,i){i===t[e]&&"object"!=typeof i||("className"===e&&(t=(0,a.wrap)(t)),t[e]=i)}_setPendingProperty(t,e,a){let i=this.__dataHasPaths&&(0,r.isPath)(t),s=i?this.__dataTemp:this.__data;return!!this._shouldPropertyChange(t,e,s[t])&&(this.__dataPending||(this.__dataPending={},this.__dataOld={}),t in this.__dataOld||(this.__dataOld[t]=this.__data[t]),i?this.__dataTemp[t]=e:this.__data[t]=e,this.__dataPending[t]=e,(i||this[h.NOTIFY]&&this[h.NOTIFY][t])&&(this.__dataToNotify=this.__dataToNotify||{},this.__dataToNotify[t]=a),!0)}_setProperty(t,e){this._setPendingProperty(t,e,!0)&&this._invalidateProperties()}_invalidateProperties(){this.__dataReady&&this._flushProperties()}_enqueueClient(t){this.__dataPendingClients=this.__dataPendingClients||[],t!==this&&this.__dataPendingClients.push(t)}_flushProperties(){this.__dataCounter++,super._flushProperties(),this.__dataCounter--}_flushClients(){this.__dataClientsReady?this.__enableOrFlushClients():(this.__dataClientsReady=!0,this._readyClients(),this.__dataReady=!0)}__enableOrFlushClients(){let t=this.__dataPendingClients;if(t){this.__dataPendingClients=null;for(let e=0;e<t.length;e++){let a=t[e];a.__dataEnabled?a.__dataPending&&a._flushProperties():a._enableProperties()}}}_readyClients(){this.__enableOrFlushClients()}setProperties(t,e){for(let a in t)!e&&this[h.READ_ONLY]&&this[h.READ_ONLY][a]||this._setPendingPropertyOrPath(a,t[a],!0);this._invalidateProperties()}ready(){this._flushProperties(),this.__dataClientsReady||this._flushClients(),this.__dataPending&&this._flushProperties()}_propertiesChanged(t,e,a){let i=this.__dataHasPaths;this.__dataHasPaths=!1,function runComputedEffects(t,e,a,i){let r=t[h.COMPUTE];if(r){let s=e;for(;runEffects(t,r,s,a,i);)Object.assign(a,t.__dataOld),Object.assign(e,t.__dataPending),s=t.__dataPending,t.__dataPending=null}}(this,e,a,i);let r=this.__dataToNotify;this.__dataToNotify=null,this._propagatePropertyChanges(e,a,i),this._flushClients(),runEffects(this,this[h.REFLECT],e,a,i),runEffects(this,this[h.OBSERVE],e,a,i),r&&function runNotifyEffects(t,e,a,i,r){let s,n,o=t[h.NOTIFY],l=d++;for(let d in e)e[d]&&(o&&runEffectsForProperty(t,o,l,d,a,i,r)?s=!0:r&&notifyPath(t,d,a)&&(s=!0));s&&(n=t.__dataHost)&&n._invalidateProperties&&n._invalidateProperties()}(this,r,e,a,i),1==this.__dataCounter&&(this.__dataTemp={})}_propagatePropertyChanges(t,e,a){this[h.PROPAGATE]&&runEffects(this,this[h.PROPAGATE],t,e,a);let i=this.__templateInfo;for(;i;)runEffects(this,i.propertyEffects,t,e,a,i.nodeList),i=i.nextTemplateInfo}linkPaths(t,e){t=(0,r.normalize)(t),e=(0,r.normalize)(e),this.__dataLinkedPaths=this.__dataLinkedPaths||{},this.__dataLinkedPaths[t]=e}unlinkPaths(t){t=(0,r.normalize)(t),this.__dataLinkedPaths&&delete this.__dataLinkedPaths[t]}notifySplices(t,e){let a={path:""};notifySplices(this,(0,r.get)(this,t,a),a.path,e)}get(t,e){return(0,r.get)(e||this,t)}set(t,e,a){a?(0,r.set)(a,t,e):this[h.READ_ONLY]&&this[h.READ_ONLY][t]||this._setPendingPropertyOrPath(t,e,!0)&&this._invalidateProperties()}push(t,...e){let a={path:""},i=(0,r.get)(this,t,a),s=i.length,n=i.push(...e);return e.length&&notifySplice(this,i,a.path,s,e.length,[]),n}pop(t){let e={path:""},a=(0,r.get)(this,t,e),i=Boolean(a.length),s=a.pop();return i&&notifySplice(this,a,e.path,a.length,0,[s]),s}splice(t,e,a,...i){let s,n={path:""},o=(0,r.get)(this,t,n);return e<0?e=o.length-Math.floor(-e):e&&(e=Math.floor(e)),s=2===arguments.length?o.splice(e):o.splice(e,a,...i),(i.length||s.length)&&notifySplice(this,o,n.path,e,i.length,s),s}shift(t){let e={path:""},a=(0,r.get)(this,t,e),i=Boolean(a.length),s=a.shift();return i&&notifySplice(this,a,e.path,0,0,[s]),s}unshift(t,...e){let a={path:""},i=(0,r.get)(this,t,a),s=i.unshift(...e);return e.length&&notifySplice(this,i,a.path,0,e.length,[]),s}notifyPath(t,e){let a;if(1==arguments.length){let i={path:""};e=(0,r.get)(this,t,i),a=i.path}else a=Array.isArray(t)?(0,r.normalize)(t):t;this._setPendingPropertyOrPath(a,e,!0,!0)&&this._invalidateProperties()}_createReadOnlyProperty(t,e){this._addPropertyEffect(t,h.READ_ONLY),e&&(this["_set"+function upper(t){return t[0].toUpperCase()+t.substring(1)}(t)]=function(e){this._setProperty(t,e)})}_createPropertyObserver(t,e,a){let i={property:t,method:e,dynamicFn:Boolean(a)};this._addPropertyEffect(t,h.OBSERVE,{fn:runObserverEffect,info:i,trigger:{name:t}}),a&&this._addPropertyEffect(e,h.OBSERVE,{fn:runObserverEffect,info:i,trigger:{name:e}})}_createMethodObserver(t,e){let a=parseMethod(t);if(!a)throw new Error("Malformed observer expression '"+t+"'");createMethodEffect(this,a,h.OBSERVE,runMethodEffect,null,e)}_createNotifyingProperty(t){this._addPropertyEffect(t,h.NOTIFY,{fn:runNotifyEffect,info:{eventName:(0,s.camelToDashCase)(t)+"-changed",property:t}})}_createReflectedProperty(t){let e=this.constructor.attributeNameForProperty(t);"-"===e[0]?console.warn("Property "+t+" cannot be reflected to attribute "+e+' because "-" is not a valid starting attribute name. Use a lowercase first letter for the property instead.'):this._addPropertyEffect(t,h.REFLECT,{fn:runReflectEffect,info:{attrName:e}})}_createComputedProperty(t,e,a){let i=parseMethod(e);if(!i)throw new Error("Malformed computed expression '"+e+"'");createMethodEffect(this,i,h.COMPUTE,runComputedEffect,t,a)}_marshalArgs(t,e,a){const i=this.__data,s=[];for(let n=0,o=t.length;n<o;n++){let{name:o,structured:l,wildcard:d,value:h,literal:_}=t[n];if(!_)if(d){const t=(0,r.isDescendant)(o,e),s=getArgValue(i,a,t?e:o);h={path:t?e:o,value:s,base:t?(0,r.get)(i,o):s}}else h=l?getArgValue(i,a,o):i[o];s[n]=h}return s}static addPropertyEffect(t,e,a){this.prototype._addPropertyEffect(t,e,a)}static createPropertyObserver(t,e,a){this.prototype._createPropertyObserver(t,e,a)}static createMethodObserver(t,e){this.prototype._createMethodObserver(t,e)}static createNotifyingProperty(t){this.prototype._createNotifyingProperty(t)}static createReadOnlyProperty(t,e){this.prototype._createReadOnlyProperty(t,e)}static createReflectedProperty(t){this.prototype._createReflectedProperty(t)}static createComputedProperty(t,e,a){this.prototype._createComputedProperty(t,e,a)}static bindTemplate(t){return this.prototype._bindTemplate(t)}_bindTemplate(t,e){let a=this.constructor._parseTemplate(t),i=this.__templateInfo==a;if(!i)for(let r in a.propertyEffects)this._createPropertyAccessor(r);if(e&&(a=Object.create(a),a.wasPreBound=i,!i&&this.__templateInfo)){let t=this.__templateInfoLast||this.__templateInfo;return this.__templateInfoLast=t.nextTemplateInfo=a,a.previousTemplateInfo=t,a}return this.__templateInfo=a}static _addTemplatePropertyEffect(t,e,a){(t.hostProps=t.hostProps||{})[e]=!0;let i=t.propertyEffects=t.propertyEffects||{};(i[e]=i[e]||[]).push(a)}_stampTemplate(t){u.beginHosting(this);let e=super._stampTemplate(t);u.endHosting(this);let a=this._bindTemplate(t,!0);if(a.nodeList=e.nodeList,!a.wasPreBound){let t=a.childNodes=[];for(let a=e.firstChild;a;a=a.nextSibling)t.push(a)}return e.templateInfo=a,function setupBindings(t,e){let{nodeList:a,nodeInfoList:i}=e;if(i.length)for(let r=0;r<i.length;r++){let e=i[r],s=a[r],n=e.bindings;if(n)for(let a=0;a<n.length;a++){let e=n[a];setupCompoundStorage(s,e),addNotifyListener(s,t,e)}s.__dataHost=t}}(this,a),this.__dataReady&&runEffects(this,a.propertyEffects,this.__data,null,!1,a.nodeList),e}_removeBoundDom(t){let e=t.templateInfo;e.previousTemplateInfo&&(e.previousTemplateInfo.nextTemplateInfo=e.nextTemplateInfo),e.nextTemplateInfo&&(e.nextTemplateInfo.previousTemplateInfo=e.previousTemplateInfo),this.__templateInfoLast==e&&(this.__templateInfoLast=e.previousTemplateInfo),e.previousTemplateInfo=e.nextTemplateInfo=null;let a=e.childNodes;for(let i=0;i<a.length;i++){let t=a[i];t.parentNode.removeChild(t)}}static _parseTemplateNode(t,a,i){let r=e._parseTemplateNode.call(this,t,a,i);if(t.nodeType===Node.TEXT_NODE){let e=this._parseBindings(t.textContent,a);e&&(t.textContent=literalFromParts(e)||" ",addBinding(this,a,i,"text","textContent",e),r=!0)}return r}static _parseTemplateNodeAttribute(t,a,i,r,n){let o=this._parseBindings(n,a);if(o){let e=r,n="property";_.test(r)?n="attribute":"$"==r[r.length-1]&&(r=r.slice(0,-1),n="attribute");let l=literalFromParts(o);return l&&"attribute"==n&&("class"==r&&t.hasAttribute("class")&&(l+=" "+t.getAttribute(r)),t.setAttribute(r,l)),"input"===t.localName&&"value"===e&&t.setAttribute(e,""),t.removeAttribute(e),"property"===n&&(r=(0,s.dashToCamelCase)(r)),addBinding(this,a,i,n,r,o,l),!0}return e._parseTemplateNodeAttribute.call(this,t,a,i,r,n)}static _parseTemplateNestedTemplate(t,a,i){let r=e._parseTemplateNestedTemplate.call(this,t,a,i),s=i.templateInfo.hostProps;for(let e in s){addBinding(this,a,i,"property","_host_"+e,[{mode:"{",source:e,dependencies:[e]}])}return r}static _parseBindings(t,e){let a,i=[],r=0;for(;null!==(a=p.exec(t));){a.index>r&&i.push({literal:t.slice(r,a.index)});let s=a[1][0],n=Boolean(a[2]),o=a[3].trim(),l=!1,d="",h=-1;"{"==s&&(h=o.indexOf("::"))>0&&(d=o.substring(h+2),o=o.substring(0,h),l=!0);let _=parseMethod(o),f=[];if(_){let{args:t,methodName:a}=_;for(let e=0;e<t.length;e++){let a=t[e];a.literal||f.push(a)}let i=e.dynamicFns;(i&&i[a]||_.static)&&(f.push(a),_.dynamicFn=!0)}else f.push(o);i.push({source:o,mode:s,negate:n,customEvent:l,signature:_,dependencies:f,event:d}),r=p.lastIndex}if(r&&r<t.length){let e=t.substring(r);e&&i.push({literal:e})}return i.length?i:null}static _evaluateBinding(t,e,a,i,s,n){let o;return o=e.signature?runMethodEffect(t,a,i,0,e.signature):a!=e.source?(0,r.get)(t,e.source):n&&(0,r.isPath)(a)?(0,r.get)(t,a):t.__data[a],e.negate&&(o=!o),o}}});t.PropertyEffects=c;const u=new class HostStack{constructor(){this.stack=[]}registerHost(t){if(this.stack.length){this.stack[this.stack.length-1]._enqueueClient(t)}}beginHosting(t){this.stack.push(t)}endHosting(t){let e=this.stack.length;e&&this.stack[e-1]==t&&this.stack.pop()}}}));