/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.15.5(3d42593a5844407ab71d47b348ea3a8de5fec848)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
(function(){var L,N,P=["require","exports","vs/editor/common/core/position","vs/base/common/platform","vs/base/common/errors","vs/editor/common/core/range","vs/editor/common/core/uint","vs/base/common/lifecycle","vs/base/common/winjs.base","vs/base/common/event","vs/base/common/cancellation","vs/base/common/uri","vs/base/common/iterator","vs/base/common/diff/diff","vs/base/common/async","vs/base/common/linkedList","vs/base/common/functional","vs/base/common/strings","vs/base/common/winjs.polyfill.promise","vs/editor/common/model/mirrorTextModel","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/editor/common/core/selection","vs/editor/common/core/token","vs/base/common/arrays","vs/editor/common/core/characterClassifier","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],t=function(L){for(var N=[],A=0,M=L.length;A<M;A++)N[A]=P[L[A]];return N},A=this,M="object"==typeof global?global:{};!function(L){L.global=A;var N=function(){function t(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(t.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!0,configurable:!0}),t.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode="undefined"!=typeof module&&!!module.exports,this._isElectronRenderer="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type,this._isWebWorker="function"==typeof L.global.importScripts)},t._isWindows=function(){return!!("undefined"!=typeof navigator&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0)||"undefined"!=typeof process&&"win32"===process.platform},t}();L.Environment=N}(N||(N={})),function(L){var t=function(L,N,P){this.type=L,this.detail=N,this.timestamp=P};L.LoaderEvent=t;var N=function(){function n(L){this._events=[new t(1,"",L)]}return n.prototype.record=function(N,P){this._events.push(new t(N,P,L.Utilities.getHighPerformanceTimestamp()))},n.prototype.getEvents=function(){return this._events},n}();L.LoaderEventRecorder=N;var P=function(){function e(){}return e.prototype.record=function(L,N){},e.prototype.getEvents=function(){return[]},e}();P.INSTANCE=new P,L.NullLoaderEventRecorder=P}(N||(N={})),function(L){var N=function(){function t(){}return t.fileUriToFilePath=function(L,N){if(N=decodeURI(N).replace(/%23/g,"#"),L){if(/^file:\/\/\//.test(N))return N.substr(8);if(/^file:\/\//.test(N))return N.substr(5)}else if(/^file:\/\//.test(N))return N.substr(7);return N},t.startsWith=function(L,N){return L.length>=N.length&&L.substr(0,N.length)===N},t.endsWith=function(L,N){return L.length>=N.length&&L.substr(L.length-N.length)===N},t.containsQueryString=function(L){return/^[^\#]*\?/gi.test(L)},t.isAbsolutePath=function(L){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(L)},t.forEachProperty=function(L,N){if(L){var P=void 0;for(P in L)L.hasOwnProperty(P)&&N(P,L[P])}},t.isEmpty=function(L){var N=!0;return t.forEachProperty(L,(function(){N=!1})),N},t.recursiveClone=function(L){if(!L||"object"!=typeof L)return L;var N=Array.isArray(L)?[]:{};return t.forEachProperty(L,(function(L,P){N[L]=P&&"object"==typeof P?t.recursiveClone(P):P})),N},t.generateAnonymousModule=function(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="},t.isAnonymousModule=function(L){return t.startsWith(L,"===anonymous")},t.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=L.global.performance&&"function"==typeof L.global.performance.now),this.HAS_PERFORMANCE_NOW?L.global.performance.now():Date.now()},t}();N.NEXT_ANONYMOUS_ID=1,N.PERFORMANCE_NOW_PROBED=!1,N.HAS_PERFORMANCE_NOW=!1,L.Utilities=N}(N||(N={})),function(L){var N=function(){function t(){}return t.validateConfigurationOptions=function(N){return"string"!=typeof(N=N||{}).baseUrl&&(N.baseUrl=""),"boolean"!=typeof N.isBuild&&(N.isBuild=!1),"object"!=typeof N.paths&&(N.paths={}),"object"!=typeof N.config&&(N.config={}),void 0===N.catchError&&(N.catchError=!1),"string"!=typeof N.urlArgs&&(N.urlArgs=""),"function"!=typeof N.onError&&(N.onError=function n(L){return"load"===L.errorCode?(console.error('Loading "'+L.moduleId+'" failed'),console.error("Detail: ",L.detail),L.detail&&L.detail.stack&&console.error(L.detail.stack),console.error("Here are the modules that depend on it:"),void console.error(L.neededBy)):"factory"===L.errorCode?(console.error('The factory method of "'+L.moduleId+'" has thrown an exception'),console.error(L.detail),void(L.detail&&L.detail.stack&&console.error(L.detail.stack))):void 0}),"object"==typeof N.ignoreDuplicateModules&&Array.isArray(N.ignoreDuplicateModules)||(N.ignoreDuplicateModules=[]),N.baseUrl.length>0&&(L.Utilities.endsWith(N.baseUrl,"/")||(N.baseUrl+="/")),"string"!=typeof N.cspNonce&&(N.cspNonce=""),Array.isArray(N.nodeModules)||(N.nodeModules=[]),("number"!=typeof N.nodeCachedDataWriteDelay||N.nodeCachedDataWriteDelay<0)&&(N.nodeCachedDataWriteDelay=7e3),"function"!=typeof N.onNodeCachedData&&(N.onNodeCachedData=function(L,N){L&&("cachedDataRejected"===L.errorCode?console.warn("Rejected cached data from file: "+L.path):"unlink"===L.errorCode||"writeFile"===L.errorCode?(console.error("Problems writing cached data file: "+L.path),console.error(L.detail)):console.error(L))}),N},t.mergeConfigurationOptions=function(N,P){void 0===N&&(N=null),void 0===P&&(P=null);var A=L.Utilities.recursiveClone(P||{});return L.Utilities.forEachProperty(N,(function(N,P){"ignoreDuplicateModules"===N&&void 0!==A.ignoreDuplicateModules?A.ignoreDuplicateModules=A.ignoreDuplicateModules.concat(P):"paths"===N&&void 0!==A.paths?L.Utilities.forEachProperty(P,(function(L,N){return A.paths[L]=N})):"config"===N&&void 0!==A.config?L.Utilities.forEachProperty(P,(function(L,N){return A.config[L]=N})):A[N]=L.Utilities.recursiveClone(P)})),t.validateConfigurationOptions(A)},t}();L.ConfigurationOptionsUtil=N;var P=function(){function n(L,P){if(this._env=L,this.options=N.mergeConfigurationOptions(P),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),""===this.options.baseUrl){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var A=this.options.nodeRequire.main.filename,M=Math.max(A.lastIndexOf("/"),A.lastIndexOf("\\"));this.options.baseUrl=A.substring(0,M+1)}if(this.options.nodeMain&&this._env.isNode){A=this.options.nodeMain,M=Math.max(A.lastIndexOf("/"),A.lastIndexOf("\\"));this.options.baseUrl=A.substring(0,M+1)}}}return n.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var L=0;L<this.options.ignoreDuplicateModules.length;L++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[L]]=!0},n.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var L=0,N=this.options.nodeModules;L<N.length;L++){var P=N[L];this.nodeModulesMap[P]=!0}},n.prototype._createSortedPathsRules=function(){var N=this;this.sortedPathsRules=[],L.Utilities.forEachProperty(this.options.paths,(function(L,P){Array.isArray(P)?N.sortedPathsRules.push({from:L,to:P}):N.sortedPathsRules.push({from:L,to:[P]})})),this.sortedPathsRules.sort((function(L,N){return N.from.length-L.from.length}))},n.prototype.cloneAndMerge=function(L){return new n(this._env,N.mergeConfigurationOptions(L,this.options))},n.prototype.getOptionsLiteral=function(){return this.options},n.prototype._applyPaths=function(N){for(var P,A=0,M=this.sortedPathsRules.length;A<M;A++)if(P=this.sortedPathsRules[A],L.Utilities.startsWith(N,P.from)){for(var I=[],w=0,D=P.to.length;w<D;w++)I.push(P.to[w]+N.substr(P.from.length));return I}return[N]},n.prototype._addUrlArgsToUrl=function(N){return L.Utilities.containsQueryString(N)?N+"&"+this.options.urlArgs:N+"?"+this.options.urlArgs},n.prototype._addUrlArgsIfNecessaryToUrl=function(L){return this.options.urlArgs?this._addUrlArgsToUrl(L):L},n.prototype._addUrlArgsIfNecessaryToUrls=function(L){if(this.options.urlArgs)for(var N=0,P=L.length;N<P;N++)L[N]=this._addUrlArgsToUrl(L[N]);return L},n.prototype.moduleIdToPaths=function(N){if(!0===this.nodeModulesMap[N])return this.isBuild()?["empty:"]:["node|"+N];var P,A=N;if(L.Utilities.endsWith(A,".js")||L.Utilities.isAbsolutePath(A))L.Utilities.endsWith(A,".js")||L.Utilities.containsQueryString(A)||(A+=".js"),P=[A];else for(var M=0,I=(P=this._applyPaths(A)).length;M<I;M++)this.isBuild()&&"empty:"===P[M]||(L.Utilities.isAbsolutePath(P[M])||(P[M]=this.options.baseUrl+P[M]),L.Utilities.endsWith(P[M],".js")||L.Utilities.containsQueryString(P[M])||(P[M]=P[M]+".js"));return this._addUrlArgsIfNecessaryToUrls(P)},n.prototype.requireToUrl=function(N){var P=N;return L.Utilities.isAbsolutePath(P)||(P=this._applyPaths(P)[0],L.Utilities.isAbsolutePath(P)||(P=this.options.baseUrl+P)),this._addUrlArgsIfNecessaryToUrl(P)},n.prototype.isBuild=function(){return this.options.isBuild},n.prototype.isDuplicateMessageIgnoredFor=function(L){return this.ignoreDuplicateModulesMap.hasOwnProperty(L)},n.prototype.getConfigForModule=function(L){if(this.options.config)return this.options.config[L]},n.prototype.shouldCatchError=function(){return this.options.catchError},n.prototype.shouldRecordStats=function(){return this.options.recordStats},n.prototype.onError=function(L){this.options.onError(L)},n}();L.Configuration=P}(N||(N={})),function(L){var N=function(){function e(L){this._env=L,this._scriptLoader=null,this._callbackMap={}}return e.prototype.load=function(L,N,M,w){var D=this;this._scriptLoader||(this._scriptLoader=this._env.isWebWorker?new A:this._env.isNode?new I(this._env):new P);var O={callback:M,errorback:w};this._callbackMap.hasOwnProperty(N)?this._callbackMap[N].push(O):(this._callbackMap[N]=[O],this._scriptLoader.load(L,N,(function(){return D.triggerCallback(N)}),(function(L){return D.triggerErrorback(N,L)})))},e.prototype.triggerCallback=function(L){var N=this._callbackMap[L];delete this._callbackMap[L];for(var P=0;P<N.length;P++)N[P].callback()},e.prototype.triggerErrorback=function(L,N){var P=this._callbackMap[L];delete this._callbackMap[L];for(var A=0;A<P.length;A++)P[A].errorback(N)},e}(),P=function(){function e(){}return e.prototype.attachListeners=function(L,N,P){var r=function(){L.removeEventListener("load",i),L.removeEventListener("error",o)},i=function(L){r(),N()},o=function(L){r(),P(L)};L.addEventListener("load",i),L.addEventListener("error",o)},e.prototype.load=function(L,N,P,A){var M=document.createElement("script");M.setAttribute("async","async"),M.setAttribute("type","text/javascript"),this.attachListeners(M,P,A),M.setAttribute("src",N);var I=L.getConfig().getOptionsLiteral().cspNonce;I&&M.setAttribute("nonce",I),document.getElementsByTagName("head")[0].appendChild(M)},e}(),A=function(){function e(){}return e.prototype.load=function(L,N,P,A){try{importScripts(N),P()}catch(L){A(L)}},e}(),I=function(){function t(L){this._env=L,this._didInitialize=!1,this._didPatchNodeRequire=!1}return t.prototype._init=function(L){if(!this._didInitialize){this._didInitialize=!0,this._fs=L("fs"),this._vm=L("vm"),this._path=L("path"),this._crypto=L("crypto"),this._jsflags="";for(var N=0,P=process.argv;N<P.length;N++){var A=P[N];if(0===A.indexOf("--js-flags=")){this._jsflags=A;break}}}},t.prototype._initNodeRequire=function(L,N){var P=N.getConfig().getOptionsLiteral().nodeCachedDataDir;if(P&&!this._didPatchNodeRequire){this._didPatchNodeRequire=!0;var A=this,I=L("module");I.prototype._compile=function(L,w){L=L.replace(/^#!.*/,"");var D=I.wrap(L),O=A._getCachedDataPath(P,w),T={filename:w};try{T.cachedData=A._fs.readFileSync(O)}catch(L){T.produceCachedData=!0}var R=new A._vm.Script(D,T),x=R.runInThisContext(T),k=A._path.dirname(w),U=function(L){var N=L.constructor,n=function(N){try{return L.require(N)}finally{}};return n.resolve=function(P){return N._resolveFilename(P,L)},n.main=process.mainModule,n.extensions=N._extensions,n.cache=N._cache,n}(this),F=[this.exports,U,this,w,k,process,M,Buffer],W=x.apply(this.exports,F);return A._processCachedData(N,R,O),W}}},t.prototype.load=function(N,P,A,M){var I=this,w=N.getConfig().getOptionsLiteral(),D=w.nodeRequire||L.global.nodeRequire,O=w.nodeInstrumenter||function(L){return L};this._init(D),this._initNodeRequire(D,N);var T=N.getRecorder();if(/^node\|/.test(P)){var R=P.split("|"),x=null;try{x=D(R[1])}catch(L){return void M(L)}N.enqueueDefineAnonymousModule([],(function(){return x})),A()}else P=L.Utilities.fileUriToFilePath(this._env.isWindows,P),this._fs.readFile(P,{encoding:"utf8"},(function(L,D){if(L)M(L);else{var R=I._path.normalize(P),x=R;if(I._env.isElectronRenderer){var k=x.match(/^([a-z])\:(.*)/i);x=k?"file:///"+(k[1].toUpperCase()+":"+k[2]).replace(/\\/g,"/"):"file://"+x}var U,F="(function (require, define, __filename, __dirname) { ";if(U=D.charCodeAt(0)===t._BOM?F+D.substring(1)+"\n});":F+D+"\n});",U=O(U,R),w.nodeCachedDataDir){var W=I._getCachedDataPath(w.nodeCachedDataDir,P);I._fs.readFile(W,(function(L,w){var D={filename:x,produceCachedData:void 0===w,cachedData:w},O=I._loadAndEvalScript(N,P,x,U,D,T,A,M);I._processCachedData(N,O,W)}))}else I._loadAndEvalScript(N,P,x,U,{filename:x},T,A,M)}}))},t.prototype._loadAndEvalScript=function(N,P,A,M,I,w,D,O){w.record(31,P);var T=new this._vm.Script(M,I),R=T.runInThisContext(I),x=N.getGlobalAMDDefineFunc(),k=!1,h=function(){return k=!0,x.apply(null,arguments)};return h.amd=x.amd,R.call(L.global,N.getGlobalAMDRequireFunc(),h,A,this._path.dirname(P)),w.record(32,P),k?D():O(new Error("Didn't receive define call in "+P+"!")),T},t.prototype._getCachedDataPath=function(L,N){var P=this._crypto.createHash("md5").update(N,"utf8").update(this._jsflags,"utf8").digest("hex"),A=this._path.basename(N).replace(/\.js$/,"");return this._path.join(L,A+"-"+P+".code")},t.prototype._processCachedData=function(L,N,P){var A=this;N.cachedDataRejected?(L.getConfig().getOptionsLiteral().onNodeCachedData({errorCode:"cachedDataRejected",path:P}),t._runSoon((function(){return A._fs.unlink(P,(function(N){N&&L.getConfig().getOptionsLiteral().onNodeCachedData({errorCode:"unlink",path:P,detail:N})}))}),L.getConfig().getOptionsLiteral().nodeCachedDataWriteDelay)):N.cachedDataProduced&&(L.getConfig().getOptionsLiteral().onNodeCachedData(void 0,{path:P,length:N.cachedData.length}),t._runSoon((function(){return A._fs.writeFile(P,N.cachedData,(function(N){N&&L.getConfig().getOptionsLiteral().onNodeCachedData({errorCode:"writeFile",path:P,detail:N})}))}),L.getConfig().getOptionsLiteral().nodeCachedDataWriteDelay))},t._runSoon=function(L,N){var P=N+Math.ceil(Math.random()*N);setTimeout(L,P)},t}();I._BOM=65279,L.createScriptLoader=function(L){return new N(L)}}(N||(N={})),function(L){var N=function(){function t(L){var N=L.lastIndexOf("/");this.fromModulePath=-1!==N?L.substr(0,N+1):""}return t._normalizeModuleId=function(L){var N,P=L;for(N=/\/\.\//;N.test(P);)P=P.replace(N,"/");for(P=P.replace(/^\.\//g,""),N=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;N.test(P);)P=P.replace(N,"/");return P.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,"")},t.prototype.resolveModule=function(N){var P=N;return L.Utilities.isAbsolutePath(P)||(L.Utilities.startsWith(P,"./")||L.Utilities.startsWith(P,"../"))&&(P=t._normalizeModuleId(this.fromModulePath+P)),P},t}();N.ROOT=new N(""),L.ModuleIdResolver=N;var P=function(){function t(L,N,P,A,M,I){this.id=L,this.strId=N,this.dependencies=P,this._callback=A,this._errorback=M,this.moduleIdResolver=I,this.exports={},this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return t._safeInvokeFunction=function(N,P){try{return{returnedValue:N.apply(L.global,P),producedError:null}}catch(L){return{returnedValue:null,producedError:L}}},t._invokeFactory=function(N,P,A,M){return N.isBuild()&&!L.Utilities.isAnonymousModule(P)?{returnedValue:null,producedError:null}:N.shouldCatchError()?this._safeInvokeFunction(A,M):{returnedValue:A.apply(L.global,M),producedError:null}},t.prototype.complete=function(N,P,A){this._isComplete=!0;var M=null;if(this._callback)if("function"==typeof this._callback){N.record(21,this.strId);var I=t._invokeFactory(P,this.strId,this._callback,A);M=I.producedError,N.record(22,this.strId),M||void 0===I.returnedValue||this.exportsPassedIn&&!L.Utilities.isEmpty(this.exports)||(this.exports=I.returnedValue)}else this.exports=this._callback;M&&P.onError({errorCode:"factory",moduleId:this.strId,detail:M}),this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},t.prototype.onDependencyError=function(L){return!!this._errorback&&(this._errorback(L),!0)},t.prototype.isComplete=function(){return this._isComplete},t}();L.Module=P;var A=function(){function e(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return e.prototype.getMaxModuleId=function(){return this._nextId},e.prototype.getModuleId=function(L){var N=this._strModuleIdToIntModuleId.get(L);return void 0===N&&(N=this._nextId++,this._strModuleIdToIntModuleId.set(L,N),this._intModuleIdToStrModuleId[N]=L),N},e.prototype.getStrModuleId=function(L){return this._intModuleIdToStrModuleId[L]},e}(),i=function(L){this.id=L};i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),L.RegularDependency=i;var o=function(L,N,P){this.id=L,this.pluginId=N,this.pluginParam=P};L.PluginDependency=o;var M=function(){function s(N,P,M,I,w){void 0===w&&(w=0),this._env=N,this._scriptLoader=P,this._loaderAvailableTimestamp=w,this._defineFunc=M,this._requireFunc=I,this._moduleIdProvider=new A,this._config=new L.Configuration(this._env),this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return s.prototype.reset=function(){return new s(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},s.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},s.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},s._findRelevantLocationInStack=function(L,N){for(var n=function(L){return L.replace(/\\/g,"/")},P=n(L),A=N.split(/\n/),M=0;M<A.length;M++){var I=A[M].match(/(.*):(\d+):(\d+)\)?$/);if(I){var w=I[1],D=I[2],O=I[3],T=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if((w=n(w=w.substr(T)))===P){var R={line:parseInt(D,10),col:parseInt(O,10)};return 1===R.line&&(R.col-="(function (require, define, __filename, __dirname) { ".length),R}}}throw new Error("Could not correlate define call site for needle "+L)},s.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var L=[],N=0,P=0,A=this._modules2.length;P<A;P++){var M=this._modules2[P];if(M){var I=this._buildInfoPath[M.id]||null,w=this._buildInfoDefineStack[M.id]||null,D=this._buildInfoDependencies[M.id];L[N++]={id:M.strId,path:I,defineLocation:I&&w?s._findRelevantLocationInStack(I,w):null,dependencies:D,shim:null,exports:M.exports}}}return L},s.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new L.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=L.NullLoaderEventRecorder.INSTANCE),this._recorder},s.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},s.prototype.enqueueDefineAnonymousModule=function(L,N){if(null!==this._currentAnnonymousDefineCall)throw new Error("Can only have one anonymous define call per script file");var P=null;this._config.isBuild()&&(P=new Error("StackLocation").stack),this._currentAnnonymousDefineCall={stack:P,dependencies:L,callback:N}},s.prototype.defineModule=function(L,A,M,I,w,D){var O=this;void 0===D&&(D=new N(L));var T=this._moduleIdProvider.getModuleId(L);if(this._modules2[T])this._config.isDuplicateMessageIgnoredFor(L)||console.warn("Duplicate definition of module '"+L+"'");else{var R=new P(T,L,this._normalizeDependencies(A,D),M,I,D);this._modules2[T]=R,this._config.isBuild()&&(this._buildInfoDefineStack[T]=w,this._buildInfoDependencies[T]=R.dependencies.map((function(L){return O._moduleIdProvider.getStrModuleId(L.id)}))),this._resolve(R)}},s.prototype._normalizeDependency=function(L,N){if("exports"===L)return i.EXPORTS;if("module"===L)return i.MODULE;if("require"===L)return i.REQUIRE;var P=L.indexOf("!");if(P>=0){var A=N.resolveModule(L.substr(0,P)),M=N.resolveModule(L.substr(P+1)),I=this._moduleIdProvider.getModuleId(A+"!"+M),w=this._moduleIdProvider.getModuleId(A);return new o(I,w,M)}return new i(this._moduleIdProvider.getModuleId(N.resolveModule(L)))},s.prototype._normalizeDependencies=function(L,N){for(var P=[],A=0,M=0,I=L.length;M<I;M++)P[A++]=this._normalizeDependency(L[M],N);return P},s.prototype._relativeRequire=function(N,P,A,M){if("string"==typeof P)return this.synchronousRequire(P,N);this.defineModule(L.Utilities.generateAnonymousModule(),P,A,M,null,N)},s.prototype.synchronousRequire=function(L,P){void 0===P&&(P=new N(L));var A=this._normalizeDependency(L,P),M=this._modules2[A.id];if(!M)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+L+"'. This is the first mention of this module!");if(!M.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+L+"'. This module has not been resolved completely yet.");return M.exports},s.prototype.configure=function(N,P){var A=this._config.shouldRecordStats();this._config=P?new L.Configuration(this._env,N):this._config.cloneAndMerge(N),this._config.shouldRecordStats()&&!A&&(this._recorder=null)},s.prototype.getConfig=function(){return this._config},s.prototype._onLoad=function(L){if(null!==this._currentAnnonymousDefineCall){var N=this._currentAnnonymousDefineCall;this._currentAnnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(L),N.dependencies,N.callback,null,N.stack)}},s.prototype._createLoadError=function(L,N){var P=this;return{errorCode:"load",moduleId:this._moduleIdProvider.getStrModuleId(L),neededBy:(this._inverseDependencies2[L]||[]).map((function(L){return P._moduleIdProvider.getStrModuleId(L)})),detail:N}},s.prototype._onLoadError=function(L,N){for(var P=this._createLoadError(L,N),A=[],M=0,I=this._moduleIdProvider.getMaxModuleId();M<I;M++)A[M]=!1;var w=!1,D=[];for(D.push(L),A[L]=!0;D.length>0;){var O=D.shift(),T=this._modules2[O];T&&(w=T.onDependencyError(P)||w);var R=this._inverseDependencies2[O];if(R)for(M=0,I=R.length;M<I;M++){var x=R[M];A[x]||(D.push(x),A[x]=!0)}}w||this._config.onError(P)},s.prototype._hasDependencyPath=function(L,N){var P=this._modules2[L];if(!P)return!1;for(var A=[],M=0,I=this._moduleIdProvider.getMaxModuleId();M<I;M++)A[M]=!1;var w=[];for(w.push(P),A[L]=!0;w.length>0;){var D=w.shift().dependencies;if(D)for(M=0,I=D.length;M<I;M++){var O=D[M];if(O.id===N)return!0;var T=this._modules2[O.id];T&&!A[O.id]&&(A[O.id]=!0,w.push(T))}}return!1},s.prototype._findCyclePath=function(L,N,P){if(L===N||50===P)return[L];var A=this._modules2[L];if(!A)return null;for(var M=A.dependencies,I=0,w=M.length;I<w;I++){var D=this._findCyclePath(M[I].id,N,P+1);if(null!==D)return D.push(L),D}return null},s.prototype._createRequire=function(N){var P=this,r=function(L,A,M){return P._relativeRequire(N,L,A,M)};return r.toUrl=function(L){return P._config.requireToUrl(N.resolveModule(L))},r.getStats=function(){return P.getLoaderEvents()},r.__$__nodeRequire=L.global.nodeRequire,r},s.prototype._loadModule=function(L){var N=this;if(!this._modules2[L]&&!this._knownModules2[L]){this._knownModules2[L]=!0;var P=this._moduleIdProvider.getStrModuleId(L),A=this._config.moduleIdToPaths(P);this._env.isNode&&(-1===P.indexOf("/")||/^@[^\/]+\/[^\/]+$/.test(P))&&A.push("node|"+P);var M=-1,o=function(P){if(++M>=A.length)N._onLoadError(L,P);else{var I=A[M],w=N.getRecorder();if(N._config.isBuild()&&"empty:"===I)return N._buildInfoPath[L]=I,N.defineModule(N._moduleIdProvider.getStrModuleId(L),[],null,null,null),void N._onLoad(L);w.record(10,I),N._scriptLoader.load(N,I,(function(){N._config.isBuild()&&(N._buildInfoPath[L]=I),w.record(11,I),N._onLoad(L)}),(function(L){w.record(12,I),o(L)}))}};o(null)}},s.prototype._loadPluginDependency=function(L,P){var A=this;if(!this._modules2[P.id]&&!this._knownModules2[P.id]){this._knownModules2[P.id]=!0;var i=function(L){A.defineModule(A._moduleIdProvider.getStrModuleId(P.id),[],L,null,null)};i.error=function(L){A._config.onError(A._createLoadError(P.id,L))},L.load(P.pluginParam,this._createRequire(N.ROOT),i,this._config.getOptionsLiteral())}},s.prototype._resolve=function(L){for(var N=this,P=L.dependencies,A=0,M=P.length;A<M;A++){var I=P[A];if(I!==i.EXPORTS)if(I!==i.MODULE)if(I!==i.REQUIRE){var w=this._modules2[I.id];if(w&&w.isComplete())L.unresolvedDependenciesCount--;else if(this._hasDependencyPath(I.id,L.id)){console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(I.id)+"' and '"+this._moduleIdProvider.getStrModuleId(L.id)+"'. The cyclic path follows:");var D=this._findCyclePath(I.id,L.id,0);D.reverse(),D.push(I.id),console.warn(D.map((function(L){return N._moduleIdProvider.getStrModuleId(L)})).join(" => \n")),L.unresolvedDependenciesCount--}else if(this._inverseDependencies2[I.id]=this._inverseDependencies2[I.id]||[],this._inverseDependencies2[I.id].push(L.id),I instanceof o){var O=this._modules2[I.pluginId];if(O&&O.isComplete()){this._loadPluginDependency(O.exports,I);continue}var T=this._inversePluginDependencies2.get(I.pluginId);T||(T=[],this._inversePluginDependencies2.set(I.pluginId,T)),T.push(I),this._loadModule(I.pluginId)}else this._loadModule(I.id)}else L.unresolvedDependenciesCount--;else L.unresolvedDependenciesCount--;else L.exportsPassedIn=!0,L.unresolvedDependenciesCount--}0===L.unresolvedDependenciesCount&&this._onModuleComplete(L)},s.prototype._onModuleComplete=function(L){var N=this,P=this.getRecorder();if(!L.isComplete()){for(var A=L.dependencies,M=[],I=0,w=A.length;I<w;I++){var D=A[I];if(D!==i.EXPORTS)if(D!==i.MODULE)if(D!==i.REQUIRE){var O=this._modules2[D.id];M[I]=O?O.exports:null}else M[I]=this._createRequire(L.moduleIdResolver);else M[I]={id:L.strId,config:function(){return N._config.getConfigForModule(L.strId)}};else M[I]=L.exports}L.complete(P,this._config,M);var T=this._inverseDependencies2[L.id];if(this._inverseDependencies2[L.id]=null,T)for(I=0,w=T.length;I<w;I++){var R=T[I],x=this._modules2[R];x.unresolvedDependenciesCount--,0===x.unresolvedDependenciesCount&&this._onModuleComplete(x)}var k=this._inversePluginDependencies2.get(L.id);if(k){this._inversePluginDependencies2.delete(L.id);for(I=0,w=k.length;I<w;I++)this._loadPluginDependency(L.exports,k[I])}}},s}();L.ModuleManager=M}(N||(N={})),function(N){function t(){if(void 0!==N.global.require||"undefined"!=typeof require){var L=N.global.require||require;if("function"==typeof L&&"function"==typeof L.resolve){var i=function(N){A.getRecorder().record(33,N);try{return L(N)}finally{A.getRecorder().record(34,N)}};N.global.nodeRequire=i,u.nodeRequire=i,u.__$__nodeRequire=i}}P.isNode&&!P.isElectronRenderer?(module.exports=u,require=u):(P.isElectronRenderer||(N.global.define=o),N.global.require=u)}var P=new N.Environment,A=null,o=function(L,N,P){"string"!=typeof L&&(P=N,N=L,L=null),"object"==typeof N&&Array.isArray(N)||(P=N,N=null),N||(N=["require","exports","module"]),L?A.defineModule(L,N,P,null,null):A.enqueueDefineAnonymousModule(N,P)};o.amd={jQuery:!0};var s=function(L,N){void 0===N&&(N=!1),A.configure(L,N)},u=function(){if(1===arguments.length){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0]))return void s(arguments[0]);if("string"==typeof arguments[0])return A.synchronousRequire(arguments[0])}if(2!==arguments.length&&3!==arguments.length||!Array.isArray(arguments[0]))throw new Error("Unrecognized require call");A.defineModule(N.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null)};u.config=s,u.getConfig=function(){return A.getConfig().getOptionsLiteral()},u.reset=function(){A=A.reset()},u.getBuildInfo=function(){return A.getBuildInfo()},u.getStats=function(){return A.getLoaderEvents()},u.define=function(){return o.apply(null,arguments)},N.init=t,"function"==typeof N.global.define&&N.global.define.amd||(A=new N.ModuleManager(P,N.createScriptLoader(P),o,u,N.Utilities.getHighPerformanceTimestamp()),void 0!==N.global.require&&"function"!=typeof N.global.require&&u.config(N.global.require),(L=function(){return o.apply(null,arguments)}).amd=o.amd,"undefined"==typeof doNotInitLoader&&t())}(N||(N={})),L(P[24],t([0,1]),(function(L,N){"use strict";function n(L,N){return function r(L,N,P,A,M){if(!(A<=P)){var I=P+(A-P)/2|0;r(L,N,P,I,M),r(L,N,I+1,A,M),N(L[I],L[I+1])<=0||function(L,N,P,A,M,I){for(var w=P,D=A+1,O=P;O<=M;O++)I[O]=L[O];for(O=P;O<=M;O++)w>A?L[O]=I[D++]:D>M?L[O]=I[w++]:N(I[D],I[w])<0?L[O]=I[D++]:L[O]=I[w++]}(L,N,P,I,A,M)}}(L,N,0,L.length-1,[]),L}function i(L,N){for(var P=0;P<L.length;P++)if(N(L[P]))return P;return-1}Object.defineProperty(N,"__esModule",{value:!0}),N.tail=function(L,N){return void 0===N&&(N=0),L[L.length-(1+N)]},N.tail2=function(L){if(0===L.length)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]},N.equals=function(L,N,P){if(void 0===P&&(P=function(L,N){return L===N}),L===N)return!0;if(!L||!N)return!1;if(L.length!==N.length)return!1;for(var A=0,M=L.length;A<M;A++)if(!P(L[A],N[A]))return!1;return!0},N.binarySearch=function(L,N,P){for(var A=0,M=L.length-1;A<=M;){var I=(A+M)/2|0,w=P(L[I],N);if(w<0)A=I+1;else{if(!(w>0))return I;M=I-1}}return-(A+1)},N.findFirstInSorted=function(L,N){var P=0,A=L.length;if(0===A)return 0;for(;P<A;){var M=Math.floor((P+A)/2);N(L[M])?A=M:P=M+1}return P},N.mergeSort=n,N.groupBy=function(L,N){for(var P=[],A=void 0,M=0,I=n(L.slice(0),N);M<I.length;M++){var w=I[M];A&&0===N(A[0],w)?A.push(w):(A=[w],P.push(A))}return P},N.coalesce=function(L){return L?L.filter((function(L){return!!L})):L},N.isFalsyOrEmpty=function(L){return!Array.isArray(L)||0===L.length},N.distinct=function(L,N){if(!N)return L.filter((function(N,P){return L.indexOf(N)===P}));var P=Object.create(null);return L.filter((function(L){var A=N(L);return!P[A]&&(P[A]=!0,!0)}))},N.firstIndex=i,N.first=function(L,N,P){void 0===P&&(P=null);var A=i(L,N);return A<0?P:L[A]},N.flatten=function(L){var N;return(N=[]).concat.apply(N,L)},N.range=function(L,N){var P="number"==typeof N?L:0;"number"==typeof N?P=L:(P=0,N=L);var A=[];if(P<=N)for(M=P;M<N;M++)A.push(M);else for(var M=P;M>N;M--)A.push(M);return A},N.arrayInsert=function(L,N,P){var A=L.slice(0,N),M=L.slice(N);return A.concat(P,M)}})),L(P[20],t([0,1]),(function(L,N){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var P=function(){function e(L,N,P,A){this.originalStart=L,this.originalLength=N,this.modifiedStart=P,this.modifiedLength=A}return e.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},e.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},e}();N.DiffChange=P})),L(P[13],t([0,1,20]),(function(L,N,P){"use strict";function r(L){return{getLength:function(){return L.length},getElementAtIndex:function(N){return L.charCodeAt(N)}}}Object.defineProperty(N,"__esModule",{value:!0}),N.stringDiff=function(L,N,P){return new w(r(L),r(N)).ComputeDiff(P)};var A=function(){function e(){}return e.Assert=function(L,N){if(!L)throw new Error(N)},e}();N.Debug=A;var M=function(){function e(){}return e.Copy=function(L,N,P,A,M){for(var I=0;I<M;I++)P[A+I]=L[N+I]},e}();N.MyArray=M;var I=function(){function e(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return e.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},e.prototype.AddOriginalElement=function(L,N){this.m_originalStart=Math.min(this.m_originalStart,L),this.m_modifiedStart=Math.min(this.m_modifiedStart,N),this.m_originalCount++},e.prototype.AddModifiedElement=function(L,N){this.m_originalStart=Math.min(this.m_originalStart,L),this.m_modifiedStart=Math.min(this.m_modifiedStart,N),this.m_modifiedCount++},e.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},e.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},e}(),w=function(){function e(L,N,P){void 0===P&&(P=null),this.OriginalSequence=L,this.ModifiedSequence=N,this.ContinueProcessingPredicate=P,this.m_forwardHistory=[],this.m_reverseHistory=[]}return e.prototype.ElementsAreEqual=function(L,N){return this.OriginalSequence.getElementAtIndex(L)===this.ModifiedSequence.getElementAtIndex(N)},e.prototype.OriginalElementsAreEqual=function(L,N){return this.OriginalSequence.getElementAtIndex(L)===this.OriginalSequence.getElementAtIndex(N)},e.prototype.ModifiedElementsAreEqual=function(L,N){return this.ModifiedSequence.getElementAtIndex(L)===this.ModifiedSequence.getElementAtIndex(N)},e.prototype.ComputeDiff=function(L){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1,L)},e.prototype._ComputeDiff=function(L,N,P,A,M){var I=this.ComputeDiffRecursive(L,N,P,A,[!1]);return M?this.PrettifyChanges(I):I},e.prototype.ComputeDiffRecursive=function(L,N,M,I,w){for(w[0]=!1;L<=N&&M<=I&&this.ElementsAreEqual(L,M);)L++,M++;for(;N>=L&&I>=M&&this.ElementsAreEqual(N,I);)N--,I--;if(L>N||M>I){var D=void 0;return M<=I?(A.Assert(L===N+1,"originalStart should only be one more than originalEnd"),D=[new P.DiffChange(L,0,M,I-M+1)]):L<=N?(A.Assert(M===I+1,"modifiedStart should only be one more than modifiedEnd"),D=[new P.DiffChange(L,N-L+1,M,0)]):(A.Assert(L===N+1,"originalStart should only be one more than originalEnd"),A.Assert(M===I+1,"modifiedStart should only be one more than modifiedEnd"),D=[]),D}var O=[0],T=[0],R=this.ComputeRecursionPoint(L,N,M,I,O,T,w),x=O[0],k=T[0];if(null!==R)return R;if(!w[0]){var U,F=this.ComputeDiffRecursive(L,x,M,k,w);return U=w[0]?[new P.DiffChange(x+1,N-(x+1)+1,k+1,I-(k+1)+1)]:this.ComputeDiffRecursive(x+1,N,k+1,I,w),this.ConcatenateChanges(F,U)}return[new P.DiffChange(L,N-L+1,M,I-M+1)]},e.prototype.WALKTRACE=function(L,N,A,M,w,D,O,T,R,x,k,U,F,W,q,j,K,B){var V,Y,H=null,G=new I,J=N,z=A,Q=F[0]-j[0]-M,X=Number.MIN_VALUE,$=this.m_forwardHistory.length-1;do{(V=Q+L)===J||V<z&&R[V-1]<R[V+1]?(W=(k=R[V+1])-Q-M,k<X&&G.MarkNextChange(),X=k,G.AddModifiedElement(k+1,W),Q=V+1-L):(W=(k=R[V-1]+1)-Q-M,k<X&&G.MarkNextChange(),X=k-1,G.AddOriginalElement(k,W+1),Q=V-1-L),$>=0&&(L=(R=this.m_forwardHistory[$])[0],J=1,z=R.length-1)}while(--$>=-1);if(Y=G.getReverseChanges(),B[0]){var Z=F[0]+1,ee=j[0]+1;if(null!==Y&&Y.length>0){var te=Y[Y.length-1];Z=Math.max(Z,te.getOriginalEnd()),ee=Math.max(ee,te.getModifiedEnd())}H=[new P.DiffChange(Z,U-Z+1,ee,q-ee+1)]}else{G=new I,J=D,z=O,Q=F[0]-j[0]-T,X=Number.MAX_VALUE,$=K?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{(V=Q+w)===J||V<z&&x[V-1]>=x[V+1]?(W=(k=x[V+1]-1)-Q-T,k>X&&G.MarkNextChange(),X=k+1,G.AddOriginalElement(k+1,W+1),Q=V+1-w):(W=(k=x[V-1])-Q-T,k>X&&G.MarkNextChange(),X=k,G.AddModifiedElement(k+1,W+1),Q=V-1-w),$>=0&&(w=(x=this.m_reverseHistory[$])[0],J=1,z=x.length-1)}while(--$>=-1);H=G.getChanges()}return this.ConcatenateChanges(Y,H)},e.prototype.ComputeRecursionPoint=function(L,N,A,I,w,D,O){var T,R=0,x=0,k=0,U=0,F=0,W=0;L--,A--,w[0]=0,D[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var q,j,K=N-L+(I-A),B=K+1,V=new Array(B),Y=new Array(B),H=I-A,G=N-L,J=L-A,z=N-I,Q=(G-H)%2==0;for(V[H]=L,Y[G]=N,O[0]=!1,T=1;T<=K/2+1;T++){var X=0,$=0;for(k=this.ClipDiagonalBound(H-T,T,H,B),U=this.ClipDiagonalBound(H+T,T,H,B),q=k;q<=U;q+=2){for(x=(R=q===k||q<U&&V[q-1]<V[q+1]?V[q+1]:V[q-1]+1)-(q-H)-J,j=R;R<N&&x<I&&this.ElementsAreEqual(R+1,x+1);)R++,x++;if(V[q]=R,R+x>X+$&&(X=R,$=x),!Q&&Math.abs(q-G)<=T-1&&R>=Y[q])return w[0]=R,D[0]=x,j<=Y[q]&&T<=1448?this.WALKTRACE(H,k,U,J,G,F,W,z,V,Y,R,N,w,x,I,D,Q,O):null}var Z=(X-L+($-A)-T)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(X,this.OriginalSequence,Z))return O[0]=!0,w[0]=X,D[0]=$,Z>0&&T<=1448?this.WALKTRACE(H,k,U,J,G,F,W,z,V,Y,R,N,w,x,I,D,Q,O):(L++,A++,[new P.DiffChange(L,N-L+1,A,I-A+1)]);for(F=this.ClipDiagonalBound(G-T,T,G,B),W=this.ClipDiagonalBound(G+T,T,G,B),q=F;q<=W;q+=2){for(x=(R=q===F||q<W&&Y[q-1]>=Y[q+1]?Y[q+1]-1:Y[q-1])-(q-G)-z,j=R;R>L&&x>A&&this.ElementsAreEqual(R,x);)R--,x--;if(Y[q]=R,Q&&Math.abs(q-H)<=T&&R<=V[q])return w[0]=R,D[0]=x,j>=V[q]&&T<=1448?this.WALKTRACE(H,k,U,J,G,F,W,z,V,Y,R,N,w,x,I,D,Q,O):null}if(T<=1447){var ee=new Array(U-k+2);ee[0]=H-k+1,M.Copy(V,k,ee,1,U-k+1),this.m_forwardHistory.push(ee),(ee=new Array(W-F+2))[0]=G-F+1,M.Copy(Y,F,ee,1,W-F+1),this.m_reverseHistory.push(ee)}}return this.WALKTRACE(H,k,U,J,G,F,W,z,V,Y,R,N,w,x,I,D,Q,O)},e.prototype.PrettifyChanges=function(L){for(D=0;D<L.length;D++){for(var N=L[D],P=D<L.length-1?L[D+1].originalStart:this.OriginalSequence.getLength(),A=D<L.length-1?L[D+1].modifiedStart:this.ModifiedSequence.getLength(),M=N.originalLength>0,I=N.modifiedLength>0;N.originalStart+N.originalLength<P&&N.modifiedStart+N.modifiedLength<A&&(!M||this.OriginalElementsAreEqual(N.originalStart,N.originalStart+N.originalLength))&&(!I||this.ModifiedElementsAreEqual(N.modifiedStart,N.modifiedStart+N.modifiedLength));)N.originalStart++,N.modifiedStart++;var w=[null];D<L.length-1&&this.ChangesOverlap(L[D],L[D+1],w)&&(L[D]=w[0],L.splice(D+1,1),D--)}for(var D=L.length-1;D>=0;D--){N=L[D],P=0,A=0;if(D>0){var O=L[D-1];O.originalLength>0&&(P=O.originalStart+O.originalLength),O.modifiedLength>0&&(A=O.modifiedStart+O.modifiedLength)}M=N.originalLength>0,I=N.modifiedLength>0;for(var T=0,R=this._boundaryScore(N.originalStart,N.originalLength,N.modifiedStart,N.modifiedLength),x=1;;x++){var k=N.originalStart-x,U=N.modifiedStart-x;if(k<P||U<A)break;if(M&&!this.OriginalElementsAreEqual(k,k+N.originalLength))break;if(I&&!this.ModifiedElementsAreEqual(U,U+N.modifiedLength))break;var F=this._boundaryScore(k,N.originalLength,U,N.modifiedLength);F>R&&(R=F,T=x)}N.originalStart-=T,N.modifiedStart-=T}return L},e.prototype._OriginalIsBoundary=function(L){if(L<=0||L>=this.OriginalSequence.getLength()-1)return!0;var N=this.OriginalSequence.getElementAtIndex(L);return"string"==typeof N&&/^\s*$/.test(N)},e.prototype._OriginalRegionIsBoundary=function(L,N){if(this._OriginalIsBoundary(L)||this._OriginalIsBoundary(L-1))return!0;if(N>0){var P=L+N;if(this._OriginalIsBoundary(P-1)||this._OriginalIsBoundary(P))return!0}return!1},e.prototype._ModifiedIsBoundary=function(L){if(L<=0||L>=this.ModifiedSequence.getLength()-1)return!0;var N=this.ModifiedSequence.getElementAtIndex(L);return"string"==typeof N&&/^\s*$/.test(N)},e.prototype._ModifiedRegionIsBoundary=function(L,N){if(this._ModifiedIsBoundary(L)||this._ModifiedIsBoundary(L-1))return!0;if(N>0){var P=L+N;if(this._ModifiedIsBoundary(P-1)||this._ModifiedIsBoundary(P))return!0}return!1},e.prototype._boundaryScore=function(L,N,P,A){return(this._OriginalRegionIsBoundary(L,N)?1:0)+(this._ModifiedRegionIsBoundary(P,A)?1:0)},e.prototype.ConcatenateChanges=function(L,N){var P=[];if(0===L.length||0===N.length)return N.length>0?N:L;if(this.ChangesOverlap(L[L.length-1],N[0],P))return A=new Array(L.length+N.length-1),M.Copy(L,0,A,0,L.length-1),A[L.length-1]=P[0],M.Copy(N,1,A,L.length,N.length-1),A;var A=new Array(L.length+N.length);return M.Copy(L,0,A,0,L.length),M.Copy(N,0,A,L.length,N.length),A},e.prototype.ChangesOverlap=function(L,N,M){if(A.Assert(L.originalStart<=N.originalStart,"Left change is not less than or equal to right change"),A.Assert(L.modifiedStart<=N.modifiedStart,"Left change is not less than or equal to right change"),L.originalStart+L.originalLength>=N.originalStart||L.modifiedStart+L.modifiedLength>=N.modifiedStart){var I=L.originalStart,w=L.originalLength,D=L.modifiedStart,O=L.modifiedLength;return L.originalStart+L.originalLength>=N.originalStart&&(w=N.originalStart+N.originalLength-L.originalStart),L.modifiedStart+L.modifiedLength>=N.modifiedStart&&(O=N.modifiedStart+N.modifiedLength-L.modifiedStart),M[0]=new P.DiffChange(I,w,D,O),!0}return M[0]=null,!1},e.prototype.ClipDiagonalBound=function(L,N,P,A){if(L>=0&&L<A)return L;var M=N%2==0;return L<0?M===(P%2==0)?0:1:M===((A-P-1)%2==0)?A-1:A-2},e}();N.LcsDiff=w})),L(P[16],t([0,1]),(function(L,N){"use strict";Object.defineProperty(N,"__esModule",{value:!0}),N.once=function(L){var N,P=this,A=!1;return function(){return A?N:(A=!0,N=L.apply(P,arguments))}}}));var I,w=this&&this.__extends||function(){var e=function(L,N){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(L,N){L.__proto__=N}||function(L,N){for(var P in N)N.hasOwnProperty(P)&&(L[P]=N[P])})(L,N)};return function(L,N){function r(){this.constructor=L}e(L,N),L.prototype=null===N?Object.create(N):(r.prototype=N.prototype,new r)}}();L(P[12],t([0,1]),(function(L,N){"use strict";Object.defineProperty(N,"__esModule",{value:!0}),N.FIN={done:!0,value:void 0},function(L){function n(L,N){for(var P=L.next();!P.done;P=L.next())N(P.value)}var P={next:function(){return N.FIN}};L.empty=function(){return P},L.fromArray=function(L,P,A){return void 0===P&&(P=0),void 0===A&&(A=L.length),{next:function(){return P>=A?N.FIN:{done:!1,value:L[P++]}}}},L.from=function(N){return N?Array.isArray(N)?L.fromArray(N):N:L.empty()},L.map=function(L,P){return{next:function(){var A=L.next();return A.done?N.FIN:{done:!1,value:P(A.value)}}}},L.filter=function(L,P){return{next:function(){for(;;){var A=L.next();if(A.done)return N.FIN;if(P(A.value))return{done:!1,value:A.value}}}}},L.forEach=n,L.collect=function(L){var N=[];return n(L,(function(L){return N.push(L)})),N}}(N.Iterator||(N.Iterator={}));var P=function(){function e(L,N,P,A){void 0===N&&(N=0),void 0===P&&(P=L.length),void 0===A&&(A=N-1),this.items=L,this.start=N,this.end=P,this.index=A}return e.prototype.next=function(){return this.index=Math.min(this.index+1,this.end),this.current()},e.prototype.current=function(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]},e}();N.ArrayIterator=P;var A=function(L){function t(N,P,A,M){return void 0===P&&(P=0),void 0===A&&(A=N.length),void 0===M&&(M=P-1),L.call(this,N,P,A,M)||this}return w(t,L),t.prototype.current=function(){return L.prototype.current.call(this)},t.prototype.previous=function(){return this.index=Math.max(this.index-1,this.start-1),this.current()},t.prototype.first=function(){return this.index=this.start,this.current()},t.prototype.last=function(){return this.index=this.end-1,this.current()},t.prototype.parent=function(){return null},t}(P);N.ArrayNavigator=A;var M=function(){function e(L,N){this.iterator=L,this.fn=N}return e.prototype.next=function(){return this.fn(this.iterator.next())},e}();N.MappedIterator=M})),L(P[21],t([0,1]),(function(L,N){"use strict";function n(L,N){var P=!!(2048&L),A=!!(256&L);return new w(2===N?A:P,!!(1024&L),!!(512&L),2===N?P:A,255&L)}Object.defineProperty(N,"__esModule",{value:!0});var P=function(){function e(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}return e.prototype.define=function(L,N){this._keyCodeToStr[L]=N,this._strToKeyCode[N.toLowerCase()]=L},e.prototype.keyCodeToStr=function(L){return this._keyCodeToStr[L]},e.prototype.strToKeyCode=function(L){return this._strToKeyCode[L.toLowerCase()]||0},e}(),A=new P,M=new P,I=new P;!function(){function e(L,N,P,w){void 0===P&&(P=N),void 0===w&&(w=P),A.define(L,N),M.define(L,P),I.define(L,w)}e(0,"unknown"),e(1,"Backspace"),e(2,"Tab"),e(3,"Enter"),e(4,"Shift"),e(5,"Ctrl"),e(6,"Alt"),e(7,"PauseBreak"),e(8,"CapsLock"),e(9,"Escape"),e(10,"Space"),e(11,"PageUp"),e(12,"PageDown"),e(13,"End"),e(14,"Home"),e(15,"LeftArrow","Left"),e(16,"UpArrow","Up"),e(17,"RightArrow","Right"),e(18,"DownArrow","Down"),e(19,"Insert"),e(20,"Delete"),e(21,"0"),e(22,"1"),e(23,"2"),e(24,"3"),e(25,"4"),e(26,"5"),e(27,"6"),e(28,"7"),e(29,"8"),e(30,"9"),e(31,"A"),e(32,"B"),e(33,"C"),e(34,"D"),e(35,"E"),e(36,"F"),e(37,"G"),e(38,"H"),e(39,"I"),e(40,"J"),e(41,"K"),e(42,"L"),e(43,"M"),e(44,"N"),e(45,"O"),e(46,"P"),e(47,"Q"),e(48,"R"),e(49,"S"),e(50,"T"),e(51,"U"),e(52,"V"),e(53,"W"),e(54,"X"),e(55,"Y"),e(56,"Z"),e(57,"Meta"),e(58,"ContextMenu"),e(59,"F1"),e(60,"F2"),e(61,"F3"),e(62,"F4"),e(63,"F5"),e(64,"F6"),e(65,"F7"),e(66,"F8"),e(67,"F9"),e(68,"F10"),e(69,"F11"),e(70,"F12"),e(71,"F13"),e(72,"F14"),e(73,"F15"),e(74,"F16"),e(75,"F17"),e(76,"F18"),e(77,"F19"),e(78,"NumLock"),e(79,"ScrollLock"),e(80,";",";","OEM_1"),e(81,"=","=","OEM_PLUS"),e(82,",",",","OEM_COMMA"),e(83,"-","-","OEM_MINUS"),e(84,".",".","OEM_PERIOD"),e(85,"/","/","OEM_2"),e(86,"`","`","OEM_3"),e(110,"ABNT_C1"),e(111,"ABNT_C2"),e(87,"[","[","OEM_4"),e(88,"\\","\\","OEM_5"),e(89,"]","]","OEM_6"),e(90,"'","'","OEM_7"),e(91,"OEM_8"),e(92,"OEM_102"),e(93,"NumPad0"),e(94,"NumPad1"),e(95,"NumPad2"),e(96,"NumPad3"),e(97,"NumPad4"),e(98,"NumPad5"),e(99,"NumPad6"),e(100,"NumPad7"),e(101,"NumPad8"),e(102,"NumPad9"),e(103,"NumPad_Multiply"),e(104,"NumPad_Add"),e(105,"NumPad_Separator"),e(106,"NumPad_Subtract"),e(107,"NumPad_Decimal"),e(108,"NumPad_Divide")}(),function(L){L.toString=function(L){return A.keyCodeToStr(L)},L.fromString=function(L){return A.strToKeyCode(L)},L.toUserSettingsUS=function(L){return M.keyCodeToStr(L)},L.toUserSettingsGeneral=function(L){return I.keyCodeToStr(L)},L.fromUserSettings=function(L){return M.strToKeyCode(L)||I.strToKeyCode(L)}}(N.KeyCodeUtils||(N.KeyCodeUtils={})),N.KeyChord=function(L,N){return(L|(65535&N)<<16>>>0)>>>0},N.createKeybinding=function(L,N){if(0===L)return null;var P=(65535&L)>>>0,A=(4294901760&L)>>>16;return 0!==A?new a(n(P,N),n(A,N)):n(P,N)},N.createSimpleKeybinding=n;var w=function(){function e(L,N,P,A,M){this.type=1,this.ctrlKey=L,this.shiftKey=N,this.altKey=P,this.metaKey=A,this.keyCode=M}return e.prototype.equals=function(L){return 1===L.type&&this.ctrlKey===L.ctrlKey&&this.shiftKey===L.shiftKey&&this.altKey===L.altKey&&this.metaKey===L.metaKey&&this.keyCode===L.keyCode},e.prototype.isModifierKey=function(){return 0===this.keyCode||5===this.keyCode||57===this.keyCode||6===this.keyCode||4===this.keyCode},e.prototype.isDuplicateModifierCase=function(){return this.ctrlKey&&5===this.keyCode||this.shiftKey&&4===this.keyCode||this.altKey&&6===this.keyCode||this.metaKey&&57===this.keyCode},e}();N.SimpleKeybinding=w;var a=function(L,N){this.type=2,this.firstPart=L,this.chordPart=N};N.ChordKeybinding=a;var l=function(L,N,P,A,M,I){this.ctrlKey=L,this.shiftKey=N,this.altKey=P,this.metaKey=A,this.keyLabel=M,this.keyAriaLabel=I};N.ResolvedKeybindingPart=l;var c=function(){};N.ResolvedKeybinding=c})),L(P[7],t([0,1]),(function(L,N){"use strict";function n(L){for(var N=[],P=1;P<arguments.length;P++)N[P-1]=arguments[P];return Array.isArray(L)?(L.forEach((function(L){return L&&L.dispose()})),[]):0!==N.length?(n(L),n(N),[]):L?(L.dispose(),L):void 0}Object.defineProperty(N,"__esModule",{value:!0}),N.isDisposable=function(L){return"function"==typeof L.dispose&&0===L.dispose.length},N.dispose=n,N.combinedDisposable=function(L){return{dispose:function(){return n(L)}}},N.toDisposable=function(L){return{dispose:function(){L()}}};var P=function(){function e(){this._toDispose=[]}return e.prototype.dispose=function(){this._toDispose=n(this._toDispose)},e.prototype._register=function(L){return this._toDispose.push(L),L},e.None=Object.freeze({dispose:function(){}}),e}();N.Disposable=P;var A=function(){function e(L){this.object=L}return e.prototype.dispose=function(){},e}();N.ImmortalReference=A})),L(P[15],t([0,1,12]),(function(L,N,P){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var r=function(L){this.element=L},A=function(){function e(){}return e.prototype.isEmpty=function(){return!this._first},e.prototype.unshift=function(L){return this.insert(L,!1)},e.prototype.push=function(L){return this.insert(L,!0)},e.prototype.insert=function(L,N){var P=this,A=new r(L);if(this._first)if(N){var M=this._last;this._last=A,A.prev=M,M.next=A}else{var I=this._first;this._first=A,A.next=I,I.prev=A}else this._first=A,this._last=A;return function(){for(var L=P._first;L instanceof r;){if(L===A){if(L.prev&&L.next){var N=L.prev;N.next=L.next,L.next.prev=N}else L.prev||L.next?L.next?L.prev||(P._first=P._first.next,P._first.prev=void 0):(P._last=P._last.prev,P._last.next=void 0):(P._first=void 0,P._last=void 0);break}L=L.next}}},e.prototype.iterator=function(){var L,N=this._first;return{next:function(){return N?(L?L.value=N.element:L={done:!1,value:N.element},N=N.next,L):P.FIN}}},e}();N.LinkedList=A})),L(P[3],t([0,1]),(function(L,N){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var P=!1,A=!1,M=!1,I=!1,w=!1;N.LANGUAGE_DEFAULT="en";var D="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type;if("object"!=typeof navigator||D){if("object"==typeof process){P="win32"===process.platform,A="darwin"===process.platform,M="linux"===process.platform,N.LANGUAGE_DEFAULT,N.LANGUAGE_DEFAULT;var O=process.env.VSCODE_NLS_CONFIG;if(O)try{var T=JSON.parse(O),R=T.availableLanguages["*"];T.locale,R||N.LANGUAGE_DEFAULT,T._translationsConfigFile}catch(L){}I=!0}}else{var x=navigator.userAgent;P=x.indexOf("Windows")>=0,A=x.indexOf("Macintosh")>=0,M=x.indexOf("Linux")>=0,w=!0,navigator.language}N.isWindows=P,N.isMacintosh=A,N.isLinux=M,N.isNative=I,N.isWeb=w;var k="object"==typeof self?self:"object"==typeof global?global:{};N.globals=k;var U=null;N.setImmediate=function(L){return null===U&&(U=N.globals.setImmediate?N.globals.setImmediate.bind(N.globals):"undefined"!=typeof process&&"function"==typeof process.nextTick?process.nextTick.bind(process):N.globals.setTimeout.bind(N.globals)),U(L)},N.OS=A?2:P?1:3})),L(P[17],t([0,1]),(function(L,N){"use strict";function n(L){return L.replace(/[\-\\\{\}\*\+\?\|\^\$\.\[\]\(\)\#]/g,"\\$&")}function r(L,N){if(!L||!N)return L;var P=N.length;if(0===P||0===L.length)return L;for(var A=0;L.indexOf(N,A)===A;)A+=P;return L.substring(A)}function i(L,N){if(!L||!N)return L;var P=N.length,A=L.length;if(0===P||0===A)return L;for(var M=A,I=-1;-1!==(I=L.lastIndexOf(N,M-1))&&I+P===M;){if(0===I)return"";M=I}return L.substring(0,M)}function o(L){return L>=97&&L<=122}function s(L){return L>=65&&L<=90}function u(L){return o(L)||s(L)}function a(L,N,P){if(void 0===P&&(P=L.length),"string"!=typeof L||"string"!=typeof N)return!1;for(var A=0;A<P;A++){var M=L.charCodeAt(A),I=N.charCodeAt(A);if(M!==I)if(u(M)&&u(I)){var w=Math.abs(M-I);if(0!==w&&32!==w)return!1}else if(String.fromCharCode(M).toLowerCase()!==String.fromCharCode(I).toLowerCase())return!1}return!0}function l(L){return(L=+L)>=11904&&L<=55215||L>=63744&&L<=64255||L>=65281&&L<=65374}Object.defineProperty(N,"__esModule",{value:!0}),N.empty="",N.isFalsyOrWhitespace=function(L){return!L||"string"!=typeof L||0===L.trim().length},N.pad=function(L,N,P){void 0===P&&(P="0");for(var A=""+L,M=[A],I=A.length;I<N;I++)M.push(P);return M.reverse().join("")};var P=/{(\d+)}/g;N.format=function(L){for(var N=[],A=1;A<arguments.length;A++)N[A-1]=arguments[A];return 0===N.length?L:L.replace(P,(function(L,P){var A=parseInt(P,10);return isNaN(A)||A<0||A>=N.length?L:N[A]}))},N.escape=function(L){return L.replace(/[<|>|&]/g,(function(L){switch(L){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return L}}))},N.escapeRegExpCharacters=n,N.trim=function(L,N){return void 0===N&&(N=" "),i(r(L,N),N)},N.ltrim=r,N.rtrim=i,N.convertSimple2RegExpPattern=function(L){return L.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},N.startsWith=function(L,N){if(L.length<N.length)return!1;if(L===N)return!0;for(var P=0;P<N.length;P++)if(L[P]!==N[P])return!1;return!0},N.endsWith=function(L,N){var P=L.length-N.length;return P>0?L.indexOf(N,P)===P:0===P&&L===N},N.createRegExp=function(L,N,P){if(void 0===P&&(P={}),!L)throw new Error("Cannot create regex from empty string");N||(L=n(L)),P.wholeWord&&(/\B/.test(L.charAt(0))||(L="\\b"+L),/\B/.test(L.charAt(L.length-1))||(L+="\\b"));var A="";return P.global&&(A+="g"),P.matchCase||(A+="i"),P.multiline&&(A+="m"),new RegExp(L,A)},N.regExpLeadsToEndlessLoop=function(L){return"^"!==L.source&&"^$"!==L.source&&"$"!==L.source&&"^\\s*$"!==L.source&&!(!L.exec("")||0!==L.lastIndex)},N.firstNonWhitespaceIndex=function(L){for(var N=0,P=L.length;N<P;N++){var A=L.charCodeAt(N);if(32!==A&&9!==A)return N}return-1},N.getLeadingWhitespace=function(L,N,P){void 0===N&&(N=0),void 0===P&&(P=L.length);for(var A=N;A<P;A++){var M=L.charCodeAt(A);if(32!==M&&9!==M)return L.substring(N,A)}return L.substring(N,P)},N.lastNonWhitespaceIndex=function(L,N){void 0===N&&(N=L.length-1);for(var P=N;P>=0;P--){var A=L.charCodeAt(P);if(32!==A&&9!==A)return P}return-1},N.compare=function(L,N){return L<N?-1:L>N?1:0},N.isLowerAsciiLetter=o,N.isUpperAsciiLetter=s,N.equalsIgnoreCase=function(L,N){return(L?L.length:0)===(N?N.length:0)&&a(L,N)},N.startsWithIgnoreCase=function(L,N){var P=N.length;return!(N.length>L.length)&&a(L,N,P)},N.commonPrefixLength=function(L,N){var P,A=Math.min(L.length,N.length);for(P=0;P<A;P++)if(L.charCodeAt(P)!==N.charCodeAt(P))return P;return A},N.commonSuffixLength=function(L,N){var P,A=Math.min(L.length,N.length),M=L.length-1,I=N.length-1;for(P=0;P<A;P++)if(L.charCodeAt(M-P)!==N.charCodeAt(I-P))return P;return A},N.isHighSurrogate=function(L){return 55296<=L&&L<=56319},N.isLowSurrogate=function(L){return 56320<=L&&L<=57343};var A=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;N.containsRTL=function(L){return A.test(L)};var M=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEF8]|\uD83E[\uDD00-\uDDE6])/;N.containsEmoji=function(L){return M.test(L)};var I=/^[\t\n\r\x20-\x7E]*$/;N.isBasicASCII=function(L){return I.test(L)},N.containsFullWidthCharacter=function(L){for(var N=0,P=L.length;N<P;N++)if(l(L.charCodeAt(N)))return!0;return!1},N.isFullWidthCharacter=l,N.UTF8_BOM_CHARACTER=String.fromCharCode(65279),N.startsWithUTF8BOM=function(L){return!!(L&&L.length>0&&65279===L.charCodeAt(0))},N.safeBtoa=function(L){return btoa(encodeURIComponent(L))},N.repeat=function(L,N){for(var P="",A=0;A<N;A++)P+=L;return P}})),L(P[11],t([0,1,3]),(function(L,N,P){"use strict";function r(L,N){for(var P=void 0,A=-1,M=0;M<L.length;M++){var I=L.charCodeAt(M);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||45===I||46===I||95===I||126===I||N&&47===I)-1!==A&&(P+=encodeURIComponent(L.substring(A,M)),A=-1),void 0!==P&&(P+=L.charAt(M));else{void 0===P&&(P=L.substr(0,M));var w=U[I];void 0!==w?(-1!==A&&(P+=encodeURIComponent(L.substring(A,M)),A=-1),P+=w):-1===A&&(A=M)}}return-1!==A&&(P+=encodeURIComponent(L.substring(A))),void 0!==P?P:L}function i(L){var N;return N=L.authority&&L.path.length>1&&"file"===L.scheme?"//"+L.authority+L.path:47===L.path.charCodeAt(0)&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&58===L.path.charCodeAt(2)?L.path[1].toLowerCase()+L.path.substr(2):L.path,P.isWindows&&(N=N.replace(/\//g,"\\")),N}function o(L,N){var P=N?function(L){for(var N=void 0,P=0;P<L.length;P++){var A=L.charCodeAt(P);35===A||63===A?(void 0===N&&(N=L.substr(0,P)),N+=U[A]):void 0!==N&&(N+=L[P])}return void 0!==N?N:L}:r,A="",M=L.scheme,I=L.authority,w=L.path,D=L.query,O=L.fragment;if(M&&(A+=M,A+=":"),(I||"file"===M)&&(A+=T,A+=T),I){var R=I.indexOf("@");if(-1!==R){var x=I.substr(0,R);I=I.substr(R+1),-1===(R=x.indexOf(":"))?A+=P(x,!1):(A+=P(x.substr(0,R),!1),A+=":",A+=P(x.substr(R+1),!1)),A+="@"}-1===(R=(I=I.toLowerCase()).indexOf(":"))?A+=P(I,!1):(A+=P(I.substr(0,R),!1),A+=I.substr(R))}if(w){if(w.length>=3&&47===w.charCodeAt(0)&&58===w.charCodeAt(2))(k=w.charCodeAt(1))>=65&&k<=90&&(w="/"+String.fromCharCode(k+32)+":"+w.substr(3));else if(w.length>=2&&58===w.charCodeAt(1)){var k=w.charCodeAt(0);k>=65&&k<=90&&(w=String.fromCharCode(k+32)+":"+w.substr(2))}A+=P(w,!0)}return D&&(A+="?",A+=P(D,!1)),O&&(A+="#",A+=N?O:r(O,!1)),A}Object.defineProperty(N,"__esModule",{value:!0});var A,M=/^\w[\w\d+.-]*$/,I=/^\//,D=/^\/\//,O="",T="/",R=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,x=function(){function e(L,N,P,A,w){"object"==typeof L?(this.scheme=L.scheme||O,this.authority=L.authority||O,this.path=L.path||O,this.query=L.query||O,this.fragment=L.fragment||O):(this.scheme=L||O,this.authority=N||O,this.path=function(L,N){switch(L){case"https":case"http":case"file":N?N[0]!==T&&(N=T+N):N=T}return N}(this.scheme,P||O),this.query=A||O,this.fragment=w||O,function(L){if(!L.scheme)throw new Error('[UriError]: Scheme is missing: {scheme: "", authority: "'+L.authority+'", path: "'+L.path+'", query: "'+L.query+'", fragment: "'+L.fragment+'"}');if(L.scheme&&!M.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path)if(L.authority){if(!I.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this))}return e.isUri=function(L){return L instanceof e||!!L&&"string"==typeof L.authority&&"string"==typeof L.fragment&&"string"==typeof L.path&&"string"==typeof L.query&&"string"==typeof L.scheme},Object.defineProperty(e.prototype,"fsPath",{get:function(){return i(this)},enumerable:!0,configurable:!0}),e.prototype.with=function(L){if(!L)return this;var N=L.scheme,P=L.authority,A=L.path,M=L.query,I=L.fragment;return void 0===N?N=this.scheme:null===N&&(N=O),void 0===P?P=this.authority:null===P&&(P=O),void 0===A?A=this.path:null===A&&(A=O),void 0===M?M=this.query:null===M&&(M=O),void 0===I?I=this.fragment:null===I&&(I=O),N===this.scheme&&P===this.authority&&A===this.path&&M===this.query&&I===this.fragment?this:new k(N,P,A,M,I)},e.parse=function(L){var N=R.exec(L);return N?new k(N[2]||O,decodeURIComponent(N[4]||O),decodeURIComponent(N[5]||O),decodeURIComponent(N[7]||O),decodeURIComponent(N[9]||O)):new k(O,O,O,O,O)},e.file=function(L){var N=O;if(P.isWindows&&(L=L.replace(/\\/g,T)),L[0]===T&&L[1]===T){var A=L.indexOf(T,2);-1===A?(N=L.substring(2),L=T):(N=L.substring(2,A),L=L.substring(A)||T)}return new k("file",N,L,O,O)},e.from=function(L){return new k(L.scheme,L.authority,L.path,L.query,L.fragment)},e.prototype.toString=function(L){return void 0===L&&(L=!1),o(this,L)},e.prototype.toJSON=function(){return this},e.revive=function(L){if(L){if(L instanceof e)return L;var N=new k(L);return N._fsPath=L.fsPath,N._formatted=L.external,N}return L},e}();N.URI=x;var k=function(L){function t(){var N=null!==L&&L.apply(this,arguments)||this;return N._formatted=null,N._fsPath=null,N}return w(t,L),Object.defineProperty(t.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=i(this)),this._fsPath},enumerable:!0,configurable:!0}),t.prototype.toString=function(L){return void 0===L&&(L=!1),L?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)},t.prototype.toJSON=function(){var L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L},t}(x),U=((A={})[58]="%3A",A[47]="%2F",A[63]="%3F",A[35]="%23",A[91]="%5B",A[93]="%5D",A[64]="%40",A[33]="%21",A[36]="%24",A[38]="%26",A[39]="%27",A[40]="%28",A[41]="%29",A[42]="%2A",A[43]="%2B",A[44]="%2C",A[59]="%3B",A[61]="%3D",A[32]="%20",A)})),function(){var N=Object.create(null);N["WinJS/Core/_WinJS"]={};var t=function(L,P,A){var M={},I=!1,w=P.map((function(L){return"exports"===L?(I=!0,M):N[L]})),D=A.apply({},w);N[L]=I?M:D};t("WinJS/Core/_Global",[],(function(){"use strict";return"undefined"!=typeof window?window:"undefined"!=typeof self?self:"undefined"!=typeof global?global:{}})),t("WinJS/Core/_BaseCoreUtils",["WinJS/Core/_Global"],(function(L){"use strict";var N=null;return{hasWinRT:!!L.Windows,markSupportedForProcessing:function(L){return L.supportedForProcessing=!0,L},_setImmediate:function(P){null===N&&(N=L.setImmediate?L.setImmediate.bind(L):"undefined"!=typeof process&&"function"==typeof process.nextTick?process.nextTick.bind(process):L.setTimeout.bind(L)),N(P)}}})),t("WinJS/Core/_WriteProfilerMark",["WinJS/Core/_Global"],(function(L){"use strict";return L.msWriteProfilerMark||function(){}})),t("WinJS/Core/_Base",["WinJS/Core/_WinJS","WinJS/Core/_Global","WinJS/Core/_BaseCoreUtils","WinJS/Core/_WriteProfilerMark"],(function(L,N,P,A){"use strict";function i(L,N,P){var A,M,I,w=Object.keys(N),D=Array.isArray(L);for(M=0,I=w.length;M<I;M++){var O=w[M],T=95!==O.charCodeAt(0),R=N[O];!R||"object"!=typeof R||void 0===R.value&&"function"!=typeof R.get&&"function"!=typeof R.set?T?D?L.forEach((function(L){L[O]=R})):L[O]=R:(A=A||{})[O]={value:R,enumerable:T,configurable:!0,writable:!0}:(void 0===R.enumerable&&(R.enumerable=T),P&&R.setName&&"function"==typeof R.setName&&R.setName(P+"."+O),(A=A||{})[O]=R)}A&&(D?L.forEach((function(L){Object.defineProperties(L,A)})):Object.defineProperties(L,A))}return function(){function n(P,A){var M=P||{};if(A){var I=A.split(".");M===N&&"WinJS"===I[0]&&(M=L,I.splice(0,1));for(var w=0,D=I.length;w<D;w++){var O=I[w];M[O]||Object.defineProperty(M,O,{value:{},writable:!1,enumerable:!0,configurable:!0}),M=M[O]}}return M}function o(L,N,P){var A=n(L,N);return P&&i(A,P,N||"<ANONYMOUS>"),A}var P=L;P.Namespace||(P.Namespace=Object.create(Object.prototype));var M=1,I=2,w=3;Object.defineProperties(P.Namespace,{defineWithParent:{value:o,writable:!0,enumerable:!0,configurable:!0},define:{value:function(L,P){return o(N,L,P)},writable:!0,enumerable:!0,configurable:!0},_lazy:{value:function(L){var N,P,D=M;return{setName:function(L){N=L},get:function(){switch(D){case w:return P;case M:D=I;try{A("WinJS.Namespace._lazy:"+N+",StartTM"),P=L()}finally{A("WinJS.Namespace._lazy:"+N+",StopTM"),D=M}return L=null,D=w,P;case I:throw"Illegal: reentrancy on initialization";default:throw"Illegal"}},set:function(L){switch(D){case I:throw"Illegal: reentrancy on initialization";default:D=w,P=L}},enumerable:!0,configurable:!0}},writable:!0,enumerable:!0,configurable:!0},_moduleDefine:{value:function(L,P,A){var M=[L],I=null;return P&&(I=n(N,P),M.push(I)),i(M,A,P||"<ANONYMOUS>"),I},writable:!0,enumerable:!0,configurable:!0}})}(),function(){function t(L,N,A){return L=L||function(){},P.markSupportedForProcessing(L),N&&i(L.prototype,N),A&&i(L,A),L}L.Namespace.define("WinJS.Class",{define:t,derive:function(L,N,A,M){if(L){N=N||function(){};var I=L.prototype;return N.prototype=Object.create(I),P.markSupportedForProcessing(N),Object.defineProperty(N.prototype,"constructor",{value:N,writable:!0,configurable:!0,enumerable:!0}),A&&i(N.prototype,A),M&&i(N,M),N}return t(N,A,M)},mix:function(L){var N,P;for(L=L||function(){},N=1,P=arguments.length;N<P;N++)i(L.prototype,arguments[N]);return L}})}(),{Namespace:L.Namespace,Class:L.Class}})),t("WinJS/Core/_ErrorFromName",["WinJS/Core/_Base"],(function(L){"use strict";var N=L.Class.derive(Error,(function(L,N){this.name=L,this.message=N||L}),{},{supportedForProcessing:!1});return L.Namespace.define("WinJS",{ErrorFromName:N}),N})),t("WinJS/Core/_Events",["exports","WinJS/Core/_Base"],(function(L,N){"use strict";function n(L){var N="_on"+L+"state";return{get:function(){var L=this[N];return L&&L.userHandler},set:function(P){var A=this[N];P?(A||(A={wrapper:function(L){return A.userHandler(L)},userHandler:P},Object.defineProperty(this,N,{value:A,enumerable:!1,writable:!0,configurable:!0}),this.addEventListener(L,A.wrapper,!1)),A.userHandler=P):A&&(this.removeEventListener(L,A.wrapper,!1),this[N]=null)},enumerable:!0}}var P=N.Class.define((function(L,N,P){this.detail=N,this.target=P,this.timeStamp=Date.now(),this.type=L}),{bubbles:{value:!1,writable:!1},cancelable:{value:!1,writable:!1},currentTarget:{get:function(){return this.target}},defaultPrevented:{get:function(){return this._preventDefaultCalled}},trusted:{value:!1,writable:!1},eventPhase:{value:0,writable:!1},target:null,timeStamp:null,type:null,preventDefault:function(){this._preventDefaultCalled=!0},stopImmediatePropagation:function(){this._stopImmediatePropagationCalled=!0},stopPropagation:function(){}},{supportedForProcessing:!1}),A={_listeners:null,addEventListener:function(L,N,P){P=P||!1,this._listeners=this._listeners||{};for(var A=this._listeners[L]=this._listeners[L]||[],M=0,I=A.length;M<I;M++){var w=A[M];if(w.useCapture===P&&w.listener===N)return}A.push({listener:N,useCapture:P})},dispatchEvent:function(L,N){var A=this._listeners&&this._listeners[L];if(A){for(var M=new P(L,N,this),I=0,w=(A=A.slice(0,A.length)).length;I<w&&!M._stopImmediatePropagationCalled;I++)A[I].listener(M);return M.defaultPrevented||!1}return!1},removeEventListener:function(L,N,P){P=P||!1;var A=this._listeners&&this._listeners[L];if(A)for(var M=0,I=A.length;M<I;M++){var w=A[M];if(w.listener===N&&w.useCapture===P){A.splice(M,1),0===A.length&&delete this._listeners[L];break}}}};N.Namespace._moduleDefine(L,"WinJS.Utilities",{_createEventProperty:n,createEventProperties:function(){for(var L={},N=0,P=arguments.length;N<P;N++){var A=arguments[N];L["on"+A]=n(A)}return L},eventMixin:A})})),t("WinJS/Core/_Trace",["WinJS/Core/_Global"],(function(L){"use strict";function t(L){return L}return{_traceAsyncOperationStarting:L.Debug&&L.Debug.msTraceAsyncOperationStarting&&L.Debug.msTraceAsyncOperationStarting.bind(L.Debug)||t,_traceAsyncOperationCompleted:L.Debug&&L.Debug.msTraceAsyncOperationCompleted&&L.Debug.msTraceAsyncOperationCompleted.bind(L.Debug)||t,_traceAsyncCallbackStarting:L.Debug&&L.Debug.msTraceAsyncCallbackStarting&&L.Debug.msTraceAsyncCallbackStarting.bind(L.Debug)||t,_traceAsyncCallbackCompleted:L.Debug&&L.Debug.msTraceAsyncCallbackCompleted&&L.Debug.msTraceAsyncCallbackCompleted.bind(L.Debug)||t}})),t("WinJS/Promise/_StateMachine",["WinJS/Core/_Global","WinJS/Core/_BaseCoreUtils","WinJS/Core/_Base","WinJS/Core/_ErrorFromName","WinJS/Core/_Events","WinJS/Core/_Trace"],(function(L,N,P,A,M,I){"use strict";function s(){}function u(L,N){var P;P=N&&"object"==typeof N&&"function"==typeof N.then?U:j,L._value=N,L._setState(P)}function a(L,N,P,A,M,I){return{exception:L,error:N,promise:P,handler:I,id:A,parent:M}}function l(L,N,P,A){var M=P._isException;return a(M?N:null,M?null:N,L,P._errorId,P,A)}function c(L,N,P){var A=P._isException,M=P._errorId;return b(L,M,A),a(A?N:null,A?null:N,L,M,P)}function f(L,N){var P=++Y;return b(L,P),a(null,N,L,P)}function d(L,N){var P=++Y;return b(L,P,!0),a(N,null,L,P)}function h(L,N,P,A){y(L,{c:N,e:P,p:A,asyncOpID:I._traceAsyncOperationStarting("WinJS.Promise.done")})}function p(L,N,P,A){L._value=N,_(L,N,P,A),L._setState(B)}function m(N,P){var A,M,w=N._value,D=N._listeners;if(D)for(N._listeners=null,A=0,M=Array.isArray(D)?D.length:1;A<M;A++){var O=1===M?D:D[A],T=O.c,R=O.promise;if(I._traceAsyncOperationCompleted(O.asyncOpID,L.Debug&&L.Debug.MS_ASYNC_OP_STATUS_SUCCESS),R){I._traceAsyncCallbackStarting(O.asyncOpID);try{R._setCompleteValue(T?T(w):w)}catch(L){R._setExceptionValue(L)}finally{I._traceAsyncCallbackCompleted()}R._state!==U&&R._listeners&&P.push(R)}else X.prototype.done.call(N,T)}}function g(N,P){var A,M,w=N._value,D=N._listeners;if(D)for(N._listeners=null,A=0,M=Array.isArray(D)?D.length:1;A<M;A++){var T=1===M?D:D[A],R=T.e,x=T.promise,k=L.Debug&&(w&&w.name===O?L.Debug.MS_ASYNC_OP_STATUS_CANCELED:L.Debug.MS_ASYNC_OP_STATUS_ERROR);if(I._traceAsyncOperationCompleted(T.asyncOpID,k),x){var F=!1;try{R?(I._traceAsyncCallbackStarting(T.asyncOpID),F=!0,R.handlesOnError||_(x,w,l,N,R),x._setCompleteValue(R(w))):x._setChainedErrorValue(w,N)}catch(L){x._setExceptionValue(L)}finally{F&&I._traceAsyncCallbackCompleted()}x._state!==U&&x._listeners&&P.push(x)}else z.prototype.done.call(N,null,R)}}function _(L,N,P,A,M){if(w._listeners[D]){if(N instanceof Error&&N.message===O)return;w.dispatchEvent(D,P(L,N,A,M))}}function v(L,N){var P,A,M=L._listeners;if(M)for(P=0,A=Array.isArray(M)?M.length:1;P<A;P++){var I=1===A?M:M[P],w=I.p;if(w)try{w(N)}catch(L){}I.c||I.e||!I.promise||I.promise._progress(N)}}function y(L,N){var P=L._listeners;P?(P=Array.isArray(P)?P:[P]).push(N):P=N,L._listeners=P}function b(L,N,P){L._isException=P||!1,L._errorId=N}function C(L,N,P,A){L._value=N,_(L,N,P,A),L._setState(V)}function E(L,N){var P;P=N&&"object"==typeof N&&"function"==typeof N.then?U:K,L._value=N,L._setState(P)}function S(L,N,P,A){var M=new J(L);return y(L,{promise:M,c:N,e:P,p:A,asyncOpID:I._traceAsyncOperationStarting("WinJS.Promise.then")}),M}L.Debug&&(L.Debug.setNonUserCodeExceptions=!0);var w=new(P.Class.mix(P.Class.define(null,{},{supportedForProcessing:!1}),M.eventMixin));w._listeners={};var D="error",O="Canceled",T=!1,R={promise:1,thenPromise:2,errorPromise:4,exceptionPromise:8,completePromise:16};R.all=R.promise|R.thenPromise|R.errorPromise|R.exceptionPromise|R.completePromise;var x,k,U,F,W,q,j,K,B,V,Y=1;x={name:"created",enter:function(L){L._setState(k)},cancel:s,done:s,then:s,_completed:s,_error:s,_notify:s,_progress:s,_setCompleteValue:s,_setErrorValue:s},k={name:"working",enter:s,cancel:function(L){L._setState(W)},done:h,then:S,_completed:u,_error:p,_notify:s,_progress:v,_setCompleteValue:E,_setErrorValue:C},U={name:"waiting",enter:function(L){var N=L._value;if(N instanceof J&&N._state!==V&&N._state!==K)y(N,{promise:L});else{var n=function(P){N._errorId?L._chainedError(P,N):(_(L,P,l,N,n),L._error(P))};n.handlesOnError=!0,N.then(L._completed.bind(L),n,L._progress.bind(L))}},cancel:function(L){L._setState(F)},done:h,then:S,_completed:u,_error:p,_notify:s,_progress:v,_setCompleteValue:E,_setErrorValue:C},F={name:"waiting_canceled",enter:function(L){L._setState(q);var N=L._value;N.cancel&&N.cancel()},cancel:s,done:h,then:S,_completed:u,_error:p,_notify:s,_progress:v,_setCompleteValue:E,_setErrorValue:C},W={name:"canceled",enter:function(L){L._setState(q),L._cancelAction()},cancel:s,done:h,then:S,_completed:u,_error:p,_notify:s,_progress:v,_setCompleteValue:E,_setErrorValue:C},q={name:"canceling",enter:function(L){var N=new Error(O);N.name=N.message,L._value=N,L._setState(B)},cancel:s,done:s,then:s,_completed:s,_error:s,_notify:s,_progress:s,_setCompleteValue:s,_setErrorValue:s},j={name:"complete_notify",enter:function(L){if(L.done=X.prototype.done,L.then=X.prototype.then,L._listeners)for(var N,P=[L];P.length;)(N=P.shift())._state._notify(N,P);L._setState(K)},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:m,_progress:s,_setCompleteValue:s,_setErrorValue:s},K={name:"success",enter:function(L){L.done=X.prototype.done,L.then=X.prototype.then,L._cleanupAction()},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:m,_progress:s,_setCompleteValue:s,_setErrorValue:s},B={name:"error_notify",enter:function(L){if(L.done=z.prototype.done,L.then=z.prototype.then,L._listeners)for(var N,P=[L];P.length;)(N=P.shift())._state._notify(N,P);L._setState(V)},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:g,_progress:s,_setCompleteValue:s,_setErrorValue:s},V={name:"error",enter:function(L){L.done=z.prototype.done,L.then=z.prototype.then,L._cleanupAction()},cancel:s,done:null,then:null,_completed:s,_error:s,_notify:g,_progress:s,_setCompleteValue:s,_setErrorValue:s};var H,G=P.Class.define(null,{_listeners:null,_nextState:null,_state:null,_value:null,cancel:function(){this._state.cancel(this),this._run()},done:function(L,N,P){this._state.done(this,L,N,P)},then:function e(L,N,P){if(this.then===e)return this._state.then(this,L,N,P);this.then(L,N,P)},_chainedError:function(L,N){var P=this._state._error(this,L,c,N);return this._run(),P},_completed:function(L){var N=this._state._completed(this,L);return this._run(),N},_error:function(L){var N=this._state._error(this,L,f);return this._run(),N},_progress:function(L){this._state._progress(this,L)},_setState:function(L){this._nextState=L},_setCompleteValue:function(L){this._state._setCompleteValue(this,L),this._run()},_setChainedErrorValue:function(L,N){var P=this._state._setErrorValue(this,L,c,N);return this._run(),P},_setExceptionValue:function(L){var N=this._state._setErrorValue(this,L,d);return this._run(),N},_run:function(){for(;this._nextState;)this._state=this._nextState,this._nextState=null,this._state.enter(this)}},{supportedForProcessing:!1}),J=P.Class.derive(G,(function(L){T&&(!0===T||T&R.thenPromise)&&(this._stack=$._getStack()),this._creator=L,this._setState(x),this._run()}),{_creator:null,_cancelAction:function(){this._creator&&this._creator.cancel()},_cleanupAction:function(){this._creator=null}},{supportedForProcessing:!1}),z=P.Class.define((function(L){T&&(!0===T||T&R.errorPromise)&&(this._stack=$._getStack()),this._value=L,_(this,L,f)}),{cancel:function(){},done:function(L,N){var P=this._value;if(N)try{N.handlesOnError||_(null,P,l,this,N);var A=N(P);return void(A&&"object"==typeof A&&"function"==typeof A.done&&A.done())}catch(L){P=L}P instanceof Error&&P.message===O||$._doneHandler(P)},then:function(L,N){if(!N)return this;var P,A=this._value;try{N.handlesOnError||_(null,A,l,this,N),P=new X(N(A))}catch(L){P=L===A?this:new Q(L)}return P}},{supportedForProcessing:!1}),Q=P.Class.derive(z,(function(L){T&&(!0===T||T&R.exceptionPromise)&&(this._stack=$._getStack()),this._value=L,_(this,L,d)}),{},{supportedForProcessing:!1}),X=P.Class.define((function(L){if(T&&(!0===T||T&R.completePromise)&&(this._stack=$._getStack()),L&&"object"==typeof L&&"function"==typeof L.then){var N=new J(null);return N._setCompleteValue(L),N}this._value=L}),{cancel:function(){},done:function(L){if(L)try{var N=L(this._value);N&&"object"==typeof N&&"function"==typeof N.done&&N.done()}catch(L){$._doneHandler(L)}},then:function(L){try{var N=L?L(this._value):this._value;return N===this._value?this:new X(N)}catch(L){return new Q(L)}}},{supportedForProcessing:!1}),$=P.Class.derive(G,(function(L,N){T&&(!0===T||T&R.promise)&&(this._stack=$._getStack()),this._oncancel=N,this._setState(x),this._run();try{L(this._completed.bind(this),this._error.bind(this),this._progress.bind(this))}catch(L){this._setExceptionValue(L)}}),{_oncancel:null,_cancelAction:function(){try{if(!this._oncancel)throw new Error("Promise did not implement oncancel");this._oncancel()}catch(L){L.message,L.stack,w.dispatchEvent("error",L)}},_cleanupAction:function(){this._oncancel=null}},{addEventListener:function(L,N,P){w.addEventListener(L,N,P)},any:function(L){return new $((function(N,P){var A=Object.keys(L);0===A.length&&N();var M=0;A.forEach((function(I){$.as(L[I]).then((function(){N({key:I,value:L[I]})}),(function(w){w instanceof Error&&w.name===O?++M===A.length&&N($.cancel):P({key:I,value:L[I]})}))}))}),(function(){Object.keys(L).forEach((function(N){var P=$.as(L[N]);"function"==typeof P.cancel&&P.cancel()}))}))},as:function(L){return L&&"object"==typeof L&&"function"==typeof L.then?L:new X(L)},cancel:{get:function(){return H=H||new z(new A(O))}},dispatchEvent:function(L,N){return w.dispatchEvent(L,N)},is:function(L){return L&&"object"==typeof L&&"function"==typeof L.then},join:function(L){return new $((function(N,P,A){var M=Object.keys(L),I=Array.isArray(L)?[]:{},w=Array.isArray(L)?[]:{},D=0,T=M.length,l=function(L){if(0==--T){var D=Object.keys(I).length;if(0===D)N(w);else{var R=0;M.forEach((function(L){var N=I[L];N instanceof Error&&N.name===O&&R++})),R===D?N($.cancel):P(I)}}else A({Key:L,Done:!0})};M.forEach((function(N){var P=L[N];void 0===P?D++:$.then(P,(function(L){w[N]=L,l(N)}),(function(L){I[N]=L,l(N)}))})),0!=(T-=D)||N(w)}),(function(){Object.keys(L).forEach((function(N){var P=$.as(L[N]);"function"==typeof P.cancel&&P.cancel()}))}))},removeEventListener:function(L,N,P){w.removeEventListener(L,N,P)},supportedForProcessing:!1,then:function(L,N,P,A){return $.as(L).then(N,P,A)},thenEach:function(L,N,P,A){var M=Array.isArray(L)?[]:{};return Object.keys(L).forEach((function(I){M[I]=$.as(L[I]).then(N,P,A)})),$.join(M)},timeout:function(P,A){var M=function(P){var A;return new $((function(M){P?A=L.setTimeout(M,P):N._setImmediate(M)}),(function(){A&&L.clearTimeout(A)}))}(P);return A?function(L,N){var n=function(){L.cancel()};return L.then((function(){N.cancel()})),N.then(n,n),N}(M,A):M},wrap:function(L){return new X(L)},wrapError:function(L){return new z(L)},_veryExpensiveTagWithStack:{get:function(){return T},set:function(L){T=L}},_veryExpensiveTagWithStack_tag:R,_getStack:function(){if(L.Debug&&L.Debug.debuggerEnabled)try{throw new Error}catch(L){return L.stack}},_cancelBlocker:function(L,N){if(!$.is(L))return $.wrap(L);var P,A,M=new $((function(L,N){P=L,A=N}),(function(){P=null,A=null,N&&N()}));return L.then((function(L){P&&P(L)}),(function(L){A&&A(L)})),M}});return Object.defineProperties($,M.createEventProperties(D)),$._doneHandler=function(L){N._setImmediate((function(){throw L}))},{PromiseStateMachine:G,Promise:$,state_created:x}})),t("WinJS/Promise",["WinJS/Core/_Base","WinJS/Promise/_StateMachine"],(function(L,N){"use strict";return L.Namespace.define("WinJS",{Promise:N.Promise}),N.Promise})),(I=N["WinJS/Core/_WinJS"]).TPromise=I.Promise,I.PPromise=I.Promise,"undefined"==typeof exports&&"function"==typeof L&&L.amd?L("vs/base/common/winjs.base",[],I):module.exports=I}(),L(P[4],t([0,1,8]),(function(L,N,P){"use strict";function r(L){i(L)||N.errorHandler.onUnexpectedError(L)}function i(L){return L instanceof Error&&L.name===I&&L.message===I}Object.defineProperty(N,"__esModule",{value:!0});var A={};P.TPromise.addEventListener("error",(function(L){var N=L.detail,P=N.id;N.parent?N.handler&&A&&delete A[P]:(A[P]=N,1===Object.keys(A).length&&setTimeout((function(){var L=A;A={},Object.keys(L).forEach((function(N){var P=L[N];P.exception?r(P.exception):P.error&&r(P.error),console.log("WARNING: Promise with no error callback:"+P.id),console.log(P),P.exception&&console.log(P.exception.stack)}))}),0))}));var M=function(){function e(){this.listeners=[],this.unexpectedErrorHandler=function(L){setTimeout((function(){if(L.stack)throw new Error(L.message+"\n\n"+L.stack);throw L}),0)}}return e.prototype.emit=function(L){this.listeners.forEach((function(N){N(L)}))},e.prototype.onUnexpectedError=function(L){this.unexpectedErrorHandler(L),this.emit(L)},e.prototype.onUnexpectedExternalError=function(L){this.unexpectedErrorHandler(L)},e}();N.ErrorHandler=M,N.errorHandler=new M,N.onUnexpectedError=r,N.onUnexpectedExternalError=function(L){i(L)||N.errorHandler.onUnexpectedExternalError(L)},N.transformErrorForSerialization=function(L){return L instanceof Error?{$isError:!0,name:L.name,message:L.message,stack:L.stacktrace||L.stack}:L};var I="Canceled";N.isPromiseCanceledError=i,N.canceled=function(){var L=new Error(I);return L.name=L.message,L},N.illegalArgument=function(L){return L?new Error("Illegal argument: "+L):new Error("Illegal argument")},N.illegalState=function(L){return L?new Error("Illegal state: "+L):new Error("Illegal state")}})),L(P[9],t([0,1,4,16,7,15]),(function(L,N,P,A,M,I){"use strict";function s(L,N){return function(P,A,M){return void 0===A&&(A=null),L((function(L){return P.call(A,N(L))}),null,M)}}function u(L,N){return function(P,A,M){return void 0===A&&(A=null),L((function(L){return N(L)&&P.call(A,L)}),null,M)}}var w;Object.defineProperty(N,"__esModule",{value:!0}),function(L){var N={dispose:function(){}};L.None=function(){return N}}(w=N.Event||(N.Event={}));var D=function(){function e(L){void 0===L&&(L=null),this._options=L,this._event=null,this._disposed=!1,this._deliveryQueue=null,this._listeners=null}return Object.defineProperty(e.prototype,"event",{get:function(){var L=this;return this._event||(this._event=function(N,P,A){L._listeners||(L._listeners=new I.LinkedList);var M=L._listeners.isEmpty();M&&L._options&&L._options.onFirstListenerAdd&&L._options.onFirstListenerAdd(L);var w,D=L._listeners.push(P?[N,P]:N);return M&&L._options&&L._options.onFirstListenerDidAdd&&L._options.onFirstListenerDidAdd(L),L._options&&L._options.onListenerDidAdd&&L._options.onListenerDidAdd(L,N,P),w={dispose:function(){w.dispose=e._noop,!L._disposed&&(D(),L._options&&L._options.onLastListenerRemove)&&(L._listeners&&!L._listeners.isEmpty()||L._options.onLastListenerRemove(L))}},Array.isArray(A)&&A.push(w),w}),this._event},enumerable:!0,configurable:!0}),e.prototype.fire=function(L){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=[]);for(var N=this._listeners.iterator(),A=N.next();!A.done;A=N.next())this._deliveryQueue.push([A.value,L]);for(;this._deliveryQueue.length>0;){var M=this._deliveryQueue.shift(),I=M[0],w=M[1];try{"function"==typeof I?I.call(void 0,w):I[0].call(I[1],w)}catch(A){P.onUnexpectedError(A)}}}},e.prototype.dispose=function(){this._listeners&&(this._listeners=null),this._deliveryQueue&&(this._deliveryQueue.length=0),this._disposed=!0},e._noop=function(){},e}();N.Emitter=D;var O=function(){function e(){var L=this;this.hasListeners=!1,this.events=[],this.emitter=new D({onFirstListenerAdd:function(){return L.onFirstListenerAdd()},onLastListenerRemove:function(){return L.onLastListenerRemove()}})}return Object.defineProperty(e.prototype,"event",{get:function(){return this.emitter.event},enumerable:!0,configurable:!0}),e.prototype.add=function(L){var N=this,P={event:L,listener:null};return this.events.push(P),this.hasListeners&&this.hook(P),M.toDisposable(A.once((function(){N.hasListeners&&N.unhook(P);var L=N.events.indexOf(P);N.events.splice(L,1)})))},e.prototype.onFirstListenerAdd=function(){var L=this;this.hasListeners=!0,this.events.forEach((function(N){return L.hook(N)}))},e.prototype.onLastListenerRemove=function(){var L=this;this.hasListeners=!1,this.events.forEach((function(N){return L.unhook(N)}))},e.prototype.hook=function(L){var N=this;L.listener=L.event((function(L){return N.emitter.fire(L)}))},e.prototype.unhook=function(L){L.listener&&L.listener.dispose(),L.listener=null},e.prototype.dispose=function(){this.emitter.dispose()},e}();N.EventMultiplexer=O,N.once=function(L){return function(N,P,A){void 0===P&&(P=null);var M=!1,I=L((function(L){if(!M)return I?I.dispose():M=!0,N.call(P,L)}),null,A);return M&&I.dispose(),I}},N.anyEvent=function(){for(var L=[],N=0;N<arguments.length;N++)L[N]=arguments[N];return function(N,P,A){return void 0===P&&(P=null),M.combinedDisposable(L.map((function(L){return L((function(L){return N.call(P,L)}),null,A)})))}},N.debounceEvent=function(L,N,P,A){void 0===P&&(P=100),void 0===A&&(A=!1);var M,I=void 0,w=void 0,O=0,T=new D({onFirstListenerAdd:function(){M=L((function(L){O++,I=N(I,L),A&&!w&&T.fire(I),clearTimeout(w),w=setTimeout((function(){var L=I;I=void 0,w=void 0,(!A||O>1)&&T.fire(L),O=0}),P)}))},onLastListenerRemove:function(){M.dispose()}});return T.event};var T=function(){function e(){this.buffers=[]}return e.prototype.wrapEvent=function(L){var N=this;return function(P,A,M){return L((function(L){var M=N.buffers[N.buffers.length-1];M?M.push((function(){return P.call(A,L)})):P.call(A,L)}),void 0,M)}},e.prototype.bufferEvents=function(L){var N=[];this.buffers.push(N);var P=L();return this.buffers.pop(),N.forEach((function(L){return L()})),P},e}();N.EventBufferer=T,N.mapEvent=s,N.filterEvent=u;var R=function(){function e(L){this._event=L}return Object.defineProperty(e.prototype,"event",{get:function(){return this._event},enumerable:!0,configurable:!0}),e.prototype.map=function(L){return new e(s(this._event,L))},e.prototype.filter=function(L){return new e(u(this._event,L))},e.prototype.on=function(L,N,P){return this._event(L,N,P)},e}();N.chain=function(L){return new R(L)};var x=function(){function e(){var L=this;this.listening=!1,this.inputEvent=w.None,this.inputEventListener=M.Disposable.None,this.emitter=new D({onFirstListenerDidAdd:function(){L.listening=!0,L.inputEventListener=L.inputEvent(L.emitter.fire,L.emitter)},onLastListenerRemove:function(){L.listening=!1,L.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(e.prototype,"input",{set:function(L){this.inputEvent=L,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=L(this.emitter.fire,this.emitter))},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},e}();N.Relay=x})),L(P[10],t([0,1,9]),(function(L,N,P){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var A,M=Object.freeze((function(L,N){var P=setTimeout(L.bind(N),0);return{dispose:function(){clearTimeout(P)}}}));!function(L){L.isCancellationToken=function(N){return N===L.None||N===L.Cancelled||N instanceof I||!(!N||"object"!=typeof N)&&"boolean"==typeof N.isCancellationRequested&&"function"==typeof N.onCancellationRequested},L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})}(A=N.CancellationToken||(N.CancellationToken={}));var I=function(){function e(){this._isCancelled=!1,this._emitter=null}return e.prototype.cancel=function(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))},Object.defineProperty(e.prototype,"isCancellationRequested",{get:function(){return this._isCancelled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onCancellationRequested",{get:function(){return this._isCancelled?M:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this._emitter&&(this._emitter.dispose(),this._emitter=null)},e}(),w=function(){function e(){}return Object.defineProperty(e.prototype,"token",{get:function(){return this._token||(this._token=new I),this._token},enumerable:!0,configurable:!0}),e.prototype.cancel=function(){this._token?this._token instanceof I&&this._token.cancel():this._token=A.Cancelled},e.prototype.dispose=function(){this._token?this._token instanceof I&&this._token.dispose():this._token=A.None},e}();N.CancellationTokenSource=w})),L(P[14],t([0,1,10,4,7,8]),(function(L,N,P,A,M,I){"use strict";function u(L){var N=new P.CancellationTokenSource,M=L(N.token),I=new Promise((function(L,P){N.token.onCancellationRequested((function(){P(A.canceled())})),Promise.resolve(M).then((function(P){N.dispose(),L(P)}),(function(L){N.dispose(),P(L)}))}));return new(function(){function e(){}return e.prototype.cancel=function(){N.cancel()},e.prototype.then=function(L,N){return I.then(L,N)},e.prototype.catch=function(L){return this.then(void 0,L)},e}())}Object.defineProperty(N,"__esModule",{value:!0}),N.isThenable=function(L){return L&&"function"==typeof L.then},N.createCancelablePromise=u;var D=function(){function e(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.task=null}return e.prototype.trigger=function(L,N){var P=this;return void 0===N&&(N=this.defaultDelay),this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new I.TPromise((function(L,N){P.doResolve=L,P.doReject=N})).then((function(){P.completionPromise=null,P.doResolve=null;var L=P.task;return P.task=null,L()}))),this.timeout=setTimeout((function(){P.timeout=null,P.doResolve(null)}),N),this.completionPromise},e.prototype.cancel=function(){this.cancelTimeout(),this.completionPromise&&(this.doReject(A.canceled()),this.completionPromise=null)},e.prototype.cancelTimeout=function(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)},e.prototype.dispose=function(){this.cancelTimeout()},e}();N.Delayer=D,N.timeout=function a(L,N){return N?new Promise((function(P,M){var I=setTimeout(P,L);N.onCancellationRequested((function(){clearTimeout(I),M(A.canceled())}))})):u((function(N){return a(L,N)}))},N.always=function(L,N){function n(){try{N()}catch(L){A.onUnexpectedError(L)}}return L.then((function(L){return n()}),(function(L){return n()})),Promise.resolve(L)},N.first=function(L,N,P){void 0===N&&(N=function(L){return!!L}),void 0===P&&(P=null);var A=0,M=L.length,o=function(){if(A>=M)return Promise.resolve(P);var I=L[A++];return Promise.resolve(I()).then((function(L){return N(L)?Promise.resolve(L):o()}))};return o()};var O=function(L){function t(N,P){var A=L.call(this)||this;return A._token=-1,"function"==typeof N&&"number"==typeof P&&A.setIfNotSet(N,P),A}return w(t,L),t.prototype.dispose=function(){this.cancel(),L.prototype.dispose.call(this)},t.prototype.cancel=function(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)},t.prototype.cancelAndSet=function(L,N){var P=this;this.cancel(),this._token=setTimeout((function(){P._token=-1,L()}),N)},t.prototype.setIfNotSet=function(L,N){var P=this;-1===this._token&&(this._token=setTimeout((function(){P._token=-1,L()}),N))},t}(M.Disposable);N.TimeoutTimer=O;var T=function(L){function t(){var N=L.call(this)||this;return N._token=-1,N}return w(t,L),t.prototype.dispose=function(){this.cancel(),L.prototype.dispose.call(this)},t.prototype.cancel=function(){-1!==this._token&&(clearInterval(this._token),this._token=-1)},t.prototype.cancelAndSet=function(L,N){this.cancel(),this._token=setInterval((function(){L()}),N)},t}(M.Disposable);N.IntervalTimer=T;var R=function(){function e(L,N){this.timeoutToken=-1,this.runner=L,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}return e.prototype.dispose=function(){this.cancel(),this.runner=null},e.prototype.cancel=function(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)},e.prototype.schedule=function(L){void 0===L&&(L=this.timeout),this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)},e.prototype.isScheduled=function(){return-1!==this.timeoutToken},e.prototype.onTimeout=function(){this.timeoutToken=-1,this.runner&&this.doRun()},e.prototype.doRun=function(){this.runner&&this.runner()},e}();N.RunOnceScheduler=R,function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){var L=Object.freeze({didTimeout:!0,timeRemaining:function(){return 15}});N.runWhenIdle=function(N,P){void 0===P&&(P=0);var A=setTimeout((function(){return N(L)}),P),M=!1;return{dispose:function(){M||(M=!0,clearTimeout(A))}}}}else N.runWhenIdle=function(L,N){var P=requestIdleCallback(L,"number"==typeof N?{timeout:N}:void 0),A=!1;return{dispose:function(){A||(A=!0,cancelIdleCallback(P))}}}}();var x=function(){function e(L){var P=this;this._executor=function(){try{P._value=L()}catch(L){P._error=L}finally{P._didRun=!0}},this._handle=N.runWhenIdle((function(){return P._executor()}))}return e.prototype.dispose=function(){this._handle.dispose()},e.prototype.getValue=function(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value},e}();N.IdleValue=x})),L(P[18],t([0,1,8,3,14]),(function(L,N,P,A,M){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var I=function(){function e(L){!function(L){return M.isThenable(L)&&"function"==typeof L.done}(L)?this._winjsPromise=new P.Promise((function(N,P){var M=!0;L((function(L){M?A.setImmediate((function(){return N(L)})):N(L)}),(function(L){M?A.setImmediate((function(){return P(L)})):P(L)})),M=!1})):this._winjsPromise=L}return e.all=function(L){return new e(P.Promise.join(L).then(null,(function(L){for(var N in L)if(L.hasOwnProperty(N))return L[N]})))},e.race=function(L){return new e(P.Promise.any(L).then((function(L){return L.value}),(function(L){return L.value})))},e.resolve=function(L){return new e(P.Promise.wrap(L))},e.reject=function(L){return new e(P.Promise.wrapError(L))},e.prototype.then=function(L,N){var M=!0,I=new e(this._winjsPromise.then(L&&function(N){return M?new P.Promise((function(P,M){A.setImmediate((function(){var A;try{A=L(N)}catch(N){return void M(N)}P(A)}))})):L(N)},N&&function(L){return M?new P.Promise((function(P,M){A.setImmediate((function(){var A;try{A=N(L)}catch(L){return void M(L)}P(A)}))})):N(L)}));return M=!1,I},e.prototype.catch=function(L){return this.then(null,L)},e}();N.PolyfillPromise=I})),L(P[33],t([0,1,4,7,3,18]),(function(L,N,P,A,M,I){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var D=self;void 0===D.Promise&&(D.Promise=I.PolyfillPromise);var O="$initialize",T=!1;N.logOnceWebWorkerWarning=function(L){M.isWeb&&(T||(T=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/Microsoft/monaco-editor#faq")),console.warn(L.message))};var R=function(){function e(L){this._workerId=-1,this._handler=L,this._lastSentReq=0,this._pendingReplies=Object.create(null)}return e.prototype.setWorkerId=function(L){this._workerId=L},e.prototype.sendMessage=function(L,N){var P=this,A=String(++this._lastSentReq);return new Promise((function(M,I){P._pendingReplies[A]={resolve:M,reject:I},P._send({vsWorker:P._workerId,req:A,method:L,args:N})}))},e.prototype.handleMessage=function(L){var N;try{N=JSON.parse(L)}catch(L){return}N&&N.vsWorker&&(-1!==this._workerId&&N.vsWorker!==this._workerId||this._handleMessage(N))},e.prototype._handleMessage=function(L){var N=this;if(L.seq){var A=L;if(!this._pendingReplies[A.seq])return void console.warn("Got reply to unknown seq");var M=this._pendingReplies[A.seq];if(delete this._pendingReplies[A.seq],A.err){var I=A.err;return A.err.$isError&&((I=new Error).name=A.err.name,I.message=A.err.message,I.stack=A.err.stack),void M.reject(I)}M.resolve(A.res)}else{var w=L,D=w.req;this._handler.handleMessage(w.method,w.args).then((function(L){N._send({vsWorker:N._workerId,seq:D,res:L,err:void 0})}),(function(L){L.detail instanceof Error&&(L.detail=P.transformErrorForSerialization(L.detail)),N._send({vsWorker:N._workerId,seq:D,res:void 0,err:P.transformErrorForSerialization(L)})}))}},e.prototype._send=function(L){var N=JSON.stringify(L);this._handler.sendMessage(N)},e}(),x=function(L){function t(N,P){var A=L.call(this)||this,M=null;A._worker=A._register(N.create("vs/base/common/worker/simpleWorker",(function(L){A._protocol.handleMessage(L)}),(function(L){M&&M(L)}))),A._protocol=new R({sendMessage:function(L){A._worker.postMessage(L)},handleMessage:function(L,N){return Promise.resolve(null)}}),A._protocol.setWorkerId(A._worker.getId());var I=null;void 0!==self.require&&"function"==typeof self.require.getConfig?I=self.require.getConfig():void 0!==self.requirejs&&(I=self.requirejs.s.contexts._.config),A._onModuleLoaded=A._protocol.sendMessage(O,[A._worker.getId(),P,I]),A._lazyProxy=new Promise((function(L,N){M=N,A._onModuleLoaded.then((function(N){for(var P={},A=0;A<N.length;A++)P[N[A]]=u(N[A],s);L(P)}),(function(L){N(L),A._onError("Worker failed to load "+P,L)}))}));var s=function(L,N){return A._request(L,N)},u=function(L,N){return function(){var P=Array.prototype.slice.call(arguments,0);return N(L,P)}};return A}return w(t,L),t.prototype.getProxyObject=function(){return this._lazyProxy},t.prototype._request=function(L,N){var P=this;return new Promise((function(A,M){P._onModuleLoaded.then((function(){P._protocol.sendMessage(L,N).then(A,M)}),M)}))},t.prototype._onError=function(L,N){console.error(L),console.info(N)},t}(A.Disposable);N.SimpleWorkerClient=x;var k=function(){function e(L,N){var P=this;this._requestHandler=N,this._protocol=new R({sendMessage:function(N){L(N)},handleMessage:function(L,N){return P._handleMessage(L,N)}})}return e.prototype.onmessage=function(L){this._protocol.handleMessage(L)},e.prototype._handleMessage=function(L,N){if(L===O)return this.initialize(N[0],N[1],N[2]);if(!this._requestHandler||"function"!=typeof this._requestHandler[L])return Promise.reject(new Error("Missing requestHandler or method: "+L));try{return Promise.resolve(this._requestHandler[L].apply(this._requestHandler,N))}catch(L){return Promise.reject(L)}},e.prototype.initialize=function(L,N,P){var A=this;if(this._protocol.setWorkerId(L),this._requestHandler){var M=[];for(var I in this._requestHandler)"function"==typeof this._requestHandler[I]&&M.push(I);return Promise.resolve(M)}return P&&(void 0!==P.baseUrl&&delete P.baseUrl,void 0!==P.paths&&void 0!==P.paths.vs&&delete P.paths.vs,P.catchError=!0,self.require.config(P)),new Promise((function(L,P){self.require([N],(function(){for(var N=[],M=0;M<arguments.length;M++)N[M]=arguments[M];var I=N[0];if(A._requestHandler=I.create(),A._requestHandler){var w=[];for(var D in A._requestHandler)"function"==typeof A._requestHandler[D]&&w.push(D);L(w)}else P(new Error("No RequestHandler!"))}),P)}))},e}();N.SimpleWorkerServer=k,N.create=function(L){return new k(L,null)}})),L(P[2],t([0,1]),(function(L,N){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var P=function(){function e(L,N){this.lineNumber=L,this.column=N}return e.prototype.with=function(L,N){return void 0===L&&(L=this.lineNumber),void 0===N&&(N=this.column),L===this.lineNumber&&N===this.column?this:new e(L,N)},e.prototype.delta=function(L,N){return void 0===L&&(L=0),void 0===N&&(N=0),this.with(this.lineNumber+L,this.column+N)},e.prototype.equals=function(L){return e.equals(this,L)},e.equals=function(L,N){return!L&&!N||!!L&&!!N&&L.lineNumber===N.lineNumber&&L.column===N.column},e.prototype.isBefore=function(L){return e.isBefore(this,L)},e.isBefore=function(L,N){return L.lineNumber<N.lineNumber||!(N.lineNumber<L.lineNumber)&&L.column<N.column},e.prototype.isBeforeOrEqual=function(L){return e.isBeforeOrEqual(this,L)},e.isBeforeOrEqual=function(L,N){return L.lineNumber<N.lineNumber||!(N.lineNumber<L.lineNumber)&&L.column<=N.column},e.compare=function(L,N){var P=0|L.lineNumber,A=0|N.lineNumber;return P===A?(0|L.column)-(0|N.column):P-A},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.lift=function(L){return new e(L.lineNumber,L.column)},e.isIPosition=function(L){return L&&"number"==typeof L.lineNumber&&"number"==typeof L.column},e}();N.Position=P})),L(P[5],t([0,1,2]),(function(L,N,P){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var A=function(){function e(L,N,P,A){L>P||L===P&&N>A?(this.startLineNumber=P,this.startColumn=A,this.endLineNumber=L,this.endColumn=N):(this.startLineNumber=L,this.startColumn=N,this.endLineNumber=P,this.endColumn=A)}return e.prototype.isEmpty=function(){return e.isEmpty(this)},e.isEmpty=function(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn},e.prototype.containsPosition=function(L){return e.containsPosition(this,L)},e.containsPosition=function(L,N){return!(N.lineNumber<L.startLineNumber||N.lineNumber>L.endLineNumber||N.lineNumber===L.startLineNumber&&N.column<L.startColumn||N.lineNumber===L.endLineNumber&&N.column>L.endColumn)},e.prototype.containsRange=function(L){return e.containsRange(this,L)},e.containsRange=function(L,N){return!(N.startLineNumber<L.startLineNumber||N.endLineNumber<L.startLineNumber||N.startLineNumber>L.endLineNumber||N.endLineNumber>L.endLineNumber||N.startLineNumber===L.startLineNumber&&N.startColumn<L.startColumn||N.endLineNumber===L.endLineNumber&&N.endColumn>L.endColumn)},e.prototype.plusRange=function(L){return e.plusRange(this,L)},e.plusRange=function(L,N){var P,A,M,I;return N.startLineNumber<L.startLineNumber?(P=N.startLineNumber,A=N.startColumn):N.startLineNumber===L.startLineNumber?(P=N.startLineNumber,A=Math.min(N.startColumn,L.startColumn)):(P=L.startLineNumber,A=L.startColumn),N.endLineNumber>L.endLineNumber?(M=N.endLineNumber,I=N.endColumn):N.endLineNumber===L.endLineNumber?(M=N.endLineNumber,I=Math.max(N.endColumn,L.endColumn)):(M=L.endLineNumber,I=L.endColumn),new e(P,A,M,I)},e.prototype.intersectRanges=function(L){return e.intersectRanges(this,L)},e.intersectRanges=function(L,N){var P=L.startLineNumber,A=L.startColumn,M=L.endLineNumber,I=L.endColumn,w=N.startLineNumber,D=N.startColumn,O=N.endLineNumber,T=N.endColumn;return P<w?(P=w,A=D):P===w&&(A=Math.max(A,D)),M>O?(M=O,I=T):M===O&&(I=Math.min(I,T)),P>M?null:P===M&&A>I?null:new e(P,A,M,I)},e.prototype.equalsRange=function(L){return e.equalsRange(this,L)},e.equalsRange=function(L,N){return!!L&&!!N&&L.startLineNumber===N.startLineNumber&&L.startColumn===N.startColumn&&L.endLineNumber===N.endLineNumber&&L.endColumn===N.endColumn},e.prototype.getEndPosition=function(){return new P.Position(this.endLineNumber,this.endColumn)},e.prototype.getStartPosition=function(){return new P.Position(this.startLineNumber,this.startColumn)},e.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},e.prototype.setEndPosition=function(L,N){return new e(this.startLineNumber,this.startColumn,L,N)},e.prototype.setStartPosition=function(L,N){return new e(L,N,this.endLineNumber,this.endColumn)},e.prototype.collapseToStart=function(){return e.collapseToStart(this)},e.collapseToStart=function(L){return new e(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)},e.fromPositions=function(L,N){return void 0===N&&(N=L),new e(L.lineNumber,L.column,N.lineNumber,N.column)},e.lift=function(L){return L?new e(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null},e.isIRange=function(L){return L&&"number"==typeof L.startLineNumber&&"number"==typeof L.startColumn&&"number"==typeof L.endLineNumber&&"number"==typeof L.endColumn},e.areIntersectingOrTouching=function(L,N){return!(L.endLineNumber<N.startLineNumber||L.endLineNumber===N.startLineNumber&&L.endColumn<N.startColumn||N.endLineNumber<L.startLineNumber||N.endLineNumber===L.startLineNumber&&N.endColumn<L.startColumn)},e.areIntersecting=function(L,N){return!(L.endLineNumber<N.startLineNumber||L.endLineNumber===N.startLineNumber&&L.endColumn<=N.startColumn||N.endLineNumber<L.startLineNumber||N.endLineNumber===L.startLineNumber&&N.endColumn<=L.startColumn)},e.compareRangesUsingStarts=function(L,N){if(L&&N){var P=0|L.startLineNumber,A=0|N.startLineNumber;if(P===A){var M=0|L.startColumn,I=0|N.startColumn;if(M===I){var w=0|L.endLineNumber,D=0|N.endLineNumber;return w===D?(0|L.endColumn)-(0|N.endColumn):w-D}return M-I}return P-A}return(L?1:0)-(N?1:0)},e.compareRangesUsingEnds=function(L,N){return L.endLineNumber===N.endLineNumber?L.endColumn===N.endColumn?L.startLineNumber===N.startLineNumber?L.startColumn-N.startColumn:L.startLineNumber-N.startLineNumber:L.endColumn-N.endColumn:L.endLineNumber-N.endLineNumber},e.spansMultipleLines=function(L){return L.endLineNumber>L.startLineNumber},e}();N.Range=A})),L(P[22],t([0,1,2,5]),(function(L,N,P,A){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var M=function(L){function t(N,P,A,M){var I=L.call(this,N,P,A,M)||this;return I.selectionStartLineNumber=N,I.selectionStartColumn=P,I.positionLineNumber=A,I.positionColumn=M,I}return w(t,L),t.prototype.clone=function(){return new t(this.selectionStartLineNumber,this.selectionStartColumn,this.positionLineNumber,this.positionColumn)},t.prototype.toString=function(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"},t.prototype.equalsSelection=function(L){return t.selectionsEqual(this,L)},t.selectionsEqual=function(L,N){return L.selectionStartLineNumber===N.selectionStartLineNumber&&L.selectionStartColumn===N.selectionStartColumn&&L.positionLineNumber===N.positionLineNumber&&L.positionColumn===N.positionColumn},t.prototype.getDirection=function(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1},t.prototype.setEndPosition=function(L,N){return 0===this.getDirection()?new t(this.startLineNumber,this.startColumn,L,N):new t(L,N,this.startLineNumber,this.startColumn)},t.prototype.getPosition=function(){return new P.Position(this.positionLineNumber,this.positionColumn)},t.prototype.setStartPosition=function(L,N){return 0===this.getDirection()?new t(L,N,this.endLineNumber,this.endColumn):new t(this.endLineNumber,this.endColumn,L,N)},t.fromPositions=function(L,N){return void 0===N&&(N=L),new t(L.lineNumber,L.column,N.lineNumber,N.column)},t.liftSelection=function(L){return new t(L.selectionStartLineNumber,L.selectionStartColumn,L.positionLineNumber,L.positionColumn)},t.selectionsArrEqual=function(L,N){if(L&&!N||!L&&N)return!1;if(!L&&!N)return!0;if(L.length!==N.length)return!1;for(var P=0,A=L.length;P<A;P++)if(!this.selectionsEqual(L[P],N[P]))return!1;return!0},t.isISelection=function(L){return L&&"number"==typeof L.selectionStartLineNumber&&"number"==typeof L.selectionStartColumn&&"number"==typeof L.positionLineNumber&&"number"==typeof L.positionColumn},t.createWithDirection=function(L,N,P,A,M){return 0===M?new t(L,N,P,A):new t(P,A,L,N)},t}(A.Range);N.Selection=M})),L(P[23],t([0,1]),(function(L,N){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var P=function(){function e(L,N,P){this.offset=0|L,this.type=N,this.language=P}return e.prototype.toString=function(){return"("+this.offset+", "+this.type+")"},e}();N.Token=P;var r=function(L,N){this.tokens=L,this.endState=N};N.TokenizationResult=r;var i=function(L,N){this.tokens=L,this.endState=N};N.TokenizationResult2=i})),L(P[6],t([0,1]),(function(L,N){"use strict";function n(L){return L<0?0:L>4294967295?4294967295:0|L}Object.defineProperty(N,"__esModule",{value:!0});var P=function(){function e(L,N,P){for(var A=new Uint8Array(L*N),M=0,I=L*N;M<I;M++)A[M]=P;this._data=A,this.rows=L,this.cols=N}return e.prototype.get=function(L,N){return this._data[L*this.cols+N]},e.prototype.set=function(L,N,P){this._data[L*this.cols+N]=P},e}();N.Uint8Matrix=P,N.toUint8=function(L){return L<0?0:L>255?255:0|L},N.toUint32=n,N.toUint32Array=function(L){for(var N=L.length,P=new Uint32Array(N),A=0;A<N;A++)P[A]=n(L[A]);return P}})),L(P[25],t([0,1,6]),(function(L,N,P){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var A=function(){function e(L){var N=P.toUint8(L);this._defaultValue=N,this._asciiMap=e._createAsciiMap(N),this._map=new Map}return e._createAsciiMap=function(L){for(var N=new Uint8Array(256),P=0;P<256;P++)N[P]=L;return N},e.prototype.set=function(L,N){var A=P.toUint8(N);L>=0&&L<256?this._asciiMap[L]=A:this._map.set(L,A)},e.prototype.get=function(L){return L>=0&&L<256?this._asciiMap[L]:this._map.get(L)||this._defaultValue},e}();N.CharacterClassifier=A;var M=function(){function e(){this._actual=new A(0)}return e.prototype.add=function(L){this._actual.set(L,1)},e.prototype.has=function(L){return 1===this._actual.get(L)},e}();N.CharacterSet=M})),L(P[26],t([0,1,13,17]),(function(L,N,P,A){"use strict";function i(L,N,A,M){return new P.LcsDiff(L,N,A).ComputeDiff(M)}Object.defineProperty(N,"__esModule",{value:!0});var M=function(){function e(L){for(var N=[],P=[],A=0,M=L.length;A<M;A++)N[A]=e._getFirstNonBlankColumn(L[A],1),P[A]=e._getLastNonBlankColumn(L[A],1);this._lines=L,this._startColumns=N,this._endColumns=P}return e.prototype.getLength=function(){return this._lines.length},e.prototype.getElementAtIndex=function(L){return this._lines[L].substring(this._startColumns[L]-1,this._endColumns[L]-1)},e.prototype.getStartLineNumber=function(L){return L+1},e.prototype.getEndLineNumber=function(L){return L+1},e._getFirstNonBlankColumn=function(L,N){var P=A.firstNonWhitespaceIndex(L);return-1===P?N:P+1},e._getLastNonBlankColumn=function(L,N){var P=A.lastNonWhitespaceIndex(L);return-1===P?N:P+2},e.prototype.getCharSequence=function(L,N,P){for(var A=[],M=[],w=[],D=0,O=N;O<=P;O++)for(var T=this._lines[O],R=L?this._startColumns[O]:1,x=L?this._endColumns[O]:T.length+1,k=R;k<x;k++)A[D]=T.charCodeAt(k-1),M[D]=O+1,w[D]=k,D++;return new I(A,M,w)},e}(),I=function(){function e(L,N,P){this._charCodes=L,this._lineNumbers=N,this._columns=P}return e.prototype.getLength=function(){return this._charCodes.length},e.prototype.getElementAtIndex=function(L){return this._charCodes[L]},e.prototype.getStartLineNumber=function(L){return this._lineNumbers[L]},e.prototype.getStartColumn=function(L){return this._columns[L]},e.prototype.getEndLineNumber=function(L){return this._lineNumbers[L]},e.prototype.getEndColumn=function(L){return this._columns[L]+1},e}(),w=function(){function e(L,N,P,A,M,I,w,D){this.originalStartLineNumber=L,this.originalStartColumn=N,this.originalEndLineNumber=P,this.originalEndColumn=A,this.modifiedStartLineNumber=M,this.modifiedStartColumn=I,this.modifiedEndLineNumber=w,this.modifiedEndColumn=D}return e.createFromDiffChange=function(L,N,P){var A,M,I,w,D,O,T,R;return 0===L.originalLength?(A=0,M=0,I=0,w=0):(A=N.getStartLineNumber(L.originalStart),M=N.getStartColumn(L.originalStart),I=N.getEndLineNumber(L.originalStart+L.originalLength-1),w=N.getEndColumn(L.originalStart+L.originalLength-1)),0===L.modifiedLength?(D=0,O=0,T=0,R=0):(D=P.getStartLineNumber(L.modifiedStart),O=P.getStartColumn(L.modifiedStart),T=P.getEndLineNumber(L.modifiedStart+L.modifiedLength-1),R=P.getEndColumn(L.modifiedStart+L.modifiedLength-1)),new e(A,M,I,w,D,O,T,R)},e}(),D=function(){function e(L,N,P,A,M){this.originalStartLineNumber=L,this.originalEndLineNumber=N,this.modifiedStartLineNumber=P,this.modifiedEndLineNumber=A,this.charChanges=M}return e.createFromDiffResult=function(L,N,P,A,M,I,D){var O,T,R,x,k=void 0;if(0===N.originalLength?(O=P.getStartLineNumber(N.originalStart)-1,T=0):(O=P.getStartLineNumber(N.originalStart),T=P.getEndLineNumber(N.originalStart+N.originalLength-1)),0===N.modifiedLength?(R=A.getStartLineNumber(N.modifiedStart)-1,x=0):(R=A.getStartLineNumber(N.modifiedStart),x=A.getEndLineNumber(N.modifiedStart+N.modifiedLength-1)),I&&0!==N.originalLength&&0!==N.modifiedLength&&M()){var U=P.getCharSequence(L,N.originalStart,N.originalStart+N.originalLength-1),F=A.getCharSequence(L,N.modifiedStart,N.modifiedStart+N.modifiedLength-1),W=i(U,F,M,!0);D&&(W=function(L){if(L.length<=1)return L;for(var N=[L[0]],P=N[0],A=1,M=L.length;A<M;A++){var I=L[A],w=I.originalStart-(P.originalStart+P.originalLength),D=I.modifiedStart-(P.modifiedStart+P.modifiedLength);Math.min(w,D)<3?(P.originalLength=I.originalStart+I.originalLength-P.originalStart,P.modifiedLength=I.modifiedStart+I.modifiedLength-P.modifiedStart):(N.push(I),P=I)}return N}(W)),k=[];for(var q=0,j=W.length;q<j;q++)k.push(w.createFromDiffChange(W[q],U,F))}return new e(O,T,R,x,k)},e}(),O=function(){function e(L,N,P){this.shouldComputeCharChanges=P.shouldComputeCharChanges,this.shouldPostProcessCharChanges=P.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=P.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=P.shouldMakePrettyDiff,this.maximumRunTimeMs=5e3,this.originalLines=L,this.modifiedLines=N,this.original=new M(L),this.modified=new M(N)}return e.prototype.computeDiff=function(){if(1===this.original.getLength()&&0===this.original.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.getLength(),charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];if(1===this.modified.getLength()&&0===this.modified.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:this.original.getLength(),modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];this.computationStartTime=(new Date).getTime();var L=i(this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldMakePrettyDiff);if(this.shouldIgnoreTrimWhitespace){for(var N=[],P=0,A=L.length;P<A;P++)N.push(D.createFromDiffResult(this.shouldIgnoreTrimWhitespace,L[P],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return N}for(var I=[],w=0,O=0,T=(P=-1,L.length);P<T;P++){for(var R=P+1<T?L[P+1]:null,x=R?R.originalStart:this.originalLines.length,k=R?R.modifiedStart:this.modifiedLines.length;w<x&&O<k;){var U=this.originalLines[w],F=this.modifiedLines[O];if(U!==F){for(var W=M._getFirstNonBlankColumn(U,1),q=M._getFirstNonBlankColumn(F,1);W>1&&q>1&&(Y=U.charCodeAt(W-2))===(H=F.charCodeAt(q-2));)W--,q--;(W>1||q>1)&&this._pushTrimWhitespaceCharChange(I,w+1,1,W,O+1,1,q);for(var j=M._getLastNonBlankColumn(U,1),K=M._getLastNonBlankColumn(F,1),B=U.length+1,V=F.length+1;j<B&&K<V;){var Y=U.charCodeAt(j-1),H=U.charCodeAt(K-1);if(Y!==H)break;j++,K++}(j<B||K<V)&&this._pushTrimWhitespaceCharChange(I,w+1,j,B,O+1,K,V)}w++,O++}R&&(I.push(D.createFromDiffResult(this.shouldIgnoreTrimWhitespace,R,this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),w+=R.originalLength,O+=R.modifiedLength)}return I},e.prototype._pushTrimWhitespaceCharChange=function(L,N,P,A,M,I,O){if(!this._mergeTrimWhitespaceCharChange(L,N,P,A,M,I,O)){var T=void 0;this.shouldComputeCharChanges&&(T=[new w(N,P,N,A,M,I,M,O)]),L.push(new D(N,N,M,M,T))}},e.prototype._mergeTrimWhitespaceCharChange=function(L,N,P,A,M,I,D){var O=L.length;if(0===O)return!1;var T=L[O-1];return 0!==T.originalEndLineNumber&&0!==T.modifiedEndLineNumber&&T.originalEndLineNumber+1===N&&T.modifiedEndLineNumber+1===M&&(T.originalEndLineNumber=N,T.modifiedEndLineNumber=M,this.shouldComputeCharChanges&&T.charChanges.push(new w(N,P,N,A,M,I,M,D)),!0)},e.prototype._continueProcessingPredicate=function(){return 0===this.maximumRunTimeMs||(new Date).getTime()-this.computationStartTime<this.maximumRunTimeMs},e}();N.DiffComputer=O})),L(P[27],t([0,1]),(function(L,N){"use strict";Object.defineProperty(N,"__esModule",{value:!0}),N.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",N.DEFAULT_WORD_REGEXP=function(L){void 0===L&&(L="");for(var P="(-?\\d*\\.\\d\\w*)|([^",A=0;A<N.USUAL_WORD_SEPARATORS.length;A++)L.indexOf(N.USUAL_WORD_SEPARATORS[A])>=0||(P+="\\"+N.USUAL_WORD_SEPARATORS[A]);return P+="\\s]+)",new RegExp(P,"g")}(),N.ensureValidWordDefinition=function(L){var P=N.DEFAULT_WORD_REGEXP;if(L&&L instanceof RegExp)if(L.global)P=L;else{var A="g";L.ignoreCase&&(A+="i"),L.multiline&&(A+="m"),P=new RegExp(L.source,A)}return P.lastIndex=0,P},N.getWordAtText=function(L,N,P,A){N.lastIndex=0;var M=N.exec(P);if(!M)return null;var I=M[0].indexOf(" ")>=0?function(L,N,P,A){var M,I=L-1-A;for(N.lastIndex=0;M=N.exec(P);){var w=M.index||0;if(w>I)return null;if(N.lastIndex>=I)return{word:M[0],startColumn:A+1+w,endColumn:A+1+N.lastIndex}}return null}(L,N,P,A):function(L,N,P,A){var M,I=L-1-A,w=P.lastIndexOf(" ",I-1)+1,D=P.indexOf(" ",I);for(-1===D&&(D=P.length),N.lastIndex=w;M=N.exec(P);){var O=M.index||0;if(O<=I&&N.lastIndex>=I)return{word:M[0],startColumn:A+1+O,endColumn:A+1+N.lastIndex}}return null}(L,N,P,A);return N.lastIndex=0,I}})),L(P[28],t([0,1,25,6]),(function(L,N,P,A){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var M=function(){function e(L){for(var N=0,P=0,M=0,I=L.length;M<I;M++){var w=L[M],D=w[0];(R=w[1])>N&&(N=R),D>P&&(P=D),(x=w[2])>P&&(P=x)}N++,P++;var O=new A.Uint8Matrix(P,N,0);for(M=0,I=L.length;M<I;M++){var T=L[M],R=(D=T[0],T[1]),x=T[2];O.set(D,R,x)}this._states=O,this._maxCharCode=N}return e.prototype.nextState=function(L,N){return N<0||N>=this._maxCharCode?0:this._states.get(L,N)},e}(),I=null,w=null,D=function(){function e(){}return e._createLink=function(L,N,P,A,M){var I=M-1;do{var w=N.charCodeAt(I);if(2!==L.get(w))break;I--}while(I>A);if(A>0){var D=N.charCodeAt(A-1),O=N.charCodeAt(I);(40===D&&41===O||91===D&&93===O||123===D&&125===O)&&I--}return{range:{startLineNumber:P,startColumn:A+1,endLineNumber:P,endColumn:I+2},url:N.substring(A,I+1)}},e.computeLinks=function(L){for(var N=(null===I&&(I=new M([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),I),A=function(){if(null===w){for(w=new P.CharacterClassifier(0),L=0;L<" \t<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…".length;L++)w.set(" \t<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…".charCodeAt(L),1);for(var L=0;L<".,;".length;L++)w.set(".,;".charCodeAt(L),2)}return w}(),D=[],O=1,T=L.getLineCount();O<=T;O++){for(var R=L.getLineContent(O),x=R.length,k=0,U=0,F=0,W=1,q=!1,j=!1,K=!1;k<x;){var B=!1,V=R.charCodeAt(k);if(13===W){switch(Y=void 0,V){case 40:q=!0,Y=0;break;case 41:Y=q?0:1;break;case 91:j=!0,Y=0;break;case 93:Y=j?0:1;break;case 123:K=!0,Y=0;break;case 125:Y=K?0:1;break;case 39:Y=34===F||96===F?0:1;break;case 34:Y=39===F||96===F?0:1;break;case 96:Y=39===F||34===F?0:1;break;default:Y=A.get(V)}1===Y&&(D.push(e._createLink(A,R,O,U,k)),B=!0)}else if(12===W){var Y;1===(Y=A.get(V))?B=!0:W=13}else 0===(W=N.nextState(W,V))&&(B=!0);B&&(W=1,q=!1,j=!1,K=!1,U=k+1,F=V),k++}13===W&&D.push(e._createLink(A,R,O,U,x))}return D},e}();N.computeLinks=function(L){return L&&"function"==typeof L.getLineCount&&"function"==typeof L.getLineContent?D.computeLinks(L):[]}})),L(P[29],t([0,1]),(function(L,N){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var P=function(){function e(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}return e.prototype.navigateValueSet=function(L,N,P,A,M){if(L&&N&&(I=this.doNavigateValueSet(N,M)))return{range:L,value:I};if(P&&A){var I=this.doNavigateValueSet(A,M);if(I)return{range:P,value:I}}return null},e.prototype.doNavigateValueSet=function(L,N){var P=this.numberReplace(L,N);return null!==P?P:this.textReplace(L,N)},e.prototype.numberReplace=function(L,N){var P=Math.pow(10,L.length-(L.lastIndexOf(".")+1)),A=Number(L),M=parseFloat(L);return isNaN(A)||isNaN(M)||A!==M?null:0!==A||N?(A=Math.floor(A*P),A+=N?P:-P,String(A/P)):null},e.prototype.textReplace=function(L,N){return this.valueSetsReplace(this._defaultValueSet,L,N)},e.prototype.valueSetsReplace=function(L,N,P){for(var A=null,M=0,I=L.length;null===A&&M<I;M++)A=this.valueSetReplace(L[M],N,P);return A},e.prototype.valueSetReplace=function(L,N,P){var A=L.indexOf(N);return A>=0?((A+=P?1:-1)<0?A=L.length-1:A%=L.length,L[A]):null},e.INSTANCE=new e,e}();N.BasicInplaceReplace=P})),L(P[30],t([0,1]),(function(L,N){"use strict";Object.defineProperty(N,"__esModule",{value:!0}),function(L){L[L.Unnecessary=1]="Unnecessary"}(N.MarkerTag||(N.MarkerTag={})),function(L){L[L.Hint=1]="Hint",L[L.Info=2]="Info",L[L.Warning=4]="Warning",L[L.Error=8]="Error"}(N.MarkerSeverity||(N.MarkerSeverity={})),function(L){L[L.Unknown=0]="Unknown",L[L.Backspace=1]="Backspace",L[L.Tab=2]="Tab",L[L.Enter=3]="Enter",L[L.Shift=4]="Shift",L[L.Ctrl=5]="Ctrl",L[L.Alt=6]="Alt",L[L.PauseBreak=7]="PauseBreak",L[L.CapsLock=8]="CapsLock",L[L.Escape=9]="Escape",L[L.Space=10]="Space",L[L.PageUp=11]="PageUp",L[L.PageDown=12]="PageDown",L[L.End=13]="End",L[L.Home=14]="Home",L[L.LeftArrow=15]="LeftArrow",L[L.UpArrow=16]="UpArrow",L[L.RightArrow=17]="RightArrow",L[L.DownArrow=18]="DownArrow",L[L.Insert=19]="Insert",L[L.Delete=20]="Delete",L[L.KEY_0=21]="KEY_0",L[L.KEY_1=22]="KEY_1",L[L.KEY_2=23]="KEY_2",L[L.KEY_3=24]="KEY_3",L[L.KEY_4=25]="KEY_4",L[L.KEY_5=26]="KEY_5",L[L.KEY_6=27]="KEY_6",L[L.KEY_7=28]="KEY_7",L[L.KEY_8=29]="KEY_8",L[L.KEY_9=30]="KEY_9",L[L.KEY_A=31]="KEY_A",L[L.KEY_B=32]="KEY_B",L[L.KEY_C=33]="KEY_C",L[L.KEY_D=34]="KEY_D",L[L.KEY_E=35]="KEY_E",L[L.KEY_F=36]="KEY_F",L[L.KEY_G=37]="KEY_G",L[L.KEY_H=38]="KEY_H",L[L.KEY_I=39]="KEY_I",L[L.KEY_J=40]="KEY_J",L[L.KEY_K=41]="KEY_K",L[L.KEY_L=42]="KEY_L",L[L.KEY_M=43]="KEY_M",L[L.KEY_N=44]="KEY_N",L[L.KEY_O=45]="KEY_O",L[L.KEY_P=46]="KEY_P",L[L.KEY_Q=47]="KEY_Q",L[L.KEY_R=48]="KEY_R",L[L.KEY_S=49]="KEY_S",L[L.KEY_T=50]="KEY_T",L[L.KEY_U=51]="KEY_U",L[L.KEY_V=52]="KEY_V",L[L.KEY_W=53]="KEY_W",L[L.KEY_X=54]="KEY_X",L[L.KEY_Y=55]="KEY_Y",L[L.KEY_Z=56]="KEY_Z",L[L.Meta=57]="Meta",L[L.ContextMenu=58]="ContextMenu",L[L.F1=59]="F1",L[L.F2=60]="F2",L[L.F3=61]="F3",L[L.F4=62]="F4",L[L.F5=63]="F5",L[L.F6=64]="F6",L[L.F7=65]="F7",L[L.F8=66]="F8",L[L.F9=67]="F9",L[L.F10=68]="F10",L[L.F11=69]="F11",L[L.F12=70]="F12",L[L.F13=71]="F13",L[L.F14=72]="F14",L[L.F15=73]="F15",L[L.F16=74]="F16",L[L.F17=75]="F17",L[L.F18=76]="F18",L[L.F19=77]="F19",L[L.NumLock=78]="NumLock",L[L.ScrollLock=79]="ScrollLock",L[L.US_SEMICOLON=80]="US_SEMICOLON",L[L.US_EQUAL=81]="US_EQUAL",L[L.US_COMMA=82]="US_COMMA",L[L.US_MINUS=83]="US_MINUS",L[L.US_DOT=84]="US_DOT",L[L.US_SLASH=85]="US_SLASH",L[L.US_BACKTICK=86]="US_BACKTICK",L[L.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",L[L.US_BACKSLASH=88]="US_BACKSLASH",L[L.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",L[L.US_QUOTE=90]="US_QUOTE",L[L.OEM_8=91]="OEM_8",L[L.OEM_102=92]="OEM_102",L[L.NUMPAD_0=93]="NUMPAD_0",L[L.NUMPAD_1=94]="NUMPAD_1",L[L.NUMPAD_2=95]="NUMPAD_2",L[L.NUMPAD_3=96]="NUMPAD_3",L[L.NUMPAD_4=97]="NUMPAD_4",L[L.NUMPAD_5=98]="NUMPAD_5",L[L.NUMPAD_6=99]="NUMPAD_6",L[L.NUMPAD_7=100]="NUMPAD_7",L[L.NUMPAD_8=101]="NUMPAD_8",L[L.NUMPAD_9=102]="NUMPAD_9",L[L.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",L[L.NUMPAD_ADD=104]="NUMPAD_ADD",L[L.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",L[L.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",L[L.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",L[L.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",L[L.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",L[L.ABNT_C1=110]="ABNT_C1",L[L.ABNT_C2=111]="ABNT_C2",L[L.MAX_VALUE=112]="MAX_VALUE"}(N.KeyCode||(N.KeyCode={})),function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"}(N.SelectionDirection||(N.SelectionDirection={})),function(L){L[L.Auto=1]="Auto",L[L.Hidden=2]="Hidden",L[L.Visible=3]="Visible"}(N.ScrollbarVisibility||(N.ScrollbarVisibility={})),function(L){L[L.Left=1]="Left",L[L.Center=2]="Center",L[L.Right=4]="Right",L[L.Full=7]="Full"}(N.OverviewRulerLane||(N.OverviewRulerLane={})),function(L){L[L.TextDefined=0]="TextDefined",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"}(N.EndOfLinePreference||(N.EndOfLinePreference={})),function(L){L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"}(N.DefaultEndOfLine||(N.DefaultEndOfLine={})),function(L){L[L.LF=0]="LF",L[L.CRLF=1]="CRLF"}(N.EndOfLineSequence||(N.EndOfLineSequence={})),function(L){L[L.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",L[L.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",L[L.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",L[L.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"}(N.TrackedRangeStickiness||(N.TrackedRangeStickiness={})),function(L){L[L.Smooth=0]="Smooth",L[L.Immediate=1]="Immediate"}(N.ScrollType||(N.ScrollType={})),function(L){L[L.NotSet=0]="NotSet",L[L.ContentFlush=1]="ContentFlush",L[L.RecoverFromMarkers=2]="RecoverFromMarkers",L[L.Explicit=3]="Explicit",L[L.Paste=4]="Paste",L[L.Undo=5]="Undo",L[L.Redo=6]="Redo"}(N.CursorChangeReason||(N.CursorChangeReason={})),function(L){L[L.None=0]="None",L[L.Small=1]="Small",L[L.Large=2]="Large",L[L.SmallBlocks=3]="SmallBlocks",L[L.LargeBlocks=4]="LargeBlocks"}(N.RenderMinimap||(N.RenderMinimap={})),function(L){L[L.None=0]="None",L[L.Same=1]="Same",L[L.Indent=2]="Indent",L[L.DeepIndent=3]="DeepIndent"}(N.WrappingIndent||(N.WrappingIndent={})),function(L){L[L.Hidden=0]="Hidden",L[L.Blink=1]="Blink",L[L.Smooth=2]="Smooth",L[L.Phase=3]="Phase",L[L.Expand=4]="Expand",L[L.Solid=5]="Solid"}(N.TextEditorCursorBlinkingStyle||(N.TextEditorCursorBlinkingStyle={})),function(L){L[L.Line=1]="Line",L[L.Block=2]="Block",L[L.Underline=3]="Underline",L[L.LineThin=4]="LineThin",L[L.BlockOutline=5]="BlockOutline",L[L.UnderlineThin=6]="UnderlineThin"}(N.TextEditorCursorStyle||(N.TextEditorCursorStyle={})),function(L){L[L.Off=0]="Off",L[L.On=1]="On",L[L.Relative=2]="Relative",L[L.Interval=3]="Interval",L[L.Custom=4]="Custom"}(N.RenderLineNumbersType||(N.RenderLineNumbersType={})),function(L){L[L.EXACT=0]="EXACT",L[L.ABOVE=1]="ABOVE",L[L.BELOW=2]="BELOW"}(N.ContentWidgetPositionPreference||(N.ContentWidgetPositionPreference={})),function(L){L[L.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",L[L.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",L[L.TOP_CENTER=2]="TOP_CENTER"}(N.OverlayWidgetPositionPreference||(N.OverlayWidgetPositionPreference={})),function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.TEXTAREA=1]="TEXTAREA",L[L.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",L[L.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",L[L.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",L[L.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",L[L.CONTENT_TEXT=6]="CONTENT_TEXT",L[L.CONTENT_EMPTY=7]="CONTENT_EMPTY",L[L.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",L[L.CONTENT_WIDGET=9]="CONTENT_WIDGET",L[L.OVERVIEW_RULER=10]="OVERVIEW_RULER",L[L.SCROLLBAR=11]="SCROLLBAR",L[L.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",L[L.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"}(N.MouseTargetType||(N.MouseTargetType={})),function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"}(N.IndentAction||(N.IndentAction={})),function(L){L[L.Method=0]="Method",L[L.Function=1]="Function",L[L.Constructor=2]="Constructor",L[L.Field=3]="Field",L[L.Variable=4]="Variable",L[L.Class=5]="Class",L[L.Struct=6]="Struct",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Event=10]="Event",L[L.Operator=11]="Operator",L[L.Unit=12]="Unit",L[L.Value=13]="Value",L[L.Constant=14]="Constant",L[L.Enum=15]="Enum",L[L.EnumMember=16]="EnumMember",L[L.Keyword=17]="Keyword",L[L.Text=18]="Text",L[L.Color=19]="Color",L[L.File=20]="File",L[L.Reference=21]="Reference",L[L.Customcolor=22]="Customcolor",L[L.Folder=23]="Folder",L[L.TypeParameter=24]="TypeParameter",L[L.Snippet=25]="Snippet"}(N.CompletionItemKind||(N.CompletionItemKind={})),function(L){L[L.KeepWhitespace=1]="KeepWhitespace",L[L.InsertAsSnippet=4]="InsertAsSnippet"}(N.CompletionItemInsertTextRule||(N.CompletionItemInsertTextRule={})),function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"}(N.CompletionTriggerKind||(N.CompletionTriggerKind={})),function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"}(N.SignatureHelpTriggerReason||(N.SignatureHelpTriggerReason={})),function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"}(N.DocumentHighlightKind||(N.DocumentHighlightKind={})),function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"}(N.SymbolKind||(N.SymbolKind={}))})),L(P[31],t([0,1,10,9,21,11,8,2,5,22,23,30]),(function(L,N,P,A,M,I,w,D,O,T,R,x){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var k=function(){function e(){}return e.chord=function(L,N){return M.KeyChord(L,N)},e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256,e}();N.KeyMod=k,N.createMonacoBaseAPI=function(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:A.Emitter,KeyCode:x.KeyCode,KeyMod:k,Position:D.Position,Range:O.Range,Selection:T.Selection,SelectionDirection:x.SelectionDirection,MarkerSeverity:x.MarkerSeverity,MarkerTag:x.MarkerTag,Promise:w.TPromise,Uri:I.URI,Token:R.Token}}})),L(P[32],t([0,1,6]),(function(L,N,P){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var r=function(L,N){this.index=L,this.remainder=N};N.PrefixSumIndexOfResult=r;var A=function(){function e(L){this.values=L,this.prefixSum=new Uint32Array(L.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}return e.prototype.getCount=function(){return this.values.length},e.prototype.insertValues=function(L,N){L=P.toUint32(L);var A=this.values,M=this.prefixSum,I=N.length;return 0!==I&&(this.values=new Uint32Array(A.length+I),this.values.set(A.subarray(0,L),0),this.values.set(A.subarray(L),L+I),this.values.set(N,L),L-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=L-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},e.prototype.changeValue=function(L,N){return L=P.toUint32(L),N=P.toUint32(N),this.values[L]!==N&&(this.values[L]=N,L-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=L-1),!0)},e.prototype.removeValues=function(L,N){L=P.toUint32(L),N=P.toUint32(N);var A=this.values,M=this.prefixSum;if(L>=A.length)return!1;var I=A.length-L;return N>=I&&(N=I),0!==N&&(this.values=new Uint32Array(A.length-N),this.values.set(A.subarray(0,L),0),this.values.set(A.subarray(L+N),L),this.prefixSum=new Uint32Array(this.values.length),L-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=L-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(M.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},e.prototype.getTotalValue=function(){return 0===this.values.length?0:this._getAccumulatedValue(this.values.length-1)},e.prototype.getAccumulatedValue=function(L){return L<0?0:(L=P.toUint32(L),this._getAccumulatedValue(L))},e.prototype._getAccumulatedValue=function(L){if(L<=this.prefixSumValidIndex[0])return this.prefixSum[L];var N=this.prefixSumValidIndex[0]+1;0===N&&(this.prefixSum[0]=this.values[0],N++),L>=this.values.length&&(L=this.values.length-1);for(var P=N;P<=L;P++)this.prefixSum[P]=this.prefixSum[P-1]+this.values[P];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],L),this.prefixSum[L]},e.prototype.getIndexOf=function(L){L=Math.floor(L),this.getTotalValue();for(var N=0,P=this.values.length-1,A=0,M=0,I=0;N<=P;)if(A=N+(P-N)/2|0,L<(I=(M=this.prefixSum[A])-this.values[A]))P=A-1;else{if(!(L>=M))break;N=A+1}return new r(A,L-I)},e}();N.PrefixSumComputer=A;var M=function(){function e(L){this._cacheAccumulatedValueStart=0,this._cache=null,this._actual=new A(L),this._bustCache()}return e.prototype._bustCache=function(){this._cacheAccumulatedValueStart=0,this._cache=null},e.prototype.insertValues=function(L,N){this._actual.insertValues(L,N)&&this._bustCache()},e.prototype.changeValue=function(L,N){this._actual.changeValue(L,N)&&this._bustCache()},e.prototype.removeValues=function(L,N){this._actual.removeValues(L,N)&&this._bustCache()},e.prototype.getTotalValue=function(){return this._actual.getTotalValue()},e.prototype.getAccumulatedValue=function(L){return this._actual.getAccumulatedValue(L)},e.prototype.getIndexOf=function(L){if(L=Math.floor(L),null!==this._cache){var N=L-this._cacheAccumulatedValueStart;if(N>=0&&N<this._cache.length)return this._cache[N]}return this._actual.getIndexOf(L)},e.prototype.warmUpCache=function(L,N){for(var P=[],A=L;A<=N;A++)P[A-L]=this.getIndexOf(A);this._cache=P,this._cacheAccumulatedValueStart=L},e}();N.PrefixSumComputerWithCache=M})),L(P[19],t([0,1,2,32]),(function(L,N,P,A){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var M=function(){function e(L,N,P,A){this._uri=L,this._lines=N,this._eol=P,this._versionId=A,this._lineStarts=null}return e.prototype.dispose=function(){this._lines.length=0},e.prototype.getText=function(){return this._lines.join(this._eol)},e.prototype.onEvents=function(L){L.eol&&L.eol!==this._eol&&(this._eol=L.eol,this._lineStarts=null);for(var N=L.changes,A=0,M=N.length;A<M;A++){var I=N[A];this._acceptDeleteRange(I.range),this._acceptInsertText(new P.Position(I.range.startLineNumber,I.range.startColumn),I.text)}this._versionId=L.versionId},e.prototype._ensureLineStarts=function(){if(!this._lineStarts){for(var L=this._eol.length,N=this._lines.length,P=new Uint32Array(N),M=0;M<N;M++)P[M]=this._lines[M].length+L;this._lineStarts=new A.PrefixSumComputer(P)}},e.prototype._setLineText=function(L,N){this._lines[L]=N,this._lineStarts&&this._lineStarts.changeValue(L,this._lines[L].length+this._eol.length)},e.prototype._acceptDeleteRange=function(L){if(L.startLineNumber!==L.endLineNumber)this._setLineText(L.startLineNumber-1,this._lines[L.startLineNumber-1].substring(0,L.startColumn-1)+this._lines[L.endLineNumber-1].substring(L.endColumn-1)),this._lines.splice(L.startLineNumber,L.endLineNumber-L.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(L.startLineNumber,L.endLineNumber-L.startLineNumber);else{if(L.startColumn===L.endColumn)return;this._setLineText(L.startLineNumber-1,this._lines[L.startLineNumber-1].substring(0,L.startColumn-1)+this._lines[L.startLineNumber-1].substring(L.endColumn-1))}},e.prototype._acceptInsertText=function(L,N){if(0!==N.length){var P=N.split(/\r\n|\r|\n/);if(1!==P.length){P[P.length-1]+=this._lines[L.lineNumber-1].substring(L.column-1),this._setLineText(L.lineNumber-1,this._lines[L.lineNumber-1].substring(0,L.column-1)+P[0]);for(var A=new Uint32Array(P.length-1),M=1;M<P.length;M++)this._lines.splice(L.lineNumber+M-1,0,P[M]),A[M-1]=P[M].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(L.lineNumber,A)}else this._setLineText(L.lineNumber-1,this._lines[L.lineNumber-1].substring(0,L.column-1)+P[0]+this._lines[L.lineNumber-1].substring(L.column-1))}},e}();N.MirrorTextModel=M})),L(P[34],t([0,1,24,13,12,3,11,2,5,26,19,27,28,29,31]),(function(L,N,P,A,M,I,D,O,T,R,x,k,U,F,W){"use strict";Object.defineProperty(N,"__esModule",{value:!0});var q=function(L){function t(){return null!==L&&L.apply(this,arguments)||this}return w(t,L),Object.defineProperty(t.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"version",{get:function(){return this._versionId},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"eol",{get:function(){return this._eol},enumerable:!0,configurable:!0}),t.prototype.getValue=function(){return this.getText()},t.prototype.getLinesContent=function(){return this._lines.slice(0)},t.prototype.getLineCount=function(){return this._lines.length},t.prototype.getLineContent=function(L){return this._lines[L-1]},t.prototype.getWordAtPosition=function(L,N){var P=k.getWordAtText(L.column,k.ensureValidWordDefinition(N),this._lines[L.lineNumber-1],0);return P?new T.Range(L.lineNumber,P.startColumn,L.lineNumber,P.endColumn):null},t.prototype.getWordUntilPosition=function(L,N){var P=this.getWordAtPosition(L,N);return P?{word:this._lines[L.lineNumber-1].substring(P.startColumn-1,L.column-1),startColumn:P.startColumn,endColumn:L.column}:{word:"",startColumn:L.column,endColumn:L.column}},t.prototype.createWordIterator=function(L){var N,P,A=this,I=0,w=0,D=[],a=function(){if(w<D.length){var O=P.substring(D[w].start,D[w].end);return w+=1,N?N.value=O:N={done:!1,value:O},N}return I>=A._lines.length?M.FIN:(P=A._lines[I],D=A._wordenize(P,L),w=0,I+=1,a())};return{next:a}},t.prototype.getLineWords=function(L,N){for(var P=this._lines[L-1],A=[],M=0,I=this._wordenize(P,N);M<I.length;M++){var w=I[M];A.push({word:P.substring(w.start,w.end),startColumn:w.start+1,endColumn:w.end+1})}return A},t.prototype._wordenize=function(L,N){var P,A=[];for(N.lastIndex=0;(P=N.exec(L))&&0!==P[0].length;)A.push({start:P.index,end:P.index+P[0].length});return A},t.prototype.getValueInRange=function(L){if((L=this._validateRange(L)).startLineNumber===L.endLineNumber)return this._lines[L.startLineNumber-1].substring(L.startColumn-1,L.endColumn-1);var N=this._eol,P=L.startLineNumber-1,A=L.endLineNumber-1,M=[];M.push(this._lines[P].substring(L.startColumn-1));for(var I=P+1;I<A;I++)M.push(this._lines[I]);return M.push(this._lines[A].substring(0,L.endColumn-1)),M.join(N)},t.prototype.offsetAt=function(L){return L=this._validatePosition(L),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(L.lineNumber-2)+(L.column-1)},t.prototype.positionAt=function(L){L=Math.floor(L),L=Math.max(0,L),this._ensureLineStarts();var N=this._lineStarts.getIndexOf(L),P=this._lines[N.index].length;return{lineNumber:1+N.index,column:1+Math.min(N.remainder,P)}},t.prototype._validateRange=function(L){var N=this._validatePosition({lineNumber:L.startLineNumber,column:L.startColumn}),P=this._validatePosition({lineNumber:L.endLineNumber,column:L.endColumn});return N.lineNumber!==L.startLineNumber||N.column!==L.startColumn||P.lineNumber!==L.endLineNumber||P.column!==L.endColumn?{startLineNumber:N.lineNumber,startColumn:N.column,endLineNumber:P.lineNumber,endColumn:P.column}:L},t.prototype._validatePosition=function(L){if(!O.Position.isIPosition(L))throw new Error("bad position");var N=L.lineNumber,P=L.column,A=!1;if(N<1)N=1,P=1,A=!0;else if(N>this._lines.length)N=this._lines.length,P=this._lines[N-1].length+1,A=!0;else{var M=this._lines[N-1].length+1;P<1?(P=1,A=!0):P>M&&(P=M,A=!0)}return A?{lineNumber:N,column:P}:L},t}(x.MirrorTextModel),j=function(){function t(L){this._foreignModuleFactory=L,this._foreignModule=null}return t.prototype.computeDiff=function(L,N,P){var A=this._getModel(L),M=this._getModel(N);if(!A||!M)return Promise.resolve(null);var I=A.getLinesContent(),w=M.getLinesContent(),D=new R.DiffComputer(I,w,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:P,shouldMakePrettyDiff:!0}).computeDiff(),O=!(D.length>0)&&this._modelsAreIdentical(A,M);return Promise.resolve({identical:O,changes:D})},t.prototype._modelsAreIdentical=function(L,N){var P=L.getLineCount();if(P!==N.getLineCount())return!1;for(var A=1;A<=P;A++)if(L.getLineContent(A)!==N.getLineContent(A))return!1;return!0},t.prototype.computeMoreMinimalEdits=function(L,N){var M=this._getModel(L);if(!M)return Promise.resolve(N);for(var I=[],w=void 0,D=0,O=N=P.mergeSort(N,(function(L,N){return L.range&&N.range?T.Range.compareRangesUsingStarts(L.range,N.range):(L.range?0:1)-(N.range?0:1)}));D<O.length;D++){var R=O[D],x=R.range,k=R.text,U=R.eol;if("number"==typeof U&&(w=U),x){var F=M.getValueInRange(x);if(F!==(k=k.replace(/\r\n|\n|\r/g,M.eol)))if(Math.max(k.length,F.length)>t._diffLimit)I.push({range:x,text:k});else for(var W=A.stringDiff(F,k,!1),q=M.offsetAt(T.Range.lift(x).getStartPosition()),j=0,K=W;j<K.length;j++){var B=K[j],V=M.positionAt(q+B.originalStart),Y=M.positionAt(q+B.originalStart+B.originalLength),H={text:k.substr(B.modifiedStart,B.modifiedLength),range:{startLineNumber:V.lineNumber,startColumn:V.column,endLineNumber:Y.lineNumber,endColumn:Y.column}};M.getValueInRange(H.range)!==H.text&&I.push(H)}}}return"number"==typeof w&&I.push({eol:w,text:void 0,range:void 0}),Promise.resolve(I)},t.prototype.computeLinks=function(L){var N=this._getModel(L);return N?Promise.resolve(U.computeLinks(N)):Promise.resolve(null)},t.prototype.textualSuggest=function(L,N,P,A){var M=this._getModel(L);if(!M)return Promise.resolve(null);var I=[],w=new RegExp(P,A),D=M.getWordUntilPosition(N,w),O=Object.create(null);O[D.word]=!0;for(var T=M.createWordIterator(w),R=T.next();!R.done&&I.length<=t._suggestionsLimit;R=T.next()){var x=R.value;O[x]||(O[x]=!0,isNaN(Number(x))&&I.push({kind:18,label:x,insertText:x,range:{startLineNumber:N.lineNumber,startColumn:D.startColumn,endLineNumber:N.lineNumber,endColumn:D.endColumn}}))}return Promise.resolve({suggestions:I})},t.prototype.computeWordRanges=function(L,N,P,A){var M=this._getModel(L);if(!M)return Promise.resolve(Object.create(null));for(var I=new RegExp(P,A),w=Object.create(null),D=N.startLineNumber;D<N.endLineNumber;D++)for(var O=0,T=M.getLineWords(D,I);O<T.length;O++){var R=T[O];if(isNaN(Number(R.word))){var x=w[R.word];x||(x=[],w[R.word]=x),x.push({startLineNumber:D,startColumn:R.startColumn,endLineNumber:D,endColumn:R.endColumn})}}return Promise.resolve(w)},t.prototype.navigateValueSet=function(L,N,P,A,M){var I=this._getModel(L);if(!I)return Promise.resolve(null);var w=new RegExp(A,M);N.startColumn===N.endColumn&&(N={startLineNumber:N.startLineNumber,startColumn:N.startColumn,endLineNumber:N.endLineNumber,endColumn:N.endColumn+1});var D=I.getValueInRange(N),O=I.getWordAtPosition({lineNumber:N.startLineNumber,column:N.startColumn},w);if(!O)return Promise.resolve(null);var T=I.getValueInRange(O),R=F.BasicInplaceReplace.INSTANCE.navigateValueSet(N,D,O,T,P);return Promise.resolve(R)},t.prototype.loadForeignModule=function(N,P){var A=this,M={getMirrorModels:function(){return A._getModels()}};if(this._foreignModuleFactory){this._foreignModule=this._foreignModuleFactory(M,P);var I=[];for(var w in this._foreignModule)"function"==typeof this._foreignModule[w]&&I.push(w);return Promise.resolve(I)}return new Promise((function(I,w){L([N],(function(L){A._foreignModule=L.create(M,P);var N=[];for(var w in A._foreignModule)"function"==typeof A._foreignModule[w]&&N.push(w);I(N)}),w)}))},t.prototype.fmr=function(L,N){if(!this._foreignModule||"function"!=typeof this._foreignModule[L])return Promise.reject(new Error("Missing requestHandler or method: "+L));try{return Promise.resolve(this._foreignModule[L].apply(this._foreignModule,N))}catch(L){return Promise.reject(L)}},t._diffLimit=1e4,t._suggestionsLimit=1e4,t}();N.BaseEditorSimpleWorker=j;var K=function(L){function t(N){var P=L.call(this,N)||this;return P._models=Object.create(null),P}return w(t,L),t.prototype.dispose=function(){this._models=Object.create(null)},t.prototype._getModel=function(L){return this._models[L]},t.prototype._getModels=function(){var L=this,N=[];return Object.keys(this._models).forEach((function(P){return N.push(L._models[P])})),N},t.prototype.acceptNewModel=function(L){this._models[L.url]=new q(D.URI.parse(L.url),L.lines,L.EOL,L.versionId)},t.prototype.acceptModelChanged=function(L,N){this._models[L]&&this._models[L].onEvents(N)},t.prototype.acceptRemovedModel=function(L){this._models[L]&&delete this._models[L]},t}(j);N.EditorSimpleWorkerImpl=K,N.create=function(){return new K(null)},"function"==typeof importScripts&&(I.globals.monaco=W.createMonacoBaseAPI())})),function(){"use strict";var L=self.MonacoEnvironment,N=L&&L.baseUrl?L.baseUrl:"../../../";"function"==typeof self.define&&self.define.amd||importScripts(N+"vs/loader.js"),require.config({baseUrl:N,catchError:!0});var P=!0,A=[];self.onmessage=function(L){P?(P=!1,function(L){require([L],(function(L){setTimeout((function(){var N=L.create((function(L){self.postMessage(L)}),null);for(self.onmessage=function(L){return N.onmessage(L.data)};A.length>0;)self.onmessage(A.shift())}),0)}))}(L.data)):A.push(L)}}()}).call(this);