/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-css version: 2.3.0(a450f6054cbfb890c2ede882f6d2e47cc0e47f2f)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-css/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/css/workerManager",["require","exports"],(function(t,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0});var u=function(){function e(t){var r=this;this._defaults=t,this._worker=null,this._idleCheckInterval=setInterval((function(){return r._checkIfIdle()}),3e4),this._lastUsedTime=0,this._configChangeListener=this._defaults.onDidChange((function(){return r._stopWorker()}))}return e.prototype._stopWorker=function(){this._worker&&(this._worker.dispose(),this._worker=null),this._client=null},e.prototype.dispose=function(){clearInterval(this._idleCheckInterval),this._configChangeListener.dispose(),this._stopWorker()},e.prototype._checkIfIdle=function(){this._worker&&12e4<Date.now()-this._lastUsedTime&&this._stopWorker()},e.prototype._getClient=function(){return this._lastUsedTime=Date.now(),this._client||(this._worker=monaco.editor.createWebWorker({moduleId:"vs/language/css/cssWorker",label:this._defaults.languageId,createData:{languageSettings:this._defaults.diagnosticsOptions,languageId:this._defaults.languageId}}),this._client=this._worker.getProxy()),this._client},e.prototype.getLanguageServiceWorker=function(){for(var t,r=this,u=[],d=0;d<arguments.length;d++)u[d]=arguments[d];return this._getClient().then((function(r){t=r})).then((function(t){return r._worker.withSyncedResources(u)})).then((function(r){return t}))},e}();r.WorkerManager=u})),function(t){if("object"==typeof module&&"object"==typeof module.exports){var r=t(require,exports);void 0!==r&&(module.exports=r)}else"function"==typeof define&&define.amd&&define("vscode-languageserver-types/main",["require","exports"],t)}((function(t,r){"use strict";var u,d,l,f,m,p,h,v,y,b,C,_,k,x,I,w,S,D,K,E,T,A,M,R;Object.defineProperty(r,"__esModule",{value:!0}),(d=u=r.Position||(r.Position={})).create=function(t,r){return{line:t,character:r}},d.is=function(t){var r=t;return ue.objectLiteral(r)&&ue.number(r.line)&&ue.number(r.character)},(f=l=r.Range||(r.Range={})).create=function(t,r,d,l){if(ue.number(t)&&ue.number(r)&&ue.number(d)&&ue.number(l))return{start:u.create(t,r),end:u.create(d,l)};if(u.is(t)&&u.is(r))return{start:t,end:r};throw new Error("Range#create called with invalid arguments["+t+", "+r+", "+d+", "+l+"]")},f.is=function(t){var r=t;return ue.objectLiteral(r)&&u.is(r.start)&&u.is(r.end)},(p=m=r.Location||(r.Location={})).create=function(t,r){return{uri:t,range:r}},p.is=function(t){var r=t;return ue.defined(r)&&l.is(r.range)&&(ue.string(r.uri)||ue.undefined(r.uri))},(v=h=r.Color||(r.Color={})).create=function(t,r,u,d){return{red:t,green:r,blue:u,alpha:d}},v.is=function(t){var r=t;return ue.number(r.red)&&ue.number(r.green)&&ue.number(r.blue)&&ue.number(r.alpha)},(y=r.ColorInformation||(r.ColorInformation={})).create=function(t,r){return{range:t,color:r}},y.is=function(t){var r=t;return l.is(r.range)&&h.is(r.color)},(b=r.ColorPresentation||(r.ColorPresentation={})).create=function(t,r,u){return{label:t,textEdit:r,additionalTextEdits:u}},b.is=function(t){var r=t;return ue.string(r.label)&&(ue.undefined(r.textEdit)||E.is(r))&&(ue.undefined(r.additionalTextEdits)||ue.typedArray(r.additionalTextEdits,E.is))},(C=r.FoldingRangeKind||(r.FoldingRangeKind={})).Comment="comment",C.Imports="imports",C.Region="region",(_=r.FoldingRange||(r.FoldingRange={})).create=function(t,r,u,d,l){var f={startLine:t,endLine:r};return ue.defined(u)&&(f.startCharacter=u),ue.defined(d)&&(f.endCharacter=d),ue.defined(l)&&(f.kind=l),f},_.is=function(t){var r=t;return ue.number(r.startLine)&&ue.number(r.startLine)&&(ue.undefined(r.startCharacter)||ue.number(r.startCharacter))&&(ue.undefined(r.endCharacter)||ue.number(r.endCharacter))&&(ue.undefined(r.kind)||ue.string(r.kind))},(x=k=r.DiagnosticRelatedInformation||(r.DiagnosticRelatedInformation={})).create=function(t,r){return{location:t,message:r}},x.is=function(t){var r=t;return ue.defined(r)&&m.is(r.location)&&ue.string(r.message)},(I=r.DiagnosticSeverity||(r.DiagnosticSeverity={})).Error=1,I.Warning=2,I.Information=3,I.Hint=4,(S=w=r.Diagnostic||(r.Diagnostic={})).create=function(t,r,u,d,l,f){var m={range:t,message:r};return ue.defined(u)&&(m.severity=u),ue.defined(d)&&(m.code=d),ue.defined(l)&&(m.source=l),ue.defined(f)&&(m.relatedInformation=f),m},S.is=function(t){var r=t;return ue.defined(r)&&l.is(r.range)&&ue.string(r.message)&&(ue.number(r.severity)||ue.undefined(r.severity))&&(ue.number(r.code)||ue.string(r.code)||ue.undefined(r.code))&&(ue.string(r.source)||ue.undefined(r.source))&&(ue.undefined(r.relatedInformation)||ue.typedArray(r.relatedInformation,k.is))},(K=D=r.Command||(r.Command={})).create=function(t,r){for(var u=[],d=2;d<arguments.length;d++)u[d-2]=arguments[d];var l={title:t,command:r};return ue.defined(u)&&0<u.length&&(l.arguments=u),l},K.is=function(t){var r=t;return ue.defined(r)&&ue.string(r.title)&&ue.string(r.command)},(T=E=r.TextEdit||(r.TextEdit={})).replace=function(t,r){return{range:t,newText:r}},T.insert=function(t,r){return{range:{start:t,end:t},newText:r}},T.del=function(t){return{range:t,newText:""}},T.is=function(t){var r=t;return ue.objectLiteral(r)&&ue.string(r.newText)&&l.is(r.range)},(M=A=r.TextDocumentEdit||(r.TextDocumentEdit={})).create=function(t,r){return{textDocument:t,edits:r}},M.is=function(t){var r=t;return ue.defined(r)&&P.is(r.textDocument)&&Array.isArray(r.edits)},(R=r.WorkspaceEdit||(r.WorkspaceEdit={})).is=function(t){var r=t;return r&&(void 0!==r.changes||void 0!==r.documentChanges)&&(void 0===r.documentChanges||ue.typedArray(r.documentChanges,A.is))};var F,P,L,O,j,H,W,N,V,U,q,z,B,$,G=function(){function e(t){this.edits=t}return e.prototype.insert=function(t,r){this.edits.push(E.insert(t,r))},e.prototype.replace=function(t,r){this.edits.push(E.replace(t,r))},e.prototype.delete=function(t){this.edits.push(E.del(t))},e.prototype.add=function(t){this.edits.push(t)},e.prototype.all=function(){return this.edits},e.prototype.clear=function(){this.edits.splice(0,this.edits.length)},e}(),J=function(){function e(t){var r=this;this._textEditChanges=Object.create(null),t&&((this._workspaceEdit=t).documentChanges?t.documentChanges.forEach((function(t){var u=new G(t.edits);r._textEditChanges[t.textDocument.uri]=u})):t.changes&&Object.keys(t.changes).forEach((function(u){var d=new G(t.changes[u]);r._textEditChanges[u]=d})))}return Object.defineProperty(e.prototype,"edit",{get:function(){return this._workspaceEdit},enumerable:!0,configurable:!0}),e.prototype.getTextEditChange=function(t){if(P.is(t)){if(this._workspaceEdit||(this._workspaceEdit={documentChanges:[]}),!this._workspaceEdit.documentChanges)throw new Error("Workspace edit is not configured for versioned document changes.");var r=t;if(!(d=this._textEditChanges[r.uri])){var u={textDocument:r,edits:l=[]};this._workspaceEdit.documentChanges.push(u),d=new G(l),this._textEditChanges[r.uri]=d}return d}if(this._workspaceEdit||(this._workspaceEdit={changes:Object.create(null)}),!this._workspaceEdit.changes)throw new Error("Workspace edit is not configured for normal text edit changes.");var d;if(!(d=this._textEditChanges[t])){var l=[];this._workspaceEdit.changes[t]=l,d=new G(l),this._textEditChanges[t]=d}return d},e}();r.WorkspaceChange=J,(F=r.TextDocumentIdentifier||(r.TextDocumentIdentifier={})).create=function(t){return{uri:t}},F.is=function(t){var r=t;return ue.defined(r)&&ue.string(r.uri)},(L=P=r.VersionedTextDocumentIdentifier||(r.VersionedTextDocumentIdentifier={})).create=function(t,r){return{uri:t,version:r}},L.is=function(t){var r=t;return ue.defined(r)&&ue.string(r.uri)&&ue.number(r.version)},(O=r.TextDocumentItem||(r.TextDocumentItem={})).create=function(t,r,u,d){return{uri:t,languageId:r,version:u,text:d}},O.is=function(t){var r=t;return ue.defined(r)&&ue.string(r.uri)&&ue.string(r.languageId)&&ue.number(r.version)&&ue.string(r.text)},(H=j=r.MarkupKind||(r.MarkupKind={})).PlainText="plaintext",H.Markdown="markdown",(W=j=r.MarkupKind||(r.MarkupKind={})).is=function(t){var r=t;return r===W.PlainText||r===W.Markdown},(N=r.MarkupContent||(r.MarkupContent={})).is=function(t){var r=t;return ue.objectLiteral(t)&&j.is(r.kind)&&ue.string(r.value)},(V=r.CompletionItemKind||(r.CompletionItemKind={})).Text=1,V.Method=2,V.Function=3,V.Constructor=4,V.Field=5,V.Variable=6,V.Class=7,V.Interface=8,V.Module=9,V.Property=10,V.Unit=11,V.Value=12,V.Enum=13,V.Keyword=14,V.Snippet=15,V.Color=16,V.File=17,V.Reference=18,V.Folder=19,V.EnumMember=20,V.Constant=21,V.Struct=22,V.Event=23,V.Operator=24,V.TypeParameter=25,(U=r.InsertTextFormat||(r.InsertTextFormat={})).PlainText=1,U.Snippet=2,(r.CompletionItem||(r.CompletionItem={})).create=function(t){return{label:t}},(r.CompletionList||(r.CompletionList={})).create=function(t,r){return{items:t||[],isIncomplete:!!r}},(z=q=r.MarkedString||(r.MarkedString={})).fromPlainText=function(t){return t.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")},z.is=function(t){var r=t;return ue.string(r)||ue.objectLiteral(r)&&ue.string(r.language)&&ue.string(r.value)},(r.Hover||(r.Hover={})).is=function(t){var r=t;return ue.objectLiteral(r)&&(N.is(r.contents)||q.is(r.contents)||ue.typedArray(r.contents,q.is))&&(void 0===t.range||l.is(t.range))},(r.ParameterInformation||(r.ParameterInformation={})).create=function(t,r){return r?{label:t,documentation:r}:{label:t}},(r.SignatureInformation||(r.SignatureInformation={})).create=function(t,r){for(var u=[],d=2;d<arguments.length;d++)u[d-2]=arguments[d];var l={label:t};return ue.defined(r)&&(l.documentation=r),ue.defined(u)?l.parameters=u:l.parameters=[],l},(B=r.DocumentHighlightKind||(r.DocumentHighlightKind={})).Text=1,B.Read=2,B.Write=3,(r.DocumentHighlight||(r.DocumentHighlight={})).create=function(t,r){var u={range:t};return ue.number(r)&&(u.kind=r),u},($=r.SymbolKind||(r.SymbolKind={})).File=1,$.Module=2,$.Namespace=3,$.Package=4,$.Class=5,$.Method=6,$.Property=7,$.Field=8,$.Constructor=9,$.Enum=10,$.Interface=11,$.Function=12,$.Variable=13,$.Constant=14,$.String=15,$.Number=16,$.Boolean=17,$.Array=18,$.Object=19,$.Key=20,$.Null=21,$.EnumMember=22,$.Struct=23,$.Event=24,$.Operator=25,$.TypeParameter=26,(r.SymbolInformation||(r.SymbolInformation={})).create=function(t,r,u,d,l){var f={name:t,kind:r,location:{uri:d,range:u}};return l&&(f.containerName=l),f};var X,Z,ee,ne,te,re,Q=function(){};r.DocumentSymbol=Q,(X=Q=r.DocumentSymbol||(r.DocumentSymbol={})).create=function(t,r,u,d,l,f){var m={name:t,detail:r,kind:u,range:d,selectionRange:l};return void 0!==f&&(m.children=f),m},X.is=function(t){var r=t;return r&&ue.string(r.name)&&ue.string(r.detail)&&ue.number(r.kind)&&l.is(r.range)&&l.is(r.selectionRange)&&(void 0===r.deprecated||ue.boolean(r.deprecated))&&(void 0===r.children||Array.isArray(r.children))},r.DocumentSymbol=Q,(Z=r.CodeActionKind||(r.CodeActionKind={})).QuickFix="quickfix",Z.Refactor="refactor",Z.RefactorExtract="refactor.extract",Z.RefactorInline="refactor.inline",Z.RefactorRewrite="refactor.rewrite",Z.Source="source",Z.SourceOrganizeImports="source.organizeImports",(ee=r.CodeActionContext||(r.CodeActionContext={})).create=function(t,r){var u={diagnostics:t};return null!=r&&(u.only=r),u},ee.is=function(t){var r=t;return ue.defined(r)&&ue.typedArray(r.diagnostics,w.is)&&(void 0===r.only||ue.typedArray(r.only,ue.string))},(ne=r.CodeAction||(r.CodeAction={})).create=function(t,r,u){var d={title:t};return D.is(r)?d.command=r:d.edit=r,void 0!==u&&(d.kind=u),d},ne.is=function(t){var r=t;return r&&ue.string(r.title)&&(void 0===r.diagnostics||ue.typedArray(r.diagnostics,w.is))&&(void 0===r.kind||ue.string(r.kind))&&(void 0!==r.edit||void 0!==r.command)&&(void 0===r.command||D.is(r.command))&&(void 0===r.edit||R.is(r.edit))},(te=r.CodeLens||(r.CodeLens={})).create=function(t,r){var u={range:t};return ue.defined(r)&&(u.data=r),u},te.is=function(t){var r=t;return ue.defined(r)&&l.is(r.range)&&(ue.undefined(r.command)||D.is(r.command))},(re=r.FormattingOptions||(r.FormattingOptions={})).create=function(t,r){return{tabSize:t,insertSpaces:r}},re.is=function(t){var r=t;return ue.defined(r)&&ue.number(r.tabSize)&&ue.boolean(r.insertSpaces)};var ie,oe,ae,Y=function(){};r.DocumentLink=Y,(ie=Y=r.DocumentLink||(r.DocumentLink={})).create=function(t,r,u){return{range:t,target:r,data:u}},ie.is=function(t){var r=t;return ue.defined(r)&&l.is(r.range)&&(ue.undefined(r.target)||ue.string(r.target))},r.DocumentLink=Y,r.EOL=["\n","\r\n","\r"],(oe=r.TextDocument||(r.TextDocument={})).create=function(t,r,u,d){return new de(t,r,u,d)},oe.is=function(t){var r=t;return!!(ue.defined(r)&&ue.string(r.uri)&&(ue.undefined(r.languageId)||ue.string(r.languageId))&&ue.number(r.lineCount)&&ue.func(r.getText)&&ue.func(r.positionAt)&&ue.func(r.offsetAt))},oe.applyEdits=function(t,r){for(var u=t.getText(),d=function e(t,r){if(t.length<=1)return t;var u=t.length/2|0,d=t.slice(0,u),l=t.slice(u);e(d,r),e(l,r);for(var f=0,m=0,p=0;f<d.length&&m<l.length;){var h=r(d[f],l[m]);t[p++]=h<=0?d[f++]:l[m++]}for(;f<d.length;)t[p++]=d[f++];for(;m<l.length;)t[p++]=l[m++];return t}(r,(function(t,r){var u=t.range.start.line-r.range.start.line;return 0===u?t.range.start.character-r.range.start.character:u})),l=u.length,f=d.length-1;0<=f;f--){var m=d[f],p=t.offsetAt(m.range.start),h=t.offsetAt(m.range.end);if(!(h<=l))throw new Error("Ovelapping edit");u=u.substring(0,p)+m.newText+u.substring(h,u.length),l=p}return u},(ae=r.TextDocumentSaveReason||(r.TextDocumentSaveReason={})).Manual=1,ae.AfterDelay=2,ae.FocusOut=3;var ue,se,ce,de=function(){function e(t,r,u,d){this._uri=t,this._languageId=r,this._version=u,this._content=d,this._lineOffsets=null}return Object.defineProperty(e.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"version",{get:function(){return this._version},enumerable:!0,configurable:!0}),e.prototype.getText=function(t){if(t){var r=this.offsetAt(t.start),u=this.offsetAt(t.end);return this._content.substring(r,u)}return this._content},e.prototype.update=function(t,r){this._content=t.text,this._version=r,this._lineOffsets=null},e.prototype.getLineOffsets=function(){if(null===this._lineOffsets){for(var t=[],r=this._content,u=!0,d=0;d<r.length;d++){u&&(t.push(d),u=!1);var l=r.charAt(d);u="\r"===l||"\n"===l,"\r"===l&&d+1<r.length&&"\n"===r.charAt(d+1)&&d++}u&&0<r.length&&t.push(r.length),this._lineOffsets=t}return this._lineOffsets},e.prototype.positionAt=function(t){t=Math.max(Math.min(t,this._content.length),0);var r=this.getLineOffsets(),d=0,l=r.length;if(0===l)return u.create(0,t);for(;d<l;){var f=Math.floor((d+l)/2);r[f]>t?l=f:d=f+1}var m=d-1;return u.create(m,t-r[m])},e.prototype.offsetAt=function(t){var r=this.getLineOffsets();if(t.line>=r.length)return this._content.length;if(t.line<0)return 0;var u=r[t.line],d=t.line+1<r.length?r[t.line+1]:this._content.length;return Math.max(Math.min(u+t.character,d),u)},Object.defineProperty(e.prototype,"lineCount",{get:function(){return this.getLineOffsets().length},enumerable:!0,configurable:!0}),e}();se=ue||(ue={}),ce=Object.prototype.toString,se.defined=function(t){return void 0!==t},se.undefined=function(t){return void 0===t},se.boolean=function(t){return!0===t||!1===t},se.string=function(t){return"[object String]"===ce.call(t)},se.number=function(t){return"[object Number]"===ce.call(t)},se.func=function(t){return"[object Function]"===ce.call(t)},se.objectLiteral=function(t){return null!==t&&"object"==typeof t},se.typedArray=function(t,r){return Array.isArray(t)&&t.every(r)}})),define("vscode-languageserver-types",["vscode-languageserver-types/main"],(function(t){return t})),define("vs/language/css/languageFeatures",["require","exports","vscode-languageserver-types"],(function(t,r,u){"use strict";Object.defineProperty(r,"__esModule",{value:!0});var d=monaco.Uri,l=function(){function e(t,r,u){var d=this;this._languageId=t,this._worker=r,this._disposables=[],this._listener=Object.create(null);var i=function(t){var r,u=t.getModeId();u===d._languageId&&(d._listener[t.uri.toString()]=t.onDidChangeContent((function(){clearTimeout(r),r=setTimeout((function(){return d._doValidate(t.uri,u)}),500)})),d._doValidate(t.uri,u))},o=function(t){monaco.editor.setModelMarkers(t,d._languageId,[]);var r=t.uri.toString(),u=d._listener[r];u&&(u.dispose(),delete d._listener[r])};this._disposables.push(monaco.editor.onDidCreateModel(i)),this._disposables.push(monaco.editor.onWillDisposeModel(o)),this._disposables.push(monaco.editor.onDidChangeModelLanguage((function(t){o(t.model),i(t.model)}))),u.onDidChange((function(t){monaco.editor.getModels().forEach((function(t){t.getModeId()===d._languageId&&(o(t),i(t))}))})),this._disposables.push({dispose:function(){for(var t in d._listener)d._listener[t].dispose()}}),monaco.editor.getModels().forEach(i)}return e.prototype.dispose=function(){this._disposables.forEach((function(t){return t&&t.dispose()})),this._disposables=[]},e.prototype._doValidate=function(t,r){this._worker(t).then((function(r){return r.doValidation(t.toString())})).then((function(d){var l=d.map((function(t){return d="number"==typeof(r=t).code?String(r.code):r.code,{severity:function(t){switch(t){case u.DiagnosticSeverity.Error:return monaco.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return monaco.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return monaco.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return monaco.MarkerSeverity.Hint;default:return monaco.MarkerSeverity.Info}}(r.severity),startLineNumber:r.range.start.line+1,startColumn:r.range.start.character+1,endLineNumber:r.range.end.line+1,endColumn:r.range.end.character+1,message:r.message,code:d,source:r.source};var r,d})),f=monaco.editor.getModel(t);f.getModeId()===r&&monaco.editor.setModelMarkers(f,r,l)})).then(void 0,(function(t){console.error(t)}))},e}();function a(t){if(t)return{character:t.column-1,line:t.lineNumber-1}}function s(t){if(t)return new monaco.Range(t.start.line+1,t.start.character+1,t.end.line+1,t.end.character+1)}function c(t){if(t)return{range:s(t.range),text:t.newText}}r.DiagnosticsAdapter=l;var f=function(){function e(t){this._worker=t}return Object.defineProperty(e.prototype,"triggerCharacters",{get:function(){return[" ",":"]},enumerable:!0,configurable:!0}),e.prototype.provideCompletionItems=function(t,r,d,l){t.getWordUntilPosition(r);var f=t.uri;return this._worker(f).then((function(t){return t.doComplete(f.toString(),a(r))})).then((function(t){if(t){var r=t.items.map((function(t){var r={label:t.label,insertText:t.insertText||t.label,sortText:t.sortText,filterText:t.filterText,documentation:t.documentation,detail:t.detail,kind:function(t){var r=monaco.languages.CompletionItemKind;switch(t){case u.CompletionItemKind.Text:return r.Text;case u.CompletionItemKind.Method:return r.Method;case u.CompletionItemKind.Function:return r.Function;case u.CompletionItemKind.Constructor:return r.Constructor;case u.CompletionItemKind.Field:return r.Field;case u.CompletionItemKind.Variable:return r.Variable;case u.CompletionItemKind.Class:return r.Class;case u.CompletionItemKind.Interface:return r.Interface;case u.CompletionItemKind.Module:return r.Module;case u.CompletionItemKind.Property:return r.Property;case u.CompletionItemKind.Unit:return r.Unit;case u.CompletionItemKind.Value:return r.Value;case u.CompletionItemKind.Enum:return r.Enum;case u.CompletionItemKind.Keyword:return r.Keyword;case u.CompletionItemKind.Snippet:return r.Snippet;case u.CompletionItemKind.Color:return r.Color;case u.CompletionItemKind.File:return r.File;case u.CompletionItemKind.Reference:return r.Reference}return r.Property}(t.kind)};return t.textEdit&&(r.range=s(t.textEdit.range),r.insertText=t.textEdit.newText),t.additionalTextEdits&&(r.additionalTextEdits=t.additionalTextEdits.map(c)),t.insertTextFormat===u.InsertTextFormat.Snippet&&(r.insertTextRules=monaco.languages.CompletionItemInsertTextRule.InsertAsSnippet),r}));return{isIncomplete:t.isIncomplete,suggestions:r}}}))},e}();function i(t){return"string"==typeof t?{value:t}:(r=t)&&"object"==typeof r&&"string"==typeof r.kind?"plaintext"===t.kind?{value:t.value.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}:{value:t.value}:{value:"```"+t.language+"\n"+t.value+"\n```\n"};var r}r.CompletionAdapter=f;var m=function(){function e(t){this._worker=t}return e.prototype.provideHover=function(t,r,u){var d=t.uri;return this._worker(d).then((function(t){return t.doHover(d.toString(),a(r))})).then((function(t){if(t)return{range:s(t.range),contents:function(t){if(t)return Array.isArray(t)?t.map(i):[i(t)]}(t.contents)}}))},e}();r.HoverAdapter=m;var p=function(){function e(t){this._worker=t}return e.prototype.provideDocumentHighlights=function(t,r,d){var l=t.uri;return this._worker(l).then((function(t){return t.findDocumentHighlights(l.toString(),a(r))})).then((function(t){if(t)return t.map((function(t){return{range:s(t.range),kind:function(t){switch(t){case u.DocumentHighlightKind.Read:return monaco.languages.DocumentHighlightKind.Read;case u.DocumentHighlightKind.Write:return monaco.languages.DocumentHighlightKind.Write;case u.DocumentHighlightKind.Text:return monaco.languages.DocumentHighlightKind.Text}return monaco.languages.DocumentHighlightKind.Text}(t.kind)}}))}))},e}();function g(t){return{uri:d.parse(t.uri),range:s(t.range)}}r.DocumentHighlightAdapter=p;var h=function(){function e(t){this._worker=t}return e.prototype.provideDefinition=function(t,r,u){var d=t.uri;return this._worker(d).then((function(t){return t.findDefinition(d.toString(),a(r))})).then((function(t){if(t)return[g(t)]}))},e}();r.DefinitionAdapter=h;var v=function(){function e(t){this._worker=t}return e.prototype.provideReferences=function(t,r,u,d){var l=t.uri;return this._worker(l).then((function(t){return t.findReferences(l.toString(),a(r))})).then((function(t){if(t)return t.map(g)}))},e}();r.ReferenceAdapter=v;var y=function(){function e(t){this._worker=t}return e.prototype.provideRenameEdits=function(t,r,u,l){var f=t.uri;return this._worker(f).then((function(t){return t.doRename(f.toString(),a(r),u)})).then((function(t){return function(t){if(t&&t.changes){var r=[];for(var u in t.changes){for(var l=[],f=0,m=t.changes[u];f<m.length;f++){var p=m[f];l.push({range:s(p.range),text:p.newText})}r.push({resource:d.parse(u),edits:l})}return{edits:r}}}(t)}))},e}();r.RenameAdapter=y;var b=function(){function e(t){this._worker=t}return e.prototype.provideDocumentSymbols=function(t,r){var d=t.uri;return this._worker(d).then((function(t){return t.findDocumentSymbols(d.toString())})).then((function(t){if(t)return t.map((function(t){return{name:t.name,detail:"",containerName:t.containerName,kind:function(t){var r=monaco.languages.SymbolKind;switch(t){case u.SymbolKind.File:return r.Array;case u.SymbolKind.Module:return r.Module;case u.SymbolKind.Namespace:return r.Namespace;case u.SymbolKind.Package:return r.Package;case u.SymbolKind.Class:return r.Class;case u.SymbolKind.Method:return r.Method;case u.SymbolKind.Property:return r.Property;case u.SymbolKind.Field:return r.Field;case u.SymbolKind.Constructor:return r.Constructor;case u.SymbolKind.Enum:return r.Enum;case u.SymbolKind.Interface:return r.Interface;case u.SymbolKind.Function:return r.Function;case u.SymbolKind.Variable:return r.Variable;case u.SymbolKind.Constant:return r.Constant;case u.SymbolKind.String:return r.String;case u.SymbolKind.Number:return r.Number;case u.SymbolKind.Boolean:return r.Boolean;case u.SymbolKind.Array:return r.Array}return r.Function}(t.kind),range:s(t.location.range),selectionRange:s(t.location.range)}}))}))},e}();r.DocumentSymbolAdapter=b;var C=function(){function e(t){this._worker=t}return e.prototype.provideDocumentColors=function(t,r){var u=t.uri;return this._worker(u).then((function(t){return t.findDocumentColors(u.toString())})).then((function(t){if(t)return t.map((function(t){return{color:t.color,range:s(t.range)}}))}))},e.prototype.provideColorPresentations=function(t,r,u){var d=t.uri;return this._worker(d).then((function(t){return t.getColorPresentations(d.toString(),r.color,function(t){if(t)return{start:{line:t.startLineNumber-1,character:t.startColumn-1},end:{line:t.endLineNumber-1,character:t.endColumn-1}}}(r.range))})).then((function(t){if(t)return t.map((function(t){var r={label:t.label};return t.textEdit&&(r.textEdit=c(t.textEdit)),t.additionalTextEdits&&(r.additionalTextEdits=t.additionalTextEdits.map(c)),r}))}))},e}();r.DocumentColorAdapter=C;var _=function(){function e(t){this._worker=t}return e.prototype.provideFoldingRanges=function(t,r,d){var l=t.uri;return this._worker(l).then((function(t){return t.provideFoldingRanges(l.toString(),r)})).then((function(t){if(t)return t.map((function(t){var r={start:t.startLine+1,end:t.endLine+1};return void 0!==t.kind&&(r.kind=function(t){switch(t){case u.FoldingRangeKind.Comment:return monaco.languages.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return monaco.languages.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return monaco.languages.FoldingRangeKind.Region}}(t.kind)),r}))}))},e}();r.FoldingRangeAdapter=_})),define("vs/language/css/cssMode",["require","exports","./workerManager","./languageFeatures"],(function(t,r,u,d){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.setupMode=function(t){var r=new u.WorkerManager(t),n=function(t){for(var u=[],d=1;d<arguments.length;d++)u[d-1]=arguments[d];return r.getLanguageServiceWorker.apply(r,[t].concat(u))},l=t.languageId;monaco.languages.registerCompletionItemProvider(l,new d.CompletionAdapter(n)),monaco.languages.registerHoverProvider(l,new d.HoverAdapter(n)),monaco.languages.registerDocumentHighlightProvider(l,new d.DocumentHighlightAdapter(n)),monaco.languages.registerDefinitionProvider(l,new d.DefinitionAdapter(n)),monaco.languages.registerReferenceProvider(l,new d.ReferenceAdapter(n)),monaco.languages.registerDocumentSymbolProvider(l,new d.DocumentSymbolAdapter(n)),monaco.languages.registerRenameProvider(l,new d.RenameAdapter(n)),monaco.languages.registerColorProvider(l,new d.DocumentColorAdapter(n)),monaco.languages.registerFoldingRangeProvider(l,new d.FoldingRangeAdapter(n)),new d.DiagnosticsAdapter(l,n,t)}}));