/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-html version: 2.3.0(f3174dba95daa2ea3c8b4eb686ed4a8a23fd9751)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-html/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/html/workerManager",["require","exports"],(function(n,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0});var c=function(){function e(n){var r=this;this._defaults=n,this._worker=null,this._idleCheckInterval=setInterval((function(){return r._checkIfIdle()}),3e4),this._lastUsedTime=0,this._configChangeListener=this._defaults.onDidChange((function(){return r._stopWorker()}))}return e.prototype._stopWorker=function(){this._worker&&(this._worker.dispose(),this._worker=null),this._client=null},e.prototype.dispose=function(){clearInterval(this._idleCheckInterval),this._configChangeListener.dispose(),this._stopWorker()},e.prototype._checkIfIdle=function(){this._worker&&12e4<Date.now()-this._lastUsedTime&&this._stopWorker()},e.prototype._getClient=function(){return this._lastUsedTime=Date.now(),this._client||(this._worker=monaco.editor.createWebWorker({moduleId:"vs/language/html/htmlWorker",createData:{languageSettings:this._defaults.options,languageId:this._defaults.languageId},label:this._defaults.languageId}),this._client=this._worker.getProxy()),this._client},e.prototype.getLanguageServiceWorker=function(){for(var n,r=this,c=[],d=0;d<arguments.length;d++)c[d]=arguments[d];return this._getClient().then((function(r){n=r})).then((function(n){return r._worker.withSyncedResources(c)})).then((function(r){return n}))},e}();r.WorkerManager=c})),function(n){if("object"==typeof module&&"object"==typeof module.exports){var r=n(require,exports);void 0!==r&&(module.exports=r)}else"function"==typeof define&&define.amd&&define("vscode-languageserver-types/main",["require","exports"],n)}((function(n,r){"use strict";var c,d,g,f,m,h,p,v,y,b,_,C,k,x,I,w,D,E,T,S,M,F,K,R;Object.defineProperty(r,"__esModule",{value:!0}),(d=c=r.Position||(r.Position={})).create=function(n,r){return{line:n,character:r}},d.is=function(n){var r=n;return ue.objectLiteral(r)&&ue.number(r.line)&&ue.number(r.character)},(f=g=r.Range||(r.Range={})).create=function(n,r,d,g){if(ue.number(n)&&ue.number(r)&&ue.number(d)&&ue.number(g))return{start:c.create(n,r),end:c.create(d,g)};if(c.is(n)&&c.is(r))return{start:n,end:r};throw new Error("Range#create called with invalid arguments["+n+", "+r+", "+d+", "+g+"]")},f.is=function(n){var r=n;return ue.objectLiteral(r)&&c.is(r.start)&&c.is(r.end)},(h=m=r.Location||(r.Location={})).create=function(n,r){return{uri:n,range:r}},h.is=function(n){var r=n;return ue.defined(r)&&g.is(r.range)&&(ue.string(r.uri)||ue.undefined(r.uri))},(v=p=r.Color||(r.Color={})).create=function(n,r,c,d){return{red:n,green:r,blue:c,alpha:d}},v.is=function(n){var r=n;return ue.number(r.red)&&ue.number(r.green)&&ue.number(r.blue)&&ue.number(r.alpha)},(y=r.ColorInformation||(r.ColorInformation={})).create=function(n,r){return{range:n,color:r}},y.is=function(n){var r=n;return g.is(r.range)&&p.is(r.color)},(b=r.ColorPresentation||(r.ColorPresentation={})).create=function(n,r,c){return{label:n,textEdit:r,additionalTextEdits:c}},b.is=function(n){var r=n;return ue.string(r.label)&&(ue.undefined(r.textEdit)||S.is(r))&&(ue.undefined(r.additionalTextEdits)||ue.typedArray(r.additionalTextEdits,S.is))},(_=r.FoldingRangeKind||(r.FoldingRangeKind={})).Comment="comment",_.Imports="imports",_.Region="region",(C=r.FoldingRange||(r.FoldingRange={})).create=function(n,r,c,d,g){var f={startLine:n,endLine:r};return ue.defined(c)&&(f.startCharacter=c),ue.defined(d)&&(f.endCharacter=d),ue.defined(g)&&(f.kind=g),f},C.is=function(n){var r=n;return ue.number(r.startLine)&&ue.number(r.startLine)&&(ue.undefined(r.startCharacter)||ue.number(r.startCharacter))&&(ue.undefined(r.endCharacter)||ue.number(r.endCharacter))&&(ue.undefined(r.kind)||ue.string(r.kind))},(x=k=r.DiagnosticRelatedInformation||(r.DiagnosticRelatedInformation={})).create=function(n,r){return{location:n,message:r}},x.is=function(n){var r=n;return ue.defined(r)&&m.is(r.location)&&ue.string(r.message)},(I=r.DiagnosticSeverity||(r.DiagnosticSeverity={})).Error=1,I.Warning=2,I.Information=3,I.Hint=4,(D=w=r.Diagnostic||(r.Diagnostic={})).create=function(n,r,c,d,g,f){var m={range:n,message:r};return ue.defined(c)&&(m.severity=c),ue.defined(d)&&(m.code=d),ue.defined(g)&&(m.source=g),ue.defined(f)&&(m.relatedInformation=f),m},D.is=function(n){var r=n;return ue.defined(r)&&g.is(r.range)&&ue.string(r.message)&&(ue.number(r.severity)||ue.undefined(r.severity))&&(ue.number(r.code)||ue.string(r.code)||ue.undefined(r.code))&&(ue.string(r.source)||ue.undefined(r.source))&&(ue.undefined(r.relatedInformation)||ue.typedArray(r.relatedInformation,k.is))},(T=E=r.Command||(r.Command={})).create=function(n,r){for(var c=[],d=2;d<arguments.length;d++)c[d-2]=arguments[d];var g={title:n,command:r};return ue.defined(c)&&0<c.length&&(g.arguments=c),g},T.is=function(n){var r=n;return ue.defined(r)&&ue.string(r.title)&&ue.string(r.command)},(M=S=r.TextEdit||(r.TextEdit={})).replace=function(n,r){return{range:n,newText:r}},M.insert=function(n,r){return{range:{start:n,end:n},newText:r}},M.del=function(n){return{range:n,newText:""}},M.is=function(n){var r=n;return ue.objectLiteral(r)&&ue.string(r.newText)&&g.is(r.range)},(K=F=r.TextDocumentEdit||(r.TextDocumentEdit={})).create=function(n,r){return{textDocument:n,edits:r}},K.is=function(n){var r=n;return ue.defined(r)&&P.is(r.textDocument)&&Array.isArray(r.edits)},(R=r.WorkspaceEdit||(r.WorkspaceEdit={})).is=function(n){var r=n;return r&&(void 0!==r.changes||void 0!==r.documentChanges)&&(void 0===r.documentChanges||ue.typedArray(r.documentChanges,F.is))};var A,P,L,O,j,W,H,V,N,U,q,z,B,Q,G=function(){function e(n){this.edits=n}return e.prototype.insert=function(n,r){this.edits.push(S.insert(n,r))},e.prototype.replace=function(n,r){this.edits.push(S.replace(n,r))},e.prototype.delete=function(n){this.edits.push(S.del(n))},e.prototype.add=function(n){this.edits.push(n)},e.prototype.all=function(){return this.edits},e.prototype.clear=function(){this.edits.splice(0,this.edits.length)},e}(),J=function(){function e(n){var r=this;this._textEditChanges=Object.create(null),n&&((this._workspaceEdit=n).documentChanges?n.documentChanges.forEach((function(n){var c=new G(n.edits);r._textEditChanges[n.textDocument.uri]=c})):n.changes&&Object.keys(n.changes).forEach((function(c){var d=new G(n.changes[c]);r._textEditChanges[c]=d})))}return Object.defineProperty(e.prototype,"edit",{get:function(){return this._workspaceEdit},enumerable:!0,configurable:!0}),e.prototype.getTextEditChange=function(n){if(P.is(n)){if(this._workspaceEdit||(this._workspaceEdit={documentChanges:[]}),!this._workspaceEdit.documentChanges)throw new Error("Workspace edit is not configured for versioned document changes.");var r=n;if(!(d=this._textEditChanges[r.uri])){var c={textDocument:r,edits:g=[]};this._workspaceEdit.documentChanges.push(c),d=new G(g),this._textEditChanges[r.uri]=d}return d}if(this._workspaceEdit||(this._workspaceEdit={changes:Object.create(null)}),!this._workspaceEdit.changes)throw new Error("Workspace edit is not configured for normal text edit changes.");var d;if(!(d=this._textEditChanges[n])){var g=[];this._workspaceEdit.changes[n]=g,d=new G(g),this._textEditChanges[n]=d}return d},e}();r.WorkspaceChange=J,(A=r.TextDocumentIdentifier||(r.TextDocumentIdentifier={})).create=function(n){return{uri:n}},A.is=function(n){var r=n;return ue.defined(r)&&ue.string(r.uri)},(L=P=r.VersionedTextDocumentIdentifier||(r.VersionedTextDocumentIdentifier={})).create=function(n,r){return{uri:n,version:r}},L.is=function(n){var r=n;return ue.defined(r)&&ue.string(r.uri)&&ue.number(r.version)},(O=r.TextDocumentItem||(r.TextDocumentItem={})).create=function(n,r,c,d){return{uri:n,languageId:r,version:c,text:d}},O.is=function(n){var r=n;return ue.defined(r)&&ue.string(r.uri)&&ue.string(r.languageId)&&ue.number(r.version)&&ue.string(r.text)},(W=j=r.MarkupKind||(r.MarkupKind={})).PlainText="plaintext",W.Markdown="markdown",(H=j=r.MarkupKind||(r.MarkupKind={})).is=function(n){var r=n;return r===H.PlainText||r===H.Markdown},(V=r.MarkupContent||(r.MarkupContent={})).is=function(n){var r=n;return ue.objectLiteral(n)&&j.is(r.kind)&&ue.string(r.value)},(N=r.CompletionItemKind||(r.CompletionItemKind={})).Text=1,N.Method=2,N.Function=3,N.Constructor=4,N.Field=5,N.Variable=6,N.Class=7,N.Interface=8,N.Module=9,N.Property=10,N.Unit=11,N.Value=12,N.Enum=13,N.Keyword=14,N.Snippet=15,N.Color=16,N.File=17,N.Reference=18,N.Folder=19,N.EnumMember=20,N.Constant=21,N.Struct=22,N.Event=23,N.Operator=24,N.TypeParameter=25,(U=r.InsertTextFormat||(r.InsertTextFormat={})).PlainText=1,U.Snippet=2,(r.CompletionItem||(r.CompletionItem={})).create=function(n){return{label:n}},(r.CompletionList||(r.CompletionList={})).create=function(n,r){return{items:n||[],isIncomplete:!!r}},(z=q=r.MarkedString||(r.MarkedString={})).fromPlainText=function(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")},z.is=function(n){var r=n;return ue.string(r)||ue.objectLiteral(r)&&ue.string(r.language)&&ue.string(r.value)},(r.Hover||(r.Hover={})).is=function(n){var r=n;return ue.objectLiteral(r)&&(V.is(r.contents)||q.is(r.contents)||ue.typedArray(r.contents,q.is))&&(void 0===n.range||g.is(n.range))},(r.ParameterInformation||(r.ParameterInformation={})).create=function(n,r){return r?{label:n,documentation:r}:{label:n}},(r.SignatureInformation||(r.SignatureInformation={})).create=function(n,r){for(var c=[],d=2;d<arguments.length;d++)c[d-2]=arguments[d];var g={label:n};return ue.defined(r)&&(g.documentation=r),ue.defined(c)?g.parameters=c:g.parameters=[],g},(B=r.DocumentHighlightKind||(r.DocumentHighlightKind={})).Text=1,B.Read=2,B.Write=3,(r.DocumentHighlight||(r.DocumentHighlight={})).create=function(n,r){var c={range:n};return ue.number(r)&&(c.kind=r),c},(Q=r.SymbolKind||(r.SymbolKind={})).File=1,Q.Module=2,Q.Namespace=3,Q.Package=4,Q.Class=5,Q.Method=6,Q.Property=7,Q.Field=8,Q.Constructor=9,Q.Enum=10,Q.Interface=11,Q.Function=12,Q.Variable=13,Q.Constant=14,Q.String=15,Q.Number=16,Q.Boolean=17,Q.Array=18,Q.Object=19,Q.Key=20,Q.Null=21,Q.EnumMember=22,Q.Struct=23,Q.Event=24,Q.Operator=25,Q.TypeParameter=26,(r.SymbolInformation||(r.SymbolInformation={})).create=function(n,r,c,d,g){var f={name:n,kind:r,location:{uri:d,range:c}};return g&&(f.containerName=g),f};var X,Z,ee,te,ne,re,$=function(){};r.DocumentSymbol=$,(X=$=r.DocumentSymbol||(r.DocumentSymbol={})).create=function(n,r,c,d,g,f){var m={name:n,detail:r,kind:c,range:d,selectionRange:g};return void 0!==f&&(m.children=f),m},X.is=function(n){var r=n;return r&&ue.string(r.name)&&ue.string(r.detail)&&ue.number(r.kind)&&g.is(r.range)&&g.is(r.selectionRange)&&(void 0===r.deprecated||ue.boolean(r.deprecated))&&(void 0===r.children||Array.isArray(r.children))},r.DocumentSymbol=$,(Z=r.CodeActionKind||(r.CodeActionKind={})).QuickFix="quickfix",Z.Refactor="refactor",Z.RefactorExtract="refactor.extract",Z.RefactorInline="refactor.inline",Z.RefactorRewrite="refactor.rewrite",Z.Source="source",Z.SourceOrganizeImports="source.organizeImports",(ee=r.CodeActionContext||(r.CodeActionContext={})).create=function(n,r){var c={diagnostics:n};return null!=r&&(c.only=r),c},ee.is=function(n){var r=n;return ue.defined(r)&&ue.typedArray(r.diagnostics,w.is)&&(void 0===r.only||ue.typedArray(r.only,ue.string))},(te=r.CodeAction||(r.CodeAction={})).create=function(n,r,c){var d={title:n};return E.is(r)?d.command=r:d.edit=r,void 0!==c&&(d.kind=c),d},te.is=function(n){var r=n;return r&&ue.string(r.title)&&(void 0===r.diagnostics||ue.typedArray(r.diagnostics,w.is))&&(void 0===r.kind||ue.string(r.kind))&&(void 0!==r.edit||void 0!==r.command)&&(void 0===r.command||E.is(r.command))&&(void 0===r.edit||R.is(r.edit))},(ne=r.CodeLens||(r.CodeLens={})).create=function(n,r){var c={range:n};return ue.defined(r)&&(c.data=r),c},ne.is=function(n){var r=n;return ue.defined(r)&&g.is(r.range)&&(ue.undefined(r.command)||E.is(r.command))},(re=r.FormattingOptions||(r.FormattingOptions={})).create=function(n,r){return{tabSize:n,insertSpaces:r}},re.is=function(n){var r=n;return ue.defined(r)&&ue.number(r.tabSize)&&ue.boolean(r.insertSpaces)};var ie,oe,ae,Y=function(){};r.DocumentLink=Y,(ie=Y=r.DocumentLink||(r.DocumentLink={})).create=function(n,r,c){return{range:n,target:r,data:c}},ie.is=function(n){var r=n;return ue.defined(r)&&g.is(r.range)&&(ue.undefined(r.target)||ue.string(r.target))},r.DocumentLink=Y,r.EOL=["\n","\r\n","\r"],(oe=r.TextDocument||(r.TextDocument={})).create=function(n,r,c,d){return new de(n,r,c,d)},oe.is=function(n){var r=n;return!!(ue.defined(r)&&ue.string(r.uri)&&(ue.undefined(r.languageId)||ue.string(r.languageId))&&ue.number(r.lineCount)&&ue.func(r.getText)&&ue.func(r.positionAt)&&ue.func(r.offsetAt))},oe.applyEdits=function(n,r){for(var c=n.getText(),d=function e(n,r){if(n.length<=1)return n;var c=n.length/2|0,d=n.slice(0,c),g=n.slice(c);e(d,r),e(g,r);for(var f=0,m=0,h=0;f<d.length&&m<g.length;){var p=r(d[f],g[m]);n[h++]=p<=0?d[f++]:g[m++]}for(;f<d.length;)n[h++]=d[f++];for(;m<g.length;)n[h++]=g[m++];return n}(r,(function(n,r){var c=n.range.start.line-r.range.start.line;return 0===c?n.range.start.character-r.range.start.character:c})),g=c.length,f=d.length-1;0<=f;f--){var m=d[f],h=n.offsetAt(m.range.start),p=n.offsetAt(m.range.end);if(!(p<=g))throw new Error("Ovelapping edit");c=c.substring(0,h)+m.newText+c.substring(p,c.length),g=h}return c},(ae=r.TextDocumentSaveReason||(r.TextDocumentSaveReason={})).Manual=1,ae.AfterDelay=2,ae.FocusOut=3;var ue,se,ce,de=function(){function e(n,r,c,d){this._uri=n,this._languageId=r,this._version=c,this._content=d,this._lineOffsets=null}return Object.defineProperty(e.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"languageId",{get:function(){return this._languageId},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"version",{get:function(){return this._version},enumerable:!0,configurable:!0}),e.prototype.getText=function(n){if(n){var r=this.offsetAt(n.start),c=this.offsetAt(n.end);return this._content.substring(r,c)}return this._content},e.prototype.update=function(n,r){this._content=n.text,this._version=r,this._lineOffsets=null},e.prototype.getLineOffsets=function(){if(null===this._lineOffsets){for(var n=[],r=this._content,c=!0,d=0;d<r.length;d++){c&&(n.push(d),c=!1);var g=r.charAt(d);c="\r"===g||"\n"===g,"\r"===g&&d+1<r.length&&"\n"===r.charAt(d+1)&&d++}c&&0<r.length&&n.push(r.length),this._lineOffsets=n}return this._lineOffsets},e.prototype.positionAt=function(n){n=Math.max(Math.min(n,this._content.length),0);var r=this.getLineOffsets(),d=0,g=r.length;if(0===g)return c.create(0,n);for(;d<g;){var f=Math.floor((d+g)/2);r[f]>n?g=f:d=f+1}var m=d-1;return c.create(m,n-r[m])},e.prototype.offsetAt=function(n){var r=this.getLineOffsets();if(n.line>=r.length)return this._content.length;if(n.line<0)return 0;var c=r[n.line],d=n.line+1<r.length?r[n.line+1]:this._content.length;return Math.max(Math.min(c+n.character,d),c)},Object.defineProperty(e.prototype,"lineCount",{get:function(){return this.getLineOffsets().length},enumerable:!0,configurable:!0}),e}();se=ue||(ue={}),ce=Object.prototype.toString,se.defined=function(n){return void 0!==n},se.undefined=function(n){return void 0===n},se.boolean=function(n){return!0===n||!1===n},se.string=function(n){return"[object String]"===ce.call(n)},se.number=function(n){return"[object Number]"===ce.call(n)},se.func=function(n){return"[object Function]"===ce.call(n)},se.objectLiteral=function(n){return null!==n&&"object"==typeof n},se.typedArray=function(n,r){return Array.isArray(n)&&n.every(r)}})),define("vscode-languageserver-types",["vscode-languageserver-types/main"],(function(n){return n})),define("vs/language/html/languageFeatures",["require","exports","vscode-languageserver-types"],(function(n,r,c){"use strict";Object.defineProperty(r,"__esModule",{value:!0});var d=monaco.Range,g=function(){function e(n,r,c){var d=this;this._languageId=n,this._worker=r,this._disposables=[],this._listener=Object.create(null);var i=function(n){var r,c=n.getModeId();c===d._languageId&&(d._listener[n.uri.toString()]=n.onDidChangeContent((function(){clearTimeout(r),r=setTimeout((function(){return d._doValidate(n.uri,c)}),500)})),d._doValidate(n.uri,c))},o=function(n){monaco.editor.setModelMarkers(n,d._languageId,[]);var r=n.uri.toString(),c=d._listener[r];c&&(c.dispose(),delete d._listener[r])};this._disposables.push(monaco.editor.onDidCreateModel(i)),this._disposables.push(monaco.editor.onWillDisposeModel((function(n){o(n)}))),this._disposables.push(monaco.editor.onDidChangeModelLanguage((function(n){o(n.model),i(n.model)}))),this._disposables.push(c.onDidChange((function(n){monaco.editor.getModels().forEach((function(n){n.getModeId()===d._languageId&&(o(n),i(n))}))}))),this._disposables.push({dispose:function(){for(var n in d._listener)d._listener[n].dispose()}}),monaco.editor.getModels().forEach(i)}return e.prototype.dispose=function(){this._disposables.forEach((function(n){return n&&n.dispose()})),this._disposables=[]},e.prototype._doValidate=function(n,r){this._worker(n).then((function(d){return d.doValidation(n.toString()).then((function(d){var g=d.map((function(n){return d="number"==typeof(r=n).code?String(r.code):r.code,{severity:function(n){switch(n){case c.DiagnosticSeverity.Error:return monaco.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return monaco.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return monaco.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return monaco.MarkerSeverity.Hint;default:return monaco.MarkerSeverity.Info}}(r.severity),startLineNumber:r.range.start.line+1,startColumn:r.range.start.character+1,endLineNumber:r.range.end.line+1,endColumn:r.range.end.character+1,message:r.message,code:d,source:r.source};var r,d}));monaco.editor.setModelMarkers(monaco.editor.getModel(n),r,g)}))})).then(void 0,(function(n){console.error(n)}))},e}();function a(n){if(n)return{character:n.column-1,line:n.lineNumber-1}}function u(n){if(n)return new d(n.start.line+1,n.start.character+1,n.end.line+1,n.end.character+1)}function s(n){if(n)return{range:u(n.range),text:n.newText}}r.DiagnosticsAdapter=g;var f=function(){function e(n){this._worker=n}return Object.defineProperty(e.prototype,"triggerCharacters",{get:function(){return[".",":","<",'"',"=","/"]},enumerable:!0,configurable:!0}),e.prototype.provideCompletionItems=function(n,r,d,g){n.getWordUntilPosition(r);var f=n.uri;return this._worker(f).then((function(n){return n.doComplete(f.toString(),a(r))})).then((function(n){if(n){var r=n.items.map((function(n){var r={label:n.label,insertText:n.insertText||n.label,sortText:n.sortText,filterText:n.filterText,documentation:n.documentation,detail:n.detail,kind:function(n){var r=monaco.languages.CompletionItemKind;switch(n){case c.CompletionItemKind.Text:return r.Text;case c.CompletionItemKind.Method:return r.Method;case c.CompletionItemKind.Function:return r.Function;case c.CompletionItemKind.Constructor:return r.Constructor;case c.CompletionItemKind.Field:return r.Field;case c.CompletionItemKind.Variable:return r.Variable;case c.CompletionItemKind.Class:return r.Class;case c.CompletionItemKind.Interface:return r.Interface;case c.CompletionItemKind.Module:return r.Module;case c.CompletionItemKind.Property:return r.Property;case c.CompletionItemKind.Unit:return r.Unit;case c.CompletionItemKind.Value:return r.Value;case c.CompletionItemKind.Enum:return r.Enum;case c.CompletionItemKind.Keyword:return r.Keyword;case c.CompletionItemKind.Snippet:return r.Snippet;case c.CompletionItemKind.Color:return r.Color;case c.CompletionItemKind.File:return r.File;case c.CompletionItemKind.Reference:return r.Reference}return r.Property}(n.kind)};return n.textEdit&&(r.range=u(n.textEdit.range),r.insertText=n.textEdit.newText),n.additionalTextEdits&&(r.additionalTextEdits=n.additionalTextEdits.map(s)),n.insertTextFormat===c.InsertTextFormat.Snippet&&(r.insertTextRules=monaco.languages.CompletionItemInsertTextRule.InsertAsSnippet),r}));return{isIncomplete:n.isIncomplete,suggestions:r}}}))},e}();r.CompletionAdapter=f;var m=function(){function e(n){this._worker=n}return e.prototype.provideDocumentHighlights=function(n,r,d){var g=n.uri;return this._worker(g).then((function(n){return n.findDocumentHighlights(g.toString(),a(r))})).then((function(n){if(n)return n.map((function(n){return{range:u(n.range),kind:function(n){var r=monaco.languages.DocumentHighlightKind;switch(n){case c.DocumentHighlightKind.Read:return r.Read;case c.DocumentHighlightKind.Write:return r.Write;case c.DocumentHighlightKind.Text:return r.Text}return r.Text}(n.kind)}}))}))},e}();r.DocumentHighlightAdapter=m;var h=function(){function e(n){this._worker=n}return e.prototype.provideLinks=function(n,r){var c=n.uri;return this._worker(c).then((function(n){return n.findDocumentLinks(c.toString())})).then((function(n){if(n)return n.map((function(n){return{range:u(n.range),url:n.target}}))}))},e}();function l(n){return{tabSize:n.tabSize,insertSpaces:n.insertSpaces}}r.DocumentLinkAdapter=h;var p=function(){function e(n){this._worker=n}return e.prototype.provideDocumentFormattingEdits=function(n,r,c){var d=n.uri;return this._worker(d).then((function(n){return n.format(d.toString(),null,l(r)).then((function(n){if(n&&0!==n.length)return n.map(s)}))}))},e}();r.DocumentFormattingEditProvider=p;var v=function(){function e(n){this._worker=n}return e.prototype.provideDocumentRangeFormattingEdits=function(n,r,c,d){var g=n.uri;return this._worker(g).then((function(n){return n.format(g.toString(),function(n){if(n)return{start:a(n.getStartPosition()),end:a(n.getEndPosition())}}(r),l(c)).then((function(n){if(n&&0!==n.length)return n.map(s)}))}))},e}();r.DocumentRangeFormattingEditProvider=v;var y=function(){function e(n){this._worker=n}return e.prototype.provideFoldingRanges=function(n,r,d){var g=n.uri;return this._worker(g).then((function(n){return n.provideFoldingRanges(g.toString(),r)})).then((function(n){if(n)return n.map((function(n){var r={start:n.startLine+1,end:n.endLine+1};return void 0!==n.kind&&(r.kind=function(n){switch(n){case c.FoldingRangeKind.Comment:return monaco.languages.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return monaco.languages.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return monaco.languages.FoldingRangeKind.Region}}(n.kind)),r}))}))},e}();r.FoldingRangeAdapter=y})),define("vs/language/html/htmlMode",["require","exports","./workerManager","./languageFeatures"],(function(n,r,c,d){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.setupMode=function(n){var r=new c.WorkerManager(n),t=function(){for(var n=[],c=0;c<arguments.length;c++)n[c]=arguments[c];return r.getLanguageServiceWorker.apply(r,n)},g=n.languageId;monaco.languages.registerCompletionItemProvider(g,new d.CompletionAdapter(t)),monaco.languages.registerDocumentHighlightProvider(g,new d.DocumentHighlightAdapter(t)),monaco.languages.registerLinkProvider(g,new d.DocumentLinkAdapter(t)),monaco.languages.registerFoldingRangeProvider(g,new d.FoldingRangeAdapter(t)),"html"===g&&(monaco.languages.registerDocumentFormattingEditProvider(g,new d.DocumentFormattingEditProvider(t)),monaco.languages.registerDocumentRangeFormattingEditProvider(g,new d.DocumentRangeFormattingEditProvider(t)),new d.DiagnosticsAdapter(g,t,n))}}));