/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-typescript version: 3.3.1(dbbf69725062a240258a04596d6bd8544365ac91)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-typescript/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/typescript/workerManager",["require","exports"],(function(o,l){"use strict";Object.defineProperty(l,"__esModule",{value:!0});var p=function(){function e(o,l){var p=this;this._modeId=o,this._defaults=l,this._worker=null,this._idleCheckInterval=setInterval((function(){return p._checkIfIdle()}),3e4),this._lastUsedTime=0,this._configChangeListener=this._defaults.onDidChange((function(){return p._stopWorker()}))}return e.prototype._stopWorker=function(){this._worker&&(this._worker.dispose(),this._worker=null),this._client=null},e.prototype.dispose=function(){clearInterval(this._idleCheckInterval),this._configChangeListener.dispose(),this._stopWorker()},e.prototype._checkIfIdle=function(){if(this._worker){var o=this._defaults.getWorkerMaxIdleTime(),l=Date.now()-this._lastUsedTime;0<o&&o<l&&this._stopWorker()}},e.prototype._getClient=function(){var o=this;if(this._lastUsedTime=Date.now(),!this._client){this._worker=monaco.editor.createWebWorker({moduleId:"vs/language/typescript/tsWorker",label:this._modeId,createData:{compilerOptions:this._defaults.getCompilerOptions(),extraLibs:this._defaults.getExtraLibs()}});var l=this._worker.getProxy();this._defaults.getEagerModelSync()&&(l=l.then((function(l){return o._worker.withSyncedResources(monaco.editor.getModels().filter((function(l){return l.getModeId()===o._modeId})).map((function(o){return o.uri})))}))),this._client=l}return this._client},e.prototype.getLanguageServiceWorker=function(){for(var o,l=this,p=[],g=0;g<arguments.length;g++)p[g]=arguments[g];return this._getClient().then((function(l){o=l})).then((function(o){return l._worker.withSyncedResources(p)})).then((function(l){return o}))},e}();l.WorkerManager=p}));var __extends=this&&this.__extends||function(){var r=function(o,l){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(o,l){o.__proto__=l}||function(o,l){for(var p in l)l.hasOwnProperty(p)&&(o[p]=l[p])})(o,l)};return function(o,l){function n(){this.constructor=o}r(o,l),o.prototype=null===l?Object.create(l):(n.prototype=l.prototype,new n)}}();define("vs/language/typescript/languageFeatures",["require","exports"],(function(o,l){"use strict";Object.defineProperty(l,"__esModule",{value:!0});var p,g,m=monaco.Uri,f=monaco.Promise;function c(o){return o?o.map((function(o){return o.text})).join(""):""}(g=p||(p={}))[g.None=0]="None",g[g.Block=1]="Block",g[g.Smart=2]="Smart";var d=function(){function e(o){this._worker=o}return e.prototype._positionToOffset=function(o,l){return monaco.editor.getModel(o).getOffsetAt(l)},e.prototype._offsetToPosition=function(o,l){return monaco.editor.getModel(o).getPositionAt(l)},e.prototype._textSpanToRange=function(o,l){var p=this._offsetToPosition(o,l.start),g=this._offsetToPosition(o,l.start+l.length);return{startLineNumber:p.lineNumber,startColumn:p.column,endLineNumber:g.lineNumber,endColumn:g.column}},e}(),h=function(o){function e(l,p,g){var m=o.call(this,g)||this;m._defaults=l,m._selector=p,m._disposables=[],m._listener=Object.create(null);var i=function(o){if(o.getModeId()===p){var l,g=o.onDidChangeContent((function(){clearTimeout(l),l=setTimeout((function(){return m._doValidate(o.uri)}),500)}));m._listener[o.uri.toString()]={dispose:function(){g.dispose(),clearTimeout(l)}},m._doValidate(o.uri)}},a=function(o){monaco.editor.setModelMarkers(o,m._selector,[]);var l=o.uri.toString();m._listener[l]&&(m._listener[l].dispose(),delete m._listener[l])};return m._disposables.push(monaco.editor.onDidCreateModel(i)),m._disposables.push(monaco.editor.onWillDisposeModel(a)),m._disposables.push(monaco.editor.onDidChangeModelLanguage((function(o){a(o.model),i(o.model)}))),m._disposables.push({dispose:function(){for(var o=0,l=monaco.editor.getModels();o<l.length;o++){var p=l[o];a(p)}}}),m._disposables.push(m._defaults.onDidChange((function(){for(var o=0,l=monaco.editor.getModels();o<l.length;o++){var p=l[o];a(p),i(p)}}))),monaco.editor.getModels().forEach(i),m}return __extends(e,o),e.prototype.dispose=function(){this._disposables.forEach((function(o){return o&&o.dispose()})),this._disposables=[]},e.prototype._doValidate=function(o){var l=this;this._worker(o).then((function(p){if(!monaco.editor.getModel(o))return null;var g=[],m=l._defaults.getDiagnosticsOptions(),d=m.noSyntaxValidation,h=m.noSemanticValidation;return d||g.push(p.getSyntacticDiagnostics(o.toString())),h||g.push(p.getSemanticDiagnostics(o.toString())),f.join(g)})).then((function(p){if(!p||!monaco.editor.getModel(o))return null;var g=p.reduce((function(o,l){return l.concat(o)}),[]).map((function(p){return l._convertDiagnostics(o,p)}));monaco.editor.setModelMarkers(monaco.editor.getModel(o),l._selector,g)})).then(void 0,(function(o){console.error(o)}))},e.prototype._convertDiagnostics=function(o,l){var p=this._offsetToPosition(o,l.start),g=p.lineNumber,m=p.column,f=this._offsetToPosition(o,l.start+l.length),d=f.lineNumber,h=f.column;return{severity:monaco.MarkerSeverity.Error,startLineNumber:g,startColumn:m,endLineNumber:d,endColumn:h,message:function(o,l){if("string"==typeof o)return o;for(var p=o,g="",m=0;p;){if(m){g+="\n";for(var f=0;f<m;f++)g+="  "}g+=p.messageText,m++,p=p.next}return g}(l.messageText)}},e}(l.Adapter=d);l.DiagnostcsAdapter=h;var _=function(o){function u(){return null!==o&&o.apply(this,arguments)||this}return __extends(u,o),Object.defineProperty(u.prototype,"triggerCharacters",{get:function(){return["."]},enumerable:!0,configurable:!0}),u.prototype.provideCompletionItems=function(o,l,p,g){o.getWordUntilPosition(l);var m=o.uri,f=this._positionToOffset(m,l);return this._worker(m).then((function(o){return o.getCompletionsAtPosition(m.toString(),f)})).then((function(o){if(o)return{suggestions:o.entries.map((function(o){return{uri:m,position:l,label:o.name,insertText:o.name,sortText:o.sortText,kind:u.convertKind(o.kind)}}))}}))},u.prototype.resolveCompletionItem=function(o,l,p,g){var m=this,f=p,d=f.uri,h=f.position;return this._worker(d).then((function(o){return o.getCompletionEntryDetails(d.toString(),m._positionToOffset(d,h),f.label)})).then((function(o){return o?{uri:d,position:h,label:o.name,kind:u.convertKind(o.kind),detail:c(o.displayParts),documentation:{value:c(o.documentation)}}:f}))},u.convertKind=function(o){switch(o){case x.primitiveType:case x.keyword:return monaco.languages.CompletionItemKind.Keyword;case x.variable:case x.localVariable:return monaco.languages.CompletionItemKind.Variable;case x.memberVariable:case x.memberGetAccessor:case x.memberSetAccessor:return monaco.languages.CompletionItemKind.Field;case x.function:case x.memberFunction:case x.constructSignature:case x.callSignature:case x.indexSignature:return monaco.languages.CompletionItemKind.Function;case x.enum:return monaco.languages.CompletionItemKind.Enum;case x.module:return monaco.languages.CompletionItemKind.Module;case x.class:return monaco.languages.CompletionItemKind.Class;case x.interface:return monaco.languages.CompletionItemKind.Interface;case x.warning:return monaco.languages.CompletionItemKind.File}return monaco.languages.CompletionItemKind.Property},u}(d);l.SuggestAdapter=_;var v=function(o){function e(){var l=null!==o&&o.apply(this,arguments)||this;return l.signatureHelpTriggerCharacters=["(",","],l}return __extends(e,o),e.prototype.provideSignatureHelp=function(o,l,p){var g=this,m=o.uri;return this._worker(m).then((function(o){return o.getSignatureHelpItems(m.toString(),g._positionToOffset(m,l))})).then((function(o){if(o){var l={activeSignature:o.selectedItemIndex,activeParameter:o.argumentIndex,signatures:[]};return o.items.forEach((function(o){var p={label:"",documentation:null,parameters:[]};p.label+=c(o.prefixDisplayParts),o.parameters.forEach((function(l,g,m){var f=c(l.displayParts),d={label:f,documentation:c(l.documentation)};p.label+=f,p.parameters.push(d),g<m.length-1&&(p.label+=c(o.separatorDisplayParts))})),p.label+=c(o.suffixDisplayParts),l.signatures.push(p)})),l}}))},e}(d);l.SignatureHelpAdapter=v;var y=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return __extends(t,o),t.prototype.provideHover=function(o,l,p){var g=this,m=o.uri;return this._worker(m).then((function(o){return o.getQuickInfoAtPosition(m.toString(),g._positionToOffset(m,l))})).then((function(o){if(o){var l=c(o.documentation),p=o.tags?o.tags.map((function(o){var l="*@"+o.name+"*";return o.text?l+(o.text.match(/\r\n|\n/g)?" \n"+o.text:" - "+o.text):l})).join("  \n\n"):"",f=c(o.displayParts);return{range:g._textSpanToRange(m,o.textSpan),contents:[{value:"```js\n"+f+"\n```\n"},{value:l+(p?"\n\n"+p:"")}]}}}))},t}(d);l.QuickInfoAdapter=y;var S=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return __extends(t,o),t.prototype.provideDocumentHighlights=function(o,l,p){var g=this,m=o.uri;return this._worker(m).then((function(o){return o.getOccurrencesAtPosition(m.toString(),g._positionToOffset(m,l))})).then((function(o){if(o)return o.map((function(o){return{range:g._textSpanToRange(m,o.textSpan),kind:o.isWriteAccess?monaco.languages.DocumentHighlightKind.Write:monaco.languages.DocumentHighlightKind.Text}}))}))},t}(d);l.OccurrencesAdapter=S;var b=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return __extends(t,o),t.prototype.provideDefinition=function(o,l,p){var g=this,f=o.uri;return this._worker(f).then((function(o){return o.getDefinitionAtPosition(f.toString(),g._positionToOffset(f,l))})).then((function(o){if(o){for(var l=[],p=0,f=o;p<f.length;p++){var d=f[p],h=m.parse(d.fileName);monaco.editor.getModel(h)&&l.push({uri:h,range:g._textSpanToRange(h,d.textSpan)})}return l}}))},t}(d);l.DefinitionAdapter=b;var k=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return __extends(t,o),t.prototype.provideReferences=function(o,l,p,g){var f=this,d=o.uri;return this._worker(d).then((function(o){return o.getReferencesAtPosition(d.toString(),f._positionToOffset(d,l))})).then((function(o){if(o){for(var l=[],p=0,g=o;p<g.length;p++){var d=g[p],h=m.parse(d.fileName);monaco.editor.getModel(h)&&l.push({uri:h,range:f._textSpanToRange(h,d.textSpan)})}return l}}))},t}(d);l.ReferenceAdapter=k;var w=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return __extends(t,o),t.prototype.provideDocumentSymbols=function(o,l){var p=this,g=o.uri;return this._worker(g).then((function(o){return o.getNavigationBarItems(g.toString())})).then((function(o){if(o){var s=function(o,l,m){var f={name:l.text,detail:"",kind:T[l.kind]||monaco.languages.SymbolKind.Variable,range:p._textSpanToRange(g,l.spans[0]),selectionRange:p._textSpanToRange(g,l.spans[0]),containerName:m};if(l.childItems&&0<l.childItems.length)for(var d=0,h=l.childItems;d<h.length;d++){var _=h[d];s(o,_,f.name)}o.push(f)},l=[];return o.forEach((function(o){return s(l,o)})),l}}))},t}(d);l.OutlineAdapter=w;var x=function(){function e(){}return e.unknown="",e.keyword="keyword",e.script="script",e.module="module",e.class="class",e.interface="interface",e.type="type",e.enum="enum",e.variable="var",e.localVariable="local var",e.function="function",e.localFunction="local function",e.memberFunction="method",e.memberGetAccessor="getter",e.memberSetAccessor="setter",e.memberVariable="property",e.constructorImplementation="constructor",e.callSignature="call",e.indexSignature="index",e.constructSignature="construct",e.parameter="parameter",e.typeParameter="type parameter",e.primitiveType="primitive type",e.label="label",e.alias="alias",e.const="const",e.let="let",e.warning="warning",e}();l.Kind=x;var T=Object.create(null);T[x.module]=monaco.languages.SymbolKind.Module,T[x.class]=monaco.languages.SymbolKind.Class,T[x.enum]=monaco.languages.SymbolKind.Enum,T[x.interface]=monaco.languages.SymbolKind.Interface,T[x.memberFunction]=monaco.languages.SymbolKind.Method,T[x.memberVariable]=monaco.languages.SymbolKind.Property,T[x.memberGetAccessor]=monaco.languages.SymbolKind.Property,T[x.memberSetAccessor]=monaco.languages.SymbolKind.Property,T[x.variable]=monaco.languages.SymbolKind.Variable,T[x.const]=monaco.languages.SymbolKind.Variable,T[x.localVariable]=monaco.languages.SymbolKind.Variable,T[x.variable]=monaco.languages.SymbolKind.Variable,T[x.function]=monaco.languages.SymbolKind.Function,T[x.localFunction]=monaco.languages.SymbolKind.Function;var I=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return __extends(t,o),t._convertOptions=function(o){return{ConvertTabsToSpaces:o.insertSpaces,TabSize:o.tabSize,IndentSize:o.tabSize,IndentStyle:p.Smart,NewLineCharacter:"\n",InsertSpaceAfterCommaDelimiter:!0,InsertSpaceAfterSemicolonInForStatements:!0,InsertSpaceBeforeAndAfterBinaryOperators:!0,InsertSpaceAfterKeywordsInControlFlowStatements:!0,InsertSpaceAfterFunctionKeywordForAnonymousFunctions:!0,InsertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis:!1,InsertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets:!1,InsertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces:!1,PlaceOpenBraceOnNewLineForControlBlocks:!1,PlaceOpenBraceOnNewLineForFunctions:!1}},t.prototype._convertTextChanges=function(o,l){return{text:l.newText,range:this._textSpanToRange(o,l.span)}},t}(d),A=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return __extends(t,o),t.prototype.provideDocumentRangeFormattingEdits=function(o,l,p,g){var m=this,f=o.uri;return this._worker(f).then((function(o){return o.getFormattingEditsForRange(f.toString(),m._positionToOffset(f,{lineNumber:l.startLineNumber,column:l.startColumn}),m._positionToOffset(f,{lineNumber:l.endLineNumber,column:l.endColumn}),I._convertOptions(p))})).then((function(o){if(o)return o.map((function(o){return m._convertTextChanges(f,o)}))}))},t}(l.FormatHelper=I);l.FormatAdapter=A;var C=function(o){function t(){return null!==o&&o.apply(this,arguments)||this}return __extends(t,o),Object.defineProperty(t.prototype,"autoFormatTriggerCharacters",{get:function(){return[";","}","\n"]},enumerable:!0,configurable:!0}),t.prototype.provideOnTypeFormattingEdits=function(o,l,p,g,m){var f=this,d=o.uri;return this._worker(d).then((function(o){return o.getFormattingEditsAfterKeystroke(d.toString(),f._positionToOffset(d,l),p,I._convertOptions(g))})).then((function(o){if(o)return o.map((function(o){return f._convertTextChanges(d,o)}))}))},t}(I);l.FormatOnTypeAdapter=C})),define("vs/language/typescript/tsMode",["require","exports","./workerManager","./languageFeatures"],(function(o,l,p,g){"use strict";var m,f;function a(o,l){var m=new p.WorkerManager(l,o),n=function(o){for(var l=[],p=1;p<arguments.length;p++)l[p-1]=arguments[p];return m.getLanguageServiceWorker.apply(m,[o].concat(l))};return monaco.languages.registerCompletionItemProvider(l,new g.SuggestAdapter(n)),monaco.languages.registerSignatureHelpProvider(l,new g.SignatureHelpAdapter(n)),monaco.languages.registerHoverProvider(l,new g.QuickInfoAdapter(n)),monaco.languages.registerDocumentHighlightProvider(l,new g.OccurrencesAdapter(n)),monaco.languages.registerDefinitionProvider(l,new g.DefinitionAdapter(n)),monaco.languages.registerReferenceProvider(l,new g.ReferenceAdapter(n)),monaco.languages.registerDocumentSymbolProvider(l,new g.OutlineAdapter(n)),monaco.languages.registerDocumentRangeFormattingEditProvider(l,new g.FormatAdapter(n)),monaco.languages.registerOnTypeFormattingEditProvider(l,new g.FormatOnTypeAdapter(n)),new g.DiagnostcsAdapter(o,l,n),n}Object.defineProperty(l,"__esModule",{value:!0}),l.setupTypeScript=function(o){f=a(o,"typescript")},l.setupJavaScript=function(o){m=a(o,"javascript")},l.getJavaScriptWorker=function(){return new monaco.Promise((function(o,l){if(!m)return l("JavaScript not registered!");o(m)}))},l.getTypeScriptWorker=function(){return new monaco.Promise((function(o,l){if(!f)return l("TypeScript not registered!");o(f)}))}}));