/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.15.5(3d42593a5844407ab71d47b348ea3a8de5fec848)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
"use strict";var define,AMDLoader,_amdLoaderGlobal=this,_commonjsGlobal="object"==typeof global?global:{};!function(d){d.global=_amdLoaderGlobal;var l=function(){function t(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(t.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!0,configurable:!0}),t.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode="undefined"!=typeof module&&!!module.exports,this._isElectronRenderer="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type,this._isWebWorker="function"==typeof d.global.importScripts)},t._isWindows=function(){return!!("undefined"!=typeof navigator&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0)||"undefined"!=typeof process&&"win32"===process.platform},t}();d.Environment=l}(AMDLoader||(AMDLoader={})),function(d){var t=function(d,l,a){this.type=d,this.detail=l,this.timestamp=a};d.LoaderEvent=t;var l=function(){function r(d){this._events=[new t(1,"",d)]}return r.prototype.record=function(l,a){this._events.push(new t(l,a,d.Utilities.getHighPerformanceTimestamp()))},r.prototype.getEvents=function(){return this._events},r}();d.LoaderEventRecorder=l;var a=function(){function e(){}return e.prototype.record=function(d,l){},e.prototype.getEvents=function(){return[]},e}();a.INSTANCE=new a,d.NullLoaderEventRecorder=a}(AMDLoader||(AMDLoader={})),function(d){var l=function(){function t(){}return t.fileUriToFilePath=function(d,l){if(l=decodeURI(l).replace(/%23/g,"#"),d){if(/^file:\/\/\//.test(l))return l.substr(8);if(/^file:\/\//.test(l))return l.substr(5)}else if(/^file:\/\//.test(l))return l.substr(7);return l},t.startsWith=function(d,l){return d.length>=l.length&&d.substr(0,l.length)===l},t.endsWith=function(d,l){return d.length>=l.length&&d.substr(d.length-l.length)===l},t.containsQueryString=function(d){return/^[^\#]*\?/gi.test(d)},t.isAbsolutePath=function(d){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(d)},t.forEachProperty=function(d,l){if(d){var a=void 0;for(a in d)d.hasOwnProperty(a)&&l(a,d[a])}},t.isEmpty=function(d){var l=!0;return t.forEachProperty(d,(function(){l=!1})),l},t.recursiveClone=function(d){if(!d||"object"!=typeof d)return d;var l=Array.isArray(d)?[]:{};return t.forEachProperty(d,(function(d,a){l[d]=a&&"object"==typeof a?t.recursiveClone(a):a})),l},t.generateAnonymousModule=function(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="},t.isAnonymousModule=function(d){return t.startsWith(d,"===anonymous")},t.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=d.global.performance&&"function"==typeof d.global.performance.now),this.HAS_PERFORMANCE_NOW?d.global.performance.now():Date.now()},t}();l.NEXT_ANONYMOUS_ID=1,l.PERFORMANCE_NOW_PROBED=!1,l.HAS_PERFORMANCE_NOW=!1,d.Utilities=l}(AMDLoader||(AMDLoader={})),function(d){var l=function(){function t(){}return t.validateConfigurationOptions=function(l){return"string"!=typeof(l=l||{}).baseUrl&&(l.baseUrl=""),"boolean"!=typeof l.isBuild&&(l.isBuild=!1),"object"!=typeof l.paths&&(l.paths={}),"object"!=typeof l.config&&(l.config={}),void 0===l.catchError&&(l.catchError=!1),"string"!=typeof l.urlArgs&&(l.urlArgs=""),"function"!=typeof l.onError&&(l.onError=function r(d){return"load"===d.errorCode?(console.error('Loading "'+d.moduleId+'" failed'),console.error("Detail: ",d.detail),d.detail&&d.detail.stack&&console.error(d.detail.stack),console.error("Here are the modules that depend on it:"),void console.error(d.neededBy)):"factory"===d.errorCode?(console.error('The factory method of "'+d.moduleId+'" has thrown an exception'),console.error(d.detail),void(d.detail&&d.detail.stack&&console.error(d.detail.stack))):void 0}),"object"==typeof l.ignoreDuplicateModules&&Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(d.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),"string"!=typeof l.cspNonce&&(l.cspNonce=""),Array.isArray(l.nodeModules)||(l.nodeModules=[]),("number"!=typeof l.nodeCachedDataWriteDelay||l.nodeCachedDataWriteDelay<0)&&(l.nodeCachedDataWriteDelay=7e3),"function"!=typeof l.onNodeCachedData&&(l.onNodeCachedData=function(d,l){d&&("cachedDataRejected"===d.errorCode?console.warn("Rejected cached data from file: "+d.path):"unlink"===d.errorCode||"writeFile"===d.errorCode?(console.error("Problems writing cached data file: "+d.path),console.error(d.detail)):console.error(d))}),l},t.mergeConfigurationOptions=function(l,a){void 0===l&&(l=null),void 0===a&&(a=null);var u=d.Utilities.recursiveClone(a||{});return d.Utilities.forEachProperty(l,(function(l,a){"ignoreDuplicateModules"===l&&void 0!==u.ignoreDuplicateModules?u.ignoreDuplicateModules=u.ignoreDuplicateModules.concat(a):"paths"===l&&void 0!==u.paths?d.Utilities.forEachProperty(a,(function(d,l){return u.paths[d]=l})):"config"===l&&void 0!==u.config?d.Utilities.forEachProperty(a,(function(d,l){return u.config[d]=l})):u[l]=d.Utilities.recursiveClone(a)})),t.validateConfigurationOptions(u)},t}();d.ConfigurationOptionsUtil=l;var a=function(){function r(d,a){if(this._env=d,this.options=l.mergeConfigurationOptions(a),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),""===this.options.baseUrl){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var u=this.options.nodeRequire.main.filename,c=Math.max(u.lastIndexOf("/"),u.lastIndexOf("\\"));this.options.baseUrl=u.substring(0,c+1)}if(this.options.nodeMain&&this._env.isNode){u=this.options.nodeMain,c=Math.max(u.lastIndexOf("/"),u.lastIndexOf("\\"));this.options.baseUrl=u.substring(0,c+1)}}}return r.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var d=0;d<this.options.ignoreDuplicateModules.length;d++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[d]]=!0},r.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var d=0,l=this.options.nodeModules;d<l.length;d++){var a=l[d];this.nodeModulesMap[a]=!0}},r.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],d.Utilities.forEachProperty(this.options.paths,(function(d,a){Array.isArray(a)?l.sortedPathsRules.push({from:d,to:a}):l.sortedPathsRules.push({from:d,to:[a]})})),this.sortedPathsRules.sort((function(d,l){return l.from.length-d.from.length}))},r.prototype.cloneAndMerge=function(d){return new r(this._env,l.mergeConfigurationOptions(d,this.options))},r.prototype.getOptionsLiteral=function(){return this.options},r.prototype._applyPaths=function(l){for(var a,u=0,c=this.sortedPathsRules.length;u<c;u++)if(a=this.sortedPathsRules[u],d.Utilities.startsWith(l,a.from)){for(var h=[],p=0,_=a.to.length;p<_;p++)h.push(a.to[p]+l.substr(a.from.length));return h}return[l]},r.prototype._addUrlArgsToUrl=function(l){return d.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},r.prototype._addUrlArgsIfNecessaryToUrl=function(d){return this.options.urlArgs?this._addUrlArgsToUrl(d):d},r.prototype._addUrlArgsIfNecessaryToUrls=function(d){if(this.options.urlArgs)for(var l=0,a=d.length;l<a;l++)d[l]=this._addUrlArgsToUrl(d[l]);return d},r.prototype.moduleIdToPaths=function(l){if(!0===this.nodeModulesMap[l])return this.isBuild()?["empty:"]:["node|"+l];var a,u=l;if(d.Utilities.endsWith(u,".js")||d.Utilities.isAbsolutePath(u))d.Utilities.endsWith(u,".js")||d.Utilities.containsQueryString(u)||(u+=".js"),a=[u];else for(var c=0,h=(a=this._applyPaths(u)).length;c<h;c++)this.isBuild()&&"empty:"===a[c]||(d.Utilities.isAbsolutePath(a[c])||(a[c]=this.options.baseUrl+a[c]),d.Utilities.endsWith(a[c],".js")||d.Utilities.containsQueryString(a[c])||(a[c]=a[c]+".js"));return this._addUrlArgsIfNecessaryToUrls(a)},r.prototype.requireToUrl=function(l){var a=l;return d.Utilities.isAbsolutePath(a)||(a=this._applyPaths(a)[0],d.Utilities.isAbsolutePath(a)||(a=this.options.baseUrl+a)),this._addUrlArgsIfNecessaryToUrl(a)},r.prototype.isBuild=function(){return this.options.isBuild},r.prototype.isDuplicateMessageIgnoredFor=function(d){return this.ignoreDuplicateModulesMap.hasOwnProperty(d)},r.prototype.getConfigForModule=function(d){if(this.options.config)return this.options.config[d]},r.prototype.shouldCatchError=function(){return this.options.catchError},r.prototype.shouldRecordStats=function(){return this.options.recordStats},r.prototype.onError=function(d){this.options.onError(d)},r}();d.Configuration=a}(AMDLoader||(AMDLoader={})),function(d){var l=function(){function e(d){this._env=d,this._scriptLoader=null,this._callbackMap={}}return e.prototype.load=function(d,l,h,p){var _=this;this._scriptLoader||(this._scriptLoader=this._env.isWebWorker?new u:this._env.isNode?new c(this._env):new a);var g={callback:h,errorback:p};this._callbackMap.hasOwnProperty(l)?this._callbackMap[l].push(g):(this._callbackMap[l]=[g],this._scriptLoader.load(d,l,(function(){return _.triggerCallback(l)}),(function(d){return _.triggerErrorback(l,d)})))},e.prototype.triggerCallback=function(d){var l=this._callbackMap[d];delete this._callbackMap[d];for(var a=0;a<l.length;a++)l[a].callback()},e.prototype.triggerErrorback=function(d,l){var a=this._callbackMap[d];delete this._callbackMap[d];for(var u=0;u<a.length;u++)a[u].errorback(l)},e}(),a=function(){function e(){}return e.prototype.attachListeners=function(d,l,a){var n=function(){d.removeEventListener("load",o),d.removeEventListener("error",i)},o=function(d){n(),l()},i=function(d){n(),a(d)};d.addEventListener("load",o),d.addEventListener("error",i)},e.prototype.load=function(d,l,a,u){var c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript"),this.attachListeners(c,a,u),c.setAttribute("src",l);var h=d.getConfig().getOptionsLiteral().cspNonce;h&&c.setAttribute("nonce",h),document.getElementsByTagName("head")[0].appendChild(c)},e}(),u=function(){function e(){}return e.prototype.load=function(d,l,a,u){try{importScripts(l),a()}catch(d){u(d)}},e}(),c=function(){function t(d){this._env=d,this._didInitialize=!1,this._didPatchNodeRequire=!1}return t.prototype._init=function(d){if(!this._didInitialize){this._didInitialize=!0,this._fs=d("fs"),this._vm=d("vm"),this._path=d("path"),this._crypto=d("crypto"),this._jsflags="";for(var l=0,a=process.argv;l<a.length;l++){var u=a[l];if(0===u.indexOf("--js-flags=")){this._jsflags=u;break}}}},t.prototype._initNodeRequire=function(d,l){var a=l.getConfig().getOptionsLiteral().nodeCachedDataDir;if(a&&!this._didPatchNodeRequire){this._didPatchNodeRequire=!0;var u=this,c=d("module");c.prototype._compile=function(d,h){d=d.replace(/^#!.*/,"");var p=c.wrap(d),_=u._getCachedDataPath(a,h),g={filename:h};try{g.cachedData=u._fs.readFileSync(_)}catch(d){g.produceCachedData=!0}var v=new u._vm.Script(p,g),y=v.runInThisContext(g),m=u._path.dirname(h),M=function(d){var l=d.constructor,r=function(l){try{return d.require(l)}finally{}};return r.resolve=function(a){return l._resolveFilename(a,d)},r.main=process.mainModule,r.extensions=l._extensions,r.cache=l._cache,r}(this),D=[this.exports,M,this,h,m,process,_commonjsGlobal,Buffer],b=y.apply(this.exports,D);return u._processCachedData(l,v,_),b}}},t.prototype.load=function(l,a,u,c){var h=this,p=l.getConfig().getOptionsLiteral(),_=p.nodeRequire||d.global.nodeRequire,g=p.nodeInstrumenter||function(d){return d};this._init(_),this._initNodeRequire(_,l);var v=l.getRecorder();if(/^node\|/.test(a)){var y=a.split("|"),m=null;try{m=_(y[1])}catch(d){return void c(d)}l.enqueueDefineAnonymousModule([],(function(){return m})),u()}else a=d.Utilities.fileUriToFilePath(this._env.isWindows,a),this._fs.readFile(a,{encoding:"utf8"},(function(d,_){if(d)c(d);else{var y=h._path.normalize(a),m=y;if(h._env.isElectronRenderer){var M=m.match(/^([a-z])\:(.*)/i);m=M?"file:///"+(M[1].toUpperCase()+":"+M[2]).replace(/\\/g,"/"):"file://"+m}var D,b="(function (require, define, __filename, __dirname) { ";if(D=_.charCodeAt(0)===t._BOM?b+_.substring(1)+"\n});":b+_+"\n});",D=g(D,y),p.nodeCachedDataDir){var I=h._getCachedDataPath(p.nodeCachedDataDir,a);h._fs.readFile(I,(function(d,p){var _={filename:m,produceCachedData:void 0===p,cachedData:p},g=h._loadAndEvalScript(l,a,m,D,_,v,u,c);h._processCachedData(l,g,I)}))}else h._loadAndEvalScript(l,a,m,D,{filename:m},v,u,c)}}))},t.prototype._loadAndEvalScript=function(l,a,u,c,h,p,_,g){p.record(31,a);var v=new this._vm.Script(c,h),y=v.runInThisContext(h),m=l.getGlobalAMDDefineFunc(),M=!1,f=function(){return M=!0,m.apply(null,arguments)};return f.amd=m.amd,y.call(d.global,l.getGlobalAMDRequireFunc(),f,u,this._path.dirname(a)),p.record(32,a),M?_():g(new Error("Didn't receive define call in "+a+"!")),v},t.prototype._getCachedDataPath=function(d,l){var a=this._crypto.createHash("md5").update(l,"utf8").update(this._jsflags,"utf8").digest("hex"),u=this._path.basename(l).replace(/\.js$/,"");return this._path.join(d,u+"-"+a+".code")},t.prototype._processCachedData=function(d,l,a){var u=this;l.cachedDataRejected?(d.getConfig().getOptionsLiteral().onNodeCachedData({errorCode:"cachedDataRejected",path:a}),t._runSoon((function(){return u._fs.unlink(a,(function(l){l&&d.getConfig().getOptionsLiteral().onNodeCachedData({errorCode:"unlink",path:a,detail:l})}))}),d.getConfig().getOptionsLiteral().nodeCachedDataWriteDelay)):l.cachedDataProduced&&(d.getConfig().getOptionsLiteral().onNodeCachedData(void 0,{path:a,length:l.cachedData.length}),t._runSoon((function(){return u._fs.writeFile(a,l.cachedData,(function(l){l&&d.getConfig().getOptionsLiteral().onNodeCachedData({errorCode:"writeFile",path:a,detail:l})}))}),d.getConfig().getOptionsLiteral().nodeCachedDataWriteDelay))},t._runSoon=function(d,l){var a=l+Math.ceil(Math.random()*l);setTimeout(d,a)},t}();c._BOM=65279,d.createScriptLoader=function(d){return new l(d)}}(AMDLoader||(AMDLoader={})),function(d){var l=function(){function t(d){var l=d.lastIndexOf("/");this.fromModulePath=-1!==l?d.substr(0,l+1):""}return t._normalizeModuleId=function(d){var l,a=d;for(l=/\/\.\//;l.test(a);)a=a.replace(l,"/");for(a=a.replace(/^\.\//g,""),l=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;l.test(a);)a=a.replace(l,"/");return a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,"")},t.prototype.resolveModule=function(l){var a=l;return d.Utilities.isAbsolutePath(a)||(d.Utilities.startsWith(a,"./")||d.Utilities.startsWith(a,"../"))&&(a=t._normalizeModuleId(this.fromModulePath+a)),a},t}();l.ROOT=new l(""),d.ModuleIdResolver=l;var a=function(){function t(d,l,a,u,c,h){this.id=d,this.strId=l,this.dependencies=a,this._callback=u,this._errorback=c,this.moduleIdResolver=h,this.exports={},this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return t._safeInvokeFunction=function(l,a){try{return{returnedValue:l.apply(d.global,a),producedError:null}}catch(d){return{returnedValue:null,producedError:d}}},t._invokeFactory=function(l,a,u,c){return l.isBuild()&&!d.Utilities.isAnonymousModule(a)?{returnedValue:null,producedError:null}:l.shouldCatchError()?this._safeInvokeFunction(u,c):{returnedValue:u.apply(d.global,c),producedError:null}},t.prototype.complete=function(l,a,u){this._isComplete=!0;var c=null;if(this._callback)if("function"==typeof this._callback){l.record(21,this.strId);var h=t._invokeFactory(a,this.strId,this._callback,u);c=h.producedError,l.record(22,this.strId),c||void 0===h.returnedValue||this.exportsPassedIn&&!d.Utilities.isEmpty(this.exports)||(this.exports=h.returnedValue)}else this.exports=this._callback;c&&a.onError({errorCode:"factory",moduleId:this.strId,detail:c}),this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},t.prototype.onDependencyError=function(d){return!!this._errorback&&(this._errorback(d),!0)},t.prototype.isComplete=function(){return this._isComplete},t}();d.Module=a;var u=function(){function e(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return e.prototype.getMaxModuleId=function(){return this._nextId},e.prototype.getModuleId=function(d){var l=this._strModuleIdToIntModuleId.get(d);return void 0===l&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(d,l),this._intModuleIdToStrModuleId[l]=d),l},e.prototype.getStrModuleId=function(d){return this._intModuleIdToStrModuleId[d]},e}(),o=function(d){this.id=d};o.EXPORTS=new o(0),o.MODULE=new o(1),o.REQUIRE=new o(2),d.RegularDependency=o;var i=function(d,l,a){this.id=d,this.pluginId=l,this.pluginParam=a};d.PluginDependency=i;var c=function(){function s(l,a,c,h,p){void 0===p&&(p=0),this._env=l,this._scriptLoader=a,this._loaderAvailableTimestamp=p,this._defineFunc=c,this._requireFunc=h,this._moduleIdProvider=new u,this._config=new d.Configuration(this._env),this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return s.prototype.reset=function(){return new s(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},s.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},s.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},s._findRelevantLocationInStack=function(d,l){for(var r=function(d){return d.replace(/\\/g,"/")},a=r(d),u=l.split(/\n/),c=0;c<u.length;c++){var h=u[c].match(/(.*):(\d+):(\d+)\)?$/);if(h){var p=h[1],_=h[2],g=h[3],v=Math.max(p.lastIndexOf(" ")+1,p.lastIndexOf("(")+1);if((p=r(p=p.substr(v)))===a){var y={line:parseInt(_,10),col:parseInt(g,10)};return 1===y.line&&(y.col-="(function (require, define, __filename, __dirname) { ".length),y}}}throw new Error("Could not correlate define call site for needle "+d)},s.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var d=[],l=0,a=0,u=this._modules2.length;a<u;a++){var c=this._modules2[a];if(c){var h=this._buildInfoPath[c.id]||null,p=this._buildInfoDefineStack[c.id]||null,_=this._buildInfoDependencies[c.id];d[l++]={id:c.strId,path:h,defineLocation:h&&p?s._findRelevantLocationInStack(h,p):null,dependencies:_,shim:null,exports:c.exports}}}return d},s.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new d.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=d.NullLoaderEventRecorder.INSTANCE),this._recorder},s.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},s.prototype.enqueueDefineAnonymousModule=function(d,l){if(null!==this._currentAnnonymousDefineCall)throw new Error("Can only have one anonymous define call per script file");var a=null;this._config.isBuild()&&(a=new Error("StackLocation").stack),this._currentAnnonymousDefineCall={stack:a,dependencies:d,callback:l}},s.prototype.defineModule=function(d,u,c,h,p,_){var g=this;void 0===_&&(_=new l(d));var v=this._moduleIdProvider.getModuleId(d);if(this._modules2[v])this._config.isDuplicateMessageIgnoredFor(d)||console.warn("Duplicate definition of module '"+d+"'");else{var y=new a(v,d,this._normalizeDependencies(u,_),c,h,_);this._modules2[v]=y,this._config.isBuild()&&(this._buildInfoDefineStack[v]=p,this._buildInfoDependencies[v]=y.dependencies.map((function(d){return g._moduleIdProvider.getStrModuleId(d.id)}))),this._resolve(y)}},s.prototype._normalizeDependency=function(d,l){if("exports"===d)return o.EXPORTS;if("module"===d)return o.MODULE;if("require"===d)return o.REQUIRE;var a=d.indexOf("!");if(a>=0){var u=l.resolveModule(d.substr(0,a)),c=l.resolveModule(d.substr(a+1)),h=this._moduleIdProvider.getModuleId(u+"!"+c),p=this._moduleIdProvider.getModuleId(u);return new i(h,p,c)}return new o(this._moduleIdProvider.getModuleId(l.resolveModule(d)))},s.prototype._normalizeDependencies=function(d,l){for(var a=[],u=0,c=0,h=d.length;c<h;c++)a[u++]=this._normalizeDependency(d[c],l);return a},s.prototype._relativeRequire=function(l,a,u,c){if("string"==typeof a)return this.synchronousRequire(a,l);this.defineModule(d.Utilities.generateAnonymousModule(),a,u,c,null,l)},s.prototype.synchronousRequire=function(d,a){void 0===a&&(a=new l(d));var u=this._normalizeDependency(d,a),c=this._modules2[u.id];if(!c)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+d+"'. This is the first mention of this module!");if(!c.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+d+"'. This module has not been resolved completely yet.");return c.exports},s.prototype.configure=function(l,a){var u=this._config.shouldRecordStats();this._config=a?new d.Configuration(this._env,l):this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!u&&(this._recorder=null)},s.prototype.getConfig=function(){return this._config},s.prototype._onLoad=function(d){if(null!==this._currentAnnonymousDefineCall){var l=this._currentAnnonymousDefineCall;this._currentAnnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(d),l.dependencies,l.callback,null,l.stack)}},s.prototype._createLoadError=function(d,l){var a=this;return{errorCode:"load",moduleId:this._moduleIdProvider.getStrModuleId(d),neededBy:(this._inverseDependencies2[d]||[]).map((function(d){return a._moduleIdProvider.getStrModuleId(d)})),detail:l}},s.prototype._onLoadError=function(d,l){for(var a=this._createLoadError(d,l),u=[],c=0,h=this._moduleIdProvider.getMaxModuleId();c<h;c++)u[c]=!1;var p=!1,_=[];for(_.push(d),u[d]=!0;_.length>0;){var g=_.shift(),v=this._modules2[g];v&&(p=v.onDependencyError(a)||p);var y=this._inverseDependencies2[g];if(y)for(c=0,h=y.length;c<h;c++){var m=y[c];u[m]||(_.push(m),u[m]=!0)}}p||this._config.onError(a)},s.prototype._hasDependencyPath=function(d,l){var a=this._modules2[d];if(!a)return!1;for(var u=[],c=0,h=this._moduleIdProvider.getMaxModuleId();c<h;c++)u[c]=!1;var p=[];for(p.push(a),u[d]=!0;p.length>0;){var _=p.shift().dependencies;if(_)for(c=0,h=_.length;c<h;c++){var g=_[c];if(g.id===l)return!0;var v=this._modules2[g.id];v&&!u[g.id]&&(u[g.id]=!0,p.push(v))}}return!1},s.prototype._findCyclePath=function(d,l,a){if(d===l||50===a)return[d];var u=this._modules2[d];if(!u)return null;for(var c=u.dependencies,h=0,p=c.length;h<p;h++){var _=this._findCyclePath(c[h].id,l,a+1);if(null!==_)return _.push(d),_}return null},s.prototype._createRequire=function(l){var a=this,n=function(d,u,c){return a._relativeRequire(l,d,u,c)};return n.toUrl=function(d){return a._config.requireToUrl(l.resolveModule(d))},n.getStats=function(){return a.getLoaderEvents()},n.__$__nodeRequire=d.global.nodeRequire,n},s.prototype._loadModule=function(d){var l=this;if(!this._modules2[d]&&!this._knownModules2[d]){this._knownModules2[d]=!0;var a=this._moduleIdProvider.getStrModuleId(d),u=this._config.moduleIdToPaths(a);this._env.isNode&&(-1===a.indexOf("/")||/^@[^\/]+\/[^\/]+$/.test(a))&&u.push("node|"+a);var c=-1,i=function(a){if(++c>=u.length)l._onLoadError(d,a);else{var h=u[c],p=l.getRecorder();if(l._config.isBuild()&&"empty:"===h)return l._buildInfoPath[d]=h,l.defineModule(l._moduleIdProvider.getStrModuleId(d),[],null,null,null),void l._onLoad(d);p.record(10,h),l._scriptLoader.load(l,h,(function(){l._config.isBuild()&&(l._buildInfoPath[d]=h),p.record(11,h),l._onLoad(d)}),(function(d){p.record(12,h),i(d)}))}};i(null)}},s.prototype._loadPluginDependency=function(d,a){var u=this;if(!this._modules2[a.id]&&!this._knownModules2[a.id]){this._knownModules2[a.id]=!0;var o=function(d){u.defineModule(u._moduleIdProvider.getStrModuleId(a.id),[],d,null,null)};o.error=function(d){u._config.onError(u._createLoadError(a.id,d))},d.load(a.pluginParam,this._createRequire(l.ROOT),o,this._config.getOptionsLiteral())}},s.prototype._resolve=function(d){for(var l=this,a=d.dependencies,u=0,c=a.length;u<c;u++){var h=a[u];if(h!==o.EXPORTS)if(h!==o.MODULE)if(h!==o.REQUIRE){var p=this._modules2[h.id];if(p&&p.isComplete())d.unresolvedDependenciesCount--;else if(this._hasDependencyPath(h.id,d.id)){console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(d.id)+"'. The cyclic path follows:");var _=this._findCyclePath(h.id,d.id,0);_.reverse(),_.push(h.id),console.warn(_.map((function(d){return l._moduleIdProvider.getStrModuleId(d)})).join(" => \n")),d.unresolvedDependenciesCount--}else if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(d.id),h instanceof i){var g=this._modules2[h.pluginId];if(g&&g.isComplete()){this._loadPluginDependency(g.exports,h);continue}var v=this._inversePluginDependencies2.get(h.pluginId);v||(v=[],this._inversePluginDependencies2.set(h.pluginId,v)),v.push(h),this._loadModule(h.pluginId)}else this._loadModule(h.id)}else d.unresolvedDependenciesCount--;else d.unresolvedDependenciesCount--;else d.exportsPassedIn=!0,d.unresolvedDependenciesCount--}0===d.unresolvedDependenciesCount&&this._onModuleComplete(d)},s.prototype._onModuleComplete=function(d){var l=this,a=this.getRecorder();if(!d.isComplete()){for(var u=d.dependencies,c=[],h=0,p=u.length;h<p;h++){var _=u[h];if(_!==o.EXPORTS)if(_!==o.MODULE)if(_!==o.REQUIRE){var g=this._modules2[_.id];c[h]=g?g.exports:null}else c[h]=this._createRequire(d.moduleIdResolver);else c[h]={id:d.strId,config:function(){return l._config.getConfigForModule(d.strId)}};else c[h]=d.exports}d.complete(a,this._config,c);var v=this._inverseDependencies2[d.id];if(this._inverseDependencies2[d.id]=null,v)for(h=0,p=v.length;h<p;h++){var y=v[h],m=this._modules2[y];m.unresolvedDependenciesCount--,0===m.unresolvedDependenciesCount&&this._onModuleComplete(m)}var M=this._inversePluginDependencies2.get(d.id);if(M){this._inversePluginDependencies2.delete(d.id);for(h=0,p=M.length;h<p;h++)this._loadPluginDependency(d.exports,M[h])}}},s}();d.ModuleManager=c}(AMDLoader||(AMDLoader={})),function(d){function t(){if(void 0!==d.global.require||"undefined"!=typeof require){var u=d.global.require||require;if("function"==typeof u&&"function"==typeof u.resolve){var i=function(d){a.getRecorder().record(33,d);try{return u(d)}finally{a.getRecorder().record(34,d)}};d.global.nodeRequire=i,s.nodeRequire=i,s.__$__nodeRequire=i}}l.isNode&&!l.isElectronRenderer?(module.exports=s,require=s):(l.isElectronRenderer||(d.global.define=o),d.global.require=s)}var l=new d.Environment,a=null,o=function(d,l,u){"string"!=typeof d&&(u=l,l=d,d=null),"object"==typeof l&&Array.isArray(l)||(u=l,l=null),l||(l=["require","exports","module"]),d?a.defineModule(d,l,u,null,null):a.enqueueDefineAnonymousModule(l,u)};o.amd={jQuery:!0};var i=function(d,l){void 0===l&&(l=!1),a.configure(d,l)},s=function(){if(1===arguments.length){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0]))return void i(arguments[0]);if("string"==typeof arguments[0])return a.synchronousRequire(arguments[0])}if(2!==arguments.length&&3!==arguments.length||!Array.isArray(arguments[0]))throw new Error("Unrecognized require call");a.defineModule(d.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null)};s.config=i,s.getConfig=function(){return a.getConfig().getOptionsLiteral()},s.reset=function(){a=a.reset()},s.getBuildInfo=function(){return a.getBuildInfo()},s.getStats=function(){return a.getLoaderEvents()},s.define=function(){return o.apply(null,arguments)},d.init=t,"function"==typeof d.global.define&&d.global.define.amd||(a=new d.ModuleManager(l,d.createScriptLoader(l),o,s,d.Utilities.getHighPerformanceTimestamp()),void 0!==d.global.require&&"function"!=typeof d.global.require&&s.config(d.global.require),(define=function(){return o.apply(null,arguments)}).amd=o.amd,"undefined"==typeof doNotInitLoader&&t())}(AMDLoader||(AMDLoader={}));