define(["exports"],(function(t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.scopeCss=void 0;
/**
   * @license
   * Copyright Google Inc. All Rights Reserved.
   *
   * Use of this source code is governed by an MIT-style license that can be
   * found in the LICENSE file at https://angular.io/license
   *
   * This file is a port of shadowCSS from webcomponents.js to TypeScript.
   * https://github.com/webcomponents/webcomponentsjs/blob/4efecd7e0e/src/ShadowCSS/ShadowCSS.js
   * https://github.com/angular/angular/blob/master/packages/compiler/src/shadow_css.ts
   */
const s=")(?:\\(((?:\\([^)(]*\\)|[^)(]*)+?)\\))?([^,{]*)",e=new RegExp("(-shadowcsshost"+s,"gim"),o=new RegExp("(-shadowcsscontext"+s,"gim"),c=new RegExp("(-shadowcssslotted"+s,"gim"),r=/-shadowcsshost-no-combinator([^\s]*)/,n=[/::shadow/g,/::content/g],l=/-shadowcsshost/gim,a=/:host/gim,h=/::slotted/gim,i=/:host-context/gim,p=/\/\*\s*[\s\S]*?\*\//g,d=/\/\*\s*#\s*source(Mapping)?URL=[\s\S]+?\*\//g,u=/(\s*)([^;\{\}]+?)(\s*)((?:{%BLOCK%}?\s*;?)|(?:\s*;))/g,g=/([{}])/g,processRules=(t,s)=>{const e=escapeBlocks(t);let o=0;return e.escapedString.replace(u,(...t)=>{const c=t[2];let r="",n=t[4],l="";n&&n.startsWith("{%BLOCK%")&&(r=e.blocks[o++],n=n.substring("%BLOCK%".length+1),l="{");const a=s({selector:c,content:r});return`${t[1]}${a.selector}${t[3]}${l}${a.content}${n}`})},escapeBlocks=t=>{const s=t.split(g),e=[],o=[];let c=0,r=[];for(let n=0;n<s.length;n++){const t=s[n];"}"===t&&c--,c>0?r.push(t):(r.length>0&&(o.push(r.join("")),e.push("%BLOCK%"),r=[]),e.push(t)),"{"===t&&c++}return r.length>0&&(o.push(r.join("")),e.push("%BLOCK%")),{escapedString:e.join(""),blocks:o}},convertColonRule=(t,s,e)=>t.replace(s,(...t)=>{if(t[2]){const s=t[2].split(","),o=[];for(let c=0;c<s.length;c++){const r=s[c].trim();if(!r)break;o.push(e("-shadowcsshost-no-combinator",r,t[3]))}return o.join(",")}return"-shadowcsshost-no-combinator"+t[3]}),colonHostPartReplacer=(t,s,e)=>t+s.replace("-shadowcsshost","")+e,colonHostContextPartReplacer=(t,s,e)=>s.indexOf("-shadowcsshost")>-1?colonHostPartReplacer(t,s,e):t+s+e+", "+s+" "+t+e,selectorNeedsScoping=(t,s)=>!(t=>(t=t.replace(/\[/g,"\\[").replace(/\]/g,"\\]"),new RegExp("^("+t+")([>\\s~+[.,{:][\\s\\S]*)?$","m")))(s).test(t),applyStrictSelectorScope=(t,s,e)=>{const o="."+(s=s.replace(/\[is=([^\]]*)\]/g,(t,...s)=>s[0])),_scopeSelectorPart=t=>{let c=t.trim();if(!c)return"";if(t.indexOf("-shadowcsshost-no-combinator")>-1)c=((t,s,e)=>{if(l.lastIndex=0,l.test(t)){const s=`.${e}`;return t.replace(r,(t,e)=>e.replace(/([^:]*)(:*)(.*)/,(t,e,o,c)=>e+s+o+c)).replace(l,s+" ")}return s+" "+t})(t,s,e);else{const s=t.replace(l,"");if(s.length>0){const t=s.match(/([^:]*)(:*)(.*)/);t&&(c=t[1]+o+t[2]+t[3])}}return c},c=(t=>{const s=[];let e,o=0;return e=(t=t.replace(/(\[[^\]]*\])/g,(t,e)=>{const c=`__ph-${o}__`;return s.push(e),o++,c})).replace(/(:nth-[-\w]+)(\([^)]+\))/g,(t,e,c)=>{const r=`__ph-${o}__`;return s.push(c),o++,e+r}),{content:e,placeholders:s}})(t);let n,a="",h=0;const i=/( |>|\+|~(?!=))\s*/g;let p=!((t=c.content).indexOf("-shadowcsshost-no-combinator")>-1);for(;null!==(n=i.exec(t));){const s=n[1],e=t.slice(h,n.index).trim();p=p||e.indexOf("-shadowcsshost-no-combinator")>-1,a+=`${p?_scopeSelectorPart(e):e} ${s} `,h=i.lastIndex}const d=t.substring(h);return p=p||d.indexOf("-shadowcsshost-no-combinator")>-1,a+=p?_scopeSelectorPart(d):d,u=c.placeholders,a.replace(/__ph-(\d+)__/g,(t,s)=>u[+s]);var u},scopeSelectors=(t,s,e,o,c)=>processRules(t,t=>{let c=t.selector,r=t.content;return"@"!==t.selector[0]?c=((t,s,e,o)=>t.split(",").map(t=>o&&t.indexOf("."+o)>-1?t.trim():selectorNeedsScoping(t,s)?applyStrictSelectorScope(t,s,e).trim():t.trim()).join(", "))(t.selector,s,e,o):(t.selector.startsWith("@media")||t.selector.startsWith("@supports")||t.selector.startsWith("@page")||t.selector.startsWith("@document"))&&(r=scopeSelectors(t.content,s,e,o)),{selector:c.replace(/\s{2,}/g," ").trim(),content:r}}),scopeCssText=(t,s,r,l,p)=>(t=(t=>n.reduce((t,s)=>t.replace(s," "),t))(t=((t,s)=>{const e=c;return t.replace(e,(...t)=>{if(t[2]){const e=t[2].trim(),o=t[3];return"."+s+" > "+e+o}return"-shadowcsshost-no-combinator"+t[3]})})(t=(t=>convertColonRule(t,o,colonHostContextPartReplacer))(t=(t=>convertColonRule(t,e,colonHostPartReplacer))(t=t.replace(i,"-shadowcsscontext").replace(a,"-shadowcsshost").replace(h,"-shadowcssslotted"))),l)),s&&(t=scopeSelectors(t,s,r,l)),(t=(t=t.replace(/-shadowcsshost-no-combinator/g,`.${r}`)).replace(/>\s*\*\s+([^{, ]+)/gm," $1 ")).trim());t.scopeCss=(t,s,e)=>{const o=s+"-h",c=s+"-s",r=t.match(d)||[];t=(t=>t.replace(p,""))(t);const n=[];if(e){const processCommentedSelector=t=>{const s=`/*!@___${n.length}___*/`,e=`/*!@${t.selector}*/`;return n.push({placeholder:s,comment:e}),t.selector=s+t.selector,t};t=processRules(t,t=>"@"!==t.selector[0]?processCommentedSelector(t):t.selector.startsWith("@media")||t.selector.startsWith("@supports")||t.selector.startsWith("@page")||t.selector.startsWith("@document")?(t.content=processRules(t.content,processCommentedSelector),t):t)}const l=scopeCssText(t,s,o,c);return t=[l,...r].join("\n"),e&&n.forEach(({placeholder:s,comment:e})=>{t=t.replace(s,e)}),t}}));