/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
export class HAXWiring{constructor(){this.haxProperties={canScale:!1,canPosition:!1,canEditSource:!1,settings:{quick:[],configure:[],advanced:[]},wipeSlot:{}},this.pathFromUrl=e=>e.substring(0,e.lastIndexOf("/")+1),this.setup=(e,t="",i=this)=>(void 0!==this.tagName&&(t=this.tagName.toLowerCase()),window.addEventListener("hax-store-ready",this._haxStoreReady.bind(this)),void 0!==window.HaxStore&&null!=window.HaxStore.instance&&window.HaxStore.ready?this.setHaxProperties(e,t,i,!0):this.setHaxProperties(e,t,i,!1)),this._haxStoreReady=e=>{if(e.detail&&void 0!==this.tagName&&void 0!==this.haxProperties){let e=this.tagName,t=this.haxProperties,i=this;if(""!=e&&void 0===window.HaxStore){const r=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:e.toLowerCase(),properties:t,polymer:!1}});i.dispatchEvent(r)}else if(""!=e&&void 0===window.HaxStore.instance.elementList[e.toLowerCase()]){const r=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:e.toLowerCase(),properties:t}});i.dispatchEvent(r)}else if(void 0!==this.tagName&&void 0===window.HaxStore.instance.elementList[this.tagName.toLowerCase()]){const e=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:this.tagName.toLowerCase(),properties:t}});i.dispatchEvent(e)}}},this.setHaxProperties=(e={},t="",i=document,r=!1)=>{if(void 0===e.api&&(e.api="1"),"1"==e.api){if(void 0===e.canPosition&&(e.canPosition=!0),void 0===e.canScale&&(e.canScale=!0),void 0===e.canEditSource&&(e.canEditSource=!1),void 0===e.gizmo)e.gizmo=!1;else if(void 0!==e.gizmo.iconLib){const t=this.pathFromUrl(decodeURIComponent(import.meta.url));import(`${t}../../../${e.gizmo.iconLib}`)}if(void 0!==e.settings){void 0===e.settings.quick&&(e.settings.quick=[]);for(let t=0;t<e.settings.quick.length;t++)e.settings.quick[t]=this.validateSetting(e.settings.quick[t]),e.settings.quick[t]||e.settings.quick.splice(t,1);void 0===e.settings.configure&&(e.settings.configure=[]);for(let t=0;t<e.settings.configure.length;t++)e.settings.configure[t]=this.validateSetting(e.settings.configure[t]),e.settings.configure[t]||e.settings.configure.splice(t,1);void 0===e.settings.advanced&&(e.settings.advanced=[]);for(let t=0;t<e.settings.advanced.length;t++)e.settings.advanced[t]=this.validateSetting(e.settings.advanced[t]),e.settings.advanced[t]||e.settings.advanced.splice(t,1);e=this.standardAdvancedProps(e)}void 0===e.saveOptions&&(e.saveOptions={wipeSlot:!1}),r&&this.readyToFireHAXSchema(t,e,i),""===t&&("function"==typeof this._setHaxProperties?this._setHaxProperties(e):this.haxProperties=e)}else console.warn("This is't a valid usage of hax API. See hax-body-behaviors/lib/HAXWiring.js for more details on how to implement the API. https://haxtheweb.org/hax-schema for details but we will try and guess the wiring")},this.readyToFireHAXSchema=(e,t,i)=>{if(""!=e&&void 0===window.HaxStore){const r=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:e.toLowerCase(),properties:t,polymer:!1}});i.dispatchEvent(r)}else if(""!=e){const r=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:e.toLowerCase(),properties:t}});i.dispatchEvent(r)}else if(void 0!==this.tagName){const e=new CustomEvent("hax-register-properties",{bubbles:!0,composed:!0,cancelable:!0,detail:{tag:this.tagName.toLowerCase(),properties:t}});i.dispatchEvent(e)}else console.warn(`${e} missed our checks and has an issue in implementation with HAX`)},this.standardAdvancedProps=e=>(e.settings.advanced.push({attribute:"class",title:"Classes",description:"CSS classes applied manually to the element",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"style",title:"Styles",description:"Custom CSS styles as applied to the element",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"prefix",title:"Schema: prefix",description:"Schema prefixes",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"typeof",title:"Schema: TypeOf",description:"typeof definition for Schema usage",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"property",title:"Schema: Property",description:"typeof definition for Schema usage",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"resource",title:"Schema: Resource ID",description:"Schema resource identifier",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"id",title:"ID",description:"element ID, only set this if you know why",inputMethod:"textfield"}),e.settings.advanced.push({attribute:"slot",title:"slot",description:"DOM slot area",inputMethod:"textfield"}),e),this.validateSetting=e=>(void 0!==e.property||void 0!==e.slot||void 0!==e.attribute)&&(void 0===e.title&&(void 0===e.attribute?e.title=e.property:e.title=e.attribute),void 0===e.description&&(e.description=""),void 0===e.inputMethod&&(e.inputMethod="textfield"),void 0===e.type&&(e.type="settings"),void 0===e.icon&&(e.icon="android"),void 0===e.options&&(e.options={}),void 0===e.required&&(e.required=!1),void 0===e.disabled&&(e.disabled=!1),void 0===e.validation&&(e.validation=".*"),void 0===e.validationType&&(e.validationType=""),void 0!==e.slot&&(void 0===e.slotWrapper&&(e.slotWrapper="span"),void 0===e.slotAttributes&&(e.slotAttributes={})),e),this.getHaxProperties=()=>this.haxProperties,this.getHaxJSONSchema=(e,t,i=this)=>{void 0===e&&(e="configure"),void 0===t&&(t=i.haxProperties);let r=t.settings[e];var a={$schema:"http://json-schema.org/schema#",title:"HAX "+e+" form schema",type:"object",properties:{}};if(a.properties=i._getHaxJSONSchemaProperty(r,i),t.gizmo&&t.gizmo.tag&&window.customElements.get(t.gizmo.tag)){let e=document.createElement(t.gizmo.tag);a="function"==typeof e.postProcessgetHaxJSONSchema?e.postProcessgetHaxJSONSchema(a):i.postProcessgetHaxJSONSchema(a)}else a=i.postProcessgetHaxJSONSchema(a);return a},this.postProcessgetHaxJSONSchema=e=>e,this._getHaxJSONSchemaProperty=(e,t)=>{var i={};for(var r in e)if(e.hasOwnProperty(r))if(void 0!==e[r].property){switch(i[e[r].property]={title:e[r].title,type:this.getHaxJSONSchemaType(e[r].inputMethod)},void 0!==t[e[r].property]&&(i[e[r].property].value=t[e[r].property]),"url"==e[r].validationType&&(i[e[r].property].format="uri"),"datepicker"==e[r].inputMethod&&(i[e[r].property].format="date-time"),".*"!=e[r].validation&&(i[e[r].property].pattern=e[r].validation),e[r].inputMethod){case"number":i[e[r].property].component={name:"paper-input",valueProperty:"value",properties:{required:e[r].required,disabled:e[r].disabled},attributes:{type:"number"}};break;case"select":let o=[];for(var a in e[r].options){let t=[{alt:e[r].options[a],value:a}];o.push(t)}i[e[r].property].component={name:"simple-picker",valueProperty:"value",properties:{allowNull:e[r].allowNull,blockLabel:!0,required:e[r].required,options:o,disabled:e[r].disabled}};break;case"textarea":i[e[r].property].component={name:"paper-textarea",valueProperty:"value",properties:{required:e[r].required,disabled:e[r].disabled},attributes:{"char-counter":"char-counter"}};break;case"code-editor":i[e[r].property].component={name:"code-editor",valueProperty:"value",properties:{editorValue:e[r].value,title:e[r].title,theme:"vs",mode:"html",className:"hax-code-editor"}};break;case"array":i[e[r].property].component={valueProperty:"value"},i[e[r].property].items={type:"object",properties:this._getHaxJSONSchemaProperty(e[r].properties,t),itemLabel:e[r].itemLabel},i[e[r].property].type="array";break;case"fieldset":i[e[r].property].component={valueProperty:"value"},i[e[r].property].items={type:"object",properties:this._getHaxJSONSchemaProperty(e[r].properties,t)},i[e[r].property].type="fieldset";break;case"tabs":i[e[r].property].component={valueProperty:"value"},e[r].properties.map(e=>(e.inputMethod="tab",e)),i[e[r].property].items={type:"object",properties:this._getHaxJSONSchemaProperty(e[r].properties,t)},i[e[r].property].type="tabs";break;case"tab":i[e[r].property].property=e[r].property,i[e[r].property].items={type:"object",properties:this._getHaxJSONSchemaProperty(e[r].properties,t),label:e[r].itemLabel},i[e[r].property].type="tabs";break;case"textfield":i[e[r].property].component={name:"paper-input",valueProperty:"value",properties:{required:e[r].required,disabled:e[r].disabled},attributes:{"auto-validate":"auto-validate"}};break;case"markup":i[e[r].property].component={name:"marked-element",valueProperty:"markdown"},i[e[r].property].slot=e[r].value;break;case"alt":i[e[r].property].component={name:"paper-input-flagged",valueProperty:"value",properties:{required:e[r].required,disabled:e[r].disabled},attributes:{"auto-validate":"auto-validate"}};break;case"colorpicker":i[e[r].property].component={name:"simple-colors-picker",valueProperty:"value",properties:{allowNull:e[r].allowNull,blockLabel:!0,required:e[r].required,label:e[r].title,disabled:e[r].disabled}};break;case"iconpicker":i[e[r].property].component={name:"simple-icon-picker",valueProperty:"value",properties:{allowNull:e[r].allowNull,blockLabel:!0,required:e[r].required,hideOptionLabels:!0,label:e[r].title,disabled:e[r].disabled}};let s=void 0!==e[r].options&&null!==e[r].options?e[r].options:[];i[e[r].property].component.properties.icons=s;break;case"datepicker":i[e[r].property].component={name:"paper-input",valueProperty:"date",properties:{type:"date",required:e[r].required,disabled:e[r].disabled}};break;case"haxupload":i[e[r].property].component={name:"hax-upload-field",valueProperty:"value",properties:{formDataName:"file-upload",disabled:e[r].disabled,required:e[r].required,noCamera:e[r].noCamera,noVoiceRecord:e[r].noVoiceRecord}};break;case"slider":i[e[r].property].component={name:"paper-slider",valueProperty:"immediateValue",properties:{pin:!0,value:e[r].value,required:e[r].required,disabled:e[r].disabled,min:e[r].min,max:e[r].max,step:e[r].step}}}"undefined"!==e[r].hidden&&(i[e[r].property].hidden=e[r].hidden),"undefined"!==e[r].description&&(i[e[r].property].description=e[r].description)}else if(void 0!==e[r].attribute){switch(i[e[r].attribute]={title:e[r].title,type:t.getHaxJSONSchemaType(e[r].inputMethod)},"class"===e[r].attribute?i[e[r].attribute].value=t.className:"style"===e[r].attribute?i[e[r].attribute].value=t.style.cssText:"loading"===e[r].attribute?i[e[r].attribute].value="lazy":void 0!==t.attributes[e[r].attribute]&&(i[e[r].attribute].value=t.getAttribute(e[r].attribute)),"href"!=r&&"src"!=r||(i[e[r].attribute].format="uri"),"url"==e[r].validationType&&(i[e[r].attribute].format="uri"),"datepicker"==e[r].inputMethod&&(i[e[r].attribute].format="date-time"),".*"!=e[r].validation&&(i[e[r].attribute].pattern=e[r].validation),e[r].inputMethod){case"number":i[e[r].attribute].component={name:"paper-input",valueProperty:"value",properties:{required:e[r].required,disabled:e[r].disabled},attributes:{type:"number"}};break;case"select":let t=[];for(var a in e[r].options){let i=[{alt:e[r].options[a],value:a}];t.push(i)}i[e[r].attribute].component={name:"simple-picker",valueProperty:"value",properties:{allowNull:e[r].allowNull,blockLabel:!0,required:e[r].required,options:t,disabled:e[r].disabled}};break;case"textarea":i[e[r].attribute].component={name:"paper-textarea",valueProperty:"value",properties:{required:e[r].required,disabled:e[r].disabled},attributes:{"char-counter":"char-counter"}};break;case"code-editor":i[e[r].attribute].component={name:"code-editor",valueProperty:"value",properties:{editorValue:i[e[r].attribute].value,title:e[r].title,readOnly:!1,theme:"vs",mode:"html",className:"hax-code-editor"}};break;case"textfield":i[e[r].attribute].component={name:"paper-input",valueProperty:"value",properties:{required:e[r].required,disabled:e[r].disabled},attributes:{"auto-validate":"auto-validate"}};break;case"alt":i[e[r].attribute].component={name:"paper-input-flagged",valueProperty:"value",properties:{required:e[r].required,disabled:e[r].disabled},attributes:{"auto-validate":"auto-validate"}};break;case"colorpicker":i[e[r].attribute].component={name:"simple-colors-picker",valueProperty:"value",properties:{required:e[r].required,disabled:e[r].disabled}};break;case"haxupload":i[e[r].attribute].component={name:"hax-upload-field",valueProperty:"value",properties:{formDataName:"file-upload",required:e[r].required,disabled:e[r].disabled,noCamera:e[r].noCamera,noVoiceRecord:e[r].noVoiceRecord}};break;case"slider":i[e[r].attribute].component={name:"paper-slider",valueProperty:"immediateValue",properties:{pin:!0,value:e[r].value,required:e[r].required,disabled:e[r].disabled,min:e[r].min,max:e[r].max,step:e[r].step}}}"undefined"!==e[r].description&&(i[e[r].attribute].description=e[r].description)}else{i[e[r].slot]={title:e[r].title,type:t.getHaxJSONSchemaType(e[r].inputMethod),value:"",component:{name:"code-editor",valueProperty:"value",properties:{editorValue:e[r].value,title:e[r].title,theme:"vs",mode:"html",className:"hax-code-editor"}}};var o="";for(var s in t.childNodes)void 0!==t.childNodes[s]&&(1===t.childNodes[s].nodeType?e[r].slot===t.childNodes[s].slot&&(o+=t.childNodes[s].innerHTML):1!==t.childNodes[s].nodeType&&void 0!==t.childNodes[s].textContent&&""!==t.childNodes[s].textContent&&(o+=t.childNodes[s].textContent));i[e[r].slot].component.properties.editorValue=o.trim(),"undefined"!==e[r].description&&(i[e[r].slot].description=e[r].description)}return i},this.getHaxJSONSchemaType=e=>{if(this.validHAXPropertyInputMethod().includes(e))switch(e){case"flipboolean":case"boolean":return"boolean";case"number":case"slider":return"number";case"select":case"textarea":case"colorpicker":case"iconpicker":case"datepicker":case"haxupload":case"markup":case"textfield":case"alt":return"string";case"array":return"array";default:return"string"}},this.validHAXPropertyInputMethod=()=>["flipboolean","boolean","select","textfield","textarea","datepicker","haxupload","slider","markup","colorpicker","iconpicker","alt","number","code-editor","array"],this.prototypeHaxProperties=()=>({api:"1",canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Tag name",description:"",icon:"icons:android",color:"purple",groups:["Content"],handles:[{type:"data",type_exclusive:!1,url:"src"}],meta:{author:"auto"}},settings:{quick:[{property:"title",title:"Title",inputMethod:"textfield",icon:"android"},{property:"primaryColor",title:"Primary color",inputMethod:"colorpicker",icon:"color"}],configure:[{slot:"",title:"Inner content",description:"The slotted content that lives inside the tag",inputMethod:"textfield",icon:"android",required:!0,validationType:"text"},{slot:"button",title:"Button content",description:"The content that can override the button",inputMethod:"textfield",icon:"android",required:!0,validationType:"text"},{property:"title",title:"Title",description:"",inputMethod:"textfield",icon:"android",required:!0,validationType:"text"},{property:"primaryColor",title:"Title",description:"",inputMethod:"textfield",icon:"android",required:!1,validation:".*",validationType:"text"}],advanced:[{property:"secondaryColor",title:"Secondary color",description:"An optional secondary color used in certain edge cases.",inputMethod:"colorpicker",icon:"color"},{property:"endPoint",title:"API endpoint",description:"An optional endpoint to hit and load in more data dymaically.",inputMethod:"textfield",icon:"android",validation:"[a-z0-9]",validationType:"url"}]},saveOptions:{wipeSlot:!1,unsetAttributes:["end-point","secondary-color"]}})}}export const HAXElement=function(e){return class extends e{constructor(){super(),this.HAXWiring=new HAXWiring}static get properties(){return{...super.properties,haxProperties:window.HAXWiring.haxProperties}}setHaxProperties(e,t="",i=this){return""==t&&void 0!==this.tagName&&(t=this.tagName.toLowerCase()),window.addEventListener("hax-store-ready",this._haxStoreReady.bind(this)),void 0!==window.HaxStore&&null!=window.HaxStore.instance&&window.HaxStore.ready?this.HAXWiring.setHaxProperties(e,t,i,!0):this.HAXWiring.setHaxProperties(e,t,i,!1)}disconnectedCallback(){window.removeEventListener("hax-store-ready",this._haxStoreReady.bind(this)),super.disconnectedCallback&&super.disconnectedCallback()}setup(e,t="",i=this){return this.HAXWiring.setup(e,"",this)}_haxStoreReady(e){return this.HAXWiring._haxStoreReady(e)}validateSetting(e){return this.HAXWiring.validateSetting(e)}getHaxProperties(){return this.haxProperties}getHaxJSONSchema(e,t,i=this){return this.HAXWiring.getHaxJSONSchema(e,t,i)}postProcessgetHaxJSONSchema(e){return this.HAXWiring.postProcessgetHaxJSONSchema(e)}_getHaxJSONSchemaProperty(e,t){return this.HAXWiring._getHaxJSONSchemaProperty(e,t)}getHaxJSONSchemaType(e){return this.HAXWiring.getHaxJSONSchemaType(e)}validHAXPropertyInputMethod(){return this.HAXWiring.validHAXPropertyInputMethod()}prototypeHaxProperties(){return this.HAXWiring.prototypeHaxProperties()}}};window.HAXWiring=new HAXWiring,window.HAXBehaviors=window.HAXBehaviors||{},window.HAXBehaviors.PropertiesBehaviors={properties:{haxProperties:window.HAXWiring.haxProperties},setHaxProperties:function(e,t="",i=this){return""==t&&void 0!==this.tagName&&(t=this.tagName.toLowerCase()),window.addEventListener("hax-store-ready",this._haxStoreReady.bind(this)),void 0!==window.HaxStore&&null!=window.HaxStore.instance&&window.HaxStore.ready?window.HAXWiring.setHaxProperties(e,t,i,!0):window.HAXWiring.setHaxProperties(e,t,i,!1)},_haxStoreReady:function(e){return window.HAXWiring._haxStoreReady(e)},validateSetting:function(e){return window.HAXWiring.validateSetting(e)},getHaxProperties:function(){return this.haxProperties},getHaxJSONSchema:function(e,t,i=this){return window.HAXWiring.getHaxJSONSchema(e,t,i)},postProcessgetHaxJSONSchema:function(e){return window.HAXWiring.postProcessgetHaxJSONSchema(e)},_getHaxJSONSchemaProperty:function(e,t){return window.HAXWiring._getHaxJSONSchemaProperty(e,t)},getHaxJSONSchemaType:function(e){return window.HAXWiring.getHaxJSONSchemaType(e)},validHAXPropertyInputMethod:function(){return window.HAXWiring.validHAXPropertyInputMethod()},prototypeHaxProperties:function(){return window.HAXWiring.prototypeHaxProperties()}};