/**
 * @fileoverview
 * @suppress {checkPrototypalTypes}
 * @license Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
 * This code may only be used under the BSD style license found at
 * http://polymer.github.io/LICENSE.txt The complete set of authors may be found
 * at http://polymer.github.io/AUTHORS.txt The complete set of contributors may
 * be found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by
 * Google as part of the polymer project is also subject to an additional IP
 * rights grant found at http://polymer.github.io/PATENTS.txt
 */
import"../utils/boot.js";import{rootPath as t,strictTemplatePolicy as e,allowTemplateFromDomModule as r,legacyOptimizations as o,syncInitialRender as s}from"../utils/settings.js";import{dedupingMixin as i}from"../utils/mixin.js";import{stylesFromTemplate as a,stylesFromModuleImports as n}from"../utils/style-gather.js";import{pathFromUrl as p,resolveCss as l,resolveUrl as h}from"../utils/resolve-url.js";import{DomModule as c}from"../elements/dom-module.js";import{PropertyEffects as m}from"./property-effects.js";import{PropertiesMixin as y}from"./properties-mixin.js";import{wrap as d}from"../utils/wrap.js";export const version="3.3.1";const f=window.ShadyCSS&&window.ShadyCSS.cssBuild;export const ElementMixin=i(i=>{const _=y(m(i));return class PolymerElement extends _{static get polymerElementVersion(){return"3.3.1"}static _finalizeClass(){_._finalizeClass.call(this);const t=function ownObservers(t){return t.hasOwnProperty(JSCompiler_renameProperty("__ownObservers",t))||(t.__ownObservers=t.hasOwnProperty(JSCompiler_renameProperty("observers",t))?t.observers:null),t.__ownObservers}(this);t&&this.createObservers(t,this._properties),this._prepareTemplate()}static _prepareTemplate(){let t=this.template;t&&("string"==typeof t?(console.error("template getter must return HTMLTemplateElement"),t=null):o||(t=t.cloneNode(!0))),this.prototype._template=t}static createProperties(t){for(let i in t)e=this.prototype,r=i,o=t[i],s=t,o.computed&&(o.readOnly=!0),o.computed&&(e._hasReadOnlyEffect(r)?console.warn(`Cannot redefine computed property '${r}'.`):e._createComputedProperty(r,o.computed,s)),o.readOnly&&!e._hasReadOnlyEffect(r)?e._createReadOnlyProperty(r,!o.computed):!1===o.readOnly&&e._hasReadOnlyEffect(r)&&console.warn(`Cannot make readOnly property '${r}' non-readOnly.`),o.reflectToAttribute&&!e._hasReflectEffect(r)?e._createReflectedProperty(r):!1===o.reflectToAttribute&&e._hasReflectEffect(r)&&console.warn(`Cannot make reflected property '${r}' non-reflected.`),o.notify&&!e._hasNotifyEffect(r)?e._createNotifyingProperty(r):!1===o.notify&&e._hasNotifyEffect(r)&&console.warn(`Cannot make notify property '${r}' non-notify.`),o.observer&&e._createPropertyObserver(r,o.observer,s[o.observer]),e._addPropertyToAttributeMap(r);var e,r,o,s}static createObservers(t,e){const r=this.prototype;for(let o=0;o<t.length;o++)r._createMethodObserver(t[o],e)}static get template(){return this.hasOwnProperty(JSCompiler_renameProperty("_template",this))||(this._template=this.prototype.hasOwnProperty(JSCompiler_renameProperty("_template",this.prototype))?this.prototype._template:function getTemplateFromDomModule(t){let o=null;if(t&&(!e||r)&&(o=c.import(t,"template"),e&&!o))throw new Error(`strictTemplatePolicy: expecting dom-module or null template for ${t}`);return o}(this.is)||Object.getPrototypeOf(this.prototype).constructor.template),this._template}static set template(t){this._template=t}static get importPath(){if(!this.hasOwnProperty(JSCompiler_renameProperty("_importPath",this))){const t=this.importMeta;if(t)this._importPath=p(t.url);else{const t=c.import(this.is);this._importPath=t&&t.assetpath||Object.getPrototypeOf(this.prototype).constructor.importPath}}return this._importPath}constructor(){super(),this._template,this._importPath,this.rootPath,this.importPath,this.root,this.$}_initializeProperties(){this.constructor.finalize(),this.constructor._finalizeTemplate(this.localName),super._initializeProperties(),this.rootPath=t,this.importPath=this.constructor.importPath;let e=function propertyDefaults(t){if(!t.hasOwnProperty(JSCompiler_renameProperty("__propertyDefaults",t))){t.__propertyDefaults=null;let e=t._properties;for(let r in e){let o=e[r];"value"in o&&(t.__propertyDefaults=t.__propertyDefaults||{},t.__propertyDefaults[r]=o)}}return t.__propertyDefaults}(this.constructor);if(e)for(let t in e){let r=e[t];if(!this.hasOwnProperty(t)){let e="function"==typeof r.value?r.value.call(this):r.value;this._hasAccessor(t)?this._setPendingProperty(t,e,!0):this[t]=e}}}static _processStyleText(t,e){return l(t,e)}static _finalizeTemplate(t){const e=this.prototype._template;if(e&&!e.__polymerFinalized){e.__polymerFinalized=!0;const r=this.importPath;!function processElementStyles(t,e,r,o){if(!f){const s=e.content.querySelectorAll("style"),i=a(e),p=n(r),l=e.content.firstElementChild;for(let r=0;r<p.length;r++){let s=p[r];s.textContent=t._processStyleText(s.textContent,o),e.content.insertBefore(s,l)}let h=0;for(let e=0;e<i.length;e++){let r=i[e],a=s[h];a!==r?(r=r.cloneNode(!0),a.parentNode.insertBefore(r,a)):h++,r.textContent=t._processStyleText(r.textContent,o)}}window.ShadyCSS&&window.ShadyCSS.prepareTemplate(e,r)}(this,e,t,r?h(r):""),this.prototype._bindTemplate(e)}}connectedCallback(){window.ShadyCSS&&this._template&&window.ShadyCSS.styleElement(this),super.connectedCallback()}ready(){this._template&&(this.root=this._stampTemplate(this._template),this.$=this.root.$),super.ready()}_readyClients(){this._template&&(this.root=this._attachDom(this.root)),super._readyClients()}_attachDom(t){const e=d(this);if(e.attachShadow)return t?(e.shadowRoot||(e.attachShadow({mode:"open",shadyUpgradeFragment:t}),e.shadowRoot.appendChild(t)),s&&window.ShadyDOM&&window.ShadyDOM.flushInitial(e.shadowRoot),e.shadowRoot):null;throw new Error("ShadowDOM not available. PolymerElement can create dom as children instead of in ShadowDOM by setting `this.root = this;` before `ready`.")}updateStyles(t){window.ShadyCSS&&window.ShadyCSS.styleSubtree(this,t)}resolveUrl(t,e){return!e&&this.importPath&&(e=h(this.importPath)),h(t,e)}static _parseTemplateContent(t,e,r){return e.dynamicFns=e.dynamicFns||this._properties,_._parseTemplateContent.call(this,t,e,r)}static _addTemplatePropertyEffect(t,e,r){return!o||e in this._properties||console.warn(`Property '${e}' used in template but not declared in 'properties'; `+"attribute will not be observed."),_._addTemplatePropertyEffect.call(this,t,e,r)}}});export const updateStyles=function(t){window.ShadyCSS&&window.ShadyCSS.styleDocument(t)};