/**
 * @fileoverview
 * @suppress {checkPrototypalTypes}
 * @license Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
 * This code may only be used under the BSD style license found at
 * http://polymer.github.io/LICENSE.txt The complete set of authors may be found
 * at http://polymer.github.io/AUTHORS.txt The complete set of contributors may
 * be found at http://polymer.github.io/CONTRIBUTORS.txt Code distributed by
 * Google as part of the polymer project is also subject to an additional IP
 * rights grant found at http://polymer.github.io/PATENTS.txt
 */
import"../utils/boot.js";import{wrap as t}from"../utils/wrap.js";import{dedupingMixin as e}from"../utils/mixin.js";import{root as r,isAncestor as i,isDescendant as a,get as s,translate as n,isPath as o,set as l,normalize as d}from"../utils/path.js";import{camelToDashCase as h,dashToCamelCase as f}from"../utils/case-map.js";import{PropertyAccessors as _}from"./property-accessors.js";import{TemplateStamp as p}from"./template-stamp.js";import{sanitizeDOMValue as c}from"../utils/settings.js";let u=0;const g={COMPUTE:"__computeEffects",REFLECT:"__reflectEffects",NOTIFY:"__notifyEffects",PROPAGATE:"__propagateEffects",OBSERVE:"__observeEffects",READ_ONLY:"__readOnly"},P=/[A-Z]/;function ensureOwnEffectMap(t,e){let r=t[e];if(r){if(!t.hasOwnProperty(e)){r=t[e]=Object.create(t[e]);for(let t in r){let e=r[t],i=r[t]=Array(e.length);for(let t=0;t<e.length;t++)i[t]=e[t]}}}else r=t[e]={};return r}function runEffects(t,e,r,i,a,s){if(e){let n=!1,o=u++;for(let l in r)runEffectsForProperty(t,e,o,l,r,i,a,s)&&(n=!0);return n}return!1}function runEffectsForProperty(t,e,i,a,s,n,o,l){let d=!1,h=e[o?r(a):a];if(h)for(let e,r=0,f=h.length;r<f&&(e=h[r]);r++)e.info&&e.info.lastRun===i||o&&!pathMatchesTrigger(a,e.trigger)||(e.info&&(e.info.lastRun=i),e.fn(t,a,s,n,e.info,o,l),d=!0);return d}function pathMatchesTrigger(t,e){if(e){let r=e.name;return r==t||!(!e.structured||!i(r,t))||!(!e.wildcard||!a(r,t))}return!0}function runObserverEffect(t,e,r,i,a){let s="string"==typeof a.method?t[a.method]:a.method,n=a.property;s?s.call(t,t.__data[n],i[n]):a.dynamicFn||console.warn("observer method `"+a.method+"` not defined")}function notifyPath(t,e,i){let a=r(e);if(a!==e){return dispatchNotifyEvent(t,h(a)+"-changed",i[e],e),!0}return!1}function dispatchNotifyEvent(e,r,i,a){let s={value:i,queueProperty:!0};a&&(s.path=a),t(e).dispatchEvent(new CustomEvent(r,{detail:s}))}function runNotifyEffect(t,e,i,a,n,o){let l=(o?r(e):e)!=e?e:null,d=l?s(t,l):t.__data[e];l&&void 0===d&&(d=i[e]),dispatchNotifyEvent(t,n.eventName,d,l)}function runReflectEffect(t,e,r,i,a){let s=t.__data[e];c&&(s=c(s,a.attrName,"attribute",t)),t._propertyToAttribute(e,a.attrName,s)}function runComputedEffect(t,e,r,i,a){let s=runMethodEffect(t,e,r,i,a),n=a.methodInfo;t.__dataHasAccessor&&t.__dataHasAccessor[n]?t._setPendingProperty(n,s,!0):t[n]=s}function addBinding(t,e,r,i,a,s,n){r.bindings=r.bindings||[];let o={kind:i,target:a,parts:s,literal:n,isCompound:1!==s.length};if(r.bindings.push(o),function shouldAddListener(t){return Boolean(t.target)&&"attribute"!=t.kind&&"text"!=t.kind&&!t.isCompound&&"{"===t.parts[0].mode}(o)){let{event:t,negate:e}=o.parts[0];o.listenerEvent=t||h(a)+"-changed",o.listenerNegate=e}let l=e.nodeInfoList.length;for(let r=0;r<o.parts.length;r++){let i=o.parts[r];i.compoundIndex=r,addEffectForBindingPart(t,e,o,i,l)}}function addEffectForBindingPart(t,e,r,i,a){if(!i.literal)if("attribute"===r.kind&&"-"===r.target[0])console.warn("Cannot set attribute "+r.target+' because "-" is not a valid attribute starting character');else{let s=i.dependencies,n={index:a,binding:r,part:i,evaluator:t};for(let r=0;r<s.length;r++){let i=s[r];"string"==typeof i&&(i=parseArg(i),i.wildcard=!0),t._addTemplatePropertyEffect(e,i.rootProperty,{fn:runBindingEffect,info:n,trigger:i})}}}function runBindingEffect(t,e,r,i,a,s,o){let l=o[a.index],d=a.binding,h=a.part;if(s&&h.source&&e.length>h.source.length&&"property"==d.kind&&!d.isCompound&&l.__isPropertyEffectsClient&&l.__dataHasAccessor&&l.__dataHasAccessor[d.target]){let i=r[e];e=n(h.source,d.target,e),l._setPendingPropertyOrPath(e,i,!1,!0)&&t._enqueueClient(l)}else{!function applyBindingValue(t,e,r,i,a){a=function computeBindingValue(t,e,r,i){if(r.isCompound){let a=t.__dataCompoundStorage[r.target];a[i.compoundIndex]=e,e=a.join("")}"attribute"!==r.kind&&("textContent"!==r.target&&("value"!==r.target||"input"!==t.localName&&"textarea"!==t.localName)||(e=null==e?"":e));return e}(e,a,r,i),c&&(a=c(a,r.target,r.kind,e));if("attribute"==r.kind)t._valueToNodeAttribute(e,a,r.target);else{let i=r.target;e.__isPropertyEffectsClient&&e.__dataHasAccessor&&e.__dataHasAccessor[i]?e[g.READ_ONLY]&&e[g.READ_ONLY][i]||e._setPendingProperty(i,a)&&t._enqueueClient(e):t._setUnmanagedPropertyToNode(e,i,a)}}(t,l,d,h,a.evaluator._evaluateBinding(t,h,e,r,i,s))}}function setupCompoundStorage(e,r){if(r.isCompound){let i=e.__dataCompoundStorage||(e.__dataCompoundStorage={}),a=r.parts,s=new Array(a.length);for(let t=0;t<a.length;t++)s[t]=a[t].literal;let n=r.target;i[n]=s,r.literal&&"property"==r.kind&&("className"===n&&(e=t(e)),e[n]=r.literal)}}function addNotifyListener(t,e,r){if(r.listenerEvent){let i=r.parts[0];t.addEventListener(r.listenerEvent,(function(t){!function handleNotification(t,e,r,i,a){let s,o=t.detail,l=o&&o.path;l?(i=n(r,i,l),s=o&&o.value):s=t.currentTarget[r],s=a?!s:s,e[g.READ_ONLY]&&e[g.READ_ONLY][i]||!e._setPendingPropertyOrPath(i,s,!0,Boolean(l))||o&&o.queueProperty||e._invalidateProperties()}(t,e,r.target,i.source,i.negate)}))}}function createMethodEffect(t,e,r,i,a,s){s=e.static||s&&("object"!=typeof s||s[e.methodName]);let n={methodName:e.methodName,args:e.args,methodInfo:a,dynamicFn:s};for(let a,s=0;s<e.args.length&&(a=e.args[s]);s++)a.literal||t._addPropertyEffect(a.rootProperty,r,{fn:i,info:n,trigger:a});s&&t._addPropertyEffect(e.methodName,r,{fn:i,info:n})}function runMethodEffect(t,e,r,i,a){let s=t._methodHost||t,n=s[a.methodName];if(n){let i=t._marshalArgs(a.args,e,r);return n.apply(s,i)}a.dynamicFn||console.warn("method `"+a.methodName+"` not defined")}const m=[],y=new RegExp("(\\[\\[|{{)\\s*(?:(!)\\s*)?((?:[a-zA-Z_$][\\w.:$\\-*]*)\\s*(?:\\(\\s*(?:(?:(?:((?:[a-zA-Z_$][\\w.:$\\-*]*)|(?:[-+]?[0-9]*\\.?[0-9]+(?:[eE][-+]?[0-9]+)?)|(?:(?:'(?:[^'\\\\]|\\\\.)*')|(?:\"(?:[^\"\\\\]|\\\\.)*\")))\\s*)(?:,\\s*(?:((?:[a-zA-Z_$][\\w.:$\\-*]*)|(?:[-+]?[0-9]*\\.?[0-9]+(?:[eE][-+]?[0-9]+)?)|(?:(?:'(?:[^'\\\\]|\\\\.)*')|(?:\"(?:[^\"\\\\]|\\\\.)*\")))\\s*))*)?)\\)\\s*)?)(?:]]|}})","g");function literalFromParts(t){let e="";for(let r=0;r<t.length;r++){e+=t[r].literal||""}return e}function parseMethod(t){let e=t.match(/([^\s]+?)\(([\s\S]*)\)/);if(e){let t={methodName:e[1],static:!0,args:m};if(e[2].trim()){return function parseArgs(t,e){return e.args=t.map((function(t){let r=parseArg(t);return r.literal||(e.static=!1),r}),this),e}(e[2].replace(/\\,/g,"&comma;").split(","),t)}return t}return null}function parseArg(t){let e=t.trim().replace(/&comma;/g,",").replace(/\\(.)/g,"$1"),i={name:e,value:"",literal:!1},a=e[0];switch("-"===a&&(a=e[1]),a>="0"&&a<="9"&&(a="#"),a){case"'":case'"':i.value=e.slice(1,-1),i.literal=!0;break;case"#":i.value=Number(e),i.literal=!0}return i.literal||(i.rootProperty=r(e),i.structured=o(e),i.structured&&(i.wildcard=".*"==e.slice(-2),i.wildcard&&(i.name=e.slice(0,-2)))),i}function getArgValue(t,e,r){let i=s(t,r);return void 0===i&&(i=e[r]),i}function notifySplices(t,e,r,i){t.notifyPath(r+".splices",{indexSplices:i}),t.notifyPath(r+".length",e.length)}function notifySplice(t,e,r,i,a,s){notifySplices(t,e,r,[{index:i,addedCount:a,removed:s,object:e,type:"splice"}])}export const PropertyEffects=e(e=>{const i=p(_(e));return class PropertyEffects extends i{constructor(){super(),this.__isPropertyEffectsClient=!0,this.__dataCounter=0,this.__dataClientsReady,this.__dataPendingClients,this.__dataToNotify,this.__dataLinkedPaths,this.__dataHasPaths,this.__dataCompoundStorage,this.__dataHost,this.__dataTemp,this.__dataClientsInitialized,this.__data,this.__dataPending,this.__dataOld,this.__computeEffects,this.__reflectEffects,this.__notifyEffects,this.__propagateEffects,this.__observeEffects,this.__readOnly,this.__templateInfo}get PROPERTY_EFFECT_TYPES(){return g}_initializeProperties(){super._initializeProperties(),E.registerHost(this),this.__dataClientsReady=!1,this.__dataPendingClients=null,this.__dataToNotify=null,this.__dataLinkedPaths=null,this.__dataHasPaths=!1,this.__dataCompoundStorage=this.__dataCompoundStorage||null,this.__dataHost=this.__dataHost||null,this.__dataTemp={},this.__dataClientsInitialized=!1}_initializeProtoProperties(t){this.__data=Object.create(t),this.__dataPending=Object.create(t),this.__dataOld={}}_initializeInstanceProperties(t){let e=this[g.READ_ONLY];for(let r in t)e&&e[r]||(this.__dataPending=this.__dataPending||{},this.__dataOld=this.__dataOld||{},this.__data[r]=this.__dataPending[r]=t[r])}_addPropertyEffect(t,e,r){this._createPropertyAccessor(t,e==g.READ_ONLY);let i=ensureOwnEffectMap(this,e)[t];i||(i=this[e][t]=[]),i.push(r)}_removePropertyEffect(t,e,r){let i=ensureOwnEffectMap(this,e)[t],a=i.indexOf(r);a>=0&&i.splice(a,1)}_hasPropertyEffect(t,e){let r=this[e];return Boolean(r&&r[t])}_hasReadOnlyEffect(t){return this._hasPropertyEffect(t,g.READ_ONLY)}_hasNotifyEffect(t){return this._hasPropertyEffect(t,g.NOTIFY)}_hasReflectEffect(t){return this._hasPropertyEffect(t,g.REFLECT)}_hasComputedEffect(t){return this._hasPropertyEffect(t,g.COMPUTE)}_setPendingPropertyOrPath(t,e,i,o){if(o||r(Array.isArray(t)?t[0]:t)!==t){if(!o){let r=s(this,t);if(!(t=l(this,t,e))||!super._shouldPropertyChange(t,e,r))return!1}if(this.__dataHasPaths=!0,this._setPendingProperty(t,e,i))return function computeLinkedPaths(t,e,r){let i=t.__dataLinkedPaths;if(i){let s;for(let o in i){let l=i[o];a(o,e)?(s=n(o,l,e),t._setPendingPropertyOrPath(s,r,!0,!0)):a(l,e)&&(s=n(l,o,e),t._setPendingPropertyOrPath(s,r,!0,!0))}}}(this,t,e),!0}else{if(this.__dataHasAccessor&&this.__dataHasAccessor[t])return this._setPendingProperty(t,e,i);this[t]=e}return!1}_setUnmanagedPropertyToNode(e,r,i){i===e[r]&&"object"!=typeof i||("className"===r&&(e=t(e)),e[r]=i)}_setPendingProperty(t,e,r){let i=this.__dataHasPaths&&o(t),a=i?this.__dataTemp:this.__data;return!!this._shouldPropertyChange(t,e,a[t])&&(this.__dataPending||(this.__dataPending={},this.__dataOld={}),t in this.__dataOld||(this.__dataOld[t]=this.__data[t]),i?this.__dataTemp[t]=e:this.__data[t]=e,this.__dataPending[t]=e,(i||this[g.NOTIFY]&&this[g.NOTIFY][t])&&(this.__dataToNotify=this.__dataToNotify||{},this.__dataToNotify[t]=r),!0)}_setProperty(t,e){this._setPendingProperty(t,e,!0)&&this._invalidateProperties()}_invalidateProperties(){this.__dataReady&&this._flushProperties()}_enqueueClient(t){this.__dataPendingClients=this.__dataPendingClients||[],t!==this&&this.__dataPendingClients.push(t)}_flushProperties(){this.__dataCounter++,super._flushProperties(),this.__dataCounter--}_flushClients(){this.__dataClientsReady?this.__enableOrFlushClients():(this.__dataClientsReady=!0,this._readyClients(),this.__dataReady=!0)}__enableOrFlushClients(){let t=this.__dataPendingClients;if(t){this.__dataPendingClients=null;for(let e=0;e<t.length;e++){let r=t[e];r.__dataEnabled?r.__dataPending&&r._flushProperties():r._enableProperties()}}}_readyClients(){this.__enableOrFlushClients()}setProperties(t,e){for(let r in t)!e&&this[g.READ_ONLY]&&this[g.READ_ONLY][r]||this._setPendingPropertyOrPath(r,t[r],!0);this._invalidateProperties()}ready(){this._flushProperties(),this.__dataClientsReady||this._flushClients(),this.__dataPending&&this._flushProperties()}_propertiesChanged(t,e,r){let i=this.__dataHasPaths;this.__dataHasPaths=!1,function runComputedEffects(t,e,r,i){let a=t[g.COMPUTE];if(a){let s=e;for(;runEffects(t,a,s,r,i);)Object.assign(r,t.__dataOld),Object.assign(e,t.__dataPending),s=t.__dataPending,t.__dataPending=null}}(this,e,r,i);let a=this.__dataToNotify;this.__dataToNotify=null,this._propagatePropertyChanges(e,r,i),this._flushClients(),runEffects(this,this[g.REFLECT],e,r,i),runEffects(this,this[g.OBSERVE],e,r,i),a&&function runNotifyEffects(t,e,r,i,a){let s,n,o=t[g.NOTIFY],l=u++;for(let n in e)e[n]&&(o&&runEffectsForProperty(t,o,l,n,r,i,a)?s=!0:a&&notifyPath(t,n,r)&&(s=!0));s&&(n=t.__dataHost)&&n._invalidateProperties&&n._invalidateProperties()}(this,a,e,r,i),1==this.__dataCounter&&(this.__dataTemp={})}_propagatePropertyChanges(t,e,r){this[g.PROPAGATE]&&runEffects(this,this[g.PROPAGATE],t,e,r);let i=this.__templateInfo;for(;i;)runEffects(this,i.propertyEffects,t,e,r,i.nodeList),i=i.nextTemplateInfo}linkPaths(t,e){t=d(t),e=d(e),this.__dataLinkedPaths=this.__dataLinkedPaths||{},this.__dataLinkedPaths[t]=e}unlinkPaths(t){t=d(t),this.__dataLinkedPaths&&delete this.__dataLinkedPaths[t]}notifySplices(t,e){let r={path:""};notifySplices(this,s(this,t,r),r.path,e)}get(t,e){return s(e||this,t)}set(t,e,r){r?l(r,t,e):this[g.READ_ONLY]&&this[g.READ_ONLY][t]||this._setPendingPropertyOrPath(t,e,!0)&&this._invalidateProperties()}push(t,...e){let r={path:""},i=s(this,t,r),a=i.length,n=i.push(...e);return e.length&&notifySplice(this,i,r.path,a,e.length,[]),n}pop(t){let e={path:""},r=s(this,t,e),i=Boolean(r.length),a=r.pop();return i&&notifySplice(this,r,e.path,r.length,0,[a]),a}splice(t,e,r,...i){let a,n={path:""},o=s(this,t,n);return e<0?e=o.length-Math.floor(-e):e&&(e=Math.floor(e)),a=2===arguments.length?o.splice(e):o.splice(e,r,...i),(i.length||a.length)&&notifySplice(this,o,n.path,e,i.length,a),a}shift(t){let e={path:""},r=s(this,t,e),i=Boolean(r.length),a=r.shift();return i&&notifySplice(this,r,e.path,0,0,[a]),a}unshift(t,...e){let r={path:""},i=s(this,t,r),a=i.unshift(...e);return e.length&&notifySplice(this,i,r.path,0,e.length,[]),a}notifyPath(t,e){let r;if(1==arguments.length){let i={path:""};e=s(this,t,i),r=i.path}else r=Array.isArray(t)?d(t):t;this._setPendingPropertyOrPath(r,e,!0,!0)&&this._invalidateProperties()}_createReadOnlyProperty(t,e){this._addPropertyEffect(t,g.READ_ONLY),e&&(this["_set"+function upper(t){return t[0].toUpperCase()+t.substring(1)}(t)]=function(e){this._setProperty(t,e)})}_createPropertyObserver(t,e,r){let i={property:t,method:e,dynamicFn:Boolean(r)};this._addPropertyEffect(t,g.OBSERVE,{fn:runObserverEffect,info:i,trigger:{name:t}}),r&&this._addPropertyEffect(e,g.OBSERVE,{fn:runObserverEffect,info:i,trigger:{name:e}})}_createMethodObserver(t,e){let r=parseMethod(t);if(!r)throw new Error("Malformed observer expression '"+t+"'");createMethodEffect(this,r,g.OBSERVE,runMethodEffect,null,e)}_createNotifyingProperty(t){this._addPropertyEffect(t,g.NOTIFY,{fn:runNotifyEffect,info:{eventName:h(t)+"-changed",property:t}})}_createReflectedProperty(t){let e=this.constructor.attributeNameForProperty(t);"-"===e[0]?console.warn("Property "+t+" cannot be reflected to attribute "+e+' because "-" is not a valid starting attribute name. Use a lowercase first letter for the property instead.'):this._addPropertyEffect(t,g.REFLECT,{fn:runReflectEffect,info:{attrName:e}})}_createComputedProperty(t,e,r){let i=parseMethod(e);if(!i)throw new Error("Malformed computed expression '"+e+"'");createMethodEffect(this,i,g.COMPUTE,runComputedEffect,t,r)}_marshalArgs(t,e,r){const i=this.__data,n=[];for(let o=0,l=t.length;o<l;o++){let{name:l,structured:d,wildcard:h,value:f,literal:_}=t[o];if(!_)if(h){const t=a(l,e),n=getArgValue(i,r,t?e:l);f={path:t?e:l,value:n,base:t?s(i,l):n}}else f=d?getArgValue(i,r,l):i[l];n[o]=f}return n}static addPropertyEffect(t,e,r){this.prototype._addPropertyEffect(t,e,r)}static createPropertyObserver(t,e,r){this.prototype._createPropertyObserver(t,e,r)}static createMethodObserver(t,e){this.prototype._createMethodObserver(t,e)}static createNotifyingProperty(t){this.prototype._createNotifyingProperty(t)}static createReadOnlyProperty(t,e){this.prototype._createReadOnlyProperty(t,e)}static createReflectedProperty(t){this.prototype._createReflectedProperty(t)}static createComputedProperty(t,e,r){this.prototype._createComputedProperty(t,e,r)}static bindTemplate(t){return this.prototype._bindTemplate(t)}_bindTemplate(t,e){let r=this.constructor._parseTemplate(t),i=this.__templateInfo==r;if(!i)for(let t in r.propertyEffects)this._createPropertyAccessor(t);if(e&&(r=Object.create(r),r.wasPreBound=i,!i&&this.__templateInfo)){let t=this.__templateInfoLast||this.__templateInfo;return this.__templateInfoLast=t.nextTemplateInfo=r,r.previousTemplateInfo=t,r}return this.__templateInfo=r}static _addTemplatePropertyEffect(t,e,r){(t.hostProps=t.hostProps||{})[e]=!0;let i=t.propertyEffects=t.propertyEffects||{};(i[e]=i[e]||[]).push(r)}_stampTemplate(t){E.beginHosting(this);let e=super._stampTemplate(t);E.endHosting(this);let r=this._bindTemplate(t,!0);if(r.nodeList=e.nodeList,!r.wasPreBound){let t=r.childNodes=[];for(let r=e.firstChild;r;r=r.nextSibling)t.push(r)}return e.templateInfo=r,function setupBindings(t,e){let{nodeList:r,nodeInfoList:i}=e;if(i.length)for(let e=0;e<i.length;e++){let a=i[e],s=r[e],n=a.bindings;if(n)for(let e=0;e<n.length;e++){let r=n[e];setupCompoundStorage(s,r),addNotifyListener(s,t,r)}s.__dataHost=t}}(this,r),this.__dataReady&&runEffects(this,r.propertyEffects,this.__data,null,!1,r.nodeList),e}_removeBoundDom(t){let e=t.templateInfo;e.previousTemplateInfo&&(e.previousTemplateInfo.nextTemplateInfo=e.nextTemplateInfo),e.nextTemplateInfo&&(e.nextTemplateInfo.previousTemplateInfo=e.previousTemplateInfo),this.__templateInfoLast==e&&(this.__templateInfoLast=e.previousTemplateInfo),e.previousTemplateInfo=e.nextTemplateInfo=null;let r=e.childNodes;for(let t=0;t<r.length;t++){let e=r[t];e.parentNode.removeChild(e)}}static _parseTemplateNode(t,e,r){let a=i._parseTemplateNode.call(this,t,e,r);if(t.nodeType===Node.TEXT_NODE){let i=this._parseBindings(t.textContent,e);i&&(t.textContent=literalFromParts(i)||" ",addBinding(this,e,r,"text","textContent",i),a=!0)}return a}static _parseTemplateNodeAttribute(t,e,r,a,s){let n=this._parseBindings(s,e);if(n){let i=a,s="property";P.test(a)?s="attribute":"$"==a[a.length-1]&&(a=a.slice(0,-1),s="attribute");let o=literalFromParts(n);return o&&"attribute"==s&&("class"==a&&t.hasAttribute("class")&&(o+=" "+t.getAttribute(a)),t.setAttribute(a,o)),"input"===t.localName&&"value"===i&&t.setAttribute(i,""),t.removeAttribute(i),"property"===s&&(a=f(a)),addBinding(this,e,r,s,a,n,o),!0}return i._parseTemplateNodeAttribute.call(this,t,e,r,a,s)}static _parseTemplateNestedTemplate(t,e,r){let a=i._parseTemplateNestedTemplate.call(this,t,e,r),s=r.templateInfo.hostProps;for(let t in s){addBinding(this,e,r,"property","_host_"+t,[{mode:"{",source:t,dependencies:[t]}])}return a}static _parseBindings(t,e){let r,i=[],a=0;for(;null!==(r=y.exec(t));){r.index>a&&i.push({literal:t.slice(a,r.index)});let s=r[1][0],n=Boolean(r[2]),o=r[3].trim(),l=!1,d="",h=-1;"{"==s&&(h=o.indexOf("::"))>0&&(d=o.substring(h+2),o=o.substring(0,h),l=!0);let f=parseMethod(o),_=[];if(f){let{args:t,methodName:r}=f;for(let e=0;e<t.length;e++){let r=t[e];r.literal||_.push(r)}let i=e.dynamicFns;(i&&i[r]||f.static)&&(_.push(r),f.dynamicFn=!0)}else _.push(o);i.push({source:o,mode:s,negate:n,customEvent:l,signature:f,dependencies:_,event:d}),a=y.lastIndex}if(a&&a<t.length){let e=t.substring(a);e&&i.push({literal:e})}return i.length?i:null}static _evaluateBinding(t,e,r,i,a,n){let l;return l=e.signature?runMethodEffect(t,r,i,0,e.signature):r!=e.source?s(t,e.source):n&&o(r)?s(t,r):t.__data[r],e.negate&&(l=!l),l}}});const E=new class HostStack{constructor(){this.stack=[]}registerHost(t){if(this.stack.length){this.stack[this.stack.length-1]._enqueueClient(t)}}beginHosting(t){this.stack.push(t)}endHosting(t){let e=this.stack.length;e&&this.stack[e-1]==t&&this.stack.pop()}};