/**
@license
Copyright (c) 2017 Vaadin Ltd.
This program is available under Apache License Version 2.0, available at https://vaadin.com/license/
*/
export const KeyboardNavigationMixin=t=>class KeyboardNavigationMixin extends t{static get properties(){return{_headerFocusable:{type:Object,observer:"_focusableChanged"},_itemsFocusable:{type:Object,observer:"_focusableChanged"},_footerFocusable:{type:Object,observer:"_focusableChanged"},_navigatingIsHidden:Boolean,_focusedItemIndex:{type:Number,value:0},_focusedColumnOrder:Number}}ready(){super.ready(),this._ios||this._android||(this.addEventListener("keydown",this._onKeyDown),this.addEventListener("focusin",this._onFocusIn),this.addEventListener("focusout",this._onFocusOut),this.$.table.addEventListener("focusin",this._onCellFocusIn.bind(this)),this.$.table.addEventListener("focusout",this._onCellFocusOut.bind(this)),this.addEventListener("mousedown",()=>{this._toggleAttribute("navigating",!1,this),this._isMousedown=!0}),this.addEventListener("mouseup",()=>this._isMousedown=!1))}_focusableChanged(t,e){e&&e.setAttribute("tabindex","-1"),t&&t.setAttribute("tabindex","0")}_onKeyDown(t){let e,i=t.key;switch("Up"!==i&&"Down"!==i&&"Left"!==i&&"Right"!==i||(i="Arrow"+i),"Esc"===i&&(i="Escape"),"Spacebar"===i&&(i=" "),i){case"ArrowUp":case"ArrowDown":case"ArrowLeft":case"ArrowRight":case"PageUp":case"PageDown":case"Home":case"End":e="Navigation";break;case"Enter":case"Escape":case"F2":e="Interaction";break;case"Tab":e="Tab";break;case" ":e="Space"}this._detectInteracting(t),this.hasAttribute("interacting")&&"Interaction"!==e&&(e=void 0),e&&this[`_on${e}KeyDown`](t,i)}_ensureScrolledToIndex(t){Array.from(this.$.items.children).filter(e=>e.index===t)[0]||this._scrollToIndex(t)}_onNavigationKeyDown(t,e){function indexOfChildElement(t){return Array.prototype.indexOf.call(t.parentNode.children,t)}t.preventDefault();const i=this._lastVisibleIndex-this._firstVisibleIndex-1;let s=0,n=0;switch(e){case"ArrowRight":s=1;break;case"ArrowLeft":s=-1;break;case"Home":s=-1/0,t.ctrlKey&&(n=-1/0);break;case"End":s=1/0,t.ctrlKey&&(n=1/0);break;case"ArrowDown":n=1;break;case"ArrowUp":n=-1;break;case"PageDown":n=i;break;case"PageUp":n=-i}const o=t.composedPath()[0],r=indexOfChildElement(o),a=this._elementMatches(o,'[part~="details-cell"]'),h=o.parentNode,c=h.parentNode,l=(c===this.$.items?this._effectiveSize:c.children.length)-1,d=c===this.$.items?void 0!==this._focusedItemIndex?this._focusedItemIndex:h.index:indexOfChildElement(h);let u=Math.max(0,Math.min(d+n,l)),f=!1;if(c===this.$.items){const t=h._item,e=this._cache.getItemForIndex(u);f=a?0===n:1===n&&this._isDetailsOpened(t)||-1===n&&u!==d&&this._isDetailsOpened(e),f!==a&&(1===n&&f||-1===n&&!f)&&(u=d)}if(c!==this.$.items)if(u>d)for(;u<l&&c.children[u].hidden;)u++;else if(u<d)for(;u>0&&c.children[u].hidden;)u--;void 0===this._focusedColumnOrder&&(this._focusedColumnOrder=a?0:this._getColumns(c,d)[r]._order);const _=this._getColumns(c,u),g=_.filter(t=>!t.hidden).map(t=>t._order).sort((t,e)=>t-e),m=g.length-1,b=g.indexOf(g.slice(0).sort((t,e)=>Math.abs(t-this._focusedColumnOrder)-Math.abs(e-this._focusedColumnOrder))[0]),p=0===n&&a?b:Math.max(0,Math.min(b+s,m));p!==b&&(this._focusedColumnOrder=void 0),c===this.$.items&&this._ensureScrolledToIndex(u),this._toggleAttribute("navigating",!0,this);const v=_.reduce((t,e,i)=>(t[e._order]=i,t),{})[g[p]],x=c===this.$.items?Array.from(c.children).filter(t=>t.index===u)[0]:c.children[u];if(!x)return;const I=f?Array.from(x.children).filter(t=>this._elementMatches(t,'[part~="details-cell"]'))[0]:x.children[v];if(this._scrollHorizontallyToCell(I),c===this.$.items&&(this._focusedItemIndex=u),c===this.$.items){const t=I.getBoundingClientRect(),e=this.$.footer.getBoundingClientRect().top,i=this.$.header.getBoundingClientRect().bottom;t.bottom>e?(this.$.table.scrollTop+=t.bottom-e,this._scrollHandler()):t.top<i&&(this.$.table.scrollTop-=i-t.top,this._scrollHandler())}I.focus()}_parseEventPath(t){const e=t.indexOf(this.$.table);return{rowGroup:t[e-1],row:t[e-2],cell:t[e-3]}}_onInteractionKeyDown(t,e){const i=t.composedPath()[0],s="input"===i.localName&&!/^(button|checkbox|color|file|image|radio|range|reset|submit)$/i.test(i.type);let n;switch(e){case"Enter":n=!this.hasAttribute("interacting")||!s;break;case"Escape":n=!1;break;case"F2":n=!this.hasAttribute("interacting")}const{cell:o}=this._parseEventPath(t.composedPath());if(this.hasAttribute("interacting")!==n)if(n){const e=o._content.querySelector("[focus-target]")||o._content.firstElementChild;e&&(t.preventDefault(),e.focus(),this._toggleAttribute("interacting",!0,this),this._toggleAttribute("navigating",!1,this))}else t.preventDefault(),this._focusedColumnOrder=void 0,o.focus(),this._toggleAttribute("interacting",!1,this),this._toggleAttribute("navigating",!0,this)}_predictFocusStepTarget(t,e){const i=[this.$.table,this._headerFocusable,this._itemsFocusable,this._footerFocusable,this.$.focusexit];let s=i.indexOf(t);for(s+=e;s>=0&&s<=i.length-1&&(!i[s]||i[s].parentNode.hidden);)s+=e;return i[s]}_onTabKeyDown(t){const e=this._predictFocusStepTarget(t.composedPath()[0],t.shiftKey?-1:1);if(e===this.$.table)this.$.table.focus();else if(e===this.$.focusexit)this.$.focusexit.focus();else if(e===this._itemsFocusable){let i=e;const s=this._itemsFocusable.parentNode;if(this._ensureScrolledToIndex(this._focusedItemIndex),s.index!==this._focusedItemIndex){const t=Array.from(s.children).indexOf(this._itemsFocusable),e=Array.from(this.$.items.children).filter(t=>t.index===this._focusedItemIndex)[0];e&&(i=e.children[t])}t.preventDefault(),i.focus()}else t.preventDefault(),e.focus();this._toggleAttribute("navigating",!0,this)}_onSpaceKeyDown(t){t.preventDefault();const e=t.composedPath()[0];if(e._content&&e._content.firstElementChild){const t=this.hasAttribute("navigating");e._content.firstElementChild.click(),this._toggleAttribute("navigating",t,this)}else this.dispatchEvent(new CustomEvent("cell-activate",{detail:{model:this.__getRowModel(e.parentElement)}}))}_onFocusIn(t){this._isMousedown||this._toggleAttribute("navigating",!0,this);const e=t.composedPath()[0];e===this.$.table||e===this.$.focusexit?(this._predictFocusStepTarget(e,e===this.$.table?1:-1).focus(),this._toggleAttribute("interacting",!1,this)):this._detectInteracting(t)}_onFocusOut(t){this._toggleAttribute("navigating",!1,this),this._detectInteracting(t)}_onCellFocusIn(t){if(this._detectInteracting(t),3===t.composedPath().indexOf(this.$.table)){const e=t.composedPath()[0];this._activeRowGroup=e.parentNode.parentNode,this._activeRowGroup===this.$.header?this._headerFocusable=e:this._activeRowGroup===this.$.items?this._itemsFocusable=e:this._activeRowGroup===this.$.footer&&(this._footerFocusable=e),e._content.dispatchEvent(new CustomEvent("cell-focusin",{bubbles:!1}))}this._detectFocusedItemIndex(t)}_onCellFocusOut(t){if(3===t.composedPath().indexOf(this.$.table)){t.composedPath()[0]._content.dispatchEvent(new CustomEvent("cell-focusout",{bubbles:!1}))}}_detectInteracting(t){this._toggleAttribute("interacting",t.composedPath().some(t=>"vaadin-grid-cell-content"===t.localName),this)}_detectFocusedItemIndex(t){const{rowGroup:e,row:i}=this._parseEventPath(t.composedPath());e===this.$.items&&(this._focusedItemIndex=i.index)}_preventScrollerRotatingCellFocus(t,e){t.index===this._focusedItemIndex&&this.hasAttribute("navigating")&&this._activeRowGroup===this.$.items&&(this._navigatingIsHidden=!0,this._toggleAttribute("navigating",!1,this)),e===this._focusedItemIndex&&this._navigatingIsHidden&&(this._navigatingIsHidden=!1,this._toggleAttribute("navigating",!0,this))}_getColumns(t,e){let i=this._columnTree.length-1;return t===this.$.header?i=e:t===this.$.footer&&(i=this._columnTree.length-1-e),this._columnTree[i]}_resetKeyboardNavigation(){if(this.$.header.firstElementChild&&(this._headerFocusable=Array.from(this.$.header.firstElementChild.children).filter(t=>!t.hidden)[0]),this.$.items.firstElementChild){const t=this._iterateItems((t,e)=>{if(this._firstVisibleIndex===e)return this.$.items.children[t]});t&&(this._itemsFocusable=Array.from(t.children).filter(t=>!t.hidden)[0])}this.$.footer.firstElementChild&&(this._footerFocusable=Array.from(this.$.footer.firstElementChild.children).filter(t=>!t.hidden)[0])}_scrollHorizontallyToCell(t){if(t.hasAttribute("frozen")||this._elementMatches(t,'[part~="details-cell"]'))return;const e=t.getBoundingClientRect(),i=t.parentNode,s=Array.from(i.children).indexOf(t),n=this.$.table.getBoundingClientRect();let o=n.left,r=n.right;for(let t=s-1;t>=0;t--){const e=i.children[t];if(!e.hasAttribute("hidden")&&!this._elementMatches(e,'[part~="details-cell"]')&&e.hasAttribute("frozen")){o=e.getBoundingClientRect().right;break}}for(let t=s+1;t<i.children.length;t++){const e=i.children[t];if(!e.hasAttribute("hidden")&&!this._elementMatches(e,'[part~="details-cell"]')&&e.hasAttribute("frozen")){r=e.getBoundingClientRect().left;break}}e.left<o&&(this.$.table.scrollLeft+=Math.round(e.left-o)),e.right>r&&(this.$.table.scrollLeft+=Math.round(e.right-r))}_elementMatches(t,e){return t.matches?t.matches(e):-1!==Array.from(t.parentNode.querySelectorAll(e)).indexOf(t)}};