/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
var extendStatics=function(e,t){return(extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])})(e,t)};var __assign=function(){return(__assign=Object.assign||function __assign(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e}).apply(this,arguments)};function __values(e){var t="function"==typeof Symbol&&e[Symbol.iterator],r=0;return t?t.call(e):{next:function(){return e&&r>=e.length&&(e=void 0),{value:e&&e[r++],done:!e}}}}function __read(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}function __spread(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(__read(arguments[t]));return e}var e=[];Object.freeze(e);var t={};function getNextId(){return++L.mobxGuid}function fail(e){throw invariant(!1,e),"X"}function invariant(e,t){if(!e)throw new Error("[mobx] "+(t||"An invariant failed, however the error is obfuscated because this is a production build."))}Object.freeze(t);var r=[];function once(e){var t=!1;return function(){if(!t)return t=!0,e.apply(this,arguments)}}var noop=function(){};function isObject(e){return null!==e&&"object"==typeof e}function isPlainObject(e){if(null===e||"object"!=typeof e)return!1;var t=Object.getPrototypeOf(e);return t===Object.prototype||null===t}function addHiddenProp(e,t,r){Object.defineProperty(e,t,{enumerable:!1,writable:!0,configurable:!0,value:r})}function isPropertyConfigurable(e,t){var r=Object.getOwnPropertyDescriptor(e,t);return!r||!1!==r.configurable&&!1!==r.writable}function createInstanceofPredicate(e,t){var r="isMobX"+e;return t.prototype[r]=!0,function(e){return isObject(e)&&!0===e[r]}}function isArrayLike(e){return Array.isArray(e)||isObservableArray(e)}function isES6Map(e){return e instanceof Map}function isES6Set(e){return e instanceof Set}function getPlainObjectKeys(e){var t=new Set;for(var r in e)t.add(r);return Object.getOwnPropertySymbols(e).forEach((function(r){Object.getOwnPropertyDescriptor(e,r).enumerable&&t.add(r)})),Array.from(t)}function stringifyKey(e){return e&&e.toString?e.toString():new String(e).toString()}function toPrimitive(e){return null===e?null:"object"==typeof e?""+e:e}var n=Symbol("mobx administration"),o=function(){function Atom(e){void 0===e&&(e="Atom@"+getNextId()),this.name=e,this.isPendingUnobservation=!1,this.isBeingObserved=!1,this.observers=new Set,this.diffValue=0,this.lastAccessedBy=0,this.lowestObserverState=m.NOT_TRACKING}return Atom.prototype.onBecomeObserved=function(){this.onBecomeObservedListeners&&this.onBecomeObservedListeners.forEach((function(e){return e()}))},Atom.prototype.onBecomeUnobserved=function(){this.onBecomeUnobservedListeners&&this.onBecomeUnobservedListeners.forEach((function(e){return e()}))},Atom.prototype.reportObserved=function(){return reportObserved(this)},Atom.prototype.reportChanged=function(){startBatch(),function propagateChanged(e){if(e.lowestObserverState===m.STALE)return;e.lowestObserverState=m.STALE,e.observers.forEach((function(t){t.dependenciesState===m.UP_TO_DATE&&(t.isTracing!==g.NONE&&logTraceInfo(t,e),t.onBecomeStale()),t.dependenciesState=m.STALE}))}(this),endBatch()},Atom.prototype.toString=function(){return this.name},Atom}(),i=createInstanceofPredicate("Atom",o);function createAtom(e,t,r){void 0===t&&(t=noop),void 0===r&&(r=noop);var n=new o(e);return t!==noop&&onBecomeObserved(n,t),r!==noop&&onBecomeUnobserved(n,r),n}var a={identity:function identityComparer(e,t){return e===t},structural:function structuralComparer(e,t){return deepEqual(e,t)},default:function defaultComparer(e,t){return Object.is(e,t)},shallow:function shallowComparer(e,t){return deepEqual(e,t,1)}},s=Symbol("mobx did run lazy initializers"),c=Symbol("mobx pending decorators"),u={},l={};function createPropertyInitializerDescriptor(e,t){var r=t?u:l;return r[e]||(r[e]={configurable:!0,enumerable:t,get:function(){return initializeInstance(this),this[e]},set:function(t){initializeInstance(this),this[e]=t}})}function initializeInstance(e){var t,r;if(!0!==e[s]){var n=e[c];if(n){addHiddenProp(e,s,!0);var o=__spread(Object.getOwnPropertySymbols(n),Object.keys(n));try{for(var i=__values(o),a=i.next();!a.done;a=i.next()){var u=n[a.value];u.propertyCreator(e,u.prop,u.descriptor,u.decoratorTarget,u.decoratorArguments)}}catch(e){t={error:e}}finally{try{a&&!a.done&&(r=i.return)&&r.call(i)}finally{if(t)throw t.error}}}}}function createPropDecorator(t,r){return function decoratorFactory(){var n,o=function decorate(e,o,i,a){if(!0===a)return r(e,o,i,e,n),null;if("production"===process.env.NODE_ENV||quacksLikeADecorator(arguments)||fail("This function is a decorator, but it wasn't invoked like a decorator"),!Object.prototype.hasOwnProperty.call(e,c)){var s=e[c];addHiddenProp(e,c,__assign({},s))}return e[c][o]={prop:o,propertyCreator:r,descriptor:i,decoratorTarget:e,decoratorArguments:n},createPropertyInitializerDescriptor(o,t)};return quacksLikeADecorator(arguments)?(n=e,o.apply(null,arguments)):(n=Array.prototype.slice.call(arguments),o)}}function quacksLikeADecorator(e){return(2===e.length||3===e.length)&&("string"==typeof e[1]||"symbol"==typeof e[1])||4===e.length&&!0===e[3]}function deepEnhancer(e,t,r){return isObservable(e)?e:Array.isArray(e)?y.array(e,{name:r}):isPlainObject(e)?y.object(e,void 0,{name:r}):isES6Map(e)?y.map(e,{name:r}):isES6Set(e)?y.set(e,{name:r}):e}function referenceEnhancer(e){return e}function createDecoratorForEnhancer(e){invariant(e);var t=createPropDecorator(!0,(function(t,r,n,o,i){"production"!==process.env.NODE_ENV&&invariant(!n||!n.get,'@observable cannot be used on getter (property "'+stringifyKey(r)+'"), use @computed instead.');var a=n?n.initializer?n.initializer.call(t):n.value:void 0;asObservableObject(t).addObservableProp(r,a,e)})),r="undefined"!=typeof process&&process.env&&"production"!==process.env.NODE_ENV?function observableDecorator(){return arguments.length<2?fail("Incorrect decorator invocation. @observable decorator doesn't expect any arguments"):t.apply(null,arguments)}:t;return r.enhancer=e,r}var p={deep:!0,name:void 0,defaultDecorator:void 0,proxy:!0};function assertValidOption(e){/^(deep|name|equals|defaultDecorator|proxy)$/.test(e)||fail("invalid option for (extend)observable: "+e)}function asCreateObservableOptions(e){if(null==e)return p;if("string"==typeof e)return{name:e,deep:!0,proxy:!0};if("production"!==process.env.NODE_ENV){if("object"!=typeof e)return fail("expected options object");Object.keys(e).forEach(assertValidOption)}return e}Object.freeze(p);var d=createDecoratorForEnhancer(deepEnhancer),f=createDecoratorForEnhancer((function shallowEnhancer(e,t,r){return null==e?e:isObservableObject(e)||isObservableArray(e)||Z(e)||re(e)?e:Array.isArray(e)?y.array(e,{name:r,deep:!1}):isPlainObject(e)?y.object(e,void 0,{name:r,deep:!1}):isES6Map(e)?y.map(e,{name:r,deep:!1}):isES6Set(e)?y.set(e,{name:r,deep:!1}):fail("production"!==process.env.NODE_ENV&&"The shallow modifier / decorator can only used in combination with arrays, objects, maps and sets")})),v=createDecoratorForEnhancer(referenceEnhancer),b=createDecoratorForEnhancer((function refStructEnhancer(e,t,r){if("production"!==process.env.NODE_ENV&&isObservable(e))throw"observable.struct should not be used with observable values";return deepEqual(e,t)?t:e}));function getEnhancerFromOptions(e){return e.defaultDecorator?e.defaultDecorator.enhancer:!1===e.deep?referenceEnhancer:deepEnhancer}var h={box:function(e,t){arguments.length>2&&incorrectlyUsedAsDecorator("box");var r=asCreateObservableOptions(t);return new V(e,getEnhancerFromOptions(r),r.name,!0,r.equals)},array:function(e,t){arguments.length>2&&incorrectlyUsedAsDecorator("array");var r=asCreateObservableOptions(t);return createObservableArray(e,getEnhancerFromOptions(r),r.name)},map:function(e,t){arguments.length>2&&incorrectlyUsedAsDecorator("map");var r=asCreateObservableOptions(t);return new Q(e,getEnhancerFromOptions(r),r.name)},set:function(e,t){arguments.length>2&&incorrectlyUsedAsDecorator("set");var r=asCreateObservableOptions(t);return new te(e,getEnhancerFromOptions(r),r.name)},object:function(e,t,r){"string"==typeof arguments[1]&&incorrectlyUsedAsDecorator("object");var n=asCreateObservableOptions(r);if(!1===n.proxy)return extendObservable({},e,t,n);var o=getDefaultDecoratorFromObjectOptions(n),i=extendObservable({},void 0,void 0,n),a=createDynamicObservableObject(i);return extendObservableObjectWithProperties(a,e,t,o),a},ref:v,shallow:f,deep:d,struct:b},y=function createObservable(e,t,r){if("string"==typeof arguments[1]||"symbol"==typeof arguments[1])return d.apply(null,arguments);if(isObservable(e))return e;var n=isPlainObject(e)?y.object(e,t,r):Array.isArray(e)?y.array(e,t):isES6Map(e)?y.map(e,t):isES6Set(e)?y.set(e,t):e;if(n!==e)return n;fail("production"!==process.env.NODE_ENV&&"The provided value could not be converted into an observable. If you want just create an observable reference to the object use 'observable.box(value)'")};function incorrectlyUsedAsDecorator(e){fail("Expected one or two arguments to observable."+e+". Did you accidentally try to use observable."+e+" as decorator?")}Object.keys(h).forEach((function(e){return y[e]=h[e]}));var m,g,O=createPropDecorator(!1,(function(e,t,r,n,o){var i=r.get,a=r.set,s=o[0]||{};asObservableObject(e).addComputedProp(e,t,__assign({get:i,set:a,context:e},s))})),E=O({equals:a.structural}),A=function computed(e,t,r){if("string"==typeof t)return O.apply(null,arguments);if(null!==e&&"object"==typeof e&&1===arguments.length)return O.apply(null,arguments);"production"!==process.env.NODE_ENV&&(invariant("function"==typeof e,"First argument to `computed` should be an expression."),invariant(arguments.length<3,"Computed takes one or two arguments if used as function"));var n="object"==typeof t?t:{};return n.get=e,n.set="function"==typeof t?t:n.set,n.name=n.name||e.name||"",new j(n)};A.struct=E,function(e){e[e.NOT_TRACKING=-1]="NOT_TRACKING",e[e.UP_TO_DATE=0]="UP_TO_DATE",e[e.POSSIBLY_STALE=1]="POSSIBLY_STALE",e[e.STALE=2]="STALE"}(m||(m={})),function(e){e[e.NONE=0]="NONE",e[e.LOG=1]="LOG",e[e.BREAK=2]="BREAK"}(g||(g={}));var _=function _(e){this.cause=e};function isCaughtException(e){return e instanceof _}function shouldCompute(e){switch(e.dependenciesState){case m.UP_TO_DATE:return!1;case m.NOT_TRACKING:case m.STALE:return!0;case m.POSSIBLY_STALE:for(var t=allowStateReadsStart(!0),r=untrackedStart(),n=e.observing,o=n.length,i=0;i<o;i++){var a=n[i];if(C(a)){if(L.disableErrorBoundaries)a.get();else try{a.get()}catch(e){return untrackedEnd(r),allowStateReadsEnd(t),!0}if(e.dependenciesState===m.STALE)return untrackedEnd(r),allowStateReadsEnd(t),!0}}return changeDependenciesStateTo0(e),untrackedEnd(r),allowStateReadsEnd(t),!1}}function isComputingDerivation(){return null!==L.trackingDerivation}function checkIfStateModificationsAreAllowed(e){var t=e.observers.size>0;L.computationDepth>0&&t&&fail("production"!==process.env.NODE_ENV&&"Computed values are not allowed to cause side effects by changing observables that are already being observed. Tried to modify: "+e.name),L.allowStateChanges||!t&&"strict"!==L.enforceActions||fail("production"!==process.env.NODE_ENV&&(L.enforceActions?"Since strict-mode is enabled, changing observed observable values outside actions is not allowed. Please wrap the code in an `action` if this change is intended. Tried to modify: ":"Side effects like changing state are not allowed at this point. Are you trying to modify state from, for example, the render function of a React component? Tried to modify: ")+e.name)}function trackDerivedFunction(e,t,r){var n=allowStateReadsStart(!0);changeDependenciesStateTo0(e),e.newObserving=new Array(e.observing.length+100),e.unboundDepsCount=0,e.runId=++L.runId;var o,i=L.trackingDerivation;if(L.trackingDerivation=e,!0===L.disableErrorBoundaries)o=t.call(r);else try{o=t.call(r)}catch(e){o=new _(e)}return L.trackingDerivation=i,function bindDependencies(e){for(var t=e.observing,r=e.observing=e.newObserving,n=m.UP_TO_DATE,o=0,i=e.unboundDepsCount,a=0;a<i;a++){0===(s=r[a]).diffValue&&(s.diffValue=1,o!==a&&(r[o]=s),o++),s.dependenciesState>n&&(n=s.dependenciesState)}r.length=o,e.newObserving=null,i=t.length;for(;i--;){0===(s=t[i]).diffValue&&removeObserver(s,e),s.diffValue=0}for(;o--;){var s;1===(s=r[o]).diffValue&&(s.diffValue=0,addObserver(s,e))}n!==m.UP_TO_DATE&&(e.dependenciesState=n,e.onBecomeStale())}(e),function warnAboutDerivationWithoutDependencies(e){if("production"===process.env.NODE_ENV)return;if(0!==e.observing.length)return;(L.reactionRequiresObservable||e.requiresObservable)&&console.warn("[mobx] Derivation "+e.name+" is created/updated without reading any observable value")}(e),allowStateReadsEnd(n),o}function clearObserving(e){var t=e.observing;e.observing=[];for(var r=t.length;r--;)removeObserver(t[r],e);e.dependenciesState=m.NOT_TRACKING}function untracked(e){var t=untrackedStart();try{return e()}finally{untrackedEnd(t)}}function untrackedStart(){var e=L.trackingDerivation;return L.trackingDerivation=null,e}function untrackedEnd(e){L.trackingDerivation=e}function allowStateReadsStart(e){var t=L.allowStateReads;return L.allowStateReads=e,t}function allowStateReadsEnd(e){L.allowStateReads=e}function changeDependenciesStateTo0(e){if(e.dependenciesState!==m.UP_TO_DATE){e.dependenciesState=m.UP_TO_DATE;for(var t=e.observing,r=t.length;r--;)t[r].lowestObserverState=m.UP_TO_DATE}}var S=0,w=1,N=Object.getOwnPropertyDescriptor((function(){}),"name"),D=N&&N.configurable;function createAction(e,t,r){"production"!==process.env.NODE_ENV&&(invariant("function"==typeof t,"`action` can only be invoked on functions"),"string"==typeof e&&e||fail("actions should have valid names, got: '"+e+"'"));var res=function(){return executeAction(e,t,r||this,arguments)};return res.isMobxAction=!0,"production"!==process.env.NODE_ENV&&D&&Object.defineProperty(res,"name",{value:e}),res}function executeAction(e,t,r,n){var o=_startAction(e,r,n);try{return t.apply(r,n)}catch(e){throw o.error=e,e}finally{_endAction(o)}}function _startAction(e,t,r){var n=isSpyEnabled()&&!!e,o=0;if(n&&"production"!==process.env.NODE_ENV){o=Date.now();var i=r&&r.length||0,a=new Array(i);if(i>0)for(var s=0;s<i;s++)a[s]=r[s];spyReportStart({type:"action",name:e,object:t,arguments:a})}var c=untrackedStart();startBatch();var u={prevDerivation:c,prevAllowStateChanges:allowStateChangesStart(!0),prevAllowStateReads:allowStateReadsStart(!0),notifySpy:n,startTime:o,actionId:w++,parentActionId:S};return S=u.actionId,u}function _endAction(e){S!==e.actionId&&fail("invalid action stack. did you forget to finish an action?"),S=e.parentActionId,void 0!==e.error&&(L.suppressReactionErrors=!0),allowStateChangesEnd(e.prevAllowStateChanges),allowStateReadsEnd(e.prevAllowStateReads),endBatch(),untrackedEnd(e.prevDerivation),e.notifySpy&&"production"!==process.env.NODE_ENV&&spyReportEnd({time:Date.now()-e.startTime}),L.suppressReactionErrors=!1}function allowStateChanges(e,t){var r,n=allowStateChangesStart(e);try{r=t()}finally{allowStateChangesEnd(n)}return r}function allowStateChangesStart(e){var t=L.allowStateChanges;return L.allowStateChanges=e,t}function allowStateChangesEnd(e){L.allowStateChanges=e}function allowStateChangesInsideComputed(e){var t,r=L.computationDepth;L.computationDepth=0;try{t=e()}finally{L.computationDepth=r}return t}var V=function(e){function ObservableValue(t,r,n,o,i){void 0===n&&(n="ObservableValue@"+getNextId()),void 0===o&&(o=!0),void 0===i&&(i=a.default);var s=e.call(this,n)||this;return s.enhancer=r,s.name=n,s.equals=i,s.hasUnreportedChange=!1,s.value=r(t,void 0,n),o&&isSpyEnabled()&&"production"!==process.env.NODE_ENV&&spyReport({type:"create",name:s.name,newValue:""+s.value}),s}return function __extends(e,t){function __(){this.constructor=e}extendStatics(e,t),e.prototype=null===t?Object.create(t):(__.prototype=t.prototype,new __)}(ObservableValue,e),ObservableValue.prototype.dehanceValue=function(e){return void 0!==this.dehancer?this.dehancer(e):e},ObservableValue.prototype.set=function(e){var t=this.value;if((e=this.prepareNewValue(e))!==L.UNCHANGED){var r=isSpyEnabled();r&&"production"!==process.env.NODE_ENV&&spyReportStart({type:"update",name:this.name,newValue:e,oldValue:t}),this.setNewValue(e),r&&"production"!==process.env.NODE_ENV&&spyReportEnd()}},ObservableValue.prototype.prepareNewValue=function(e){if(checkIfStateModificationsAreAllowed(this),hasInterceptors(this)){var t=interceptChange(this,{object:this,type:"update",newValue:e});if(!t)return L.UNCHANGED;e=t.newValue}return e=this.enhancer(e,this.value,this.name),this.equals(this.value,e)?L.UNCHANGED:e},ObservableValue.prototype.setNewValue=function(e){var t=this.value;this.value=e,this.reportChanged(),hasListeners(this)&&notifyListeners(this,{type:"update",object:this,newValue:e,oldValue:t})},ObservableValue.prototype.get=function(){return this.reportObserved(),this.dehanceValue(this.value)},ObservableValue.prototype.intercept=function(e){return registerInterceptor(this,e)},ObservableValue.prototype.observe=function(e,t){return t&&e({object:this,type:"update",newValue:this.value,oldValue:void 0}),registerListener(this,e)},ObservableValue.prototype.toJSON=function(){return this.get()},ObservableValue.prototype.toString=function(){return this.name+"["+this.value+"]"},ObservableValue.prototype.valueOf=function(){return toPrimitive(this.get())},ObservableValue.prototype[Symbol.toPrimitive]=function(){return this.valueOf()},ObservableValue}(o),x=createInstanceofPredicate("ObservableValue",V),j=function(){function ComputedValue(e){this.dependenciesState=m.NOT_TRACKING,this.observing=[],this.newObserving=null,this.isBeingObserved=!1,this.isPendingUnobservation=!1,this.observers=new Set,this.diffValue=0,this.runId=0,this.lastAccessedBy=0,this.lowestObserverState=m.UP_TO_DATE,this.unboundDepsCount=0,this.__mapid="#"+getNextId(),this.value=new _(null),this.isComputing=!1,this.isRunningSetter=!1,this.isTracing=g.NONE,invariant(e.get,"missing option for computed: get"),this.derivation=e.get,this.name=e.name||"ComputedValue@"+getNextId(),e.set&&(this.setter=createAction(this.name+"-setter",e.set)),this.equals=e.equals||(e.compareStructural||e.struct?a.structural:a.default),this.scope=e.context,this.requiresReaction=!!e.requiresReaction,this.keepAlive=!!e.keepAlive}return ComputedValue.prototype.onBecomeStale=function(){!function propagateMaybeChanged(e){if(e.lowestObserverState!==m.UP_TO_DATE)return;e.lowestObserverState=m.POSSIBLY_STALE,e.observers.forEach((function(t){t.dependenciesState===m.UP_TO_DATE&&(t.dependenciesState=m.POSSIBLY_STALE,t.isTracing!==g.NONE&&logTraceInfo(t,e),t.onBecomeStale())}))}(this)},ComputedValue.prototype.onBecomeObserved=function(){this.onBecomeObservedListeners&&this.onBecomeObservedListeners.forEach((function(e){return e()}))},ComputedValue.prototype.onBecomeUnobserved=function(){this.onBecomeUnobservedListeners&&this.onBecomeUnobservedListeners.forEach((function(e){return e()}))},ComputedValue.prototype.get=function(){this.isComputing&&fail("Cycle detected in computation "+this.name+": "+this.derivation),0!==L.inBatch||0!==this.observers.size||this.keepAlive?(reportObserved(this),shouldCompute(this)&&this.trackAndCompute()&&function propagateChangeConfirmed(e){if(e.lowestObserverState===m.STALE)return;e.lowestObserverState=m.STALE,e.observers.forEach((function(t){t.dependenciesState===m.POSSIBLY_STALE?t.dependenciesState=m.STALE:t.dependenciesState===m.UP_TO_DATE&&(e.lowestObserverState=m.UP_TO_DATE)}))}(this)):shouldCompute(this)&&(this.warnAboutUntrackedRead(),startBatch(),this.value=this.computeValue(!1),endBatch());var e=this.value;if(isCaughtException(e))throw e.cause;return e},ComputedValue.prototype.peek=function(){var e=this.computeValue(!1);if(isCaughtException(e))throw e.cause;return e},ComputedValue.prototype.set=function(e){if(this.setter){invariant(!this.isRunningSetter,"The setter of computed value '"+this.name+"' is trying to update itself. Did you intend to update an _observable_ value, instead of the computed property?"),this.isRunningSetter=!0;try{this.setter.call(this.scope,e)}finally{this.isRunningSetter=!1}}else invariant(!1,"production"!==process.env.NODE_ENV&&"[ComputedValue '"+this.name+"'] It is not possible to assign a new value to a computed value.")},ComputedValue.prototype.trackAndCompute=function(){isSpyEnabled()&&"production"!==process.env.NODE_ENV&&spyReport({object:this.scope,type:"compute",name:this.name});var e=this.value,t=this.dependenciesState===m.NOT_TRACKING,r=this.computeValue(!0),n=t||isCaughtException(e)||isCaughtException(r)||!this.equals(e,r);return n&&(this.value=r),n},ComputedValue.prototype.computeValue=function(e){var t;if(this.isComputing=!0,L.computationDepth++,e)t=trackDerivedFunction(this,this.derivation,this.scope);else if(!0===L.disableErrorBoundaries)t=this.derivation.call(this.scope);else try{t=this.derivation.call(this.scope)}catch(e){t=new _(e)}return L.computationDepth--,this.isComputing=!1,t},ComputedValue.prototype.suspend=function(){this.keepAlive||(clearObserving(this),this.value=void 0)},ComputedValue.prototype.observe=function(e,t){var r=this,n=!0,o=void 0;return autorun((function(){var i=r.get();if(!n||t){var a=untrackedStart();e({type:"update",object:r,newValue:i,oldValue:o}),untrackedEnd(a)}n=!1,o=i}))},ComputedValue.prototype.warnAboutUntrackedRead=function(){"production"!==process.env.NODE_ENV&&(!0===this.requiresReaction&&fail("[mobx] Computed value "+this.name+" is read outside a reactive context"),this.isTracing!==g.NONE&&console.log("[mobx.trace] '"+this.name+"' is being read outside a reactive context. Doing a full recompute"),L.computedRequiresReaction&&console.warn("[mobx] Computed value "+this.name+" is being read outside a reactive context. Doing a full recompute"))},ComputedValue.prototype.toJSON=function(){return this.get()},ComputedValue.prototype.toString=function(){return this.name+"["+this.derivation.toString()+"]"},ComputedValue.prototype.valueOf=function(){return toPrimitive(this.get())},ComputedValue.prototype[Symbol.toPrimitive]=function(){return this.valueOf()},ComputedValue}(),C=createInstanceofPredicate("ComputedValue",j),R=["mobxGuid","spyListeners","enforceActions","computedRequiresReaction","reactionRequiresObservable","observableRequiresReaction","allowStateReads","disableErrorBoundaries","runId","UNCHANGED"],P=function P(){this.version=5,this.UNCHANGED={},this.trackingDerivation=null,this.computationDepth=0,this.runId=0,this.mobxGuid=0,this.inBatch=0,this.pendingUnobservations=[],this.pendingReactions=[],this.isRunningReactions=!1,this.allowStateChanges=!0,this.allowStateReads=!0,this.enforceActions=!1,this.spyListeners=[],this.globalReactionErrorHandlers=[],this.computedRequiresReaction=!1,this.reactionRequiresObservable=!1,this.observableRequiresReaction=!1,this.computedConfigurable=!1,this.disableErrorBoundaries=!1,this.suppressReactionErrors=!1},k={};function getGlobal(){return"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:k}var I=!0,T=!1,L=function(){var e=getGlobal();return e.__mobxInstanceCount>0&&!e.__mobxGlobals&&(I=!1),e.__mobxGlobals&&e.__mobxGlobals.version!==(new P).version&&(I=!1),I?e.__mobxGlobals?(e.__mobxInstanceCount+=1,e.__mobxGlobals.UNCHANGED||(e.__mobxGlobals.UNCHANGED={}),e.__mobxGlobals):(e.__mobxInstanceCount=1,e.__mobxGlobals=new P):(setTimeout((function(){T||fail("There are multiple, different versions of MobX active. Make sure MobX is loaded only once or use `configure({ isolateGlobalState: true })`")}),1),new P)}();function getGlobalState(){return L}function resetGlobalState(){var e=new P;for(var t in e)-1===R.indexOf(t)&&(L[t]=e[t]);L.allowStateChanges=!L.enforceActions}function addObserver(e,t){e.observers.add(t),e.lowestObserverState>t.dependenciesState&&(e.lowestObserverState=t.dependenciesState)}function removeObserver(e,t){e.observers.delete(t),0===e.observers.size&&queueForUnobservation(e)}function queueForUnobservation(e){!1===e.isPendingUnobservation&&(e.isPendingUnobservation=!0,L.pendingUnobservations.push(e))}function startBatch(){L.inBatch++}function endBatch(){if(0==--L.inBatch){runReactions();for(var e=L.pendingUnobservations,t=0;t<e.length;t++){var r=e[t];r.isPendingUnobservation=!1,0===r.observers.size&&(r.isBeingObserved&&(r.isBeingObserved=!1,r.onBecomeUnobserved()),r instanceof j&&r.suspend())}L.pendingUnobservations=[]}}function reportObserved(e){!function checkIfStateReadsAreAllowed(e){"production"!==process.env.NODE_ENV&&!L.allowStateReads&&L.observableRequiresReaction&&console.warn("[mobx] Observable "+e.name+" being read outside a reactive context")}(e);var t=L.trackingDerivation;return null!==t?(t.runId!==e.lastAccessedBy&&(e.lastAccessedBy=t.runId,t.newObserving[t.unboundDepsCount++]=e,e.isBeingObserved||(e.isBeingObserved=!0,e.onBecomeObserved())),!0):(0===e.observers.size&&L.inBatch>0&&queueForUnobservation(e),!1)}function logTraceInfo(e,t){if(console.log("[mobx.trace] '"+e.name+"' is invalidated due to a change in: '"+t.name+"'"),e.isTracing===g.BREAK){var r=[];!function printDepTree(e,t,r){if(t.length>=1e3)return void t.push("(and many more)");t.push(""+new Array(r).join("\t")+e.name),e.dependencies&&e.dependencies.forEach((function(e){return printDepTree(e,t,r+1)}))}(getDependencyTree(e),r,1),new Function("debugger;\n/*\nTracing '"+e.name+"'\n\nYou are entering this break point because derivation '"+e.name+"' is being traced and '"+t.name+"' is now forcing it to update.\nJust follow the stacktrace you should now see in the devtools to see precisely what piece of your code is causing this update\nThe stackframe you are looking for is at least ~6-8 stack-frames up.\n\n"+(e instanceof j?e.derivation.toString().replace(/[*]\//g,"/"):"")+"\n\nThe dependencies for this derivation are:\n\n"+r.join("\n")+"\n*/\n    ")()}}var B=function(){function Reaction(e,t,r,n){void 0===e&&(e="Reaction@"+getNextId()),void 0===n&&(n=!1),this.name=e,this.onInvalidate=t,this.errorHandler=r,this.requiresObservable=n,this.observing=[],this.newObserving=[],this.dependenciesState=m.NOT_TRACKING,this.diffValue=0,this.runId=0,this.unboundDepsCount=0,this.__mapid="#"+getNextId(),this.isDisposed=!1,this._isScheduled=!1,this._isTrackPending=!1,this._isRunning=!1,this.isTracing=g.NONE}return Reaction.prototype.onBecomeStale=function(){this.schedule()},Reaction.prototype.schedule=function(){this._isScheduled||(this._isScheduled=!0,L.pendingReactions.push(this),runReactions())},Reaction.prototype.isScheduled=function(){return this._isScheduled},Reaction.prototype.runReaction=function(){if(!this.isDisposed){if(startBatch(),this._isScheduled=!1,shouldCompute(this)){this._isTrackPending=!0;try{this.onInvalidate(),this._isTrackPending&&isSpyEnabled()&&"production"!==process.env.NODE_ENV&&spyReport({name:this.name,type:"scheduled-reaction"})}catch(e){this.reportExceptionInDerivation(e)}}endBatch()}},Reaction.prototype.track=function(e){if(!this.isDisposed){startBatch();var t,r=isSpyEnabled();r&&"production"!==process.env.NODE_ENV&&(t=Date.now(),spyReportStart({name:this.name,type:"reaction"})),this._isRunning=!0;var n=trackDerivedFunction(this,e,void 0);this._isRunning=!1,this._isTrackPending=!1,this.isDisposed&&clearObserving(this),isCaughtException(n)&&this.reportExceptionInDerivation(n.cause),r&&"production"!==process.env.NODE_ENV&&spyReportEnd({time:Date.now()-t}),endBatch()}},Reaction.prototype.reportExceptionInDerivation=function(e){var t=this;if(this.errorHandler)this.errorHandler(e,this);else{if(L.disableErrorBoundaries)throw e;var r="[mobx] Encountered an uncaught exception that was thrown by a reaction or observer component, in: '"+this+"'";L.suppressReactionErrors?console.warn("[mobx] (error in reaction '"+this.name+"' suppressed, fix error of causing action below)"):console.error(r,e),isSpyEnabled()&&spyReport({type:"error",name:this.name,message:r,error:""+e}),L.globalReactionErrorHandlers.forEach((function(r){return r(e,t)}))}},Reaction.prototype.dispose=function(){this.isDisposed||(this.isDisposed=!0,this._isRunning||(startBatch(),clearObserving(this),endBatch()))},Reaction.prototype.getDisposer=function(){var e=this.dispose.bind(this);return e[n]=this,e},Reaction.prototype.toString=function(){return"Reaction["+this.name+"]"},Reaction.prototype.trace=function(e){void 0===e&&(e=!1),trace(this,e)},Reaction}();function onReactionError(e){return L.globalReactionErrorHandlers.push(e),function(){var t=L.globalReactionErrorHandlers.indexOf(e);t>=0&&L.globalReactionErrorHandlers.splice(t,1)}}var reactionScheduler=function(e){return e()};function runReactions(){L.inBatch>0||L.isRunningReactions||reactionScheduler(runReactionsHelper)}function runReactionsHelper(){L.isRunningReactions=!0;for(var e=L.pendingReactions,t=0;e.length>0;){100==++t&&(console.error("Reaction doesn't converge to a stable state after 100 iterations. Probably there is a cycle in the reactive function: "+e[0]),e.splice(0));for(var r=e.splice(0),n=0,o=r.length;n<o;n++)r[n].runReaction()}L.isRunningReactions=!1}var M=createInstanceofPredicate("Reaction",B);function setReactionScheduler(e){var t=reactionScheduler;reactionScheduler=function(r){return e((function(){return t(r)}))}}function isSpyEnabled(){return"production"!==process.env.NODE_ENV&&!!L.spyListeners.length}function spyReport(e){if("production"!==process.env.NODE_ENV&&L.spyListeners.length)for(var t=L.spyListeners,r=0,n=t.length;r<n;r++)t[r](e)}function spyReportStart(e){"production"!==process.env.NODE_ENV&&spyReport(__assign(__assign({},e),{spyReportStart:!0}))}var U={spyReportEnd:!0};function spyReportEnd(e){"production"!==process.env.NODE_ENV&&spyReport(e?__assign(__assign({},e),{spyReportEnd:!0}):U)}function spy(e){return"production"===process.env.NODE_ENV?(console.warn("[mobx.spy] Is a no-op in production builds"),function(){}):(L.spyListeners.push(e),once((function(){L.spyListeners=L.spyListeners.filter((function(t){return t!==e}))})))}function dontReassignFields(){fail("production"!==process.env.NODE_ENV&&"@action fields are not reassignable")}function namedActionDecorator(e){return function(t,r,n){if(n){if("production"!==process.env.NODE_ENV&&void 0!==n.get)return fail("@action cannot be used with getters");if(n.value)return{value:createAction(e,n.value),enumerable:!1,configurable:!0,writable:!0};var o=n.initializer;return{enumerable:!1,configurable:!0,writable:!0,initializer:function(){return createAction(e,o.call(this))}}}return actionFieldDecorator(e).apply(this,arguments)}}function actionFieldDecorator(e){return function(t,r,n){Object.defineProperty(t,r,{configurable:!0,enumerable:!1,get:function(){},set:function(t){addHiddenProp(this,r,G(e,t))}})}}var G=function action(e,t,r,n){return 1===arguments.length&&"function"==typeof e?createAction(e.name||"<unnamed action>",e):2===arguments.length&&"function"==typeof t?createAction(e,t):1===arguments.length&&"string"==typeof e?namedActionDecorator(e):!0!==n?namedActionDecorator(t).apply(null,arguments):void addHiddenProp(e,t,createAction(e.name||t,r.value,this))};function runInAction(e,t){var r="string"==typeof e?e:e.name||"<unnamed action>",n="function"==typeof e?e:t;return"production"!==process.env.NODE_ENV&&(invariant("function"==typeof n&&0===n.length,"`runInAction` expects a function without arguments"),"string"==typeof r&&r||fail("actions should have valid names, got: '"+r+"'")),executeAction(r,n,this,void 0)}function isAction(e){return"function"==typeof e&&!0===e.isMobxAction}function defineBoundAction(e,t,r){addHiddenProp(e,t,createAction(t,r.bind(e)))}function autorun(e,r){void 0===r&&(r=t),"production"!==process.env.NODE_ENV&&(invariant("function"==typeof e,"Autorun expects a function as first argument"),invariant(!1===isAction(e),"Autorun does not accept actions since actions are untrackable"));var n,o=r&&r.name||e.name||"Autorun@"+getNextId();if(!r.scheduler&&!r.delay)n=new B(o,(function(){this.track(reactionRunner)}),r.onError,r.requiresObservable);else{var i=createSchedulerFromOptions(r),a=!1;n=new B(o,(function(){a||(a=!0,i((function(){a=!1,n.isDisposed||n.track(reactionRunner)})))}),r.onError,r.requiresObservable)}function reactionRunner(){e(n)}return n.schedule(),n.getDisposer()}G.bound=function boundActionDecorator(e,t,r,n){return!0===n?(defineBoundAction(e,t,r.value),null):r?{configurable:!0,enumerable:!1,get:function(){return defineBoundAction(this,t,r.value||r.initializer.call(this)),this[t]},set:dontReassignFields}:{enumerable:!1,configurable:!0,set:function(e){defineBoundAction(this,t,e)},get:function(){}}};var run=function(e){return e()};function createSchedulerFromOptions(e){return e.scheduler?e.scheduler:e.delay?function(t){return setTimeout(t,e.delay)}:run}function reaction(e,r,n){void 0===n&&(n=t),"production"!==process.env.NODE_ENV&&(invariant("function"==typeof e,"First argument to reaction should be a function"),invariant("object"==typeof n,"Third argument of reactions should be an object"));var o,i=n.name||"Reaction@"+getNextId(),s=G(i,n.onError?function wrapErrorHandler(e,t){return function(){try{return t.apply(this,arguments)}catch(t){e.call(this,t)}}}(n.onError,r):r),c=!n.scheduler&&!n.delay,u=createSchedulerFromOptions(n),l=!0,p=!1,d=n.compareStructural?a.structural:n.equals||a.default,f=new B(i,(function(){l||c?reactionRunner():p||(p=!0,u(reactionRunner))}),n.onError,n.requiresObservable);function reactionRunner(){if(p=!1,!f.isDisposed){var t=!1;f.track((function(){var r=e(f);t=l||!d(o,r),o=r})),l&&n.fireImmediately&&s(o,f),l||!0!==t||s(o,f),l&&(l=!1)}}return f.schedule(),f.getDisposer()}function onBecomeObserved(e,t,r){return interceptHook("onBecomeObserved",e,t,r)}function onBecomeUnobserved(e,t,r){return interceptHook("onBecomeUnobserved",e,t,r)}function interceptHook(e,t,r,n){var o="function"==typeof n?getAtom(t,r):getAtom(t),i="function"==typeof n?n:r,a=e+"Listeners";return o[a]?o[a].add(i):o[a]=new Set([i]),"function"!=typeof o[e]?fail("production"!==process.env.NODE_ENV&&"Not an atom that can be (un)observed"):function(){var e=o[a];e&&(e.delete(i),0===e.size&&delete o[a])}}function configure(e){var t=e.enforceActions,n=e.computedRequiresReaction,o=e.computedConfigurable,i=e.disableErrorBoundaries,a=e.reactionScheduler,s=e.reactionRequiresObservable,c=e.observableRequiresReaction;if(!0===e.isolateGlobalState&&function isolateGlobalState(){(L.pendingReactions.length||L.inBatch||L.isRunningReactions)&&fail("isolateGlobalState should be called before MobX is running any reactions"),T=!0,I&&(0==--getGlobal().__mobxInstanceCount&&(getGlobal().__mobxGlobals=void 0),L=new P)}(),void 0!==t){"boolean"!=typeof t&&"strict"!==t||function deprecated(e,t){return"production"!==process.env.NODE_ENV&&(t?deprecated("'"+e+"', use '"+t+"' instead."):-1===r.indexOf(e)&&(r.push(e),console.error("[mobx] Deprecated: "+e),!0))}("Deprecated value for 'enforceActions', use 'false' => '\"never\"', 'true' => '\"observed\"', '\"strict\"' => \"'always'\" instead");var u=void 0;switch(t){case!0:case"observed":u=!0;break;case!1:case"never":u=!1;break;case"strict":case"always":u="strict";break;default:fail("Invalid value for 'enforceActions': '"+t+"', expected 'never', 'always' or 'observed'")}L.enforceActions=u,L.allowStateChanges=!0!==u&&"strict"!==u}void 0!==n&&(L.computedRequiresReaction=!!n),void 0!==s&&(L.reactionRequiresObservable=!!s),void 0!==c&&(L.observableRequiresReaction=!!c,L.allowStateReads=!L.observableRequiresReaction),void 0!==o&&(L.computedConfigurable=!!o),void 0!==i&&(!0===i&&console.warn("WARNING: Debug feature only. MobX will NOT recover from errors when `disableErrorBoundaries` is enabled."),L.disableErrorBoundaries=!!i),a&&setReactionScheduler(a)}function decorate(e,t){"production"!==process.env.NODE_ENV&&invariant(isPlainObject(t),"Decorators should be a key value map");var r="function"==typeof e?e.prototype:e,_loop_1=function(e){var n=t[e];Array.isArray(n)||(n=[n]),"production"!==process.env.NODE_ENV&&invariant(n.every((function(e){return"function"==typeof e})),"Decorate: expected a decorator function or array of decorator functions for '"+e+"'");var o=Object.getOwnPropertyDescriptor(r,e),i=n.reduce((function(t,n){return n(r,e,t)}),o);i&&Object.defineProperty(r,e,i)};for(var n in t)_loop_1(n);return e}function extendObservable(e,t,r,n){"production"!==process.env.NODE_ENV&&(invariant(arguments.length>=2&&arguments.length<=4,"'extendObservable' expected 2-4 arguments"),invariant("object"==typeof e,"'extendObservable' expects an object as first argument"),invariant(!Z(e),"'extendObservable' should not be used on maps, use map.merge instead"));var o=getDefaultDecoratorFromObjectOptions(n=asCreateObservableOptions(n));return initializeInstance(e),asObservableObject(e,n.name,o.enhancer),t&&extendObservableObjectWithProperties(e,t,r,o),e}function getDefaultDecoratorFromObjectOptions(e){return e.defaultDecorator||(!1===e.deep?v:d)}function extendObservableObjectWithProperties(e,t,r,n){var o,i,a,s;if("production"!==process.env.NODE_ENV&&(invariant(!isObservable(t),"Extending an object with another observable (object) is not supported. Please construct an explicit propertymap, using `toJS` if need. See issue #540"),r)){var c=getPlainObjectKeys(r);try{for(var u=__values(c),l=u.next();!l.done;l=u.next()){(f=l.value)in t||fail("Trying to declare a decorator for unspecified property '"+stringifyKey(f)+"'")}}catch(e){o={error:e}}finally{try{l&&!l.done&&(i=u.return)&&i.call(u)}finally{if(o)throw o.error}}}startBatch();try{c=getPlainObjectKeys(t);try{for(var p=__values(c),d=p.next();!d.done;d=p.next()){var f=d.value,v=Object.getOwnPropertyDescriptor(t,f);"production"!==process.env.NODE_ENV&&(isPlainObject(t)||fail("'extendObservabe' only accepts plain objects as second argument"),isComputed(v.value)&&fail("Passing a 'computed' as initial property value is no longer supported by extendObservable. Use a getter or decorator instead"));var b=r&&f in r?r[f]:v.get?O:n;"production"!==process.env.NODE_ENV&&"function"!=typeof b&&fail("Not a valid decorator for '"+stringifyKey(f)+"', got: "+b);var h=b(e,f,v,!0);h&&Object.defineProperty(e,f,h)}}catch(e){a={error:e}}finally{try{d&&!d.done&&(s=p.return)&&s.call(p)}finally{if(a)throw a.error}}}finally{endBatch()}}function getDependencyTree(e,t){return nodeToDependencyTree(getAtom(e,t))}function nodeToDependencyTree(e){var t={name:e.name};return e.observing&&e.observing.length>0&&(t.dependencies=function unique(e){var t=[];return e.forEach((function(e){-1===t.indexOf(e)&&t.push(e)})),t}(e.observing).map(nodeToDependencyTree)),t}function getObserverTree(e,t){return nodeToObserverTree(getAtom(e,t))}function nodeToObserverTree(e){var t={name:e.name};return function hasObservers(e){return e.observers&&e.observers.size>0}(e)&&(t.observers=Array.from(function getObservers(e){return e.observers}(e)).map(nodeToObserverTree)),t}var q=0;function FlowCancellationError(){this.message="FLOW_CANCELLED"}function isFlowCancellationError(e){return e instanceof FlowCancellationError}function flow(e){1!==arguments.length&&fail(!!process.env.NODE_ENV&&"Flow expects 1 argument and cannot be used as decorator");var t=e.name||"<unnamed flow>";return function(){var r,n=this,o=arguments,i=++q,a=G(t+" - runid: "+i+" - init",e).apply(n,o),s=void 0,c=new Promise((function(e,n){var o=0;function onFulfilled(e){var r;s=void 0;try{r=G(t+" - runid: "+i+" - yield "+o++,a.next).call(a,e)}catch(e){return n(e)}next(r)}function onRejected(e){var r;s=void 0;try{r=G(t+" - runid: "+i+" - yield "+o++,a.throw).call(a,e)}catch(e){return n(e)}next(r)}function next(t){if(!t||"function"!=typeof t.then)return t.done?e(t.value):(s=Promise.resolve(t.value)).then(onFulfilled,onRejected);t.then(next,n)}r=n,onFulfilled(void 0)}));return c.cancel=G(t+" - runid: "+i+" - cancel",(function(){try{s&&cancelPromise(s);var e=a.return(void 0),t=Promise.resolve(e.value);t.then(noop,noop),cancelPromise(t),r(new FlowCancellationError)}catch(e){r(e)}})),c}}function cancelPromise(e){"function"==typeof e.cancel&&e.cancel()}function interceptReads(e,t,r){var n;if(Z(e)||isObservableArray(e)||x(e))n=getAdministration(e);else{if(!isObservableObject(e))return fail("production"!==process.env.NODE_ENV&&"Expected observable map, object or array as first array");if("string"!=typeof t)return fail("production"!==process.env.NODE_ENV&&"InterceptReads can only be used with a specific property, not with an object in general");n=getAdministration(e,t)}return void 0!==n.dehancer?fail("production"!==process.env.NODE_ENV&&"An intercept reader was already established"):(n.dehancer="function"==typeof t?t:r,function(){n.dehancer=void 0})}function intercept(e,t,r){return"function"==typeof r?function interceptProperty(e,t,r){return getAdministration(e,t).intercept(r)}(e,t,r):function interceptInterceptable(e,t){return getAdministration(e).intercept(t)}(e,t)}function _isComputed(e,t){if(null==e)return!1;if(void 0!==t){if(!1===isObservableObject(e))return!1;if(!e[n].values.has(t))return!1;var r=getAtom(e,t);return C(r)}return C(e)}function isComputed(e){return arguments.length>1?fail("production"!==process.env.NODE_ENV&&"isComputed expects only 1 argument. Use isObservableProp to inspect the observability of a property"):_isComputed(e)}function isComputedProp(e,t){return"string"!=typeof t?fail("production"!==process.env.NODE_ENV&&"isComputed expected a property name as second argument"):_isComputed(e,t)}function _isObservable(e,t){return null!=e&&(void 0!==t?"production"!==process.env.NODE_ENV&&(Z(e)||isObservableArray(e))?fail("isObservable(object, propertyName) is not supported for arrays and maps. Use map.has or array.length instead."):!!isObservableObject(e)&&e[n].values.has(t):isObservableObject(e)||!!e[n]||i(e)||M(e)||C(e))}function isObservable(e){return 1!==arguments.length&&fail("production"!==process.env.NODE_ENV&&"isObservable expects only 1 argument. Use isObservableProp to inspect the observability of a property"),_isObservable(e)}function isObservableProp(e,t){return"string"!=typeof t?fail("production"!==process.env.NODE_ENV&&"expected a property name as second argument"):_isObservable(e,t)}function keys(e){return isObservableObject(e)?e[n].getKeys():Z(e)?Array.from(e.keys()):re(e)?Array.from(e.keys()):isObservableArray(e)?e.map((function(e,t){return t})):fail("production"!==process.env.NODE_ENV&&"'keys()' can only be used on observable objects, arrays, sets and maps")}function values(e){return isObservableObject(e)?keys(e).map((function(t){return e[t]})):Z(e)?keys(e).map((function(t){return e.get(t)})):re(e)?Array.from(e.values()):isObservableArray(e)?e.slice():fail("production"!==process.env.NODE_ENV&&"'values()' can only be used on observable objects, arrays, sets and maps")}function entries(e){return isObservableObject(e)?keys(e).map((function(t){return[t,e[t]]})):Z(e)?keys(e).map((function(t){return[t,e.get(t)]})):re(e)?Array.from(e.entries()):isObservableArray(e)?e.map((function(e,t){return[t,e]})):fail("production"!==process.env.NODE_ENV&&"'entries()' can only be used on observable objects, arrays and maps")}function set(e,t,r){if(2!==arguments.length||re(e))if(isObservableObject(e)){var o=e[n],i=o.values.get(t);i?o.write(t,r):o.addObservableProp(t,r,o.defaultEnhancer)}else if(Z(e))e.set(t,r);else if(re(e))e.add(t);else{if(!isObservableArray(e))return fail("production"!==process.env.NODE_ENV&&"'set()' can only be used on observable objects, arrays and maps");"number"!=typeof t&&(t=parseInt(t,10)),invariant(t>=0,"Not a valid index: '"+t+"'"),startBatch(),t>=e.length&&(e.length=t+1),e[t]=r,endBatch()}else{startBatch();var a=t;try{for(var s in a)set(e,s,a[s])}finally{endBatch()}}}function remove(e,t){if(isObservableObject(e))e[n].remove(t);else if(Z(e))e.delete(t);else if(re(e))e.delete(t);else{if(!isObservableArray(e))return fail("production"!==process.env.NODE_ENV&&"'remove()' can only be used on observable objects, arrays and maps");"number"!=typeof t&&(t=parseInt(t,10)),invariant(t>=0,"Not a valid index: '"+t+"'"),e.splice(t,1)}}function has(e,t){return isObservableObject(e)?getAdministration(e).has(t):Z(e)?e.has(t):re(e)?e.has(t):isObservableArray(e)?t>=0&&t<e.length:fail("production"!==process.env.NODE_ENV&&"'has()' can only be used on observable objects, arrays and maps")}function get(e,t){if(has(e,t))return isObservableObject(e)?e[t]:Z(e)?e.get(t):isObservableArray(e)?e[t]:fail("production"!==process.env.NODE_ENV&&"'get()' can only be used on observable objects, arrays and maps")}function observe(e,t,r,n){return"function"==typeof r?function observeObservableProperty(e,t,r,n){return getAdministration(e,t).observe(r,n)}(e,t,r,n):function observeObservable(e,t,r){return getAdministration(e).observe(t,r)}(e,t,r)}FlowCancellationError.prototype=Object.create(Error.prototype);var F={detectCycles:!0,exportMapsAsObjects:!0,recurseEverything:!1};function cache(e,t,r,n){return n.detectCycles&&e.set(t,r),r}function toJS(e,t){var r;return"boolean"==typeof t&&(t={detectCycles:t}),t||(t=F),t.detectCycles=void 0===t.detectCycles?!0===t.recurseEverything:!0===t.detectCycles,t.detectCycles&&(r=new Map),function toJSHelper(e,t,r){if(!t.recurseEverything&&!isObservable(e))return e;if("object"!=typeof e)return e;if(null===e)return null;if(e instanceof Date)return e;if(x(e))return toJSHelper(e.get(),t,r);if(isObservable(e)&&keys(e),!0===t.detectCycles&&null!==e&&r.has(e))return r.get(e);if(isObservableArray(e)||Array.isArray(e)){var n=cache(r,e,[],t),o=e.map((function(e){return toJSHelper(e,t,r)}));n.length=o.length;for(var i=0,a=o.length;i<a;i++)n[i]=o[i];return n}if(re(e)||Object.getPrototypeOf(e)===Set.prototype){if(!1===t.exportMapsAsObjects){var s=cache(r,e,new Set,t);return e.forEach((function(e){s.add(toJSHelper(e,t,r))})),s}var c=cache(r,e,[],t);return e.forEach((function(e){c.push(toJSHelper(e,t,r))})),c}if(Z(e)||Object.getPrototypeOf(e)===Map.prototype){if(!1===t.exportMapsAsObjects){var u=cache(r,e,new Map,t);return e.forEach((function(e,n){u.set(n,toJSHelper(e,t,r))})),u}var l=cache(r,e,{},t);return e.forEach((function(e,n){l[n]=toJSHelper(e,t,r)})),l}var p=cache(r,e,{},t);return getPlainObjectKeys(e).forEach((function(n){p[n]=toJSHelper(e[n],t,r)})),p}(e,t,r)}function trace(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=!1;"boolean"==typeof e[e.length-1]&&(r=e.pop());var n=getAtomFromArgs(e);if(!n)return fail("production"!==process.env.NODE_ENV&&"'trace(break?)' can only be used inside a tracked computed value or a Reaction. Consider passing in the computed value or reaction explicitly");n.isTracing===g.NONE&&console.log("[mobx.trace] '"+n.name+"' tracing enabled"),n.isTracing=r?g.BREAK:g.LOG}function getAtomFromArgs(e){switch(e.length){case 0:return L.trackingDerivation;case 1:return getAtom(e[0]);case 2:return getAtom(e[0],e[1])}}function transaction(e,t){void 0===t&&(t=void 0),startBatch();try{return e.apply(t)}finally{endBatch()}}function when(e,t,r){return 1===arguments.length||t&&"object"==typeof t?whenPromise(e,t):_when(e,t,r||{})}function _when(e,t,r){var o;"number"==typeof r.timeout&&(o=setTimeout((function(){if(!a[n].isDisposed){a();var e=new Error("WHEN_TIMEOUT");if(!r.onError)throw e;r.onError(e)}}),r.timeout)),r.name=r.name||"When@"+getNextId();var i=createAction(r.name+"-effect",t),a=autorun((function(t){e()&&(t.dispose(),o&&clearTimeout(o),i())}),r);return a}function whenPromise(e,t){if("production"!==process.env.NODE_ENV&&t&&t.onError)return fail("the options 'onError' and 'promise' cannot be combined");var r,n=new Promise((function(n,o){var i=_when(e,n,__assign(__assign({},t),{onError:o}));r=function(){i(),o("WHEN_CANCELLED")}}));return n.cancel=r,n}function getAdm(e){return e[n]}function isPropertyKey(e){return"string"==typeof e||"number"==typeof e||"symbol"==typeof e}var K={has:function(e,t){if(t===n||"constructor"===t||t===s)return!0;var r=getAdm(e);return isPropertyKey(t)?r.has(t):t in e},get:function(e,t){if(t===n||"constructor"===t||t===s)return e[t];var r=getAdm(e),i=r.values.get(t);if(i instanceof o){var a=i.get();return void 0===a&&r.has(t),a}return isPropertyKey(t)&&r.has(t),e[t]},set:function(e,t,r){return!!isPropertyKey(t)&&(set(e,t,r),!0)},deleteProperty:function(e,t){return!!isPropertyKey(t)&&(getAdm(e).remove(t),!0)},ownKeys:function(e){return getAdm(e).keysAtom.reportObserved(),Reflect.ownKeys(e)},preventExtensions:function(e){return fail("Dynamic observable objects cannot be frozen"),!1}};function createDynamicObservableObject(e){var t=new Proxy(e,K);return e[n].proxy=t,t}function hasInterceptors(e){return void 0!==e.interceptors&&e.interceptors.length>0}function registerInterceptor(e,t){var r=e.interceptors||(e.interceptors=[]);return r.push(t),once((function(){var e=r.indexOf(t);-1!==e&&r.splice(e,1)}))}function interceptChange(e,t){var r=untrackedStart();try{for(var n=__spread(e.interceptors||[]),o=0,i=n.length;o<i&&(invariant(!(t=n[o](t))||t.type,"Intercept handlers should return nothing or a change object"),t);o++);return t}finally{untrackedEnd(r)}}function hasListeners(e){return void 0!==e.changeListeners&&e.changeListeners.length>0}function registerListener(e,t){var r=e.changeListeners||(e.changeListeners=[]);return r.push(t),once((function(){var e=r.indexOf(t);-1!==e&&r.splice(e,1)}))}function notifyListeners(e,t){var r=untrackedStart(),n=e.changeListeners;if(n){for(var o=0,i=(n=n.slice()).length;o<i;o++)n[o](t);untrackedEnd(r)}}var H={get:function(e,t){return t===n?e[n]:"length"===t?e[n].getArrayLength():"number"==typeof t?J.get.call(e,t):"string"!=typeof t||isNaN(t)?J.hasOwnProperty(t)?J[t]:e[t]:J.get.call(e,parseInt(t))},set:function(e,t,r){return"length"===t&&e[n].setArrayLength(r),"number"==typeof t&&J.set.call(e,t,r),"symbol"==typeof t||isNaN(t)?e[t]=r:J.set.call(e,parseInt(t),r),!0},preventExtensions:function(e){return fail("Observable arrays cannot be frozen"),!1}};function createObservableArray(e,t,r,o){void 0===r&&(r="ObservableArray@"+getNextId()),void 0===o&&(o=!1);var i=new z(r,t,o);!function addHiddenFinalProp(e,t,r){Object.defineProperty(e,t,{enumerable:!1,writable:!1,configurable:!0,value:r})}(i.values,n,i);var a=new Proxy(i.values,H);if(i.proxy=a,e&&e.length){var s=allowStateChangesStart(!0);i.spliceWithArray(0,0,e),allowStateChangesEnd(s)}return a}var z=function(){function ObservableArrayAdministration(e,t,r){this.owned=r,this.values=[],this.proxy=void 0,this.lastKnownLength=0,this.atom=new o(e||"ObservableArray@"+getNextId()),this.enhancer=function(r,n){return t(r,n,e+"[..]")}}return ObservableArrayAdministration.prototype.dehanceValue=function(e){return void 0!==this.dehancer?this.dehancer(e):e},ObservableArrayAdministration.prototype.dehanceValues=function(e){return void 0!==this.dehancer&&e.length>0?e.map(this.dehancer):e},ObservableArrayAdministration.prototype.intercept=function(e){return registerInterceptor(this,e)},ObservableArrayAdministration.prototype.observe=function(e,t){return void 0===t&&(t=!1),t&&e({object:this.proxy,type:"splice",index:0,added:this.values.slice(),addedCount:this.values.length,removed:[],removedCount:0}),registerListener(this,e)},ObservableArrayAdministration.prototype.getArrayLength=function(){return this.atom.reportObserved(),this.values.length},ObservableArrayAdministration.prototype.setArrayLength=function(e){if("number"!=typeof e||e<0)throw new Error("[mobx.array] Out of range: "+e);var t=this.values.length;if(e!==t)if(e>t){for(var r=new Array(e-t),n=0;n<e-t;n++)r[n]=void 0;this.spliceWithArray(t,0,r)}else this.spliceWithArray(e,t-e)},ObservableArrayAdministration.prototype.updateArrayLength=function(e,t){if(e!==this.lastKnownLength)throw new Error("[mobx] Modification exception: the internal structure of an observable array was changed.");this.lastKnownLength+=t},ObservableArrayAdministration.prototype.spliceWithArray=function(t,r,n){var o=this;checkIfStateModificationsAreAllowed(this.atom);var i=this.values.length;if(void 0===t?t=0:t>i?t=i:t<0&&(t=Math.max(0,i+t)),r=1===arguments.length?i-t:null==r?0:Math.max(0,Math.min(r,i-t)),void 0===n&&(n=e),hasInterceptors(this)){var a=interceptChange(this,{object:this.proxy,type:"splice",index:t,removedCount:r,added:n});if(!a)return e;r=a.removedCount,n=a.added}if(n=0===n.length?n:n.map((function(e){return o.enhancer(e,void 0)})),"production"!==process.env.NODE_ENV){var s=n.length-r;this.updateArrayLength(i,s)}var c=this.spliceItemsIntoValues(t,r,n);return 0===r&&0===n.length||this.notifyArraySplice(t,n,c),this.dehanceValues(c)},ObservableArrayAdministration.prototype.spliceItemsIntoValues=function(e,t,r){var n;if(r.length<1e4)return(n=this.values).splice.apply(n,__spread([e,t],r));var o=this.values.slice(e,e+t);return this.values=this.values.slice(0,e).concat(r,this.values.slice(e+t)),o},ObservableArrayAdministration.prototype.notifyArrayChildUpdate=function(e,t,r){var n=!this.owned&&isSpyEnabled(),o=hasListeners(this),i=o||n?{object:this.proxy,type:"update",index:e,newValue:t,oldValue:r}:null;n&&"production"!==process.env.NODE_ENV&&spyReportStart(__assign(__assign({},i),{name:this.atom.name})),this.atom.reportChanged(),o&&notifyListeners(this,i),n&&"production"!==process.env.NODE_ENV&&spyReportEnd()},ObservableArrayAdministration.prototype.notifyArraySplice=function(e,t,r){var n=!this.owned&&isSpyEnabled(),o=hasListeners(this),i=o||n?{object:this.proxy,type:"splice",index:e,removed:r,added:t,removedCount:r.length,addedCount:t.length}:null;n&&"production"!==process.env.NODE_ENV&&spyReportStart(__assign(__assign({},i),{name:this.atom.name})),this.atom.reportChanged(),o&&notifyListeners(this,i),n&&"production"!==process.env.NODE_ENV&&spyReportEnd()},ObservableArrayAdministration}(),J={intercept:function(e){return this[n].intercept(e)},observe:function(e,t){return void 0===t&&(t=!1),this[n].observe(e,t)},clear:function(){return this.splice(0)},replace:function(e){var t=this[n];return t.spliceWithArray(0,t.values.length,e)},toJS:function(){return this.slice()},toJSON:function(){return this.toJS()},splice:function(e,t){for(var r=[],o=2;o<arguments.length;o++)r[o-2]=arguments[o];var i=this[n];switch(arguments.length){case 0:return[];case 1:return i.spliceWithArray(e);case 2:return i.spliceWithArray(e,t)}return i.spliceWithArray(e,t,r)},spliceWithArray:function(e,t,r){return this[n].spliceWithArray(e,t,r)},push:function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=this[n];return r.spliceWithArray(r.values.length,0,e),r.values.length},pop:function(){return this.splice(Math.max(this[n].values.length-1,0),1)[0]},shift:function(){return this.splice(0,1)[0]},unshift:function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var r=this[n];return r.spliceWithArray(0,0,e),r.values.length},reverse:function(){"production"!==process.env.NODE_ENV&&console.warn("[mobx] `observableArray.reverse()` will not update the array in place. Use `observableArray.slice().reverse()` to suppress this warning and perform the operation on a copy, or `observableArray.replace(observableArray.slice().reverse())` to reverse & update in place");var e=this.slice();return e.reverse.apply(e,arguments)},sort:function(e){"production"!==process.env.NODE_ENV&&console.warn("[mobx] `observableArray.sort()` will not update the array in place. Use `observableArray.slice().sort()` to suppress this warning and perform the operation on a copy, or `observableArray.replace(observableArray.slice().sort())` to sort & update in place");var t=this.slice();return t.sort.apply(t,arguments)},remove:function(e){var t=this[n],r=t.dehanceValues(t.values).indexOf(e);return r>-1&&(this.splice(r,1),!0)},get:function(e){var t=this[n];if(t){if(e<t.values.length)return t.atom.reportObserved(),t.dehanceValue(t.values[e]);console.warn("[mobx.array] Attempt to read an array index ("+e+") that is out of bounds ("+t.values.length+"). Please check length first. Out of bound indices will not be tracked by MobX")}},set:function(e,t){var r=this[n],o=r.values;if(e<o.length){checkIfStateModificationsAreAllowed(r.atom);var i=o[e];if(hasInterceptors(r)){var a=interceptChange(r,{type:"update",object:r.proxy,index:e,newValue:t});if(!a)return;t=a.newValue}(t=r.enhancer(t,i))!==i&&(o[e]=t,r.notifyArrayChildUpdate(e,t,i))}else{if(e!==o.length)throw new Error("[mobx.array] Index out of bounds, "+e+" is larger than "+o.length);r.spliceWithArray(e,0,[t])}}};["concat","every","filter","forEach","indexOf","join","lastIndexOf","map","reduce","reduceRight","slice","some","toString","toLocaleString"].forEach((function(e){J[e]=function(){var t=this[n];t.atom.reportObserved();var r=t.dehanceValues(t.values);return r[e].apply(r,arguments)}}));var W,X=createInstanceofPredicate("ObservableArrayAdministration",z);function isObservableArray(e){return isObject(e)&&X(e[n])}var Y,$={},Q=function(){function ObservableMap(e,t,r){if(void 0===t&&(t=deepEnhancer),void 0===r&&(r="ObservableMap@"+getNextId()),this.enhancer=t,this.name=r,this[W]=$,this._keysAtom=createAtom(this.name+".keys()"),this[Symbol.toStringTag]="Map","function"!=typeof Map)throw new Error("mobx.map requires Map polyfill for the current browser. Check babel-polyfill or core-js/es6/map.js");this._data=new Map,this._hasMap=new Map,this.merge(e)}return ObservableMap.prototype._has=function(e){return this._data.has(e)},ObservableMap.prototype.has=function(e){var t=this;if(!L.trackingDerivation)return this._has(e);var r=this._hasMap.get(e);if(!r){var n=r=new V(this._has(e),referenceEnhancer,this.name+"."+stringifyKey(e)+"?",!1);this._hasMap.set(e,n),onBecomeUnobserved(n,(function(){return t._hasMap.delete(e)}))}return r.get()},ObservableMap.prototype.set=function(e,t){var r=this._has(e);if(hasInterceptors(this)){var n=interceptChange(this,{type:r?"update":"add",object:this,newValue:t,name:e});if(!n)return this;t=n.newValue}return r?this._updateValue(e,t):this._addValue(e,t),this},ObservableMap.prototype.delete=function(e){var t=this;if(hasInterceptors(this)&&!(o=interceptChange(this,{type:"delete",object:this,name:e})))return!1;if(this._has(e)){var r=isSpyEnabled(),n=hasListeners(this),o=n||r?{type:"delete",object:this,oldValue:this._data.get(e).value,name:e}:null;return r&&"production"!==process.env.NODE_ENV&&spyReportStart(__assign(__assign({},o),{name:this.name,key:e})),transaction((function(){t._keysAtom.reportChanged(),t._updateHasMapEntry(e,!1),t._data.get(e).setNewValue(void 0),t._data.delete(e)})),n&&notifyListeners(this,o),r&&"production"!==process.env.NODE_ENV&&spyReportEnd(),!0}return!1},ObservableMap.prototype._updateHasMapEntry=function(e,t){var r=this._hasMap.get(e);r&&r.setNewValue(t)},ObservableMap.prototype._updateValue=function(e,t){var r=this._data.get(e);if((t=r.prepareNewValue(t))!==L.UNCHANGED){var n=isSpyEnabled(),o=hasListeners(this),i=o||n?{type:"update",object:this,oldValue:r.value,name:e,newValue:t}:null;n&&"production"!==process.env.NODE_ENV&&spyReportStart(__assign(__assign({},i),{name:this.name,key:e})),r.setNewValue(t),o&&notifyListeners(this,i),n&&"production"!==process.env.NODE_ENV&&spyReportEnd()}},ObservableMap.prototype._addValue=function(e,t){var r=this;checkIfStateModificationsAreAllowed(this._keysAtom),transaction((function(){var n=new V(t,r.enhancer,r.name+"."+stringifyKey(e),!1);r._data.set(e,n),t=n.value,r._updateHasMapEntry(e,!0),r._keysAtom.reportChanged()}));var n=isSpyEnabled(),o=hasListeners(this),i=o||n?{type:"add",object:this,name:e,newValue:t}:null;n&&"production"!==process.env.NODE_ENV&&spyReportStart(__assign(__assign({},i),{name:this.name,key:e})),o&&notifyListeners(this,i),n&&"production"!==process.env.NODE_ENV&&spyReportEnd()},ObservableMap.prototype.get=function(e){return this.has(e)?this.dehanceValue(this._data.get(e).get()):this.dehanceValue(void 0)},ObservableMap.prototype.dehanceValue=function(e){return void 0!==this.dehancer?this.dehancer(e):e},ObservableMap.prototype.keys=function(){return this._keysAtom.reportObserved(),this._data.keys()},ObservableMap.prototype.values=function(){var e=this,t=0,r=Array.from(this.keys());return makeIterable({next:function(){return t<r.length?{value:e.get(r[t++]),done:!1}:{done:!0}}})},ObservableMap.prototype.entries=function(){var e=this,t=0,r=Array.from(this.keys());return makeIterable({next:function(){if(t<r.length){var n=r[t++];return{value:[n,e.get(n)],done:!1}}return{done:!0}}})},ObservableMap.prototype[(W=n,Symbol.iterator)]=function(){return this.entries()},ObservableMap.prototype.forEach=function(e,t){var r,n;try{for(var o=__values(this),i=o.next();!i.done;i=o.next()){var a=__read(i.value,2),s=a[0],c=a[1];e.call(t,c,s,this)}}catch(e){r={error:e}}finally{try{i&&!i.done&&(n=o.return)&&n.call(o)}finally{if(r)throw r.error}}},ObservableMap.prototype.merge=function(e){var t=this;return Z(e)&&(e=e.toJS()),transaction((function(){isPlainObject(e)?getPlainObjectKeys(e).forEach((function(r){return t.set(r,e[r])})):Array.isArray(e)?e.forEach((function(e){var r=__read(e,2),n=r[0],o=r[1];return t.set(n,o)})):isES6Map(e)?(e.constructor!==Map&&fail("Cannot initialize from classes that inherit from Map: "+e.constructor.name),e.forEach((function(e,r){return t.set(r,e)}))):null!=e&&fail("Cannot initialize map from "+e)})),this},ObservableMap.prototype.clear=function(){var e=this;transaction((function(){untracked((function(){var t,r;try{for(var n=__values(e.keys()),o=n.next();!o.done;o=n.next()){var i=o.value;e.delete(i)}}catch(e){t={error:e}}finally{try{o&&!o.done&&(r=n.return)&&r.call(n)}finally{if(t)throw t.error}}}))}))},ObservableMap.prototype.replace=function(e){var t=this;return transaction((function(){var r=function getMapLikeKeys(e){return isPlainObject(e)?Object.keys(e):Array.isArray(e)?e.map((function(e){return __read(e,1)[0]})):isES6Map(e)||Z(e)?Array.from(e.keys()):fail("Cannot get keys from '"+e+"'")}(e);Array.from(t.keys()).filter((function(e){return-1===r.indexOf(e)})).forEach((function(e){return t.delete(e)})),t.merge(e)})),this},Object.defineProperty(ObservableMap.prototype,"size",{get:function(){return this._keysAtom.reportObserved(),this._data.size},enumerable:!0,configurable:!0}),ObservableMap.prototype.toPOJO=function(){var e,t,r={};try{for(var n=__values(this),o=n.next();!o.done;o=n.next()){var i=__read(o.value,2),a=i[0],s=i[1];r["symbol"==typeof a?a:stringifyKey(a)]=s}}catch(t){e={error:t}}finally{try{o&&!o.done&&(t=n.return)&&t.call(n)}finally{if(e)throw e.error}}return r},ObservableMap.prototype.toJS=function(){return new Map(this)},ObservableMap.prototype.toJSON=function(){return this.toPOJO()},ObservableMap.prototype.toString=function(){var e=this;return this.name+"[{ "+Array.from(this.keys()).map((function(t){return stringifyKey(t)+": "+e.get(t)})).join(", ")+" }]"},ObservableMap.prototype.observe=function(e,t){return"production"!==process.env.NODE_ENV&&invariant(!0!==t,"`observe` doesn't support fireImmediately=true in combination with maps."),registerListener(this,e)},ObservableMap.prototype.intercept=function(e){return registerInterceptor(this,e)},ObservableMap}(),Z=createInstanceofPredicate("ObservableMap",Q),ee={},te=function(){function ObservableSet(e,t,r){if(void 0===t&&(t=deepEnhancer),void 0===r&&(r="ObservableSet@"+getNextId()),this.name=r,this[Y]=ee,this._data=new Set,this._atom=createAtom(this.name),this[Symbol.toStringTag]="Set","function"!=typeof Set)throw new Error("mobx.set requires Set polyfill for the current browser. Check babel-polyfill or core-js/es6/set.js");this.enhancer=function(e,n){return t(e,n,r)},e&&this.replace(e)}return ObservableSet.prototype.dehanceValue=function(e){return void 0!==this.dehancer?this.dehancer(e):e},ObservableSet.prototype.clear=function(){var e=this;transaction((function(){untracked((function(){var t,r;try{for(var n=__values(e._data.values()),o=n.next();!o.done;o=n.next()){var i=o.value;e.delete(i)}}catch(e){t={error:e}}finally{try{o&&!o.done&&(r=n.return)&&r.call(n)}finally{if(t)throw t.error}}}))}))},ObservableSet.prototype.forEach=function(e,t){var r,n;try{for(var o=__values(this),i=o.next();!i.done;i=o.next()){var a=i.value;e.call(t,a,a,this)}}catch(e){r={error:e}}finally{try{i&&!i.done&&(n=o.return)&&n.call(o)}finally{if(r)throw r.error}}},Object.defineProperty(ObservableSet.prototype,"size",{get:function(){return this._atom.reportObserved(),this._data.size},enumerable:!0,configurable:!0}),ObservableSet.prototype.add=function(e){var t=this;if((checkIfStateModificationsAreAllowed(this._atom),hasInterceptors(this))&&!(o=interceptChange(this,{type:"add",object:this,newValue:e})))return this;if(!this.has(e)){transaction((function(){t._data.add(t.enhancer(e,void 0)),t._atom.reportChanged()}));var r=isSpyEnabled(),n=hasListeners(this),o=n||r?{type:"add",object:this,newValue:e}:null;r&&"production"!==process.env.NODE_ENV&&spyReportStart(o),n&&notifyListeners(this,o),r&&"production"!==process.env.NODE_ENV&&spyReportEnd()}return this},ObservableSet.prototype.delete=function(e){var t=this;if(hasInterceptors(this)&&!(o=interceptChange(this,{type:"delete",object:this,oldValue:e})))return!1;if(this.has(e)){var r=isSpyEnabled(),n=hasListeners(this),o=n||r?{type:"delete",object:this,oldValue:e}:null;return r&&"production"!==process.env.NODE_ENV&&spyReportStart(__assign(__assign({},o),{name:this.name})),transaction((function(){t._atom.reportChanged(),t._data.delete(e)})),n&&notifyListeners(this,o),r&&"production"!==process.env.NODE_ENV&&spyReportEnd(),!0}return!1},ObservableSet.prototype.has=function(e){return this._atom.reportObserved(),this._data.has(this.dehanceValue(e))},ObservableSet.prototype.entries=function(){var e=0,t=Array.from(this.keys()),r=Array.from(this.values());return makeIterable({next:function(){var n=e;return e+=1,n<r.length?{value:[t[n],r[n]],done:!1}:{done:!0}}})},ObservableSet.prototype.keys=function(){return this.values()},ObservableSet.prototype.values=function(){this._atom.reportObserved();var e=this,t=0,r=Array.from(this._data.values());return makeIterable({next:function(){return t<r.length?{value:e.dehanceValue(r[t++]),done:!1}:{done:!0}}})},ObservableSet.prototype.replace=function(e){var t=this;return re(e)&&(e=e.toJS()),transaction((function(){Array.isArray(e)?(t.clear(),e.forEach((function(e){return t.add(e)}))):isES6Set(e)?(t.clear(),e.forEach((function(e){return t.add(e)}))):null!=e&&fail("Cannot initialize set from "+e)})),this},ObservableSet.prototype.observe=function(e,t){return"production"!==process.env.NODE_ENV&&invariant(!0!==t,"`observe` doesn't support fireImmediately=true in combination with sets."),registerListener(this,e)},ObservableSet.prototype.intercept=function(e){return registerInterceptor(this,e)},ObservableSet.prototype.toJS=function(){return new Set(this)},ObservableSet.prototype.toString=function(){return this.name+"[ "+Array.from(this).join(", ")+" ]"},ObservableSet.prototype[(Y=n,Symbol.iterator)]=function(){return this.values()},ObservableSet}(),re=createInstanceofPredicate("ObservableSet",te),ne=function(){function ObservableObjectAdministration(e,t,r,n){void 0===t&&(t=new Map),this.target=e,this.values=t,this.name=r,this.defaultEnhancer=n,this.keysAtom=new o(r+".keys")}return ObservableObjectAdministration.prototype.read=function(e){return this.values.get(e).get()},ObservableObjectAdministration.prototype.write=function(e,t){var r=this.target,n=this.values.get(e);if(n instanceof j)n.set(t);else{if(hasInterceptors(this)){if(!(a=interceptChange(this,{type:"update",object:this.proxy||r,name:e,newValue:t})))return;t=a.newValue}if((t=n.prepareNewValue(t))!==L.UNCHANGED){var o=hasListeners(this),i=isSpyEnabled(),a=o||i?{type:"update",object:this.proxy||r,oldValue:n.value,name:e,newValue:t}:null;i&&"production"!==process.env.NODE_ENV&&spyReportStart(__assign(__assign({},a),{name:this.name,key:e})),n.setNewValue(t),o&&notifyListeners(this,a),i&&"production"!==process.env.NODE_ENV&&spyReportEnd()}}},ObservableObjectAdministration.prototype.has=function(e){var t=this.pendingKeys||(this.pendingKeys=new Map),r=t.get(e);if(r)return r.get();var n=!!this.values.get(e);return r=new V(n,referenceEnhancer,this.name+"."+stringifyKey(e)+"?",!1),t.set(e,r),r.get()},ObservableObjectAdministration.prototype.addObservableProp=function(e,t,r){void 0===r&&(r=this.defaultEnhancer);var o=this.target;if(function assertPropertyConfigurable(e,t){"production"===process.env.NODE_ENV||isPropertyConfigurable(e,t)||fail("Cannot make property '"+t.toString()+"' observable, it is not configurable and writable in the target object")}(o,e),hasInterceptors(this)){var i=interceptChange(this,{object:this.proxy||o,name:e,type:"add",newValue:t});if(!i)return;t=i.newValue}var a=new V(t,r,this.name+"."+stringifyKey(e),!1);this.values.set(e,a),t=a.value,Object.defineProperty(o,e,function generateObservablePropConfig(e){return oe[e]||(oe[e]={configurable:!0,enumerable:!0,get:function(){return this[n].read(e)},set:function(t){this[n].write(e,t)}})}(e)),this.notifyPropertyAddition(e,t)},ObservableObjectAdministration.prototype.addComputedProp=function(e,t,r){var n=this.target;r.name=r.name||this.name+"."+stringifyKey(t),this.values.set(t,new j(r)),(e===n||isPropertyConfigurable(e,t))&&Object.defineProperty(e,t,function generateComputedPropConfig(e){return ie[e]||(ie[e]={configurable:L.computedConfigurable,enumerable:!1,get:function(){return getAdministrationForComputedPropOwner(this).read(e)},set:function(t){getAdministrationForComputedPropOwner(this).write(e,t)}})}(t))},ObservableObjectAdministration.prototype.remove=function(e){if(this.values.has(e)){var t=this.target;if(hasInterceptors(this))if(!(s=interceptChange(this,{object:this.proxy||t,name:e,type:"remove"})))return;try{startBatch();var r=hasListeners(this),n=isSpyEnabled(),o=this.values.get(e),i=o&&o.get();if(o&&o.set(void 0),this.keysAtom.reportChanged(),this.values.delete(e),this.pendingKeys){var a=this.pendingKeys.get(e);a&&a.set(!1)}delete this.target[e];var s=r||n?{type:"remove",object:this.proxy||t,oldValue:i,name:e}:null;n&&"production"!==process.env.NODE_ENV&&spyReportStart(__assign(__assign({},s),{name:this.name,key:e})),r&&notifyListeners(this,s),n&&"production"!==process.env.NODE_ENV&&spyReportEnd()}finally{endBatch()}}},ObservableObjectAdministration.prototype.illegalAccess=function(e,t){console.warn("Property '"+t+"' of '"+e+"' was accessed through the prototype chain. Use 'decorate' instead to declare the prop or access it statically through it's owner")},ObservableObjectAdministration.prototype.observe=function(e,t){return"production"!==process.env.NODE_ENV&&invariant(!0!==t,"`observe` doesn't support the fire immediately property for observable objects."),registerListener(this,e)},ObservableObjectAdministration.prototype.intercept=function(e){return registerInterceptor(this,e)},ObservableObjectAdministration.prototype.notifyPropertyAddition=function(e,t){var r=hasListeners(this),n=isSpyEnabled(),o=r||n?{type:"add",object:this.proxy||this.target,name:e,newValue:t}:null;if(n&&"production"!==process.env.NODE_ENV&&spyReportStart(__assign(__assign({},o),{name:this.name,key:e})),r&&notifyListeners(this,o),n&&"production"!==process.env.NODE_ENV&&spyReportEnd(),this.pendingKeys){var i=this.pendingKeys.get(e);i&&i.set(!0)}this.keysAtom.reportChanged()},ObservableObjectAdministration.prototype.getKeys=function(){var e,t;this.keysAtom.reportObserved();var r=[];try{for(var n=__values(this.values),o=n.next();!o.done;o=n.next()){var i=__read(o.value,2),a=i[0];i[1]instanceof V&&r.push(a)}}catch(t){e={error:t}}finally{try{o&&!o.done&&(t=n.return)&&t.call(n)}finally{if(e)throw e.error}}return r},ObservableObjectAdministration}();function asObservableObject(e,t,r){if(void 0===t&&(t=""),void 0===r&&(r=deepEnhancer),Object.prototype.hasOwnProperty.call(e,n))return e[n];"production"!==process.env.NODE_ENV&&invariant(Object.isExtensible(e),"Cannot make the designated object observable; it is not extensible"),isPlainObject(e)||(t=(e.constructor.name||"ObservableObject")+"@"+getNextId()),t||(t="ObservableObject@"+getNextId());var o=new ne(e,new Map,stringifyKey(t),r);return addHiddenProp(e,n,o),o}var oe=Object.create(null),ie=Object.create(null);function getAdministrationForComputedPropOwner(e){var t=e[n];return t||(initializeInstance(e),e[n])}var ae=createInstanceofPredicate("ObservableObjectAdministration",ne);function isObservableObject(e){return!!isObject(e)&&(initializeInstance(e),ae(e[n]))}function getAtom(e,t){if("object"==typeof e&&null!==e){if(isObservableArray(e))return void 0!==t&&fail("production"!==process.env.NODE_ENV&&"It is not possible to get index atoms from arrays"),e[n].atom;if(re(e))return e[n];if(Z(e)){var r=e;return void 0===t?r._keysAtom:((o=r._data.get(t)||r._hasMap.get(t))||fail("production"!==process.env.NODE_ENV&&"the entry '"+t+"' does not exist in the observable map '"+getDebugName(e)+"'"),o)}var o;if(initializeInstance(e),t&&!e[n]&&e[t],isObservableObject(e))return t?((o=e[n].values.get(t))||fail("production"!==process.env.NODE_ENV&&"no observable property '"+t+"' found on the observable object '"+getDebugName(e)+"'"),o):fail("production"!==process.env.NODE_ENV&&"please specify a property");if(i(e)||C(e)||M(e))return e}else if("function"==typeof e&&M(e[n]))return e[n];return fail("production"!==process.env.NODE_ENV&&"Cannot obtain atom from "+e)}function getAdministration(e,t){return e||fail("Expecting some object"),void 0!==t?getAdministration(getAtom(e,t)):i(e)||C(e)||M(e)?e:Z(e)||re(e)?e:(initializeInstance(e),e[n]?e[n]:void fail("production"!==process.env.NODE_ENV&&"Cannot obtain administration from "+e))}function getDebugName(e,t){return(void 0!==t?getAtom(e,t):isObservableObject(e)||Z(e)||re(e)?getAdministration(e):getAtom(e)).name}var se=Object.prototype.toString;function deepEqual(e,t,r){return void 0===r&&(r=-1),function eq(e,t,r,n,o){if(e===t)return 0!==e||1/e==1/t;if(null==e||null==t)return!1;if(e!=e)return t!=t;var i=typeof e;if("function"!==i&&"object"!==i&&"object"!=typeof t)return!1;var a=se.call(e);if(a!==se.call(t))return!1;switch(a){case"[object RegExp]":case"[object String]":return""+e==""+t;case"[object Number]":return+e!=+e?+t!=+t:0==+e?1/+e==1/t:+e==+t;case"[object Date]":case"[object Boolean]":return+e==+t;case"[object Symbol]":return"undefined"!=typeof Symbol&&Symbol.valueOf.call(e)===Symbol.valueOf.call(t);case"[object Map]":case"[object Set]":r>=0&&r++}e=unwrap(e),t=unwrap(t);var s="[object Array]"===a;if(!s){if("object"!=typeof e||"object"!=typeof t)return!1;var c=e.constructor,u=t.constructor;if(c!==u&&!("function"==typeof c&&c instanceof c&&"function"==typeof u&&u instanceof u)&&"constructor"in e&&"constructor"in t)return!1}if(0===r)return!1;r<0&&(r=-1);o=o||[];var l=(n=n||[]).length;for(;l--;)if(n[l]===e)return o[l]===t;if(n.push(e),o.push(t),s){if((l=e.length)!==t.length)return!1;for(;l--;)if(!eq(e[l],t[l],r-1,n,o))return!1}else{var p=Object.keys(e),d=void 0;if(l=p.length,Object.keys(t).length!==l)return!1;for(;l--;)if(d=p[l],!has$1(t,d)||!eq(e[d],t[d],r-1,n,o))return!1}return n.pop(),o.pop(),!0}(e,t,r)}function unwrap(e){return isObservableArray(e)?e.slice():isES6Map(e)||Z(e)?Array.from(e.entries()):isES6Set(e)||re(e)?Array.from(e.entries()):e}function has$1(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function makeIterable(e){return e[Symbol.iterator]=getSelf,e}function getSelf(){return this}if("undefined"==typeof Proxy||"undefined"==typeof Symbol)throw new Error("[mobx] MobX 5+ requires Proxy and Symbol objects. If your environment doesn't support Symbol or Proxy objects, please downgrade to MobX 4. For React Native Android, consider upgrading JSCore.");try{process.env.NODE_ENV}catch(e){var ce=getGlobal();"undefined"==typeof process&&(ce.process={}),ce.process.env={}}!function(){if("testCodeMinification"!==function testCodeMinification(){}.name&&"production"!==process.env.NODE_ENV&&"undefined"!=typeof process&&"true"!==process.env.IGNORE_MOBX_MINIFY_WARNING){var e=["process","env","NODE_ENV"].join(".");console.warn("[mobx] you are running a minified build, but '"+e+"' was not set to 'production' in your bundler. This results in an unnecessarily large and slow bundle")}}(),"object"==typeof __MOBX_DEVTOOLS_GLOBAL_HOOK__&&__MOBX_DEVTOOLS_GLOBAL_HOOK__.injectMobx({spy,extras:{getDebugName},$mobx:n});export{n as $mobx,FlowCancellationError,m as IDerivationState,Q as ObservableMap,te as ObservableSet,B as Reaction,allowStateChanges as _allowStateChanges,allowStateChangesInsideComputed as _allowStateChangesInsideComputed,allowStateReadsEnd as _allowStateReadsEnd,allowStateReadsStart as _allowStateReadsStart,_endAction,getAdministration as _getAdministration,getGlobalState as _getGlobalState,interceptReads as _interceptReads,isComputingDerivation as _isComputingDerivation,resetGlobalState as _resetGlobalState,_startAction,G as action,autorun,a as comparer,A as computed,configure,createAtom,decorate,entries,extendObservable,flow,get,getAtom,getDebugName,getDependencyTree,getObserverTree,has,intercept,isAction,isArrayLike,x as isBoxedObservable,isComputed,isComputedProp,isFlowCancellationError,isObservable,isObservableArray,Z as isObservableMap,isObservableObject,isObservableProp,re as isObservableSet,keys,y as observable,observe,onBecomeObserved,onBecomeUnobserved,onReactionError,reaction,remove,runInAction,set,spy,toJS,trace,transaction,untracked,values,when};