/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-typescript version: 3.3.1(dbbf69725062a240258a04596d6bd8544365ac91)
 * Released under the MIT license
 * https://github.com/Microsoft/monaco-typescript/blob/master/LICENSE.md
 *-----------------------------------------------------------------------------*/
define("vs/language/typescript/workerManager",["require","exports"],(function(r,o){Object.defineProperty(o,"__esModule",{value:!0});var l=function(){function e(r,o){var l=this;this._modeId=r,this._defaults=o,this._worker=null,this._idleCheckInterval=setInterval((function(){return l._checkIfIdle()}),3e4),this._lastUsedTime=0,this._configChangeListener=this._defaults.onDidChange((function(){return l._stopWorker()}))}return e.prototype._stopWorker=function(){this._worker&&(this._worker.dispose(),this._worker=null),this._client=null},e.prototype.dispose=function(){clearInterval(this._idleCheckInterval),this._configChangeListener.dispose(),this._stopWorker()},e.prototype._checkIfIdle=function(){if(this._worker){var r=this._defaults.getWorkerMaxIdleTime(),o=Date.now()-this._lastUsedTime;0<r&&r<o&&this._stopWorker()}},e.prototype._getClient=function(){var r=this;if(this._lastUsedTime=Date.now(),!this._client){this._worker=monaco.editor.createWebWorker({moduleId:"vs/language/typescript/tsWorker",label:this._modeId,createData:{compilerOptions:this._defaults.getCompilerOptions(),extraLibs:this._defaults.getExtraLibs()}});var o=this._worker.getProxy();this._defaults.getEagerModelSync()&&(o=o.then((function(o){return r._worker.withSyncedResources(monaco.editor.getModels().filter((function(o){return o.getModeId()===r._modeId})).map((function(r){return r.uri})))}))),this._client=o}return this._client},e.prototype.getLanguageServiceWorker=function(){for(var r,o=this,l=[],p=0;p<arguments.length;p++)l[p]=arguments[p];return this._getClient().then((function(o){r=o})).then((function(r){return o._worker.withSyncedResources(l)})).then((function(o){return r}))},e}();o.WorkerManager=l}));var r,o=this&&this.__extends||(r=function(o,l){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(r,o){r.__proto__=o}||function(r,o){for(var l in o)o.hasOwnProperty(l)&&(r[l]=o[l])})(o,l)},function(o,l){function n(){this.constructor=o}r(o,l),o.prototype=null===l?Object.create(l):(n.prototype=l.prototype,new n)});define("vs/language/typescript/languageFeatures",["require","exports"],(function(r,l){Object.defineProperty(l,"__esModule",{value:!0});var p,g,m=monaco.Uri,f=monaco.Promise;function c(r){return r?r.map((function(r){return r.text})).join(""):""}(g=p||(p={}))[g.None=0]="None",g[g.Block=1]="Block",g[g.Smart=2]="Smart";var d=function(){function e(r){this._worker=r}return e.prototype._positionToOffset=function(r,o){return monaco.editor.getModel(r).getOffsetAt(o)},e.prototype._offsetToPosition=function(r,o){return monaco.editor.getModel(r).getPositionAt(o)},e.prototype._textSpanToRange=function(r,o){var l=this._offsetToPosition(r,o.start),p=this._offsetToPosition(r,o.start+o.length);return{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:p.lineNumber,endColumn:p.column}},e}(),h=function(r){function e(o,l,p){var g=r.call(this,p)||this;g._defaults=o,g._selector=l,g._disposables=[],g._listener=Object.create(null);var i=function(r){if(r.getModeId()===l){var o,p=r.onDidChangeContent((function(){clearTimeout(o),o=setTimeout((function(){return g._doValidate(r.uri)}),500)}));g._listener[r.uri.toString()]={dispose:function(){p.dispose(),clearTimeout(o)}},g._doValidate(r.uri)}},a=function(r){monaco.editor.setModelMarkers(r,g._selector,[]);var o=r.uri.toString();g._listener[o]&&(g._listener[o].dispose(),delete g._listener[o])};return g._disposables.push(monaco.editor.onDidCreateModel(i)),g._disposables.push(monaco.editor.onWillDisposeModel(a)),g._disposables.push(monaco.editor.onDidChangeModelLanguage((function(r){a(r.model),i(r.model)}))),g._disposables.push({dispose:function(){for(var r=0,o=monaco.editor.getModels();r<o.length;r++){var l=o[r];a(l)}}}),g._disposables.push(g._defaults.onDidChange((function(){for(var r=0,o=monaco.editor.getModels();r<o.length;r++){var l=o[r];a(l),i(l)}}))),monaco.editor.getModels().forEach(i),g}return o(e,r),e.prototype.dispose=function(){this._disposables.forEach((function(r){return r&&r.dispose()})),this._disposables=[]},e.prototype._doValidate=function(r){var o=this;this._worker(r).then((function(l){if(!monaco.editor.getModel(r))return null;var p=[],g=o._defaults.getDiagnosticsOptions(),m=g.noSyntaxValidation,d=g.noSemanticValidation;return m||p.push(l.getSyntacticDiagnostics(r.toString())),d||p.push(l.getSemanticDiagnostics(r.toString())),f.join(p)})).then((function(l){if(!l||!monaco.editor.getModel(r))return null;var p=l.reduce((function(r,o){return o.concat(r)}),[]).map((function(l){return o._convertDiagnostics(r,l)}));monaco.editor.setModelMarkers(monaco.editor.getModel(r),o._selector,p)})).then(void 0,(function(r){console.error(r)}))},e.prototype._convertDiagnostics=function(r,o){var l=this._offsetToPosition(r,o.start),p=l.lineNumber,g=l.column,m=this._offsetToPosition(r,o.start+o.length),f=m.lineNumber,d=m.column;return{severity:monaco.MarkerSeverity.Error,startLineNumber:p,startColumn:g,endLineNumber:f,endColumn:d,message:function(r,o){if("string"==typeof r)return r;for(var l=r,p="",g=0;l;){if(g){p+="\n";for(var m=0;m<g;m++)p+="  "}p+=l.messageText,g++,l=l.next}return p}(o.messageText)}},e}(l.Adapter=d);l.DiagnostcsAdapter=h;var v=function(r){function u(){return null!==r&&r.apply(this,arguments)||this}return o(u,r),Object.defineProperty(u.prototype,"triggerCharacters",{get:function(){return["."]},enumerable:!0,configurable:!0}),u.prototype.provideCompletionItems=function(r,o,l,p){r.getWordUntilPosition(o);var g=r.uri,m=this._positionToOffset(g,o);return this._worker(g).then((function(r){return r.getCompletionsAtPosition(g.toString(),m)})).then((function(r){if(r)return{suggestions:r.entries.map((function(r){return{uri:g,position:o,label:r.name,insertText:r.name,sortText:r.sortText,kind:u.convertKind(r.kind)}}))}}))},u.prototype.resolveCompletionItem=function(r,o,l,p){var g=this,m=l,f=m.uri,d=m.position;return this._worker(f).then((function(r){return r.getCompletionEntryDetails(f.toString(),g._positionToOffset(f,d),m.label)})).then((function(r){return r?{uri:f,position:d,label:r.name,kind:u.convertKind(r.kind),detail:c(r.displayParts),documentation:{value:c(r.documentation)}}:m}))},u.convertKind=function(r){switch(r){case T.primitiveType:case T.keyword:return monaco.languages.CompletionItemKind.Keyword;case T.variable:case T.localVariable:return monaco.languages.CompletionItemKind.Variable;case T.memberVariable:case T.memberGetAccessor:case T.memberSetAccessor:return monaco.languages.CompletionItemKind.Field;case T.function:case T.memberFunction:case T.constructSignature:case T.callSignature:case T.indexSignature:return monaco.languages.CompletionItemKind.Function;case T.enum:return monaco.languages.CompletionItemKind.Enum;case T.module:return monaco.languages.CompletionItemKind.Module;case T.class:return monaco.languages.CompletionItemKind.Class;case T.interface:return monaco.languages.CompletionItemKind.Interface;case T.warning:return monaco.languages.CompletionItemKind.File}return monaco.languages.CompletionItemKind.Property},u}(d);l.SuggestAdapter=v;var _=function(r){function e(){var o=null!==r&&r.apply(this,arguments)||this;return o.signatureHelpTriggerCharacters=["(",","],o}return o(e,r),e.prototype.provideSignatureHelp=function(r,o,l){var p=this,g=r.uri;return this._worker(g).then((function(r){return r.getSignatureHelpItems(g.toString(),p._positionToOffset(g,o))})).then((function(r){if(r){var o={activeSignature:r.selectedItemIndex,activeParameter:r.argumentIndex,signatures:[]};return r.items.forEach((function(r){var l={label:"",documentation:null,parameters:[]};l.label+=c(r.prefixDisplayParts),r.parameters.forEach((function(o,p,g){var m=c(o.displayParts),f={label:m,documentation:c(o.documentation)};l.label+=m,l.parameters.push(f),p<g.length-1&&(l.label+=c(r.separatorDisplayParts))})),l.label+=c(r.suffixDisplayParts),o.signatures.push(l)})),o}}))},e}(d);l.SignatureHelpAdapter=_;var y=function(r){function t(){return null!==r&&r.apply(this,arguments)||this}return o(t,r),t.prototype.provideHover=function(r,o,l){var p=this,g=r.uri;return this._worker(g).then((function(r){return r.getQuickInfoAtPosition(g.toString(),p._positionToOffset(g,o))})).then((function(r){if(r){var o=c(r.documentation),l=r.tags?r.tags.map((function(r){var o="*@"+r.name+"*";return r.text?o+(r.text.match(/\r\n|\n/g)?" \n"+r.text:" - "+r.text):o})).join("  \n\n"):"",m=c(r.displayParts);return{range:p._textSpanToRange(g,r.textSpan),contents:[{value:"```js\n"+m+"\n```\n"},{value:o+(l?"\n\n"+l:"")}]}}}))},t}(d);l.QuickInfoAdapter=y;var S=function(r){function t(){return null!==r&&r.apply(this,arguments)||this}return o(t,r),t.prototype.provideDocumentHighlights=function(r,o,l){var p=this,g=r.uri;return this._worker(g).then((function(r){return r.getOccurrencesAtPosition(g.toString(),p._positionToOffset(g,o))})).then((function(r){if(r)return r.map((function(r){return{range:p._textSpanToRange(g,r.textSpan),kind:r.isWriteAccess?monaco.languages.DocumentHighlightKind.Write:monaco.languages.DocumentHighlightKind.Text}}))}))},t}(d);l.OccurrencesAdapter=S;var b=function(r){function t(){return null!==r&&r.apply(this,arguments)||this}return o(t,r),t.prototype.provideDefinition=function(r,o,l){var p=this,g=r.uri;return this._worker(g).then((function(r){return r.getDefinitionAtPosition(g.toString(),p._positionToOffset(g,o))})).then((function(r){if(r){for(var o=[],l=0,g=r;l<g.length;l++){var f=g[l],d=m.parse(f.fileName);monaco.editor.getModel(d)&&o.push({uri:d,range:p._textSpanToRange(d,f.textSpan)})}return o}}))},t}(d);l.DefinitionAdapter=b;var k=function(r){function t(){return null!==r&&r.apply(this,arguments)||this}return o(t,r),t.prototype.provideReferences=function(r,o,l,p){var g=this,f=r.uri;return this._worker(f).then((function(r){return r.getReferencesAtPosition(f.toString(),g._positionToOffset(f,o))})).then((function(r){if(r){for(var o=[],l=0,p=r;l<p.length;l++){var f=p[l],d=m.parse(f.fileName);monaco.editor.getModel(d)&&o.push({uri:d,range:g._textSpanToRange(d,f.textSpan)})}return o}}))},t}(d);l.ReferenceAdapter=k;var w=function(r){function t(){return null!==r&&r.apply(this,arguments)||this}return o(t,r),t.prototype.provideDocumentSymbols=function(r,o){var l=this,p=r.uri;return this._worker(p).then((function(r){return r.getNavigationBarItems(p.toString())})).then((function(r){if(r){var s=function(r,o,g){var m={name:o.text,detail:"",kind:I[o.kind]||monaco.languages.SymbolKind.Variable,range:l._textSpanToRange(p,o.spans[0]),selectionRange:l._textSpanToRange(p,o.spans[0]),containerName:g};if(o.childItems&&0<o.childItems.length)for(var f=0,d=o.childItems;f<d.length;f++){var h=d[f];s(r,h,m.name)}r.push(m)},o=[];return r.forEach((function(r){return s(o,r)})),o}}))},t}(d);l.OutlineAdapter=w;var T=function(){function e(){}return e.unknown="",e.keyword="keyword",e.script="script",e.module="module",e.class="class",e.interface="interface",e.type="type",e.enum="enum",e.variable="var",e.localVariable="local var",e.function="function",e.localFunction="local function",e.memberFunction="method",e.memberGetAccessor="getter",e.memberSetAccessor="setter",e.memberVariable="property",e.constructorImplementation="constructor",e.callSignature="call",e.indexSignature="index",e.constructSignature="construct",e.parameter="parameter",e.typeParameter="type parameter",e.primitiveType="primitive type",e.label="label",e.alias="alias",e.const="const",e.let="let",e.warning="warning",e}();l.Kind=T;var I=Object.create(null);I[T.module]=monaco.languages.SymbolKind.Module,I[T.class]=monaco.languages.SymbolKind.Class,I[T.enum]=monaco.languages.SymbolKind.Enum,I[T.interface]=monaco.languages.SymbolKind.Interface,I[T.memberFunction]=monaco.languages.SymbolKind.Method,I[T.memberVariable]=monaco.languages.SymbolKind.Property,I[T.memberGetAccessor]=monaco.languages.SymbolKind.Property,I[T.memberSetAccessor]=monaco.languages.SymbolKind.Property,I[T.variable]=monaco.languages.SymbolKind.Variable,I[T.const]=monaco.languages.SymbolKind.Variable,I[T.localVariable]=monaco.languages.SymbolKind.Variable,I[T.variable]=monaco.languages.SymbolKind.Variable,I[T.function]=monaco.languages.SymbolKind.Function,I[T.localFunction]=monaco.languages.SymbolKind.Function;var A=function(r){function t(){return null!==r&&r.apply(this,arguments)||this}return o(t,r),t._convertOptions=function(r){return{ConvertTabsToSpaces:r.insertSpaces,TabSize:r.tabSize,IndentSize:r.tabSize,IndentStyle:p.Smart,NewLineCharacter:"\n",InsertSpaceAfterCommaDelimiter:!0,InsertSpaceAfterSemicolonInForStatements:!0,InsertSpaceBeforeAndAfterBinaryOperators:!0,InsertSpaceAfterKeywordsInControlFlowStatements:!0,InsertSpaceAfterFunctionKeywordForAnonymousFunctions:!0,InsertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis:!1,InsertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets:!1,InsertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces:!1,PlaceOpenBraceOnNewLineForControlBlocks:!1,PlaceOpenBraceOnNewLineForFunctions:!1}},t.prototype._convertTextChanges=function(r,o){return{text:o.newText,range:this._textSpanToRange(r,o.span)}},t}(d),C=function(r){function t(){return null!==r&&r.apply(this,arguments)||this}return o(t,r),t.prototype.provideDocumentRangeFormattingEdits=function(r,o,l,p){var g=this,m=r.uri;return this._worker(m).then((function(r){return r.getFormattingEditsForRange(m.toString(),g._positionToOffset(m,{lineNumber:o.startLineNumber,column:o.startColumn}),g._positionToOffset(m,{lineNumber:o.endLineNumber,column:o.endColumn}),A._convertOptions(l))})).then((function(r){if(r)return r.map((function(r){return g._convertTextChanges(m,r)}))}))},t}(l.FormatHelper=A);l.FormatAdapter=C;var P=function(r){function t(){return null!==r&&r.apply(this,arguments)||this}return o(t,r),Object.defineProperty(t.prototype,"autoFormatTriggerCharacters",{get:function(){return[";","}","\n"]},enumerable:!0,configurable:!0}),t.prototype.provideOnTypeFormattingEdits=function(r,o,l,p,g){var m=this,f=r.uri;return this._worker(f).then((function(r){return r.getFormattingEditsAfterKeystroke(f.toString(),m._positionToOffset(f,o),l,A._convertOptions(p))})).then((function(r){if(r)return r.map((function(r){return m._convertTextChanges(f,r)}))}))},t}(A);l.FormatOnTypeAdapter=P})),define("vs/language/typescript/tsMode",["require","exports","./workerManager","./languageFeatures"],(function(r,o,l,p){var g,m;function a(r,o){var g=new l.WorkerManager(o,r),n=function(r){for(var o=[],l=1;l<arguments.length;l++)o[l-1]=arguments[l];return g.getLanguageServiceWorker.apply(g,[r].concat(o))};return monaco.languages.registerCompletionItemProvider(o,new p.SuggestAdapter(n)),monaco.languages.registerSignatureHelpProvider(o,new p.SignatureHelpAdapter(n)),monaco.languages.registerHoverProvider(o,new p.QuickInfoAdapter(n)),monaco.languages.registerDocumentHighlightProvider(o,new p.OccurrencesAdapter(n)),monaco.languages.registerDefinitionProvider(o,new p.DefinitionAdapter(n)),monaco.languages.registerReferenceProvider(o,new p.ReferenceAdapter(n)),monaco.languages.registerDocumentSymbolProvider(o,new p.OutlineAdapter(n)),monaco.languages.registerDocumentRangeFormattingEditProvider(o,new p.FormatAdapter(n)),monaco.languages.registerOnTypeFormattingEditProvider(o,new p.FormatOnTypeAdapter(n)),new p.DiagnostcsAdapter(r,o,n),n}Object.defineProperty(o,"__esModule",{value:!0}),o.setupTypeScript=function(r){m=a(r,"typescript")},o.setupJavaScript=function(r){g=a(r,"javascript")},o.getJavaScriptWorker=function(){return new monaco.Promise((function(r,o){if(!g)return o("JavaScript not registered!");r(g)}))},o.getTypeScriptWorker=function(){return new monaco.Promise((function(r,o){if(!m)return o("TypeScript not registered!");r(m)}))}}));